
//
// @(#)btyaccpar, based on byacc 1.8 (Berkeley)
// Parser skeleton modified for use in the Firebird project by Nickolay Samofatov
//
#define YYBTYACC 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dsql.tab.h"

#define YYERROR_DETAILED

typedef int Yshort;

/* 
*	PROGRAM:	Dynamic SQL runtime support
*	MODULE:		parse.y
*	DESCRIPTION:	Dynamic SQL parser
*
* The contents of this file are subject to the Interbase Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy
* of the License at http://www.Inprise.com/IPL.html
*
* Software distributed under the License is distributed on an
* "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
* or implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The Original Code was created by Inprise Corporation
* and its predecessors. Portions created by Inprise Corporation are
* Copyright (C) Inprise Corporation.
*
* All Rights Reserved.
* Contributor(s): ______________________________________.
*
* 2002-02-24 Sean Leyne - Code Cleanup of old Win 3.1 port (WINDOWS_ONLY)
* 2001.05.20 Neil McCalden: Allow a udf to be used in a 'group by' clause.
* 2001.05.30 Claudio Valderrama: DROP TABLE and DROP VIEW lead now to two
*   different node types so DDL can tell which is which.
* 2001.06.13 Claudio Valderrama: SUBSTRING is being surfaced.
* 2001.06.30 Claudio valderrama: Feed (line,column) for each node. See node.h.
* 2001.07.10 Claudio Valderrama: Better (line,column) report and "--" for comments.
* 2001.07.28 John Bellardo: Changes to support parsing LIMIT and FIRST
* 2001.08.03 John Bellardo: Finalized syntax for LIMIT, change LIMIT to SKIP
* 2001.08.05 Claudio Valderrama: closed Bug #448062 and other spaces that appear
*   in rdb$*_source fields when altering domains plus one unexpected null pointer.
* 2001.08.12 Claudio Valderrama: adjust SUBSTRING's starting pos argument here
*   and not in gen.c; this closes Bug #450301.
* 2001.10.01 Claudio Valderrama: enable explicit GRANT...to ROLE role_name.
* 2001.10.06 Claudio Valderrama: Honor explicit USER keyword in GRANTs and REVOKEs.
* 2002.07.05 Mark O'Donohue: change keyword DEBUG to KW_DEBUG to avoid
*			clashes with normal DEBUG macro.
* 2002.07.30 Arno Brinkman:  
* 2002.07.30 	Let IN predicate handle value_expressions
* 2002.07.30 	tokens CASE, NULLIF, COALESCE added
* 2002.07.30 	See block < CASE expression > what is added to value as case_expression
* 2002.07.30 	function is split up into aggregate_function, numeric_value_function, string_value_function, generate_value_function
* 2002.07.30 	new group_by_function and added to grp_column_elem
* 2002.07.30 	cast removed from function and added as cast_specification to value
* 2002.08.04 Claudio Valderrama: allow declaring and defining variables at the same time
* 2002.08.04 Dmitry Yemanov: ALTER VIEW
* 2002.08.06 Arno Brinkman: ordinal added to grp_column_elem for using positions in group by
* 2002.08.07 Dmitry Yemanov: INT64/LARGEINT are replaced with BIGINT and available in dialect 3 only
* 2002.08.31 Dmitry Yemanov: allowed user-defined index names for PK/FK/UK constraints
* 2002.09.01 Dmitry Yemanov: RECREATE VIEW
* 2002.09.28 Dmitry Yemanov: Reworked internal_info stuff, enhanced
*							exception handling in SPs/triggers,
*							implemented ROWS_AFFECTED system variable
* 2002.10.21 Nickolay Samofatov: Added support for explicit pessimistic locks
* 2002.10.29 Nickolay Samofatov: Added support for savepoints
* 2002.12.03 Dmitry Yemanov: Implemented ORDER BY clause in subqueries.
* 2002.12.18 Dmitry Yemanov: Added support for SQL-compliant labels and LEAVE statement
* 2002.12.28 Dmitry Yemanov: Added support for parametrized events.
* 2003.01.14 Dmitry Yemanov: Fixed bug with cursors in triggers.
* 2003.01.15 Dmitry Yemanov: Added support for runtime trigger action checks.
* 2003.02.10 Mike Nordell  : Undefined Microsoft introduced macros to get a clean compile.
* 2003.05.24 Nickolay Samofatov: Make SKIP and FIRST non-reserved keywords
* 2003.06.13 Nickolay Samofatov: Make INSERTING/UPDATING/DELETING non-reserved keywords
* 2003.07.01 Blas Rodriguez Somoza: Change DEBUG and IN to avoid conflicts in win32 build/bison
* 2003.08.11 Arno Brinkman: Changed GROUP BY to support all expressions and added "AS" support
*						   with table alias. Also removed group_by_function and ordinal.
* 2003.08.14 Arno Brinkman: Added support for derived tables.
* 2003.10.05 Dmitry Yemanov: Added support for explicit cursors in PSQL.
* 2004.01.16 Vlad Horsun: added support for default parameters and 
*   EXECUTE BLOCK statement
* Adriano dos Santos Fernandes
*/

#include "firebird.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include <stdarg.h>

#include "gen/iberror.h"
#include "../dsql/dsql.h"
#include "../jrd/ibase.h"
#include "../jrd/flags.h"
#include "../dsql/errd_proto.h"
#include "../dsql/hsh_proto.h"
#include "../dsql/make_proto.h"
#include "../dsql/keywords.h"
#include "../dsql/misc_func.h"
#include "../jrd/gds_proto.h"
#include "../jrd/thd.h"
#include "../jrd/err_proto.h"
#include "../jrd/intlobj_new.h"

/* since UNIX isn't standard, we have to define
  stuff which is in <limits.h> (which isn't available
  on all UNIXes... */

const long SHRT_POS_MAX			= 32767;
const long SHRT_UNSIGNED_MAX	= 65535;
const long SHRT_NEG_MAX			= 32768;
const long LONG_POS_MAX			= 2147483647;
const int POSITIVE	= 0;
const int NEGATIVE	= 1;
const int UNSIGNED	= 2;

/*const int MIN_CACHE_BUFFERS	= 250;*/
/*const int DEF_CACHE_BUFFERS	= 1000;*/

/* Fix 69th procedure problem - solution from Oleg Loa */
#define YYSTACKSIZE	2048
#define YYMAXDEPTH	2048

/* Make bison allocate static stack */
#define YYINITDEPTH 2048

/* Using this option causes build problems on Win32 with bison 1.28*/
/*#define YYSTACK_USE_ALLOCA 1*/

typedef dsql_nod* YYSTYPE;
#define YYSTYPE YYSTYPE
#if defined(DEBUG) || defined(DEV_BUILD)
#define YYDEBUG		1
#endif

#define YYMALLOC gds__alloc
#define YYFREE gds__free

static const char INTERNAL_FIELD_NAME[] = "DSQL internal"; /* NTX: placeholder */

inline SLONG trigger_type_suffix(const int slot1, const int slot2, const int slot3)
{
	return ((slot1 << 1) | (slot2 << 3) | (slot3 << 5));
}


dsql_nod* DSQL_parse;


#define YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous

#include "../dsql/chars.h"

const int MAX_TOKEN_LEN = 256;

static const TEXT* lex_position();
#ifdef NOT_USED_OR_REPLACED
static bool		long_int(dsql_nod*, SLONG*);
#endif
static dsql_fld*	make_field (dsql_nod*);
static dsql_fil*	make_file();
static dsql_nod*	make_list (dsql_nod*);
static dsql_nod*	make_node (NOD_TYPE, int, ...);
static dsql_nod*	make_parameter (void);
static dsql_nod*	make_flag_node (NOD_TYPE, SSHORT, int, ...);
static void	prepare_console_debug (int, int  *);
#ifdef NOT_USED_OR_REPLACED
static bool	short_int(dsql_nod*, SLONG*, SSHORT);
#endif
static void	stack_nodes (dsql_nod*, DsqlNodStack&);
inline static int	yylex (USHORT, USHORT, USHORT, bool*);

static void	yyerror(const TEXT*);
static void	yyabandon (SLONG, ISC_STATUS);

inline void check_bound(const char* const to, const char* const string)
{
	if ((to - string) >= MAX_TOKEN_LEN)
		yyabandon (-104, isc_token_too_long);
}

inline void check_copy_incr(char*& to, const char ch, const char* const string)
{
	check_bound(to, string); 
	*to++ = ch;
}

struct LexerState {
	/* This is, in fact, parser state. Not used in lexer itself */
	dsql_fld* g_field;
	dsql_fil* g_file;
	dsql_nod* g_field_name;
	int dsql_debug;
	
	/* Actual lexer state begins from here */
	const TEXT* beginning;
	const TEXT* ptr;
	const TEXT* end;
	const TEXT* last_token;
	const TEXT* line_start;
	const TEXT* last_token_bk;
	const TEXT* line_start_bk;
	SSHORT	lines, att_charset;
	SSHORT	lines_bk;
	int  prev_keyword;
	USHORT	param_number;
	
	int yylex (
		USHORT	client_dialect,
		USHORT	db_dialect,
		USHORT	parser_version,
		bool* stmt_ambiguous);
};

/* Get ready for thread-safety. Move this to BISON object pointer when we 
  switch to generating "pure" reenterant parser. */
static LexerState lex;

static int yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,   11,   11,   11,   26,   26,
   25,   25,   25,   35,   35,   30,   36,   36,   36,   36,
   36,   29,   29,   34,   34,   31,   17,   17,   17,   39,
   39,   40,   40,   28,   28,   41,   41,   41,   41,   43,
   43,   43,   43,   42,   42,   44,   44,   44,   32,   32,
   49,   33,   33,   50,   50,    8,   51,   51,   53,   58,
   58,   58,   55,   55,   55,   62,   62,   63,   65,   65,
   65,   65,   56,   56,   66,   66,   67,   67,   67,   67,
   67,   52,   69,   69,    6,   71,   71,   71,   71,   71,
   71,   71,   71,   71,   71,   71,   71,   71,   71,   16,
   88,   88,   88,   88,   88,   88,    7,   95,   95,   95,
   72,   94,   98,  100,   73,   73,   76,   76,   76,   85,
  107,  107,  107,  108,  108,  109,  109,  110,  110,  114,
  114,   84,  117,  117,  123,  119,  119,  121,  121,  125,
  125,  126,  127,  127,  128,  129,   82,   86,   87,  134,
  134,  134,  135,  135,  137,  137,  138,  138,  138,  139,
  139,  140,  140,  141,  141,  136,  136,   83,  111,  111,
  142,  143,  143,  145,  145,  146,  146,  146,  146,  146,
  144,  144,  147,  147,  148,  148,  148,  115,  149,  150,
  150,  151,  151,  152,  152,  153,  153,  153,  113,  113,
  113,   78,   90,   79,   91,  156,  156,  156,  154,  154,
  154,  155,  155,  157,  157,  158,  158,  158,  163,  164,
  164,  103,  103,  160,  160,  122,  122,  116,  167,  168,
  168,  168,   64,  124,  124,  124,  124,  124,  124,  161,
  161,  175,  175,  176,  178,  178,  178,  178,  178,  159,
  177,  177,  181,  181,  181,  181,  183,  184,  185,  180,
  180,  179,  179,  179,  179,  179,  186,  187,  188,  188,
  188,  188,   77,   89,   96,  193,  189,  189,  190,  190,
  194,  194,  196,  195,  195,  199,  198,  198,  198,  191,
  191,  200,  200,  201,  205,  205,  206,  204,  204,  208,
  208,  208,  207,  210,  210,  192,  212,  212,  212,  213,
  213,  211,  211,  202,  203,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  216,  216,  216,  216,  222,  222,  223,
  219,  229,  230,  220,  227,  227,  224,  234,  218,  235,
  232,  232,  232,  232,  228,  231,  231,  226,  226,  226,
  233,  233,  214,  214,  239,  240,  240,  241,  241,  241,
  241,  225,  225,  225,  243,  245,  244,  246,   14,  247,
  247,  247,  248,  248,  248,   15,  250,  250,  251,  251,
  252,   81,   92,  166,  104,  106,  120,  255,  255,   80,
   80,   80,   93,   93,   93,   97,   97,   97,  256,  256,
  256,  257,  257,  262,  262,  262,  262,  262,  260,  260,
  261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
  261,  261,  261,  261,  261,  258,  258,  259,    2,  264,
  264,  264,  264,  264,  264,  264,  264,  264,  270,  270,
  274,  274,  274,  274,  274,  274,  274,  265,  265,  275,
  275,  275,  275,  275,  275,  275,  275,  275,  269,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  277,  277,  279,
  279,  278,  276,  276,  276,  271,  271,  272,  272,  272,
  273,  283,  283,  284,  284,  267,  268,  268,  285,  285,
  285,  285,  285,  266,  286,  286,  287,  287,   10,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  118,  118,  197,  197,  292,  292,  293,
  293,  162,  162,  291,  291,  297,  297,  299,  299,   59,
   59,  296,  296,  296,  296,  296,  296,  296,  296,  296,
  303,  303,  295,  295,  295,  295,  305,  305,  304,  304,
  304,   61,   61,  300,  300,  300,  298,  298,  298,  309,
  309,  309,  308,  308,  307,  307,  307,  301,  301,  310,
  310,  310,  311,  311,  302,  302,  302,  302,  312,  312,
   21,   21,   21,  314,  314,  314,   19,   19,   19,  316,
  317,  320,  320,  318,  322,  322,    5,   18,  321,  321,
  323,  323,  324,  324,  313,  325,  325,  326,  326,  327,
  327,  327,  327,  327,  327,  328,  328,  329,  329,  330,
  330,  334,  334,  334,  335,  335,  335,  336,  336,  336,
  331,  331,  331,  332,  333,  338,  338,  338,  339,  339,
  337,  337,  340,  342,  342,  341,  341,  315,    4,    4,
    4,  343,  345,  345,  345,  345,  345,  345,  345,  345,
  345,  345,  345,  345,  345,  345,  347,  347,  348,  344,
  344,   20,  349,  349,  351,  351,  350,  350,  254,  352,
  352,  352,  356,  356,  357,  360,  361,  353,  353,  353,
  362,  364,  365,  365,  365,  365,  373,  373,  373,  374,
  374,  374,  366,  366,  367,  367,  376,  376,  377,  377,
  378,  378,  368,  380,  380,  381,  381,  383,  383,  383,
  385,  386,  386,  359,  359,  387,  387,  382,  382,  382,
  388,  389,  390,  392,  392,  393,  394,  384,  384,  395,
  395,  396,  396,   27,  391,  391,  391,  391,  391,  397,
  397,  370,  370,  398,  398,  399,  371,  371,  369,  369,
  372,  372,  400,  401,  401,  401,  401,  401,  402,  402,
  403,  403,  404,  404,  405,  405,  405,  406,  406,  407,
  407,  354,  354,  408,  408,  409,   74,   74,   74,  410,
  410,  411,  411,  355,  355,  355,   12,   12,   12,   13,
  414,  414,  414,  414,  415,  416,  417,  418,    9,    9,
  420,  421,   22,   22,  423,  424,   23,  425,  425,  413,
  413,  413,  422,  419,  419,  217,  221,  221,    3,    3,
  430,  430,  430,  432,  432,  433,  431,  431,  434,  434,
   37,   37,  102,  101,  101,  412,  412,  426,  435,  435,
  237,  237,  237,  165,  427,  427,  130,  130,  130,  130,
  436,  436,  436,  436,  436,  436,  436,  436,  436,  436,
  436,  436,  436,  437,  437,  437,  437,  437,  437,  437,
  437,  443,  443,  443,  443,  443,  443,  443,  443,  443,
  443,  443,  443,  443,  443,  443,  443,  449,  449,  438,
  438,  439,  439,  440,  440,  440,  440,  441,  441,  445,
  445,  446,  446,  446,  446,  444,  447,  442,  442,  448,
  448,  448,  450,  450,  451,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  174,  174,  174,  458,  458,  452,  459,
  459,  249,  249,  169,  169,  460,  460,  460,  460,  460,
  454,  454,  454,  454,  454,  253,  170,  170,  171,  172,
  172,  172,  172,  172,   57,   57,   24,   24,  263,  461,
   60,  306,  282,  282,  112,  453,  453,  429,  429,  429,
  462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
  462,  462,  462,  466,  466,  463,  463,  467,  468,  468,
  468,  470,  471,  471,  472,  465,  465,  473,  473,  473,
  473,  473,  473,  473,  473,  473,  473,  473,  473,  473,
  473,  473,  473,  473,  473,  473,  473,  473,  473,  473,
  473,  473,  473,  473,  473,  473,  473,  473,  473,  473,
  473,  473,  473,  473,  473,  473,  473,  473,  473,  473,
  473,  474,  474,  474,  474,  474,  474,  474,  464,  464,
  464,  464,  475,  477,  477,  476,  476,  476,  476,  478,
  478,  478,  428,  428,  455,  456,  456,  480,  480,  480,
  480,  480,  481,  481,  483,  483,  486,  486,  484,  484,
  489,  489,  488,  485,  487,  482,  482,  457,  457,  469,
  469,  469,  469,  469,  469,  469,  469,  469,  469,  375,
  375,  363,  363,  173,  479,   54,   70,  133,  132,  294,
  182,  209,  290,   99,   68,  242,  131,   75,  379,  238,
  346,   38,   47,  358,  289,   45,   48,  236,   46,  319,
  281,  281,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,
};
static int yylen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,    8,    8,    5,    1,    0,
    1,    2,    1,    1,    3,    1,    1,    1,    1,    2,
    2,    3,    0,    3,    0,    1,    8,    8,    5,    3,
    0,    3,    0,    1,    1,    1,    3,    3,    3,    2,
    2,    2,    2,    1,    3,    1,    2,    2,    1,    3,
    1,    1,    3,    1,    2,    2,    2,    3,    8,    1,
    1,    5,    0,    1,    3,    1,    3,    3,    0,    2,
    2,    1,    1,    3,    3,    2,    0,    2,    2,    1,
    3,    9,    1,    1,    2,    2,    7,    2,    2,    4,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    4,    2,    2,    2,    4,    2,    2,    2,
    2,    2,    2,    2,    1,    0,    1,    1,    6,    6,
    1,    1,    0,    0,    1,    0,    4,    0,    1,    1,
    2,    8,    1,    0,    3,    1,    0,    1,    0,    1,
    2,    1,    1,    1,    2,    6,    1,    1,    6,    2,
    5,    0,    0,    1,    1,    2,    1,    1,    1,    2,
    2,    2,    2,    2,    2,    0,    1,    3,    0,    1,
    1,    0,    1,    1,    2,    3,    4,    2,    2,    3,
    0,    1,    1,    2,    1,    4,    3,    3,    1,    0,
    1,    1,    2,    3,    4,    0,    1,    2,    0,    1,
    1,    5,    5,    5,    5,    4,    4,    0,    3,    2,
    0,    1,    3,    1,    1,    6,    3,    2,    6,    1,
    3,    2,    1,    2,    2,    2,    0,    1,    1,    2,
    3,    1,    0,    1,    1,    1,    1,    1,    1,    0,
    1,    1,    2,    2,    1,    1,    5,    2,    3,    2,
    2,    0,    1,    1,    1,    1,    3,    4,    8,    4,
    0,    1,    1,    2,    2,    0,    3,    3,    1,    2,
    2,    2,    8,    8,    8,    8,    3,    0,    4,    0,
    1,    3,    6,    1,    3,    3,    3,    3,    0,    1,
    0,    1,    2,    6,    1,    1,    4,    1,    0,    2,
    2,    0,    6,    1,    1,    5,    1,    2,    0,    1,
    2,    4,    3,    0,    0,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    3,    1,
    3,    8,    9,    5,    8,    6,    3,    0,    3,    2,
    1,    1,    3,    3,    7,    2,    0,    1,    1,    2,
    3,    0,    1,    2,    4,    1,    3,    2,    2,    2,
    1,    1,    1,    1,    2,    2,    5,    0,    5,    1,
    3,    0,    2,    4,    0,    7,    3,    0,    1,    3,
    3,    7,    7,    0,    0,    0,    0,    3,    0,    6,
    8,    8,    6,    8,    8,    6,    8,    8,    1,    1,
    0,    2,    2,    1,    1,    2,    2,    2,    1,    1,
    1,    1,    1,    3,    3,    3,    3,    3,    3,    5,
    5,    5,    5,    5,    5,    2,    0,    4,    2,    2,
    3,    2,    2,    3,    3,    2,    2,    3,    1,    2,
    3,    3,    2,    2,    2,    2,    3,    1,    3,    3,
    3,    2,    2,    4,    4,    4,    5,    4,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
    1,    1,    1,    1,    0,    2,    2,    4,    4,    5,
    3,    2,    0,    2,    0,    0,    1,    2,    2,    4,
    3,    2,    2,    7,    1,    0,    1,    0,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    3,    2,    2,
    2,    2,    2,    1,    1,    1,    3,    1,    1,    3,
    1,    1,    1,    4,    5,    1,    3,    1,    3,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    4,    6,    5,    3,    0,    2,    2,
    0,    3,    0,    4,    1,    5,    4,    1,    4,    1,
    2,    2,    1,    1,    1,    2,    2,    2,    2,    0,
    3,    5,    1,    1,    2,    3,    1,    2,    3,    0,
    1,    1,    1,    5,    5,    6,    1,    1,    1,    2,
    4,    1,    0,    5,    1,    0,    3,    3,    1,    0,
    2,    0,    1,    0,    3,    1,    0,    1,    2,    1,
    1,    1,    1,    1,    1,    2,    2,    1,    2,    3,
    1,    1,    3,    3,    1,    2,    3,    1,    2,    0,
    3,    2,    2,    3,    2,    1,    1,    0,    1,    1,
    1,    3,    2,    3,    0,    1,    3,    4,    5,    6,
    7,    1,    1,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    1,    2,    1,    1,    1,    2,    1,
    1,    3,    3,    0,    2,    0,    2,    0,    4,    3,
    2,    0,    1,    3,    6,    4,    4,    1,    4,    4,
    1,    9,    2,    1,    1,    0,    2,    4,    2,    2,
    4,    2,    1,    1,    1,    1,    1,    3,    1,    3,
    1,    0,    2,    1,    3,    1,    1,    1,    1,    3,
    6,    1,    0,    3,    0,    1,    3,    1,    1,    1,
    4,    5,    5,    1,    1,    2,    4,    4,    2,    3,
    0,    1,    3,    1,    1,    2,    2,    2,    0,    1,
    0,    3,    0,    1,    3,    1,    2,    0,    2,    0,
    2,    0,    4,    1,    2,    1,    1,    0,    1,    3,
    2,    1,    1,    2,    1,    4,    3,    1,    3,    4,
    0,    3,    0,    1,    3,    3,    1,    1,    0,    2,
    0,    1,    1,    2,    4,    0,    9,    6,    6,    8,
    2,    2,    1,    1,    4,    5,    3,    6,    1,    1,
    8,    4,    1,    1,    9,    5,   12,    2,    0,    2,
    4,    0,    4,    1,    3,    3,    1,    1,    7,    7,
    5,    3,    0,    1,    1,    1,    2,    0,    1,    1,
    1,    0,    3,    1,    3,    1,    0,    3,    1,    3,
    1,    3,    3,    1,    1,    3,    1,    3,    3,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    1,    1,    5,
    6,    5,    6,    3,    4,    5,    6,    3,    4,    3,
    4,    3,    4,    4,    5,    4,    4,    3,    4,    1,
    1,    1,    1,    3,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    1,    1,    1,    3,
    1,    1,    1,    1,    2,    2,    3,    0,    4,    1,
    0,    1,    3,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    2,    2,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    1,    2,    1,    1,
    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,
    4,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    6,    6,    2,    0,    1,    1,    6,    1,    1,
    1,    4,    4,    4,    4,    4,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    7,    8,    8,    8,   10,    8,    6,    1,    1,
    4,    4,    7,    2,    0,    7,    6,    6,    4,    1,
    1,    1,    4,    3,    6,    1,    1,    6,    8,    6,
    6,    8,    1,    1,    4,    6,    4,    5,    3,    5,
    4,    5,    1,    1,    1,    3,    5,    4,    6,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    1,    0,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,
};
static int yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    7,    8,    9,
   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,    0,  651,  652,  653,  657,
  658,  659,    0,  879,  880,  883,  884,  556,    0,    0,
    0,    0,    0,    0,    0,    0,  459,  669,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  135,    0,
    0,    0,    0,    0,  105,    0, 1059,    0,   25, 1057,
    0,    0,   76,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  569,    0,
    0,    0,   39,   36,   38,    0,   37,    0, 1231, 1233,
 1234, 1235, 1236, 1237, 1238, 1259, 1260, 1239, 1241, 1240,
 1252, 1253, 1246, 1242, 1247, 1243, 1245, 1248, 1244, 1249,
 1250, 1251, 1255, 1256, 1254, 1257, 1258, 1262, 1261, 1263,
 1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273,
 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283,
 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293,
 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303,
 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313,
 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323,
 1324, 1325, 1326, 1327, 1328,    0,    0,    0,    0,   34,
   71,   69, 1223, 1232,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  812, 1225,    0,
    0,    0, 1224,  751,    0,    0,    0,    0,    0,    0,
    0,    0,  120, 1230,  660,    0,    0,    2,    0,    0,
    0,    0,  758,  761,    0,  491,  492,  493,  494,  495,
  496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
  506,  507,  508,  509,  510,  511,  519,  513,  514,  512,
  515,  516,  517,  518,  520,  522,  525,  521,  523,  524,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,    0,  489,  490,    0,  460, 1214,    0,    0,
  466, 1218,    0,  463, 1222,    0,  814,    0,  462, 1226,
    0,  467, 1217,    0,  667, 1055,    0,  191,  115,    0,
  116,    0,  248, 1210,  924,  106,    0,  113,  167,    0,
    0,  108,    0,  117, 1061,    0,  109,    0,  111,    0,
  112, 1229,  168,  118,  114,  119,    0, 1209,    0,  857,
  858,    0, 1060, 1058,    0,   77,    0, 1215,    0, 1213,
  577,  570,    0,  576,  581,  571,  572,  579,  573,  574,
  575,  580,  582,  583,    0,    0,    0,   32,    0,   41,
  911,   40,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  668,    0,    0,
    0,    0,    0,    0,    0,  688,    0,    0,    0,  675,
    0,  678,  680,  681,  682,  683,  684,  685,  691,  692,
    0,  781,    0,    0,  750,    0,    0,    0,  126,    0,
    0,  121,    0,  122,    0,  125,    0,  124,    0,    0,
    0,  722,  723,  730,    0,  729,  731,  733,  738,  726,
  724,  727,  725,  734,  737,  732,  736,    0,    0,    0,
    0,    0,  742,    0,    0,    0,    0,  765,    0,    0,
    0,    0,    0,    0,    0,    0,  557,    0,    0,    0,
    0,  253,    0,  469,  134,    0,  468, 1206,  546,  547,
    0,    0,    0,    0,    0,    0,  478,    0,  429,  430,
    0,    0,  673,  671, 1056,    0,    0,    0,    0,    0,
    0,    0,  194,  153,    0,  131,    0,    0,    0,  127,
    0,  142,  141,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   78,    0,    0,    0,    0,  882,  578,    0,
    0,    0,    0, 1019, 1052,    0, 1204,    0, 1021, 1118,
    0,    0,    0, 1132, 1053,    0, 1047, 1038, 1037, 1036,
    0,    0,    0,    0, 1024,    0,    0, 1039, 1040, 1048,
 1049,    0, 1050, 1051,    0,    0,    0, 1054,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1046, 1042,    0,  921,
 1016, 1017, 1018, 1023, 1022, 1001,    0,    0,    0, 1000,
    0,    0, 1005, 1067,  997,  998,  999, 1002, 1003, 1004,
 1041, 1066, 1068, 1069, 1070, 1086, 1087, 1089, 1090, 1091,
    0, 1097, 1149, 1150,    0, 1166, 1167, 1173, 1174,  249,
    0,    0,    0,  409,    0,    0,    0,  914,   29,    0,
    0,    0,    0,   74,   72, 1227,   70,   35,    0,    0,
    0,    0,  916,    0,    0,   50,   52,    0,    0,    0,
  665,    0,    0,  718,    0,    0,  689,    0,  686,    0,
  687,  716,    0,  711,    0,    0,    0,  703,  702,  679,
    0,  813,  925,  894,    0,    0,    0,  754, 1219,  796,
    0,    0,  132,    0,    0,    0,    0,    0,    0,  662,
  661,  735,  728,    0, 1221,    0,    0,    0,  743,  747,
 1065,    0,  767,  769,    0,  770,  772, 1200,  773,    0,
  774,  763,    0,    0, 1202,    0,    0,  749,  209,    0,
    0,  150,    0,  562,    0,  563,  558,  415,    0,  473,
  475,  474,  415,  416,  476,    0,  470,    0,    0,    0,
    0,  301,    0,    0,    0,  482,  483,    0,  539,    0,
    0,    0,    0,    0,    0,    0,  440,  439,    0,  565,
    0,    0,    0,  190,    0,    0,  199,    0,  198,    0,
    0,  205,  188,    0,  203,  195,    0,    0,  608,  643,
  611,    0,  644,    0,    0,  612,    0,    0,    0,  635,
  647,  607,  630,  609,  610,  605,  592,  415,  584,  585,
  593,    0,    0,  602,  603,  604,  606,    0,    0,    0,
    0,  130,    0,    0,  128,    0,  129,    0,  145,    0,
    0,  230,    0,    0,    0,  414,    0, 1208,    0,  110,
    0,  253,    0,    0,   86,    0,  104,    0,  103, 1207,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  927,  931,  932,  933,  934,  935,  936,  937,  938,  939,
  940,  941,  942,    0,    0,    0,    0,    0, 1043,    0,
    0,    0,    0,    0,    0,    0, 1044, 1045,    0, 1025,
 1026,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  370, 1228,
    0,    0,    0,    0,    0,    0,    0,    0,  399,    0,
    0,    0,    0,    0,  588,    0,    0,  589,  591,  600,
    0,    0,    0,  407,    0,    0,    0,  913,    0,    0,
   46,   75,    0,    0,   28,    0,    0,  919,    0,    0,
    0,    0,    0,    0,  786,  787,  788,  789,  798,  799,
  800,    0,    0,    0,    0,  664,  655,    0, 1063,  654,
    0,  690,  701,    0,  698,  694,  693,    0,    0,    0,
  713,  697,  704,    0,    0,    0,    0,  886,    0,    0,
  794,    0,    0,    0,    0,    0,  414,    0,  123,  741,
  740,  719,    0,    0,    0,    0,    0,    0,  776,    0,
    0,    0,  777,    0,    0,  854,  760,  759,    0,    0,
  151,    0,  561,    0,  472,    0,  471,  477,  552,    0,
  551,    0,    0,  297,  414,  271, 1211,    0,    0,  240,
  415,    0,    0,  238,    0,  414,    0,    0,    0,  276,
  270,  273,  274,  275,  481,  544,  543,  480,  479,    0,
    0,    0,    0,    0,    0,  434,  435,  433,    0,    0,
    0,  432,    0,  415,  549,    0,  548,    0,  196,  200,
    0,    0,  204,    0,    0,    0,  631,  632,  648,    0,
  645,    0,    0,  638,  636,  637,    0,    0,    0,    0,
  601,    0,    0,    0,    0,  639,  133,    0,    0,    0,
  414,    0,  229,    0,  232,  234,  235,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  253,   81,    0,    0,
   80,    0,    0,    0,  930,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  834,  836,    0,  831,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1190, 1191, 1192, 1193,
 1194, 1195, 1198, 1199, 1196, 1197,    0,    0,    0,    0,
    0,    0,    0,    0, 1179,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1160, 1162, 1161,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1014,  401,    0, 1015, 1010,    0,    0,    0,    0,
    0,    0,    0,    0,  371,  372,    0,    0, 1020,  923,
  922,    0,    0, 1164,    0,    0,    0,  306,    0,  411,
  410,    0,  304,  334,    0,  312,  335,  915,    0,    0,
    0,   73,    0,    0,    0,  869,    0,  918,    0,  868,
    0,    0,    0,    0,    0,    0,  815,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  656, 1064,  699,  712,
  707,  706,    0,  717,    0,  926,  895,    0,    0,  797,
    0,  414,    0,    0,    0,    0,    0,  720,  739,    0,
  768,  771,    0,    0,    0,    0,    0,    0,    0,  560,
    0,    0,  208,    0,  212,    0,    0,  155,  254,  255,
  256,  257,  258,  259, 1034,  554,  415,  302,    0,  242,
    0,  244,  417,  156,    0,  237,  415,  245,    0,    0,
    0,  484,  485,  488,  416,  540,  541,  486,  437,  438,
  436,    0,    0,    0,  456,    0,  550,  220,  221,  197,
    0,  207,  619,  620, 1062,    0,    0,    0,    0,    0,
  646,    0,    0,  417,    0,    0,  596,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  222,    0,  415,    0,  416,    0,    0,  170,    0,    0,
    0,    0,    0,    0,  175,  177,  178,  179,    0,    0,
   85,    0,    0,    0,    0,   93,   87,    0,    0,   92,
   88,    0,  893, 1212,    0,    0,  943,    0,    0,    0,
  969,  968,    0,    0,    0,  978,  993,    0,  988,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  929,
    0,  835,    0,    0,    0,    0,    0,    0, 1071,    0,
    0, 1151,    0,    0,    0,    0,    0,    0,    0,    0,
 1027,    0,    0,    0,    0,    0, 1175,    0,    0,    0,
    0,    0,    0,    0, 1188, 1092, 1093, 1094, 1152, 1095,
    0, 1159,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1029,    0,    0,    0, 1096, 1163,  590,
  246,  587,    0,  299,  406,  335,  313,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   56,   64,   66,
    0,   44,    0,    0,    0,  900,    0,  920,    0,    0,
  790,    0,    0,  820,  818,  816,    0,    0,  817,    0,
    0,  899,    0,    0,  709,  710,  714,    0,    0,  755,
    0,  223,    0,    0,  416,    0,    0,  721,  780,    0,
    0,    0,    0,  778,    0,  856,  855,    0,    0,    0,
    0,  213,    0, 1035,    0,  334,  241,    0,    0,    0,
    0,    0,  277,  487,    0,    0,    0,    0,    0,    0,
  567,  416,  206,    0,    0,  614,    0,  613,  649,    0,
  641,    0,    0,    0,  594,  622,    0,    0,  624,  627,
  629,  414,    0,    0,  334,    0,  140,    0,  233,    0,
    0,    0,  420,    0,  416,    0,  180,  183,  182,  185,
  184,  181,  187,  169,  176,    0,  107,    0,  138,    0,
   96,    0,    0,    0,    0,   90,   91,    0,  986,  987,
    0,    0,    0,    0,    0,    0,    0,    0,  989,    0,
    0,    0,    0,    0,    0,    0,  979,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  842,    0,    0,    0,  881, 1077, 1076,    0,
    0,  252,    0, 1073, 1072,    0, 1081, 1080, 1079, 1078,
    0, 1075, 1074,    0,    0, 1181,    0,    0,    0, 1180,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  757,  404,  374,
  373,  305,    0,    0,   68,   60,   61,   67,   62,   63,
    0,   26,    0,    0,   27,  906,  905,    0,  904,  902,
  910,  909,  907,    0,    0,    0,  810,  808,    0,    0,
  870,    0,    0,  801,    0,   47,   48,    0,    0,  334,
    0,    0,  423,  416,    0,    0,    0,    0,  862,  863,
  860,    0,  218,  214,  416,  415,  415,  417,  416,    0,
    0,  262,    0,    0,    0,  278,    0,    0,    0,    0,
    0,    0,    0,  564,  616,    0,  617,    0,    0,    0,
    0,  160,  162,  163,  164,  599,  597,  595,  626,    0,
    0,    0,  416,  416,    0,  416,  334,  416,    0,  412,
    0,    0,  224,  415,   94,    0,    0,  100,   95,    0,
    0,    0,    0,    0,  994,    0,  995,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  844,  833,    0,
    0,  845,    0,  841,    0,  250, 1165, 1189, 1148, 1088,
    0,    0, 1177, 1176,    0, 1182, 1168, 1170,    0, 1157,
 1158,    0,    0,    0,    0,    0,    0,    0, 1171,    0,
 1083, 1082,    0,    0,  318,    0,    0,   57,   58,   59,
   65,    0,    0,  867,  792,    0,  802,    0,    0,    0,
  871,    0,  872,    0,    0,  803,  804,  805,    0,  885,
  416,  416,  416,  413,  225,    0,    0,    0,    0,  215,
  166,    0,    0,  303,  296,  236,  263,    0,    0,    0,
  265,  266,  264,    0,    0,    0,  454,  455,  451,  450,
  453,  452,  615,  642,  165,  152,  161,  334,    0,    0,
  426,  293,  147,  421,  458,  422,  418,  171,    0,    0,
    0,   98,    0,   82,    0,  955,  963,    0,    0,  956,
  964,  959,  967,    0,    0,  957,  965,  958,  966,  952,
  960,  953,  961,  954,  962,  840,    0,    0,  251,    0,
 1153, 1178,    0, 1156, 1142,    0,    0,    0,    0,    0,
    0,  325,  335,  330,  324,    0,    0,    0,    0,  315,
  316,    0,    0,   42,  901,  791,    0,    0,    0,    0,
    0,  294,  424,  425,    0,    0,  824,    0,  762,  307,
  308,    0,    0,  268,  239,    0,  280,  416,  416,  416,
    0,    0,    0,   79,  101,  102,  756,    0,    0,    0,
  847, 1169, 1143, 1144, 1145,    0, 1172,    0, 1147,    0,
  326,    0,  331,    0,  383,    0,  314,    0,    0,    0,
  875,    0,    0,    0,    0,  269,    0,    0,    0,    0,
    0,  295,  427,  428,  227,  226,    0,    0,  846,    0,
    0,    0,    0,    0,  353,    0,    0,    0,  352,    0,
    0,    0,    0,  398,  341,  337,  338,  343,    0,  339,
  340,    0,  333,  336,  342,  344,  345,  346,  347,  348,
  349,  350,  351,  354,  355,  356,  357,    0,    0,  392,
  393,  394,    0,  897,  898,  391,    0,    0,    0,    0,
  386,  384,    0,    0,    0,  876,    0,  807,  888,  887,
  825,    0,    0,    0,  279,    0,  285,    0,  284,  139,
  849,    0, 1146,    0,    0,    0,    0,  380, 1220,  395,
  396,    0,    0,  332,    0,    0,  376,  390,  389, 1216,
  388,  334,    0,    0,    0,  317,    0,    0,    0,  267,
    0,    0,  289,  288,  287,  850,    0,    0,    0,  367,
    0,    0,    0,    0,    0,  385,  387,  320,  321,    0,
    0,  292,  290,  291,    0,    0,    0,    0,    0,    0,
  323,    0,    0,  334,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  334,  878,  334,    0,    0,  334,  375,
  365,  334,  381,  362,  363,
};
static int yydgoto[] = {                                      22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45, 1866,  216,  710,  238, 1635, 1862,  217,
 1020,  218,  713, 1025,  219,  220,  400, 1033,  231,  232,
 1636, 1637, 1638, 1639,  328,  360,  221, 1640,  222,  715,
   93,  376,  553,  506,  913, 1504,  658, 1210,  877,  353,
 1181,  914,  915,  916, 1511, 1506, 1959,  377,  918,  919,
   85,  346,   86,  372, 2188, 1757,  352,  357,  910,  359,
  361,  348,  339,  341,  354,  364,  366,  253,  452,  454,
 1079,  458,  456,  449,  540,  895,  897,  892,  316,  317,
  707,  401, 1120, 1104,  929, 1107,  544,  900, 1479, 1737,
  845, 1049, 1450,  801,  802,  825,  535,  878, 1423, 1698,
 1930, 1328, 1424, 1408, 1931, 1932, 1933, 1934, 1935,  930,
  349,  367,  907, 1202, 1493, 1754, 1494, 1495, 1496, 1497,
 1498,  340,  531,  853,  532,  533,  854,  855,  803, 1403,
 1404, 1405, 1691,  546, 1194, 1953, 1195, 1196, 1197, 1122,
 1910, 1005, 1124, 1125,  660, 1200,  701, 1813, 1409,  661,
  662,  663,  664,  665, 1911, 1912,  828, 2073, 2219, 1703,
 1131, 1116, 1132, 1133, 1134, 2220, 2221, 2334,  512,  706,
 1334, 2142,  324,  821, 1332,  822, 1006, 1908,  702, 1335,
 1336, 2143, 1628, 2026, 2149, 2150, 2151, 2326, 1513, 2144,
 2145, 2146, 2147, 2204, 2252, 2253,  754, 2255, 2256, 2257,
 2258, 2259, 2260, 2261, 2262, 2263, 2264, 2265, 2266, 2267,
 2268, 1314, 2373, 2340,  666,  989,  667, 2269, 2205, 2280,
 2281, 2319, 2270, 2271, 2272, 2312,  668,  999,  669,  397,
  703,  704,  670,   46, 1745,  521,  840, 1154, 1485,  841,
 1152, 1148,   90,   67,  516,  329,  265,  496,  313,  503,
  321,  332,  507,  504,  517, 1138,  518,  835, 1438,  314,
  671, 1465,  819, 1111,  497,  842, 1712,  109,  327,  381,
  880, 1007, 1008,  345,  881, 1010, 1466, 1011, 1467,  884,
  885,  886,  887, 1166, 1459, 1457,  888,  889,  890, 1174,
  891, 1171,   47,   48,   49,   50,   51,   52,  255,  771,
   69,  732,  335,  524,  430,  431,  432,  433,  434,  435,
  436,  437,  438,  439,  440, 1056,  743, 1373, 1667,  744,
  745, 1061,  478, 1082,  479,  776,  480, 1085,  260,  483,
  779, 1775,  262,  491,  798,  244,  245,  672,  448, 1776,
  988,  263,  796,  264,  486,  790, 1091, 1395,  557, 1898,
 2059,  945,  487,  488,  791, 1092, 1093,  443,  760, 1680,
 1034, 1035, 1036, 1037, 1038, 2036,  761, 1039, 1040, 1041,
 1363, 2046, 2047, 2048, 1355,  241, 1655, 2166, 2167, 1803,
 1240, 1804, 1805, 1806, 1994, 2189, 2191, 1095, 1096, 1686,
 1901,  722, 1346, 1881, 1882, 1883, 2211, 2286,  756,   54,
   55,  558,   56,   57, 2214,  723,  757,  673,  674, 1344,
 1646, 1868, 1869, 1873, 1029,  931,  932,  933,  934,  935,
  936,  937,  938,  939,  940,  941,  942,  943, 1524, 1526,
 1527,  675,  676,  677,  678,  679,  680,  960, 1323,  681,
  374,  682,  683,  684,  685, 1845,  686,  687, 1267,  688,
  689,  690,  691,  692,  693,  694, 2002, 1290,  695,  696,
  697, 1843,  698,  699,  966, 1273, 1590, 1585,  967,  224,
};
static int yysindex[] = {                                  25796,
 3122, -149, 3081,  102, 1287,  263,25823, -118,38639,  588,
  337,   55,  -62, -149,  991,42380,42972,  847,43120,  320,
  544,    0, 1022,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  778,    0,    0,    0,    0,
    0,    0,  717,    0,    0,    0,    0,    0,42676,43120,
  817,43120,43120,43120,43120,43120,    0,    0,  781, 1157,
43120,43120,43120,  945,43120,  786,43120,43120,    0,43120,
43120,43120,43120,  695,    0,  986,    0,  878,    0,    0,
 1017,43120,    0,43120,43120,43120, 1060,43120,43120,43120,
43120,  786,43120,43120,43120,43120,43120,43120,    0,43120,
 1393, 1111,    0,    0,    0, 1418,    0, 1418,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1143, 1182,  135, 1517,    0,
    0,    0,    0,    0,43120,43120,43120,43120, 1169, 1191,
 1987,43120,  989,43120, 1242, 2495, 1249,    0,    0, 1331,
 1231,43120,    0,    0, 1601, 1613,43120,43120,43120,43120,
43120, 1081,    0,    0,    0,43120, 3125,    0, 1265, 1279,
    0,  469,    0,    0, 1525,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  736,    0,    0, 1157,    0,    0,43120,   37,
    0,    0, 1689,    0,    0, 1622,    0,   43,    0,    0,
 1217,    0,    0, 1324,    0,    0, 1307,    0,    0, 1069,
    0, 1499,    0,    0,    0,    0, 1157,    0,    0,  470,
 1689,    0,   16,    0,    0, 1459,    0,  772,    0, 1418,
    0,    0,    0,    0,    0,    0, 1473,    0, 1390,    0,
    0, 1519,    0,    0,43120,    0, 1524,    0, 1415,    0,
    0,    0,43120,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,33602,43120, 1471,    0,43120,    0,
    0,    0, 1441, 1490,42528,43120,  844, 1550,  129, 1399,
 1583, 1590, 1594, 1536, 1540,  182, 1424,    0, 1505,43120,
 1570,  -18,    3,43120, 1542,    0, 1403, 1408, 1438,    0,
 2495,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1639,    0,43120,43120,    0,43120,43120, 1709,    0, 1157,
 1689,    0, 1459,    0,  959,    0, 1418,    0, 1562, 1619,
 1580,    0,    0,    0, 1678,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1665,43120,43120,
 1629, 1513,    0,  108,  150,   71,    0,    0, 1738,  580,
 1510,  362, 1520, 1521, 1527, 1525,    0, 1126,  566, 1740,
43120,    0,  736,    0,    0, 1741,    0,    0,    0,    0,
43120, 1471,41558, 1596,41708, 2024,    0,42676,    0,    0,
   78, 1627,    0,    0,    0, 2018, 2018, 1157, 1728, 1157,
  452, 1069,    0,    0,36061,    0,43120,43120,43120,    0,
 1471,    0,    0, 1802,  637, 2049,43120,   78, 1845,43120,
43120,43120,    0, 2072,35535,26240, 1714,    0,    0, 2073,
 2074, 2076, 1668,    0,    0, 2081,    0, 2083,    0,    0,
 2084, 2085,    0,    0,    0, 2086,    0,    0,    0,    0,
    0, 2087, 1677, 1679,    0, 2090, 2090,    0,    0,    0,
    0, 2096,    0,    0,30613, 2097, 2106,    0, 2108, 1801,
 2113, 2116, 2117, 2119, 2122, 2125,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2134, 2142, 2143,    0,    0,    0,    0, 2145,
    0,    0,    0,    0,    0,    0,    0, 2148,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,33934,33934,30945,43120,    0,    0, 4830,    0,
    0,    0,    0,    0,    0,    0, 2079, 1791, 2120,    0,
    0, 2147,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2158,    0,    0,    0, 2162,    0,    0,    0,    0,    0,
41083, 2149, 1587,    0, 2168, 1948, 1605,    0,    0,43120,
43120,43120,   91,    0,    0,    0,    0,    0,43120, 1776,
43120,  516,    0,34931,43120,    0,    0, 1441, 1819,42528,
    0,43120,  101,    0,  699, 1683,    0, 1779,    0, 1779,
    0,    0, 2178,    0, 1912, 1807,  786,    0,    0,    0,
43120,    0,    0,    0, 2183,   94, 2169,    0,    0,    0,
 1699, 2191,    0, 1471, 2195,43120,   78, 1974,43120,    0,
    0,    0,    0,  737,    0, 1902, 2194,43120,    0,    0,
    0,33934,    0,    0,33934,    0,    0,    0,    0,31277,
    0,    0,33934,  717,    0,  717,33934,    0,    0, 1901,
 1906,    0, 1157,    0, 1908,    0,    0,    0, 1970,    0,
    0,    0,    0,    0,    0,36061,    0, 1157, 1893,41083,
 1705,    0, 2006,43120,40429,    0,    0,  988,    0,43120,
 1267, 1622, 1870, 1844,  482,    0,    0,    0,  644,    0,
  634, 1883,  154,    0, 1826,  786,    0, 1157,    0, 2002,
 1934,    0,    0,  452,    0,    0,  147, 1841,    0,    0,
    0, 1842,    0, 1891, 2241,    0, 1941, 2243,  670,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2196,  160,    0,    0,    0,    0,  122, 2251, 2252,
 2243,    0, 1157, 1689,    0, 1142,    0, 2029,    0, 1157,
 1157,    0,41558,   43, 1883,    0, 1977,    0, 2256,    0,
 1923,    0, 1898, 2260,    0,32934,    0, 1925,    0,    0,
 1940, 2267,26904, 2273,    0,    0,    0,26572,25026,   39,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  984, 1937, 1054,33934,  625,    0,43120,
33934, 1117, 1179,33934, 1226, 3524,    0,    0,  786,    0,
    0,33934,26904,30945, 4830, 1877,    1,33934,33934,26904,
 2009,33934,33934,33934,33934,33934,27236,25908, 3524,33934,
 1299,33934, 1065, 1065, 4830, 1720,  717, 2281,    0,    0,
43120,33934,33934,33934,33934,33934,33934,34476,    0,33934,
35088,33934,31609, 1949,    0, 2048, 1955,    0,    0,    0,
 2052, 2265,43120,    0,43120,    0,43120,    0, 1907, 1909,
    0,    0, 1874,42528,    0, 2019, 1810,    0, 1724, 2304,
 1810,34624, 2306, 1330,    0,    0,    0,    0,    0,    0,
    0, 2019,43120,43120, 2310,    0,    0,  -99,    0,    0,
  497,    0,    0, 1914,    0,    0,    0,43120,  739,43120,
    0,    0,    0, 2318,43120,43120, 1714,    0,33934,43120,
    0, 1910, 2095,41558,   43, 1883,    0, 2321,    0,    0,
    0,    0,  737,43120, 2025, 2328, 2702, 2725,    0, 2762,
 2056, 2334,    0, 2443, 2335,    0,    0,    0, 1445, 1157,
    0,  446,    0, 2325,    0, 2491,    0,    0,    0, 1157,
    0, 2048,43120,    0,    0,    0,    0, 2107, 1851,    0,
    0, 1740,  -36,    0, 2341,    0, 2042, 2051, 1418,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  786,
43120, 2092, 1740,41410, -124,    0,    0,    0, 2012, 2014,
 2015,    0,  786,    0,    0, 1034,    0, 1310,    0,    0,
 1988, 1157,    0,35535,  106, 1989,    0,    0,    0,  786,
    0, 2241,  115,    0,    0,    0, 1740,  115, 1996,  115,
    0, 2358,  786,  786,  786,    0,    0, 1471,43120,   78,
    0, 2057,    0, 1753,    0,    0,    0,   78,   11, 1910,
41857,  424,41558,43120, 1759,  184,    0,    0, 2363,  803,
    0,35535,43120, 1910,    0, 1910,24723,  116,33934,33934,
27575, 2364, 1056,27914,33934,28253,  963,28592,28931,31941,
29270,29609,29948,26904,26904,    0,    0, 2046,    0, 2370,
 1510,33934,33934, 2832,33934, 2372,33934, 2371, 2756,33934,
33934,33934,33934, 1733,33934,33934,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2102, 2373, 1763,  557,
 2871,33934,  529,33934,    0,26904, 3124, 3667,  776,43120,
 2888, 3211, 3367, 3376, 3401,    0,    0,    0, 1971,32273,
    0,    0,    0,    0,  897, 2379,  281, 4020,33934,33934,
  121,    0,    0,  469,    0,    0, 2144,  864,  864, 1065,
 1065, 1038,35685, 2380,    0,    0, 2383, 4830,    0,    0,
    0, 2120, 2385,    0, 1824,43120,43120,    0, 2082,    0,
    0, 1830,    0,    0,    0,    0,    0,    0,42045,42045,
 2058,    0,  483, 2088,33934,    0,43120,    0,33934,    0,
 2401, 1350, 2403,33934, 1331, 2070,    0, 2070, 1027,26904,
 2070, 2121, 2123, 2088, 2139, 2150,    0,    0,    0,    0,
    0,    0,  725,    0, 2030,    0,    0, 1937, 4830,    0,
 2406,    0, 1838,   78,   14, 1910,41558,    0,    0,  737,
    0,    0,43120,34931, 2016,33934, 1975,33934,33934,    0,
 2018, 2198,    0,  446,    0,26904, 1401,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2205,    0,    0,    0, 1851,    0,    0,    0, 1418, 1418,
 1979,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  558,   24,   26,    0, 2208,    0,    0,    0,    0,
43120,    0,    0,    0,    0,  102, 1855, 2060, 2052, 2434,
    0, 1826, 1876,    0, 2418, 1282,    0,43120, 1388,  786,
 2437, 2442, 2446, 2225,   43, 1883,    0, 2018, 1906,41558,
    0, 1883,    0,43120,    0, 2053, 2454,    0, 1920, -228,
  926, 1918, 1157,  424,    0,    0,    0,    0, 1886,34782,
    0,  786, 2114, 2199,32934,    0,    0,  786,  542,    0,
    0, 2204,    0,    0, 2460, 2461,    0, 3299, 4830, 2471,
    0,    0, 4830, 2472,30945,    0,    0, 2201,    0,  938,
 2480, 4830, 2481, 2596, 2489, 4830, 2490,33934,33934, 2364,
33934,32605, 2500, 4830, 2502, 2503, 4830, 2508,33934, 4830,
 2510, 4830, 2532, 2539, 4830, 2544, 2546, 4830, 2565,    0,
 2348,    0,42232, 1810, 3419, 3487,43268, 3632,    0, 3680,
33934,    0, 3725, 3771, 3969, 3985,33934, 4033, 4078,33934,
    0,33934,33934, 4830, 2200,33934,    0,33934, 4830, 2320,
  686,33934,33934,33934,    0,    0,    0,    0,    0,    0,
33934,    0,33934, 1985, 2202,33934,33934,33934,33934, 4373,
 4373,33934, 1510,    0, 1890,35685,35237,    0,    0,    0,
    0,    0,43120,    0,    0,    0,    0, 2332,43120,43120,
43120,43120,43120,43120, 2186, 2588, 2592,    0,    0,    0,
 2186,    0,  214,  214,   66,    0,  157,    0, 1897, 1331,
    0, 1933,43120,    0,    0,    0, 2298,  611,    0,34931,
34931,    0,42045,42045,    0,    0,    0, 2606, 1510,    0,
    0,    0, 1883,43120,    0, 2053, 1938,    0,    0, 2604,
 1350,26904, 2324,    0,  904,    0,    0, 4830, 1826, 2277,
 1826,    0,  140,    0,  123,    0,    0, 2366,33934, 2264,
 1979,  986,    0,    0, 2286, 2292, 2295, 2296, 2297, 2299,
    0,    0,    0, 2637,  102,    0, 2230,    0,    0,  115,
    0,   47,  115,  115,    0,    0, 2052, 2639,    0,    0,
    0,    0,   78,   70,    0, 1826,    0, 1906,    0, 2208,
    0, 2208,    0, 2405,    0, 1157,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2311,    0, 2328,    0, 2644,
    0, 2649, 1157,  465, 2650,    0,    0, 1157,    0,    0,
33934, 1910, 1910, 1947,  717, 2652,33934, 2368,    0, 1910,
 1910,33934, 1910, 1910, 4715, 4830,    0, 2616,33934, 4830,
 1910, 1910, 1910, 1910, 4830, 1910, 1910, 1910, 1910, 1910,
 1910,43120,    0, 2654, 2655, 1129,    0,    0,    0, 2326,
36061,    0, 2657,    0,    0, 4124,    0,    0,    0,    0,
 4244,    0,    0, 4304, 2130,    0,33934, 2400, 2280,    0,
33934, 4322, 1952, 4726, 4338, 4386,33934,33934, 4784, 1502,
 5010, 5044, 1994,33934, 2666, 2668, 2124,    0,    0,    0,
    0,    0, 2440, 2274,    0,    0,    0,    0,    0,    0,
 2388,    0,42045,42045,    0,    0,    0, 2288,    0,    0,
    0,    0,    0,35685, 1810,43860,    0,    0,34931, -107,
    0, 2275, 2276,    0, 1850,    0,    0,33934, 1810,    0,
 2208, 2208,    0,    0, 2311,34931, 2448, 2389,    0,    0,
    0, 1310,    0,    0,    0,    0,    0,    0,    0, 2048,
 2366,    0,  595, 4830,43120,    0, 2386, 2289, 2393, 2290,
 2430, 2395, 2432,    0,    0, 2690,    0, 2693, 2402, 2048,
   47,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1883,43120,    0,    0, 1310,    0,    0,    0, 2359,    0,
 2696, 2462,    0,    0,    0, 2384,  507,    0,    0, 2052,
 2391, 4830, 2711, 2716,    0,  469,    0, 4830,33934, 2718,
 2720, 4830, 2721, 2722,33934,33934, 4830, 2723, 2728, 2730,
 2739, 2741, 2743, 2744, 2747, 2748, 2749,    0,    0,42232,
 2755,    0,43120,    0,43120,    0,    0,    0,    0,    0,
33934, 2759,    0,    0,33934,    0,    0,    0,33934,    0,
    0, 4431, 4477,33934,33934,33934,33934,33934,    0, 4830,
    0,    0,33934,    0,    0,43120, 2419,    0,    0,    0,
    0,  214, 2380,    0,    0, 1613,    0, 2233, 2387, 2435,
    0, 2246,    0,26904, 2770,    0,    0,    0, 1995,    0,
    0,    0,    0,    0,    0, 1350,33934,26904, 1714,    0,
    0, 2491, 2491,    0,    0,    0,    0, 2476,43120, 1979,
    0,    0,    0, 2771, 1418,43120,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2208, 2208,
    0,    0,    0,    0,    0,    0,    0,    0,  -64,33934,
 1157,    0, 2369,    0, 1157,    0,    0, 1510, 4830,    0,
    0,    0,    0, 4830, 4830,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,43120, 2494,    0, 4830,
    0,    0, 4597,    0,    0, 4657, 4675, 4691, 4830, 2624,
 2504,    0,    0,    0,    0, 2518, 2390,41083, 2769,    0,
    0, 2541,    0,    0,    0,    0, 2408, 2396,   39,43120,
 2268,    0,    0,    0, 4830, 2791,    0,   39,    0,    0,
    0, 1979, 1418,    0,    0, 2465,    0,    0,    0,    0,
 2336, 2338, 4830,    0,    0,    0,    0, 2797, 2807, 2809,
    0,    0,    0,    0,    0,33934,    0,33934,    0,40102,
    0,  655,    0, 2390,    0, 2048,    0, 2536, 2519, 2447,
    0, 2007, 2318, 1810,33934,    0, 2465,  443, 1979, 2477,
 2482,    0,    0,    0,    0,    0, 2814,43120,    0,43120,
 4830, 4739,43120,  397,    0, 2818, 2528,33934,    0,    0,
43120,43120,43120,    0,    0,    0,    0,    0, 2530,    0,
    0, 2808,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  484, 2811,    0,
    0,    0,    0,    0,    0,    0,43120,43120,  102,  481,
    0,    0,  226, 2830, 2318,    0,43120,    0,    0,    0,
    0, 1979,  -44,  -44,    0, 2573,    0, 2439,    0,    0,
    0, 2835,    0,33934,33934,26904, 4830,    0,    0,    0,
    0,43120,35685,    0,  572, 2840,    0,    0,    0,    0,
    0,    0,  655, 2491, 2491,    0, 1910, 2449, 2837,    0,
 2428,  545,    0,    0,    0,    0, 4830, 1708,  227,    0,
 2547, 2380, 2397, 2549,26904,    0,    0,    0,    0, 2847,
 2849,    0,    0,    0,35685, 2464,35685,33934,35685,  384,
    0,33934, 2380,    0, 2380, 1865,  158, 2594, 2008, 2593,
35685, 2609, 2599,    0,    0,    0,  615,43120,    0,    0,
    0,    0,    0,    0,    0,
};
static int yyrindex[] = {                                   2499,
    0,  206,  785,    0,    0,    0,    0,    0,    0,    0,
    0,    0,38854,  255,    0,    0,    0,    0,    0,    0,
    0,    0, 2903,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1099,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2578,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   22, 2540,    0,    0,    0,  236,    0,  236,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2542,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1099,    0,    0, 1108,    0,    0,    0, 2023,
    0,    0,    0,    0, 2511, 2656,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  401,
32938,  369,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  422,    0,    0,    0,    0,  253,    0,    0,
    0,    0,    0, 1185,    0,    0,    0,    0,    0,  256,
    0,36426,    0,    0,    0,    0,    0,    0,    0,    0,
  422,    0,  605,    0,    0, 2881,    0,  777,    0, 2658,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  152,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  170,    0, 2659,    0,    0,    0,
    0,    0,43416,    0,    0,    0,    0,    0, 1274,    0,
    0,    0,    0,    0,    0,    0,43564,    0,    0,    0,
    0,    0,    0,    0,  257,    0,    0,    0,    0,    0,
 1220,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  422,    0, 2881,    0,  777,    0, 2658,    0,    0, 1236,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  231,    0,    0,    0,    0,33270,30281,    0,    0, 2520,
  248,    0,    0,    0,    0, 1263,    0,    0,    0,    0,
    0,    0, 1312,    0,    0,  254,    0,    0,    0,    0,
    0, 2659,  994,42824,    0, 1376,    0,    0,    0,    0,
  641,    0,    0,    0,    0, 2483, 2483,    0,    0,    0,
 1382,  285,    0,    0,    0,    0,    0,    0,    0,    0,
 2659,    0,    0, 1295,    0,    0,    0,    0,    0,    0,
    0,    0,    0,25767,    0,    0,  208,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3293,    0,    0,    0,    0, 2732, 2732,    0,    0,    0,
    0,18114,    0,    0,    0,19854,20202,    0,20550,20898,
    0,    0,    0,    0,    0,    0, 3646, 3999, 4352, 4705,
 5058, 5411, 5764, 6117, 6470, 6823, 7176, 7529, 7882, 8235,
 8588, 8941,18462,18810,21246, 9294, 9647,10000,10353,21594,
10706,11059,11412,11765,12118,12471,12824,19158,13177,13530,
13883,14236,14589,14942,15295,15648,16001,16354,16707,17060,
17413,17766,    0,    0, 2499,    0,    0,    0,  914,    0,
    0,    0,    0,    0,    0,    0,21942, 1407,  193,    0,
19506,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1411,    0,    0,    0,    0,    0,    0,    0,
    0, 2499,    0,    0,    0,    0,    0,43416,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1275,    0, 1275,
    0,    0,  792,    0,  828, 1273,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  152,    0,    0,    0,    0,
    0,    0,    0, 2659,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1425,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1414,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1257,    0,  527,    0,    0,  819,    0,    0,    0,    0,
    0,  215,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1423,    0,    0, 1171, 1309,    0,    0,
    0, 1903,    0,    0,25599,    0,    0,25611,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  578, 1461,    0,    0,    0,    0,25845, 3085,    0,
25611,    0,    0,  422,    0,  777,    0,    0,    0,    0,
    0,    0,  994,  777,  546,    0,  113,    0,    0,    0,
    0,    0,    0, 2524,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,36246,36375,36550, 2499,    0,  299,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2894,  237,34266,    0,34266,    0,    0,
    0,34266,34266,    0,34266,    0,    0,    0,    0,    0,
    0,    0,    0, 2499, 2496,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
34266,    0,22638,22986, 2893,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2901,    0,  842,    0, 1645, 1237,    0,    0,    0,
36507,    0,    0,    0,    0,   85,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  279, 1464,    0,    0,    0,
 1464, 2499,24671, 2607,    0,    0,    0,    0,    0,    0,
    0,  279,    0,    0, 1477,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  752,    0,
    0,    0,    0, 2512,    0,    0,  208,    0,    0,    0,
    0, 2499,    0,  994,  777,  546,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  533,    0,    0,    0,35385,
    0, 2631,    0,  295,  534,    0,    0,    0,  329,    0,
    0,  161,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  885,    0,    0,    0,    0,    0, 2909, 1757,    0,
    0, 1919,20912,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  548,  784,
  836,    0,    0,    0,    0,    0,    0, 1537,    0,    0,
    0,    0,    0,    0,    0, 1857,    0,    0,    0,    0,
    0,25599,    0,    0,    0,    0,  839,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2659,    0,    0,
    0,  269,    0,    0,    0,    0,    0,    0,    0, 2499,
    0,  136,  994,    0,    0,36027,    0,    0,    0,  247,
    0,    0,    0, 2499,    0, 2499,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2911,    0,    0,
  124,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1485, 2610, 2910, 2929,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   92,    0,    0,22290,24028,24374,23334,
23682,    0,    0, 1480,    0,    0,    0, 1124,    0,    0,
    0, 2917,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  539,    0,    0,    0,    0,    0,
    0,    0,    0, 1493,    0,    0,    0,    0,    0,    0,
    0, 2607, 1348,    0,25258, 2611,    0, 2611, 2607,    0,
 2611,    0,    0, 1493,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  237,  309,    0,
    0,    0,    0,    0,    0, 2499,  994,    0,    0,    0,
    0,    0,    0,    0, 2377,    0,  444,    0,    0,    0,
 2483, 2531,    0, 1359,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   85,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1548,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1506,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1939,    0,
    0,    0,    0,    0, 1450,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  777,  546,   85, 2483, 1511,  994,
    0, 2695,    0,    0,    0, 1515,    0,    0,    0,    0,
    0,    0, 1522,  243,    0,    0,    0,    0,    0,    0,
    0,    0,36027,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,25606,    0,
    0,    0,36669,    0, 2499,    0,    0,    0,    0,    0,
    0,36749,    0,36892,    0,36912,    0,    0,    0,    0,
    0,    0,    0,37031,    0,    0,37129,    0,    0,37265,
    0,37387,    0,    0,37422,    0,    0,37480,    0,    0,
38471,    0, 2894, 1464,    0,    0,37200,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2534,    0,    0,    0,    0,  681,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2920,
 2920,    0, 2940,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  249, 1535,  145,  176,    0,    0,    0,
 1535,    0,    0,    0,    0,    0, 1560,    0,    0,24973,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  124,    0,
   85,    0, 2695,    0,    0, 1515,    0,    0,    0, 2315,
 2308,    0, 1088,    0,    0,    0,    0,  532,    0, 2533,
    0,    0,    0,    0, 2040,    0,    0, 1328,    0,    0,
 1548, 2578,    0,    0,  856,  879,  950,  954, 1047, 1074,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  258,    0,    0,    0,    0,21608,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1588,    0,    0,
   85,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1591,    0, 1633,    0,    0,
    0,    0,    0,  262,    0,    0,    0,    0,    0,    0,
    0, 2499, 2499,    0,    0,    0,    0,    0,    0, 2499,
 2499,    0, 2499, 2499,    0,37624,    0,37656,    0,37686,
 2499, 2499, 2499, 2499,37831, 2499, 2499, 2499, 2499, 2499,
 2499, 1377,    0,    0, 2942,    0,    0,    0,    0, 2944,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2946,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,43712,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1464,30232,    0,    0,    0,    0,
    0, 1637, 1641,    0, 2607,    0,    0,    0, 1464,    0,
    0,    0,    0,    0, 1591,    0,    0,  486,    0,    0,
    0,  500,    0,    0,    0,    0,    0,    0,    0, 1626,
 2099,    0,    0, 2947,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1673,
  767,    0,    0,    0,    0,    0,    0,    0,    0,   85,
 2695,    0,    0,    0,  273,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   99,
    0,37861,    0,    0,    0,   92,    0,37893,    0,    0,
    0,38036,    0,    0,    0,    0,38130,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2894,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2948,
    0,    0,    0,39478,    0,    0,    0,    0,    0,    0,
    0,    0, 1676,    0,    0,38551,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2399,    0,    0,  141,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2063,
    0,    0,    0,    0,  222,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  418,    0,    0,    0,    0, 2940,38223,    0,
    0,    0,    0,38269,38391,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2050,    0, 2951,
    0,    0,    0,    0,    0,    0,    0,    0, 2062,    0,
    0,    0,    0,    0,    0,    0,39790,    0,    0,    0,
    0,    0,40756,    0,    0,    0,    0,    0,38597,    0,
  130,    0,    0,    0, 1497, 1577,    0, 2309,    0,    0,
    0, 2063,22643,    0,    0,  153,    0,    0,    0,    0,
    0,    0, 2947,    0,    0,    0,    0, 2952,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -17,
    0,    0,    0, 2694,    0,  705,    0,    0,    0,    0,
    0,    0,    0, 1464,    0,    0, 3504,    0, 1548,19520,
20216,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2067,    0, 2936,    0,    0,    0,    0,    0,    0, 1911,
 1946,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1617,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2939,    0, 2512,    0,    0,    0,    0,    0,
    0, 2063,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2941,    0,    0, 2945,    0,    0,    0,
    0,    0,    0,    0, 2499,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2499,    0,  139,    0,
    0,    0,    0,    0,    0,    0, 2953, 2954,    0,    0,
    0, 2956,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2959,    0, 2960,    0, 2704,    0,    0,39166,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
static int yycindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2478,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1297,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2525,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2981,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2653,    0, 2660,
    0,    0,    0,    0, 2978,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2984, 2986, 2987,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2988,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2506,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2514,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
static int yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,  832,    0,
    0,  846,  848,  851,    0,    0,    0,    0,    0,-1131,
    0,  852,  854,   -3, 2824, 2317,  -40,-1166, 1417, 2825,
 2020, 2833, 2337,    0,    0, 2663, -114,  -43,    0,    0,
    0,    0,  -28,   95,  -65,  -93,  -72, -367, 2675, 2038,
    0,    0,    0, 1196,    0,    0,  -55, 1561, -796,  -74,
-1279, 2160, 1875, -423,    0, 1581,    0, 2990, 1878, 1927,
    0,    0,    0, -969,  -56,    0,    0,    0,    0,    0,
    0, 3010,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -70,    0,
 -755, -675, 1593, -705,  845, -393,    0,    0,    0,    0,
 -445, -436,-1560, 1615, -471,  -60,    0, -725, 1921,-1332,
    0,-1069, -396,-1155,    0, 1164,    0, 1184, -476, -821,
   10,  -61, -229,    0,    0,    0,    0, 1606,    0,    0,
    0,    0,    0,    0,    0, 2570,    0, 2254,    0,    0,
    0, 1702,    0, 2662, -804, 1218, 1632, 2603, 2605,    0,
    0, -505, 1998,    0,  -50, -961, -388,    0,    0,-1066,
-1064,-1041,-1031,-1022,    0, 1206,-1357,    0,  902,-1557,
    0, 2293,    0,    0,    0,  901,  905,  833, -230, -407,
-1263,-1216,    0,    0,    0, 2021, -793,    0, -889,    0,
 1793, -928,-1507,    0,    0,    0,    0,    0, -869, -321,
    0,    0,    0,    0,    0,    0,-1014,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,-1254,    0,    0, -965,    0, -962,  890,  928,    0,
  812,    0,    0,    0,    0,    0,    0,    0, -641,    0,
    0, 2126, -468, -591, 1462, -288, -507, -844,-1258,    0,
    0,    0,  -57,    0,    0,    0,    0,    0, 2619,    0,
    0,    0,    0, 2640, 2313,    0,    0,    0,    0,    0,
   -9, -652,    0,    0, 2646,    0,    0,    0,    9,    0,
    0,    0,    0, -683,    0, -506, 1960, -504, 1427,    0,
    0,    0,    0,    0,    0,-1341,    0,    0,    0, 2263,
    0, 1983,    0,    0,    0,    0,    0,    0, -128,    0,
 3133,    0, 2923,    0,    0,    0, 2726,    0,    0,    0,
    0,    0,    0, 2425,    0, 2421,    0,    0,    0, 2104,
    0,    0,    0, -876,    0, -366,    0,    0,    0,    0,
    0,    5, -894, -868,-1161,  -46,    0,  -14, 1136, 3906,
    0, 1035,    0,    0,    0,    0,    0,    0, -645,    0,
    0, -989,    0, 2686,  942,    0, 1782, -975, -867,    0,
 -922, 2152,-1433,    0,    0,    0,    0,    0,    0,    0,
 1820,    0,    0,    0,    0,  177,  416,    0,  965, 2237,
    0, 1195,    0, 1392,    0, -384,    0,    0, 1806,    0,
    0,-1029, -985,    0, 1322, 1327,    0,    0,  923,    0,
    0, 2458,    0,    0,    0, 1005, -615, 1019, 1020, 2179,
 1863,-1485,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1032, 1690,
    0,    0,    0, -984,    0,    0,    0, 2642,    0, 1831,
    0,    0,    0,    0,    0, 1628,    0,    0, -539,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,-1025, 1652,    0,    0,
};
#define YYTABLESIZE 44458
static int yytable[] = {                                     223,
   89,  347,  246,  402,   53,  320,  239,  243,  363,  254,
  342,  391,  358,  986,  338,  784,  787, 1009,  355,  323,
  343,  810, 1086,  326,  240,  382, 1112,  388,  882,  879,
  883,  351, 1315,  392, 1375, 1316,  356,  714,  390, 1410,
  905, 1411, 1417,  386,  355, 1350,  394,  783,  786,  315,
  318, 1377,  322,  325,  239,  330,  333,  387, 1615,  852,
 1199,  344,  318,  333, 1412,  325,  395,  239,  330,  548,
  362,  223,  333,  368, 1413,  331, 1241, 1378,  816, 1564,
 1050,  846,  378, 1414,  239,  380,  318, 1337,  378,  333,
  322,  325, 1304,  239,  330,  362,  223,  333,  368, 1121,
  325, 1215,  240,  814,  823, 1028, 1218, 1106,  385, 1352,
 1067,  389,  172,  777, 1393, 1386,  393, 1625, 1853, 1211,
  541, 1415,  820,  866, 1397, 1333, 1675,  460,  657,  889,
 1031, 1722,  853,  898, 1024,  173, 1009, 1066,  877,  623,
  832, 1270,  623, 1916,   54, 1048,   88,  782, 1279, 1456,
  744,  830,  286, 1419, 1439, 1696, 1517,  457, 1870, 1462,
  210, 1183,  995,  993, 1428,  994,  767,  996,  721,  402,
  657,  172, 1177, 1641,  408,   55,  450,  411,  406, 1718,
 1905,  832,  866, 1907,  455,  409, 1165, 1711,  889,  785,
 1157,  744,  400,  286,  173,  445,  286,  877, 1156,  832,
 1000, 1616, 1380,   54,  451,  670, 1388,  832,  453,  744,
  830,  286,  657, 1735,  457,  344,  239,  239,  344,  210,
  764,  912,  223, 1503,  333,  406, 1884,  246,  402, 1477,
  746, 1385,  243, 2181,   55,  240,  853,  318,  325,  239,
  330,  362,  174,  419, 1118,  549,  254,  866, 1237,  736,
 1180,  400,  431,  553,  670,  192,  695,  159,   88, 1076,
  505,  229,  912, 2038,  670,  912,  832, 2356,  146, 1383,
  379,  746,  219,  457, 1483,  110,  657, 1483,  903,  912,
  912, 1440,  738,  542,  193,  408, 2325,   89,  866,  746,
   89,  536, 1237,  509,  859,  853,   68,  377,  829,  519,
 1234,  174,   97, 1872, 1274, 1275,  866, 1237,  896,  508,
 1108,  431,  553,  670,  192,  695,  159, 1321,  882, 1123,
  883, 1707,  808, 1709, 1608, 2331,  228,  146,  864, 1101,
  788,  219, 1105, 1483, 1748,  859,  837,  903,  859,  829,
 1913, 2060,  768,  193, 1022,  700,  838, 1315,  708,  781,
 1316, 1130,  896,  859,  311, 1312, 1073,  829, 1749, 1710,
 1322, 1325,  714,  734, 2332,  508,  510,  896,  853,  864,
  789,  623,  520,  508,  543, 1927, 1367, 1234,  739, 1653,
  334, 1376,  852,  742, 2093, 1484,  344,  864, 1674,  344,
  752,  111,  230,  753,  763,  716,  223,  991, 1499,  758,
  748, 1234,  992,  410,  623, 1626, 1337, 1890, 1158,  853,
  322, 2333, 1560, 1561,  239, 1422, 1235, 1929,  210, 1906,
 1671, 2372,  737,  408, 2368,  720,  377,  853,  752,  755,
  210,  246,  740,  243, 1179, 1613,  243,  759, 1296, 1297,
 1351,  748, 1276,  861, 1942, 2037,  623, 1938, 1446,  741,
  815, 1848,  839, 1431, 1591,  832, 1708,  210,   99,  748,
  700, 2039,  343,  210,  831,  210,  893,  833, 1441,  775,
  775, 1681,  847,  896,  849, 1943,  832, 1947,  457, 1909,
 1381, 1946,  172, 1948,  861,  828,  744,  861, 1234,  902,
 1337,  344, 1874, 1235,  894,  911, 1886, 1887,  730,  219,
  623,  344,  861,  344,  210,  344,  904, 1889,  836, 1669,
  909,  431, 2174, 1678, 1455, 2182,  431, 1235, 1944,  832,
 1463,  431, 2324, 1425, 2323, 1679,  828,  318,  325,  330,
  830,  865,  745,  852,  159, 1023,  556,  239, 1658,  830,
  908,  239,  322, 1330,  828,  920, 2155,  443, 1337,  781,
   87,  917,  192, 1913, 1455,  623,  781, 1826,  219, 1182,
 1828,  405,  866,  781,  172,  172,  746,   97, 1164, 1502,
  402,  832,  865,  745,  852, 2064, 1047,  600, 1807,   94,
  877,  193, 1677,  866, 1693,  832,  832,  173,  173,   54,
  865,  745,  852,  400,  695,  744,  912, 1607,  781,  192,
  853,  172,  781, 1046, 1235,  670,  443, 1190, 1486,  859,
  912, 1368,  146,  829, 2216, 1198,  219,  553,  600, 2033,
   55,  600, 1515,  829, 1516,  829,  695,  431,  193, 1155,
  859, 1734, 2052, 2053,  829, 2200,  600, 1740, 1436,  903,
  566,  431, 1620,  864,  286, 1234,  990,  172,   89,  832,
 1850,  866,  695, 1851,  670,  695,  714,  889, 1616,  987,
  830, 2295,   87, 1188,  864,  210, 1246, 1021,  832, 1019,
  753,  695,  227, 2051, 1876,  746, 2088,  829, 1026,  830,
 2104,  670, 1476,  853, 1042,  298,  829,  896,  172, 1063,
 1482,  344,  866, 1237,  174,  174,  896,  695, 1612,  566,
  239,  325,  716, 1647,  853,  799,  755, 1649, 1211,  239,
 1064, 1695, 1652,  912,  325,  239,  832, 1389, 1081, 1368,
  716, 1699,  254,   99,  820, 1075,   53,  708, 1078,  829,
 2095, 1648, 1917, 1852, 2330,  832,  748, 1957, 1885,  859,
 2293,  239, 1337,  829, 1758,  853, 1435, 1102,  850, 1683,
  896,  896,  695, 1700, 1701, 1605,  239,  219,  861,  239,
  192, 1235, 1109,  247,  853,  247,  158, 1626,  344,  219,
 1940, 1159,  695,  864, 1126,  866,  738, 1741,  537,  861,
 1474, 2322, 1505,  441, 1142,  695, 1384,  859,  355,  193,
  110,  705, 1160, 1489, 1676,  799,  219, 1401, 2315, 1643,
  828, 2003,  219,  859,  219, 2006, 1626,  829,  310,  457,
  344,  443, 1337,  853, 1117,  344,  256,  896, 1234, 1594,
 1117,  828,  859,  298, 1759,  158,  829,  715, 1891,  542,
 2179, 2180, 1586, 1587,  334,  442,  896, 1187,  157,  794,
 2066, 2353,  441,  219, 1192, 1193,  865,  489,  852,  811,
  705,  219,  343,  600,  600,  448,  864, 2102,  600,  225,
 2086,  600,  812,  538,  828, 1402,  800,  865,  745,  852,
  808, 2178, 1234,  828,  600, 2294, 1673,  853,  449,  795,
 1966, 2343, 1238, 1774,  788, 1238,  715,  143,  861, 2034,
 1143, 1705, 2354,  344,  442, 2305,  853,  157,  539,  490,
 1238, 1268, 1238, 2050,  566,  995, 2170, 2171, 1315, 1644,
  996, 1316, 1490, 1032,  448, 2382,  828, 2276,  257,  219,
  457, 1958,  443,  226, 1245,  247,  740, 2316,  247, 1306,
  828, 1149,  987, 1321, 1235,  542,  443,  449,  995,  993,
  333,  994, 1144,  996, 1175,  247, 2187, 1234,  600,  445,
 1030, 1833,  861,  444, 1032, 1689,  851, 1032, 1491, 1248,
   17, 1626,  700, 2277,  700, 1929, 1338, 1150,  987,  600,
 1588,  861, 1032, 2056, 2278,  600,  865,  745,  852, 2132,
  901,  368, 1583, 1317, 1185, 1185, 2068,  542, 1235, 2103,
 1706,  344, 2069,  498,  828, 1410, 1410, 1411, 1411, 1492,
 1021,  247, 1365,  344,  219,  344, 1032,  344,  445,  600,
 1176, 1337,  444,  828,  716,  753,   17,  742, 1626, 1374,
 1412, 1412,  325,  343, 1766, 1368, 2070, 1081,  519,  566,
 1413, 1413, 1736,  239,  325,  431,   53, 1234,  499, 1414,
 1414, 1704,  852,  158, 1400,  431,  447,  441,  239,  136,
  239,  755, 1880, 1767, 1416,  344,  143,  143, 2342,  865,
  759,  852,  700, 1235,  344, 1432, 1151, 1928, 2249, 2169,
 1936, 1145, 2279,  446,  775, 1509,   53, 1415, 1415, 1505,
  258, 1000,  355,  136, 1080, 1996,  547,  823,  336,  337,
 1433, 1743,  259, 1437, 1051, 1445, 2089, 2108,  672,  442,
 2363,  520, 2365,  344, 2367,  447, 1452,  677, 1471, 1472,
 1473, 1831, 1460,  425,  157,  157, 2377,  136, 1238,  448,
 1665, 1210, 1185, 1033,  261,  355,  355,  355,  823,  705,
 1614,  344,  446, 1371,  344,  319, 2283,  600, 1238, 1488,
  991,  113,  449, 1811,  500,  992,  823,  708, 1475, 1372,
 1510,  431,  343, 1235,  920,  247, 2152,  672,  441, 1626,
 1453,  705,  501, 1500, 1033,  715,  677, 1033, 2348, 2349,
  621, 1666,  441,  991, 1867, 1867, 1871,  115,  992,  239,
  334,  247, 1033, 2344,  674, 2254, 1733,  705,  336,  337,
  705,  368, 1146,  344,  239, 2350,  502,  715,  708, 1147,
 2062, 2063,  920, 1514,   53,  350,  705, 1210,  917,  157,
  442,  621, 1238,  445,  621,  519, 1033,  444,   53,  676,
   53, 1713, 2159,  715,  442, 1941,  715, 1210, 2290,  621,
  448,  621,  705, 1538,   87,  663, 2168, 1778, 1726,  659,
  248,  116,  715,  674,  448,  490, 2049, 1539, 2100, 1032,
  370,  117, 1902,  449, 1904, 2328,  545, 1410, 1410, 1411,
 1411, 1855,  464,  808, 1858, 1621, 1101,  449,  715,  272,
  333,  249,  696,  766,  700,  250,  118,  586,  676, 1210,
  586, 1893, 1412, 1412,  371, 1779,  251,  705,  520, 1595,
  369, 1540, 1413, 1413,  663,  586,  753,  586, 1317, 1945,
  545, 1414, 1414, 1127,  882,  879,  883,  705,  633,  272,
  447,  465,  234,  788, 1032,  545,  344,  368, 1924, 1541,
  705,  464, 1236,  715,  445, 1724,  373,  260,  444,  716,
  716,  696,  755,  700, 1081,  375,  343,  446,  445, 1415,
 1415,  991,  444,  715, 1356, 1237,  992, 1315,  633,  633,
 1316, 1950,  633, 1242, 2206, 1528,  715, 1357,  211, 1257,
 1258, 1259, 1260, 1261, 1262, 1263, 1264,  633,  260,  633,
  465,  260, 2310, 2311, 1725,  461,  788,  344,  383, 1128,
 1358,  201, 1542,  759,  325,  272,  260, 1899,  334, 1315,
   53, 1315, 1316, 1315, 1316, 1728, 1316, 1900,  519,  633,
 1238,  808,  823, 1529, 2212, 1315,  405,  252, 1316,  809,
   45,  235,  355,  555,  823,  417, 1250,  211,  236, 1129,
  526,  447,  202,  823,  559,  272, 1530, 1761,  621,  343,
 1361, 1724,  396, 1765,  461,  447, 2072, 1753,  788,  965,
  201,  908, 2341, 1742,  355,  621,  621,  621,  446,  708,
  355,  621, 1714,  527,  621,  528, 1189,  399,  908, 1033,
  623, 1991,  446,  892, 1009,  405,  823,  621, 1265,   45,
  344,  520,  555,  621,  239,  823,   49,  529, 1252,  403,
 1727,  202,  781,  559, 2339,  788,  995,  993, 1750,  994,
  344,  996,  908,  598, 1266, 1992,  826,  983,  984,  985,
 2054,  623,  530,  398,  623,  568, 1812, 1993, 2383, 1447,
  148, 2061, 1751,  586,  419, 2065,  343,  403,  823,  623,
 2074,  186,  892, 2360, 1033, 1255, 1259, 1259, 1198, 1259,
 1259, 1259,  823,  586,   43,   49,  219,  826,  403, 1859,
  826,  621,  598,  995,  993,  412,  994,  281,  996, 2091,
 2092,  908, 2094,  239, 2096,  826,  404,  344,  788,  890,
  407, 1860,  621, 1867,  568, 1857,  633,  413,  621,  148,
  554, 1802,  700,  419,  420, 1259,  822,  621,  559,  621,
  186,  633,  441,  633,  633,  633, 1856,  149,  281,  633,
  228,  281,  633,   43,  442,  219,  823,  621, 1299,   91,
   92, 1317,  621,  272,  260,  633,  281,  344,  336,  337,
  696,  633,  700,  344,  633,  823,  211,  822,  890,  716,
  325,  330,  716,  362,  223,  247, 1087, 1014,  211, 1088,
 1013,  621,  137, 1892, 1090,  822,  873, 1094, 1878,  444,
  874, 1099,  696,  243,  446, 1018,  149, 1356, 1017,  228,
  325,  325,  447,  716,  716,  211,  633, 2162, 2163, 2164,
 1357,  211, 1224,  211,  239,  786,  247, 1356,  696,  247,
  700,  696,  247,  700, 1220,  891,  459, 1210,  786,  633,
 1357,  917,  559, 1358,  247,  247,  786,  696,  247,  700,
 1951,  137, 1448, 1449,  559,  873, 1359,  481,  272,  874,
  633,  786,  211, 1358, 1360,  247,  633, 1956,  917,  843,
  633, 1926, 1961,  696,  786,  700, 1359,  633,  917,  272,
 2369,  991, 1136,  482, 1137,  272,  992,  559,  511,  559,
  621,  247,  522, 1361,  891,  633,  623,  623,  523, 1071,
  633,  623, 1070,  843,  623, 1114,  144,  144, 1113,  995,
  993,  786,  994, 1361,  996,  843, 1295,  623,  525,  272,
 1303, 1259,  534, 1000, 1348,  633, 1259, 1347,  696,  633,
  700,  545, 1217, 1656,  995,  993, 1659,  994,  991,  996,
    4,    7,  492,  992, 2222, 2223, 2224,  550,  696, 2227,
  700, 1244,  239, 1481,  493, 1249, 1480, 1295, 1254, 1501,
 1295,  696, 1207,  700,  995,  993, 1269,  994, 1271,  996,
 1802,  826, 1277, 1278,  551, 1295, 1281, 1282, 1283, 1284,
 1285, 1289, 1295,  826, 1298, 2203, 1301,  494, 1097,  495,
 1098,  623,  826,  219, 2028, 2030, 1307, 1308, 1309, 1310,
 1311,  659, 1362, 2301, 1318, 2302,  659,  659,  578,  579,
  580,  552,  623,  716,  716,  555,  618,  556,  623, 1317,
  786, 2035, 1362,  211, 1619,  709,  243, 1000,  633,  325,
 1624, 1399,  705, 1623, 2075,  826,  588,  589, 1672,  513,
  219, 1480,  514,  711,  826,  719,  325, 1243,  219, 1247,
  724,  822,  623, 1251, 1253, 1716, 1256,  618, 1715,  725,
  618, 2090,  634,  822,  726,  239,  995,  993,  727,  994,
  728,  996,  822, 1379,  729,  618, 1721,  618,  157, 1720,
  731,  219, 1300,  219,  515,  735, 1756,  826, 2015, 1480,
 1849,  733,  239, 1616, 2129,  747, 2128, 1875,  623,  748,
 1000,  826,  634,  634,  343,  219,  634, 1259, 1259, 1259,
 1259, 1259, 1259, 1259, 1259,  822, 1239, 2029, 2031,  157,
 2176,  634,  157,  634,  822, 2148,  746,  749, 1239,  378,
  219, 1239,  762, 1877,  751,  343, 1000,  157, 1895,  623,
  239, 1480,  623,  322,  991,  344,  769, 1965,  772,  992,
 1000, 1244, 2008,  634,  770, 1000,  773,  623, 1802,  623,
 2346,  774,  778, 1244,  379,  826, 1244,  822,  780,  991,
  793, 1602,  995,  993,  992,  994, 2153,  996,  797, 2177,
  623,  822,  814,  804,  826,  805,  995,  993, 2173,  994,
  806,  996, 1295, 1295, 2019, 2161,  813, 2018, 1000,  991,
 1295,  219, 2370, 2355,  992, 2184,  818, 2288, 2375, 2186,
 1017, 1000, 2380, 1295, 2381,  829, 1259, 2384, 2217,  239,
 2385, 1577,  281, 1518, 1519, 1523,  322,  832, 1532, 1534,
 1536,  843, 1544, 1547, 1550, 1552, 1555, 1558,  844, 1582,
  309,  814, 1259,  309,  899,  822, 1565, 1566,  903, 1568,
  851, 1570,  848,  851, 1573, 1574, 1575, 1576,  261, 1578,
 1579,  944, 1186,  281,  822, 1186,  281, 1187,  906,  708,
 1187,  912,  946,  947,  618,  948, 1584,  322, 1589,  949,
  950,  281,  951,  952,  953,  955,  956, 1295,  957,  959,
  958,  618,  618,  618, 1604,  962,  968,  618,  344,  261,
  618,  991,  261, 1610, 1611,  969,  992,  970, 1295,  753,
  344,  971,  972,  618, 1295,  973,  974,  261,  975,  618,
  634,  976, 2304, 1000,  977,  995,  993, 1356,  994,  997,
  996,  995,  993,  978,  994,  634,  996,  634,  634,  634,
 1357,  979,  980,  634,  981,  755,  634,  982, 1295,  659,
 2273,  998, 1001,  659,  157,  157,  623, 1002,  659,  634,
 2371, 1003,  157, 1358,   53,  634, 2318, 1015,  634, 1012,
 1027, 1016, 1044, 1053,  623,  623, 1359, 1055,  322,  623,
  322, 1058,  623,  318, 2044, 1062, 1059,  618, 1065, 1069,
 1072, 2309, 1514, 1514, 1074,  623,  753, 1077, 1083, 1084,
 1090,  623, 1094, 1688, 1100,  808,  112,  991,  618,  799,
  634, 1103,  992, 1361,  618, 1533, 1110, 1537, 1140, 1545,
 1548,  991, 1553, 1556, 1559,  618,  992,  318, 2320, 1115,
 1141, 1153,  755,  634,  781, 2321, 1161, 1162, 1167, 1168,
 1170, 1169, 1173,  618,  113, 1172, 1178, 1601,  618,  157,
 1184, 1185, 1191, 1201,  634, 1203,  114, 1204, 1317, 1206,
  634, 1837, 1514, 1207,  634, 1212, 1214,  784,  827,  623,
  157,  634, 1216, 1213,  783,  489,  157,  618, 1272,   53,
  115, 1305, 1326, 1280, 1327, 1329, 1179,  657, 1341,  634,
  623,   53, 1343, 1339,  634, 1340,  623, 1345,  281,  281,
 1317, 2045, 1317, 1349, 1317, 1354,  281,  623,  784,  827,
  157,  784, 1369, 1024,   17,  783, 1317,  721, 1382,  634,
 1387, 1390, 1362,  634, 1406,  623,  784,  827, 1514,  659,
  623, 1017, 1394,  783,  272,  261,  830, 1396, 1398, 1420,
 1427, 1429, 1785, 1786,  116, 1788, 1790, 1421, 1434, 1442,
 1430, 1443, 1444, 1795,  117, 1458, 1451, 1470,  785,  623,
  991,  814, 1508, 1525, 1468,  992,  991, 1562, 1478, 1563,
  814,  992, 1569, 1581, 1571, 1816,  618,  830, 1580,  118,
  991, 1821, 1606, 1616, 1824, 1618, 1825, 1589, 1617, 1622,
 1589,  814, 1584,  281, 1642,  830, 1832,  659, 1834,  785,
 2023, 1650,  785, 1651, 2001, 1835, 1670, 1836, 1645, 1654,
 1839, 1840, 1841, 1842,  281, 1663, 1847,  785, 1682, 1660,
  281, 1661,  634, 1690, 1668,  814, 1664, 1685, 1697,  272,
 1702, 1483, 1717,  782, 1719, 1723,  782, 1729,  782,  782,
  782,  782, 1730,  782,  995,  993, 1731,  994, 1732,  996,
  272,  782,  782, 1746,  281, 1747,  272, 1744,  623, 1502,
 1769, 1770,  782,  782, 1763,  782,  782,  782, 1752, 1768,
 1772, 1773,  782,  782,  814,  782,  782, 1777,  782, 1780,
 1781,  782,  782,  782,  782,  782,  782,  782, 1783, 1784,
  272,  814,  782,  782,  782, 1407,  782,  782,  782, 1791,
  782, 1792, 1793, 1914, 2199,  995,  993, 1794,  994, 1796,
  996,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782, 1797,  782,  782,  782,  782,  782,  782, 1798,  782,
  782,  782,  782, 1799,  782, 1800,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782, 1801,  782,  782,  782,  782, 1234,
  782,  782,  782,  782,  782, 1962,  782,  782,  782,  782,
  782, 1968,  784,  827, 1830, 1827, 1972, 1854, 1838,  783,
 1861, 1863,  784, 1977,  784, 1864, 1879,  995,  993,  783,
  994,  783,  996,  784,  827, 1888,  819, 1896, 1897,  824,
  783, 1260, 1260, 1199, 1260, 1260, 1260,  995,  993, 1903,
  994, 1915,  996, 1918, 2197,  995,  993, 2196,  994, 1919,
  996, 1589, 1920, 1921, 1922, 1589, 1923, 1925, 1455, 1939,
 1949, 2012, 2013, 1954, 1969, 1952,  784,  827, 2020, 1955,
 1960,  830, 1967,  783, 1989,  784,  827, 1997, 1990, 1995,
 1260,  830,  783,  830, 2004, 2005, 2021,  370, 2022, 2024,
 2025, 2027,  830,  785, 2032, 2058, 2040, 2042, 2076,  991,
 2057, 2077, 2079,  785,  992,  785, 2078, 2080, 2081, 2082,
 2083, 1028,  659, 2084,  785, 2097, 2098,  819,  784,  827,
 2099,  371, 1391,  995,  993,  783,  994, 2101,  996, 2085,
  784, 2106,  784,  827, 2105,  830, 2107,  783, 2110,  783,
 2111, 2112, 2113, 2116,  830, 1392,  995,  993, 2117,  994,
 2118,  996, 1028, 1028, 1028, 1028, 1028,  785, 1028, 2119,
  991, 2120,  563, 2121, 2122,  992,  785, 2123, 2124, 2125,
 1028, 1028, 1028, 1028, 2127, 2154, 1572,  995,  993, 2131,
  994, 2157,  996,  995,  993, 2038,  994,  830,  996, 2160,
  565, 2175, 2158, 2109, 2039, 2172,  784,  827, 2198, 2114,
 2115,  830, 2201,  783, 1028, 2185, 2190, 2207, 2210,  785,
 2208, 2202,  421, 2209, 2215,  784,  827, 2213,  567, 2218,
 2228,  785,  783,  785, 2225, 2130, 2226, 2229, 2230, 1589,
 2284, 2296, 2285, 2133, 2300, 2287, 2298, 2306, 2136, 2137,
 2138, 2139, 2140,  226,  422, 2313, 2314, 2141, 2317, 2327,
 2293, 2294,  991,  995,  993, 2336,  994,  992,  996, 2345,
 1066, 2352, 2357, 2351, 2359,  830, 1260, 2361, 2362, 2364,
  423, 1260,  991,  424, 2374, 2358, 2376,  992, 2378, 2379,
  991, 2165,    1, 1782,  830,  992,  752,  785,  575,  425,
  859, 1302,  995,  993,   31,  994,   33,  996,  753,  795,
  231,  912,  300, 1976,  577,   84,  785, 1203, 1596,  995,
  993,  189,  994,  838,  996,  426, 1032, 1184,  578,  579,
  580, 1031,  336,  337, 2183,  819,  917,  775,  243,  821,
  837, 1305, 1305, 1196, 1305, 1305, 1305, 1030,  457, 1183,
 1085,  583,  584,  585,  586,  587,  588,  589,  590,  591,
 1328, 1328, 1197, 1328, 1328, 1328,  593,  594,  991,  216,
  866,  217,  839,  992, 1238,  598, 1155,  416, 1084, 1028,
  427, 1154,  848, 1028,  360, 1028, 1028,  322,  328,  358,
 1305,  991, 1028,  368,  382,    0,  992, 1028, 1028,   10,
  428,  359,  361, 1028,  369, 1028, 1028,  364,  397, 1328,
   13,   19,   16,  429,   21,  442,   24,   27,   31,   16,
 1028, 2245,  991,   33, 1028, 1028, 1028,  992,  991, 1028,
 2231,   37, 2232,  992, 1043, 2246, 1028, 2247, 1028, 1028,
 2248, 2250, 1028, 2251,  414,  415, 1028, 1865, 1028, 2165,
 1028, 1342, 1028, 1366,  416, 1764, 1045, 1028, 1028,  718,
 1028, 1205, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
  717, 1507, 2307, 1762,  628, 1028, 1028,  384, 1028, 1512,
 1454,  365, 1760, 1738, 2087, 1567, 2071, 1464, 1028, 1755,
 1028,  856, 1028, 1028, 1028, 1692, 1028, 1163,  991, 1028,
 1028, 1739, 2055,  992,  765,  826, 2067,  827, 2292, 1028,
 1426, 2299, 1135, 1028, 2297,  628, 2335, 1627,  628, 1028,
 2308, 2282, 1028, 1418, 2347, 1028,  834, 1894, 1331, 1469,
 1028,  807,  817,  628, 1139,  628,  233,  991, 2337, 2338,
 1937, 1028,  992, 1186, 1461,  418,  750, 1028, 1028, 1052,
 1057, 1370, 1028, 1028,  991,  995,  993, 1592,  994,  992,
  996, 2156,  792, 1028, 1028,  628, 1028, 1684, 1657, 2291,
 1239, 1260, 1028, 1353, 2126, 1028, 1305, 1028, 1028, 1028,
 1028, 1305, 1028, 1988, 1028, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 2366, 1687, 2043, 1328,  659, 1260, 2041, 2329,
 1328, 1028, 1028, 1068, 1028, 1028, 1028, 2289, 2274, 2275,
 1364, 1028, 1028, 1028, 1028, 1028, 1662, 1028,  961, 1787,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1694, 1846, 1829,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,    0, 1028,
    0, 1597,  995,  993,    0,  994,    0,  996,    0, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
    0, 1028, 1028, 1028, 1028, 1028, 1028,    0, 1028, 1028,
 1028, 1028, 1231, 1028,    0, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028,    0, 1028, 1028, 1028, 1028,    0, 1028,
 1028, 1028, 1028, 1028,    0, 1028, 1028, 1028, 1028, 1028,
    0,    0, 1205, 1231, 1231, 1231, 1231, 1231, 1231, 1231,
  995,  993,  628,  994,    0,  996,    0,    0,    0,    0,
 1231, 1231, 1231, 1231, 1231,    0,    0,  628,    0,  628,
  628,  628,    0,    0,    0,  628,    0,    0,  628,    0,
    0,   70, 1305, 1305, 1305, 1305, 1305, 1305, 1305, 1305,
    0,  628,   71, 1231,    0, 1231,    0,  628,    0,   72,
  628, 1328, 1328, 1328, 1328, 1328, 1328, 1328, 1328,  461,
  991,    0,   73,    0,    0,  992,    0, 1598,  995,  993,
    0,  994,   58,  996,    0,  462, 1599,  995,  993,    0,
  994,    0,  996,   59,    0,    0,  463,    0,    0,    0,
   60,    0,  628,  464,   61,    0,    0,  465,  466,    0,
    0, 1600,  995,  993,    0,  994,  467,  996,    0,    0,
    0,    0,    0,    0,   62,  628,    0,  468,   74, 1808,
  995,  993,    0,  994,    0,  996,    0,    0,    0,    0,
    0,    0,    0,    0,   75,    0,  628,    0,    0,    0,
    0, 1305,  628,    0,    0,    0,  628,  991,    0,    0,
   76,    0,  992,  628,    0,    0,    0,    0,    0,    0,
 1328,    0,    0,  286,    0,   77,    0, 1305,    0,   78,
  469,  628,   79,    0,    0,   63,  628,    0,  470,    0,
   80,    0,    0,    0,    0,    0, 1328, 1809,  995,  993,
    0,  994,    0,  996,    0,    0,    0,    0,    0,   81,
    0,  628,    0,    0,  286,  628,   64,  286,    0,  471,
   65,    0,    0,  472, 1231,    0, 1231, 1231,    0,    0,
 1771,    0,  286, 1231,  473,    0,    0,    0,    0, 1231,
    0,    0,    0,    0, 1231,  991,    0, 1231,    0,    0,
  992,    0,    0,  474,  475,    0,    0,    0,    0,    0,
    0, 1231,    0,    0,    0,   82, 1231, 1231,   83,    0,
 1231,    0,    0,    0,    0,    0,    0, 1231,    0, 1231,
 1231,    0,    0, 1231,    0,    0,    0, 1231,    0, 1231,
    0, 1231,    0, 1231,    0,    0,    0,    0, 1231, 1231,
    0, 1231,    0,    0,    0,    0,   66,    0,    0,  476,
    0,   84,  477,  991,  628, 1271, 1231, 1231,  992, 1231,
    0,    0,  991,    0,    0,    0,    0,  992,    0, 1231,
    0, 1231,    0, 1231, 1231, 1231,    0, 1231,    0,    0,
 1231, 1231, 1814,  995,  993,    0,  994,  991,  996,    0,
 1231,    0,  992,    0,    0, 1098, 1271, 1271, 1271, 1271,
 1271, 1271, 1271, 1231,    0,  991, 1231,    0,    0,    0,
  992,    0,    0, 1271, 1271, 1271, 1271, 1271,  995,  993,
 1593,  994, 1231,  996,    0,    0,    0,    0, 1231, 1231,
 1815,  995,  993, 1231,  994,    0,  996,    0,    0,    0,
    0,    0,    0,    0, 1231, 1231, 1271, 1231, 1271,    0,
    0,    0,    0, 1231,    0,    0, 1231,    0, 1231, 1231,
 1231, 1231,    0, 1231,    0, 1231, 1231, 1231, 1231, 1231,
 1231, 1231, 1231,  991,    0, 1817,  995,  993,  992,  994,
    0,  996, 1231, 1231,    0, 1231, 1231, 1231,    0,  286,
  286,    0, 1231, 1231, 1231, 1231, 1231,  286, 1231,    0,
    0, 1231, 1231, 1231, 1231, 1231, 1231, 1231,    0,    0,
    0, 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231,    0,
 1231, 1818,  995,  993,    0,  994,    0,  996,    0,    0,
 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231,
 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231,
 1231,    0, 1231, 1231, 1231, 1231, 1231, 1231,    0, 1231,
 1231, 1231, 1231,    0, 1231,    0, 1231, 1231, 1231, 1231,
 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231, 1231,
 1231, 1231, 1231, 1231,  286, 1231, 1231, 1231, 1231,    0,
 1231, 1231, 1231, 1231, 1231,    0, 1231, 1231, 1231, 1231,
 1231,    0,    0,    0,    0,  286,    0,    0,    0,    0,
    0,  286,    0,    0,    0,    0,    0, 1271,  991, 1271,
 1271,    0,    0,  992,    0,    0, 1271,    0,    0,    0,
    0,    0, 1271,    0,    0,    0,    0, 1271,    0,    0,
 1271,    0,    0,    0,    0,  286,    0,    0,    0,    0,
    0,    0,    0,  991, 1271,    0,    0,    0,  992, 1271,
 1271,    0,    0, 1271,    0,    0,  991,    0,    0,    0,
 1271,  992, 1271, 1271,    0,    0, 1271,    0,    0,    0,
 1271,    0, 1271,    0, 1271,    0, 1271,    0,    0,    0,
    0, 1271, 1271,    0, 1271,    0, 1257, 1258, 1259, 1260,
 1261, 1262, 1263, 1264,    0,  286,    0,    0, 1273, 1271,
 1271,  991, 1271,    0,    0,    0,  992,    0,    0, 1819,
  995,  993, 1271,  994, 1271,  996, 1271, 1271, 1271,    0,
 1271,    0,    0, 1271, 1271, 1820,  995,  993,    0,  994,
    0,  996,    0, 1271,    0,    0,    0,    0, 1099, 1273,
 1273, 1273, 1273, 1273, 1273, 1273, 1271,  991,    0, 1271,
    0,    0,  992,    0,    0,    0, 1273, 1273, 1273, 1273,
 1273,  995,  993, 1609,  994, 1271,  996,    0,    0,    0,
    0, 1271, 1271, 1822,  995,  993, 1271,  994,    0,  996,
    0,    0,    0,    0,    0,    0,    0, 1271, 1271, 1273,
 1271, 1273,    0,    0,    0, 1265, 1271,    0,    0, 1271,
    0, 1271, 1271, 1271, 1271,    0, 1271,    0, 1271, 1271,
 1271, 1271, 1271, 1271, 1271, 1271,    0,    0, 1823,  995,
  993, 1266,  994,    0,  996, 1271, 1271,    0, 1271, 1271,
 1271,    0,    0,    0,    0, 1271, 1271, 1271, 1271, 1271,
    0, 1271,    0,    0, 1271, 1271, 1271, 1271, 1271, 1271,
 1271,    0,    0,    0, 1271, 1271, 1271, 1271, 1271, 1271,
 1271, 1271,    0, 1271, 1998,  995,  993,    0,  994,    0,
  996,    0,    0, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
 1271, 1271, 1271, 1271,    0, 1271, 1271, 1271, 1271, 1271,
 1271,    0, 1271, 1271, 1271, 1271,    0, 1271,    0, 1271,
 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
 1271, 1271, 1271, 1271, 1271, 1271, 1271,    0, 1271, 1271,
 1271, 1271,    0, 1271, 1271, 1271, 1271, 1271,    0, 1271,
 1271, 1271, 1271, 1271,    0,  991,    0,    0,    0,    0,
  992,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1273,  991, 1273, 1273,    0,    0,  992,    0,    0, 1273,
    0,    0,    0,    0,    0, 1273,    0,    0,    0,    0,
 1273,    0,    0, 1273, 1999,  995,  993,    0,  994,    0,
  996,    0,    0,    0,    0,    0,  991, 1273,    0,    0,
    0,  992, 1273, 1273,    0,    0, 1273,    0,    0,  991,
    0,    0,    0, 1273,  992, 1273, 1273,    0,    0, 1273,
    0,    0,    0, 1273,    0, 1273,    0, 1273,    0, 1273,
    0,    0,    0,    0, 1273, 1273,    0, 1273,    0,    0,
    0,    0,    0,    0, 2000,  995,  993,    0,  994,    0,
  996, 1275, 1273, 1273,  991, 1273,    0,    0,    0,  992,
    0,    0, 2007,  995,  993, 1273,  994, 1273,  996, 1273,
 1273, 1273,    0, 1273,    0,    0, 1273, 1273, 2010,  995,
  993,    0,  994,    0,  996,    0, 1273,    0,    0,    0,
    0, 1100, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1273,
  991,    0, 1273,    0,    0,  992,    0,    0,    0, 1275,
 1275, 1275, 1275, 1275,  995,  993, 1844,  994, 1273,  996,
    0,    0,    0,    0, 1273, 1273, 2011,  995,  993, 1273,
  994,    0,  996,    0,    0,    0,    0,    0,    0,    0,
 1273, 1273, 1275, 1273, 1275,    0,    0,    0,    0, 1273,
    0,    0, 1273,    0, 1273, 1273, 1273, 1273,    0, 1273,
    0, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,    0,
    0, 2134,  995,  993,    0,  994,    0,  996, 1273, 1273,
    0, 1273, 1273, 1273,    0,    0,    0,    0, 1273, 1273,
 1273, 1273, 1273,    0, 1273,    0,    0, 1273, 1273, 1273,
 1273, 1273, 1273, 1273,    0,    0,    0, 1273, 1273, 1273,
 1273, 1273, 1273, 1273, 1273,    0, 1273, 2135,  995,  993,
  991,  994,    0,  996,    0,  992, 1273, 1273, 1273, 1273,
 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,
 1273, 1273, 1273, 1273, 1273, 1273, 1273,    0, 1273, 1273,
 1273, 1273, 1273, 1273,    0, 1273, 1273, 1273, 1273,    0,
 1273,    0, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,
 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,
  991, 1273, 1273, 1273, 1273,  992, 1273, 1273, 1273, 1273,
 1273,    0, 1273, 1273, 1273, 1273, 1273,    0,  991,    0,
    0,    0,    0,  992,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1275,  991, 1275, 1275,    0,    0,  992,
    0,    0, 1275,    0,    0,    0,    0,    0, 1275,    0,
    0,    0,    0, 1275,    0,    0, 1275, 2192,  995,  993,
    0,  994,    0,  996,    0,    0,    0,    0,    0,  991,
 1275,    0,    0,    0,  992, 1275, 1275,    0,    0, 1275,
    0,    0,  991,    0,    0,    0, 1275,  992, 1275, 1275,
    0,    0, 1275,    0,    0,    0, 1275,    0, 1275,    0,
 1275,    0, 1275,    0,    0,    0,    0, 1275, 1275,    0,
 1275,    0,    0,    0,    0,    0,    0, 2193,  995,  993,
    0,  994,    0,  996, 1276, 1275, 1275,  991, 1275,    0,
    0,    0,  992,    0,    0, 2194,  995,  993, 1275,  994,
 1275,  996, 1275, 1275, 1275,    0, 1275,    0,    0, 1275,
 1275, 2195,  995,  993,    0,  994,    0,  996,    0, 1275,
    0,    0,    0,    0, 1101, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1275,  991,    0, 1275,  995,  993,  992,  994,
    0,  996, 1276, 1276, 1276, 1276, 1276,  995,  993, 2009,
  994, 1275,  996,    0,    0,    0,    0, 1275, 1275, 2303,
  995,  993, 1275,  994,    0,  996,    0,    0,    0,    0,
    0,    0,    0, 1275, 1275, 1276, 1275, 1276,    0,    0,
    0,    0, 1275,    0,    0, 1275,    0, 1275, 1275, 1275,
 1275,    0, 1275,    0, 1275, 1275, 1275, 1275, 1275, 1275,
 1275, 1275,    0,    0,    0,  995,  993, 2014,  994,    0,
  996, 1275, 1275,    0, 1275, 1275, 1275,    0,    0,    0,
    0, 1275, 1275, 1275, 1275, 1275,    0, 1275,    0,    0,
 1275, 1275, 1275, 1275, 1275, 1275, 1275,    0,    0,    0,
 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275,    0, 1275,
    0,  995,  993,  991,  994,    0,  996,    0,  992, 1275,
 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
    0, 1275, 1275, 1275, 1275, 1275, 1275,    0, 1275, 1275,
 1275, 1275,    0, 1275,    0, 1275, 1275, 1275, 1275, 1275,
 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
 1275, 1275, 1275,  991, 1275, 1275, 1275, 1275,  992, 1275,
 1275, 1275, 1275, 1275,    0, 1275, 1275, 1275, 1275, 1275,
    0,  991,    0,    0,    0,    0,  992,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1276,  991, 1276, 1276,
    0,    0,  992,    0,    0, 1276, 1975,    0,    0,    0,
    0, 1276,    0,    0,    0,    0, 1276,    0,    0, 1276,
    0,  991,    0,    0,    0,    0,  992,    0,    0,    0,
    0,    0,  991, 1276,    0,    0,    0,  992, 1276, 1276,
    0,    0, 1276,    0,    0,  991,    0,    0,    0, 1276,
  992, 1276, 1276,    0,    0, 1276,    0,    0,    0, 1276,
    0, 1276,    0, 1276,    0, 1276,    0,    0,    0,    0,
 1276, 1276,    0, 1276,    0,    0,    0,    0,    0,    0,
    0,  995,  993, 2016,  994,    0,  996, 1277, 1276, 1276,
  991, 1276,    0,    0,    0,  992,    0,    0,    0,    0,
    0, 1276,    0, 1276,    0, 1276, 1276, 1276,    0, 1276,
    0,    0, 1276, 1276,    0,  995,  993, 2017,  994,    0,
  996,    0, 1276,    0,    0,    0,    0, 1102, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1276,  991,    0, 1276,    0,
    0,  992,    0,    0,    0, 1277, 1277, 1277, 1277, 1277,
    0,    0,    0,    0, 1276,    0,    0,    0,    0,    0,
 1276, 1276,    0,    0,    0, 1276,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1276, 1276, 1277, 1276,
 1277,    0,    0,    0,    0, 1276,    0,    0, 1276,    0,
 1276, 1276, 1276, 1276,    0, 1276,    0, 1276, 1276, 1276,
 1276, 1276, 1276, 1276, 1276,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1276, 1276,    0, 1276, 1276, 1276,
    0,    0,    0,    0, 1276, 1276, 1276, 1276, 1276,    0,
 1276,    0,    0, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
    0,    0,    0, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276,    0, 1276,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1276,    0, 1276, 1276, 1276, 1276, 1276, 1276,
    0, 1276, 1276, 1276, 1276,    0, 1276,    0, 1276, 1276,
 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
 1276, 1276, 1276, 1276, 1276, 1276,  991, 1276, 1276, 1276,
 1276,  992, 1276, 1276, 1276, 1276, 1276,    0, 1276, 1276,
 1276, 1276, 1276,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1277,
  991, 1277, 1277,    0,    0,  992,    0,    0, 1277,    0,
    0,    0,    0,    0, 1277,    0,    0,    0,    0, 1277,
    0,    0, 1277,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1277,    0,    0,    0,
    0, 1277, 1277,    0,    0, 1277,    0,    0,    0,    0,
    0,    0, 1277,    0, 1277, 1277,    0,    0, 1277,    0,
    0,    0, 1277,    0, 1277,    0, 1277,    0, 1277,    0,
    0,    0,    0, 1277, 1277,    0, 1277,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1278, 1277, 1277,    0, 1277,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1277,    0, 1277,    0, 1277, 1277,
 1277,    0, 1277,    0,    0, 1277, 1277,    0,    0,    0,
    0,    0,    0,    0,    0, 1277,    0,    0,    0,    0,
 1103, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1277,    0,
    0, 1277,    0,    0,    0,    0,    0,    0, 1278, 1278,
 1278, 1278, 1278,    0,    0,    0,    0, 1277,    0,    0,
    0,    0,    0, 1277, 1277,    0,    0,    0, 1277,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1277,
 1277, 1278, 1277, 1278,    0,    0,    0,    0, 1277,    0,
    0, 1277,    0, 1277, 1277, 1277, 1277,    0, 1277,    0,
 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1277, 1277,    0,
 1277, 1277, 1277,    0,    0,    0,    0, 1277, 1277, 1277,
 1277, 1277,    0, 1277,    0,    0, 1277, 1277, 1277, 1277,
 1277, 1277, 1277,    0,    0,    0, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277,    0, 1277,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1277, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1277,    0, 1277, 1277, 1277,
 1277, 1277, 1277,    0, 1277, 1277, 1277, 1277,    0, 1277,
    0, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,    0,
 1277, 1277, 1277, 1277,    0, 1277, 1277, 1277, 1277, 1277,
    0, 1277, 1277, 1277, 1277, 1277,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1278,    0, 1278, 1278,    0, 1963, 1964,    0,
    0, 1278,    0,    0,    0, 1970, 1971, 1278, 1973, 1974,
    0,    0, 1278,    0,    0, 1278, 1978, 1979, 1980, 1981,
    0, 1982, 1983, 1984, 1985, 1986, 1987,    0,    0, 1278,
    0,    0,    0,    0, 1278, 1278,    0,    0, 1278,    0,
    0,    0,    0,    0,    0, 1278,    0, 1278, 1278,    0,
    0, 1278,    0,    0,    0, 1278,    0, 1278,    0, 1278,
    0, 1278,    0,    0,    0,    0, 1278, 1278,    0, 1278,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1279, 1278, 1278,    0, 1278,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1278,    0, 1278,
    0, 1278, 1278, 1278,    0, 1278,    0,    0, 1278, 1278,
    0,    0,    0,    0,    0,    0,    0,    0, 1278,    0,
    0,    0,    0, 1104, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1278,    0,    0, 1278,    0,    0,    0,    0,    0,
    0, 1279, 1279, 1279, 1279, 1279,    0,    0,    0,    0,
 1278,    0,    0,    0,    0,    0, 1278, 1278,    0,    0,
    0, 1278,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1278, 1278, 1279, 1278, 1279,    0,    0,    0,
    0, 1278,    0,    0, 1278,    0, 1278, 1278, 1278, 1278,
    0, 1278,    0, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1278, 1278,    0, 1278, 1278, 1278,    0,    0,    0,    0,
 1278, 1278, 1278, 1278, 1278,    0, 1278,    0,    0, 1278,
 1278, 1278, 1278, 1278, 1278, 1278,    0,    0,    0, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278,    0, 1278,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,    0,
 1278, 1278, 1278, 1278, 1278, 1278,    0, 1278, 1278, 1278,
 1278,    0, 1278,    0, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278,    0, 1278, 1278, 1278, 1278,    0, 1278, 1278,
 1278, 1278, 1278,    0, 1278, 1278, 1278, 1278, 1278,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1279,    0, 1279, 1279,    0,
    0,    0,    0,    0, 1279,    0,    0,    0,    0,    0,
 1279,    0,    0,    0,    0, 1279,    0,    0, 1279,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1279,    0,    0,    0,    0, 1279, 1279,    0,
    0, 1279,    0,    0,    0,    0,    0,    0, 1279,    0,
 1279, 1279,    0,    0, 1279,    0,    0,    0, 1279,    0,
 1279,    0, 1279,    0, 1279,    0,    0,    0,    0, 1279,
 1279,    0, 1279,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1280, 1279, 1279,    0,
 1279,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1279,    0, 1279,    0, 1279, 1279, 1279,    0, 1279,    0,
    0, 1279, 1279,    0,    0,    0,    0,    0,    0,    0,
    0, 1279,    0,    0,    0,    0, 1105, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1279,    0,    0, 1279,    0,    0,
    0,    0,    0,    0, 1280, 1280, 1280, 1280, 1280,    0,
    0,    0,    0, 1279,    0,    0,    0,    0,    0, 1279,
 1279,    0,    0,    0, 1279,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1279, 1279, 1280, 1279, 1280,
    0,    0,    0,    0, 1279,    0,    0, 1279,    0, 1279,
 1279, 1279, 1279,    0, 1279,    0, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1279, 1279,    0, 1279, 1279, 1279,    0,
    0,    0,    0, 1279, 1279, 1279, 1279, 1279,    0, 1279,
    0,    0, 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0,
    0,    0, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
    0, 1279,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279,    0, 1279, 1279, 1279, 1279, 1279, 1279,    0,
 1279, 1279, 1279, 1279,    0, 1279,    0, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279,
    0, 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279,
 1279, 1279,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1280,    0,
 1280, 1280,    0,    0,    0,    0,    0, 1280,    0,    0,
    0,    0,    0, 1280,    0,    0,    0,    0, 1280,    0,
    0, 1280,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1280,    0,    0,    0,    0,
 1280, 1280,    0,    0, 1280,    0,    0,    0,    0,    0,
    0, 1280,    0, 1280, 1280,    0,    0, 1280,    0,    0,
    0, 1280,    0, 1280,    0, 1280,    0, 1280,    0,    0,
    0,    0, 1280, 1280,    0, 1280,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1281,
 1280, 1280,    0, 1280,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1280,    0, 1280,    0, 1280, 1280, 1280,
    0, 1280,    0,    0, 1280, 1280,    0,    0,    0,    0,
    0,    0,    0,    0, 1280,    0,    0,    0,    0, 1106,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1280,    0,    0,
 1280,    0,    0,    0,    0,    0,    0, 1281, 1281, 1281,
 1281, 1281,    0,    0,    0,    0, 1280,    0,    0,    0,
    0,    0, 1280, 1280,    0,    0,    0, 1280,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1280, 1280,
 1281, 1280, 1281,    0,    0,    0,    0, 1280,    0,    0,
 1280,    0, 1280, 1280, 1280, 1280,    0, 1280,    0, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1280, 1280,    0, 1280,
 1280, 1280,    0,    0,    0,    0, 1280, 1280, 1280, 1280,
 1280,    0, 1280,    0,    0, 1280, 1280, 1280, 1280, 1280,
 1280, 1280,    0,    0,    0, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280,    0, 1280,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280,    0, 1280, 1280, 1280, 1280,
 1280, 1280,    0, 1280, 1280, 1280, 1280,    0, 1280,    0,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,    0, 1280,
 1280, 1280, 1280,    0, 1280, 1280, 1280, 1280, 1280,    0,
 1280, 1280, 1280, 1280, 1280,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1281,    0, 1281, 1281,    0,    0,    0,    0,    0,
 1281,    0,    0,    0,    0,    0, 1281,    0,    0,    0,
    0, 1281,    0,    0, 1281,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1281,    0,
    0,    0,    0, 1281, 1281,    0,    0, 1281,    0,    0,
    0,    0,    0,    0, 1281,    0, 1281, 1281,    0,    0,
 1281,    0,    0,    0, 1281,    0, 1281,    0, 1281,    0,
 1281,    0,    0,    0,    0, 1281, 1281,    0, 1281,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1282, 1281, 1281,    0, 1281,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1281,    0, 1281,    0,
 1281, 1281, 1281,    0, 1281,    0,    0, 1281, 1281,    0,
    0,    0,    0,    0,    0,    0,    0, 1281,    0,    0,
    0,    0, 1107, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1281,    0,    0, 1281,    0,    0,    0,    0,    0,    0,
 1282, 1282, 1282, 1282, 1282,    0,    0,    0,    0, 1281,
    0,    0,    0,    0,    0, 1281, 1281,    0,    0,    0,
 1281,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1281, 1281, 1282, 1281, 1282,    0,    0,    0,    0,
 1281,    0,    0, 1281,    0, 1281, 1281, 1281, 1281,    0,
 1281,    0, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1281,
 1281,    0, 1281, 1281, 1281,    0,    0,    0,    0, 1281,
 1281, 1281, 1281, 1281,    0, 1281,    0,    0, 1281, 1281,
 1281, 1281, 1281, 1281, 1281,    0,    0,    0, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281,    0, 1281,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,    0, 1281,
 1281, 1281, 1281, 1281, 1281,    0, 1281, 1281, 1281, 1281,
    0, 1281,    0, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281,    0, 1281, 1281, 1281, 1281,    0, 1281, 1281, 1281,
 1281, 1281,    0, 1281, 1281, 1281, 1281, 1281,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1282,    0, 1282, 1282,    0,    0,
    0,    0,    0, 1282,    0,    0,    0,    0,    0, 1282,
    0,    0,    0,    0, 1282,    0,    0, 1282,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1282,    0,    0,    0,    0, 1282, 1282,    0,    0,
 1282,    0,    0,    0,    0,    0,    0, 1282,    0, 1282,
 1282,    0,    0, 1282,    0,    0,    0, 1282,    0, 1282,
    0, 1282,    0, 1282,    0,    0,    0,    0, 1282, 1282,
    0, 1282,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1283, 1282, 1282,    0, 1282,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1282,
    0, 1282,    0, 1282, 1282, 1282,    0, 1282,    0,    0,
 1282, 1282,    0,    0,    0,    0,    0,    0,    0,    0,
 1282,    0,    0,    0,    0, 1108, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1282,    0,    0, 1282,    0,    0,    0,
    0,    0,    0, 1283, 1283, 1283, 1283, 1283,    0,    0,
    0,    0, 1282,    0,    0,    0,    0,    0, 1282, 1282,
    0,    0,    0, 1282,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1282, 1282, 1283, 1282, 1283,    0,
    0,    0,    0, 1282,    0,    0, 1282,    0, 1282, 1282,
 1282, 1282,    0, 1282,    0, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1282, 1282,    0, 1282, 1282, 1282,    0,    0,
    0,    0, 1282, 1282, 1282, 1282, 1282,    0, 1282,    0,
    0, 1282, 1282, 1282, 1282, 1282, 1282, 1282,    0,    0,
    0, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,    0,
 1282,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282,    0, 1282, 1282, 1282, 1282, 1282, 1282,    0, 1282,
 1282, 1282, 1282,    0, 1282,    0, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282,    0, 1282, 1282, 1282, 1282,    0,
 1282, 1282, 1282, 1282, 1282,    0, 1282, 1282, 1282, 1282,
 1282,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1283,    0, 1283,
 1283,    0,    0,    0,    0,    0, 1283,    0,    0,    0,
    0,    0, 1283,    0,    0,    0,    0, 1283,    0,    0,
 1283,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1283,    0,    0,    0,    0, 1283,
 1283,    0,    0, 1283,    0,    0,    0,    0,    0,    0,
 1283,    0, 1283, 1283,    0,    0, 1283,    0,    0,    0,
 1283,    0, 1283,    0, 1283,    0, 1283,    0,    0,    0,
    0, 1283, 1283,    0, 1283,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1284, 1283,
 1283,    0, 1283,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1283,    0, 1283,    0, 1283, 1283, 1283,    0,
 1283,    0,    0, 1283, 1283,    0,    0,    0,    0,    0,
    0,    0,    0, 1283,    0,    0,    0,    0, 1109, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1283,    0,    0, 1283,
    0,    0,    0,    0,    0,    0, 1284, 1284, 1284, 1284,
 1284,    0,    0,    0,    0, 1283,    0,    0,    0,    0,
    0, 1283, 1283,    0,    0,    0, 1283,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1283, 1283, 1284,
 1283, 1284,    0,    0,    0,    0, 1283,    0,    0, 1283,
    0, 1283, 1283, 1283, 1283,    0, 1283,    0, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1283, 1283,    0, 1283, 1283,
 1283,    0,    0,    0,    0, 1283, 1283, 1283, 1283, 1283,
    0, 1283,    0,    0, 1283, 1283, 1283, 1283, 1283, 1283,
 1283,    0,    0,    0, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283,    0, 1283,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283,    0, 1283, 1283, 1283, 1283, 1283,
 1283,    0, 1283, 1283, 1283, 1283,    0, 1283,    0, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283,    0, 1283, 1283,
 1283, 1283,    0, 1283, 1283, 1283, 1283, 1283,    0, 1283,
 1283, 1283, 1283, 1283,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1284,    0, 1284, 1284,    0,    0,    0,    0,    0, 1284,
    0,    0,    0,    0,    0, 1284,    0,    0,    0,    0,
 1284,    0,    0, 1284,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1284,    0,    0,
    0,    0, 1284, 1284,    0,    0, 1284,    0,    0,    0,
    0,    0,    0, 1284,    0, 1284, 1284,    0,    0, 1284,
    0,    0,    0, 1284,    0, 1284,    0, 1284,    0, 1284,
    0,    0,    0,    0, 1284, 1284,    0, 1284,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1285, 1284, 1284,    0, 1284,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1284,    0, 1284,    0, 1284,
 1284, 1284,    0, 1284,    0,    0, 1284, 1284,    0,    0,
    0,    0,    0,    0,    0,    0, 1284,    0,    0,    0,
    0, 1110, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1284,
    0,    0, 1284,    0,    0,    0,    0,    0,    0, 1285,
 1285, 1285, 1285, 1285,    0,    0,    0,    0, 1284,    0,
    0,    0,    0,    0, 1284, 1284,    0,    0,    0, 1284,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1284, 1284, 1285, 1284, 1285,    0,    0,    0,    0, 1284,
    0,    0, 1284,    0, 1284, 1284, 1284, 1284,    0, 1284,
    0, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1284, 1284,
    0, 1284, 1284, 1284,    0,    0,    0,    0, 1284, 1284,
 1284, 1284, 1284,    0, 1284,    0,    0, 1284, 1284, 1284,
 1284, 1284, 1284, 1284,    0,    0,    0, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284,    0, 1284,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284,    0, 1284, 1284,
 1284, 1284, 1284, 1284,    0, 1284, 1284, 1284, 1284,    0,
 1284,    0, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
    0, 1284, 1284, 1284, 1284,    0, 1284, 1284, 1284, 1284,
 1284,    0, 1284, 1284, 1284, 1284, 1284,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1285,    0, 1285, 1285,    0,    0,    0,
    0,    0, 1285,    0,    0,    0,    0,    0, 1285,    0,
    0,    0,    0, 1285,    0,    0, 1285,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1285,    0,    0,    0,    0, 1285, 1285,    0,    0, 1285,
    0,    0,    0,    0,    0,    0, 1285,    0, 1285, 1285,
    0,    0, 1285,    0,    0,    0, 1285,    0, 1285,    0,
 1285,    0, 1285,    0,    0,    0,    0, 1285, 1285,    0,
 1285,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1286, 1285, 1285,    0, 1285,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1285,    0,
 1285,    0, 1285, 1285, 1285,    0, 1285,    0,    0, 1285,
 1285,    0,    0,    0,    0,    0,    0,    0,    0, 1285,
    0,    0,    0,    0, 1111, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1285,    0,    0, 1285,    0,    0,    0,    0,
    0,    0, 1286, 1286, 1286, 1286, 1286,    0,    0,    0,
    0, 1285,    0,    0,    0,    0,    0, 1285, 1285,    0,
    0,    0, 1285,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1285, 1285, 1286, 1285, 1286,    0,    0,
    0,    0, 1285,    0,    0, 1285,    0, 1285, 1285, 1285,
 1285,    0, 1285,    0, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1285, 1285,    0, 1285, 1285, 1285,    0,    0,    0,
    0, 1285, 1285, 1285, 1285, 1285,    0, 1285,    0,    0,
 1285, 1285, 1285, 1285, 1285, 1285, 1285,    0,    0,    0,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,    0, 1285,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
    0, 1285, 1285, 1285, 1285, 1285, 1285,    0, 1285, 1285,
 1285, 1285,    0, 1285,    0, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285,    0, 1285, 1285, 1285, 1285,    0, 1285,
 1285, 1285, 1285, 1285,    0, 1285, 1285, 1285, 1285, 1285,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1286,    0, 1286, 1286,
    0,    0,    0,    0,    0, 1286,    0,    0,    0,    0,
    0, 1286,    0,    0,    0,    0, 1286,    0,    0, 1286,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1286,    0,    0,    0,    0, 1286, 1286,
    0,    0, 1286,    0,    0,    0,    0,    0,    0, 1286,
    0, 1286, 1286,    0,    0, 1286,    0,    0,    0, 1286,
    0, 1286,    0, 1286,    0, 1286,    0,    0,    0,    0,
 1286, 1286,    0, 1286,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1287, 1286, 1286,
    0, 1286,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1286,    0, 1286,    0, 1286, 1286, 1286,    0, 1286,
    0,    0, 1286, 1286,    0,    0,    0,    0,    0,    0,
    0,    0, 1286,    0,    0,    0,    0, 1112, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1286,    0,    0, 1286,    0,
    0,    0,    0,    0,    0, 1287, 1287, 1287, 1287, 1287,
    0,    0,    0,    0, 1286,    0,    0,    0,    0,    0,
 1286, 1286,    0,    0,    0, 1286,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1286, 1286, 1287, 1286,
 1287,    0,    0,    0,    0, 1286,    0,    0, 1286,    0,
 1286, 1286, 1286, 1286,    0, 1286,    0, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1286, 1286,    0, 1286, 1286, 1286,
    0,    0,    0,    0, 1286, 1286, 1286, 1286, 1286,    0,
 1286,    0,    0, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
    0,    0,    0, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286,    0, 1286,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286,    0, 1286, 1286, 1286, 1286, 1286, 1286,
    0, 1286, 1286, 1286, 1286,    0, 1286,    0, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286,    0, 1286, 1286, 1286,
 1286,    0, 1286, 1286, 1286, 1286, 1286,    0, 1286, 1286,
 1286, 1286, 1286,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1287,
    0, 1287, 1287,    0,    0,    0,    0,    0, 1287,    0,
    0,    0,    0,    0, 1287,    0,    0,    0,    0, 1287,
    0,    0, 1287,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1287,    0,    0,    0,
    0, 1287, 1287,    0,    0, 1287,    0,    0,    0,    0,
    0,    0, 1287,    0, 1287, 1287,    0,    0, 1287,    0,
    0,    0, 1287,    0, 1287,    0, 1287,    0, 1287,    0,
    0,    0,    0, 1287, 1287,    0, 1287,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1288, 1287, 1287,    0, 1287,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1287,    0, 1287,    0, 1287, 1287,
 1287,    0, 1287,    0,    0, 1287, 1287,    0,    0,    0,
    0,    0,    0,    0,    0, 1287,    0,    0,    0,    0,
 1113, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1287,    0,
    0, 1287,    0,    0,    0,    0,    0,    0, 1288, 1288,
 1288, 1288, 1288,    0,    0,    0,    0, 1287,    0,    0,
    0,    0,    0, 1287, 1287,    0,    0,    0, 1287,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1287,
 1287, 1288, 1287, 1288,    0,    0,    0,    0, 1287,    0,
    0, 1287,    0, 1287, 1287, 1287, 1287,    0, 1287,    0,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1287, 1287,    0,
 1287, 1287, 1287,    0,    0,    0,    0, 1287, 1287, 1287,
 1287, 1287,    0, 1287,    0,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287,    0,    0,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287,    0, 1287,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287,
 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287,    0, 1287,
    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,    0,
 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287, 1287,
    0, 1287, 1287, 1287, 1287, 1287,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1288,    0, 1288, 1288,    0,    0,    0,    0,
    0, 1288,    0,    0,    0,    0,    0, 1288,    0,    0,
    0,    0, 1288,    0,    0, 1288,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1288,
    0,    0,    0,    0, 1288, 1288,    0,    0, 1288,    0,
    0,    0,    0,    0,    0, 1288,    0, 1288, 1288,    0,
    0, 1288,    0,    0,    0, 1288,    0, 1288,    0, 1288,
    0, 1288,    0,    0,    0,    0, 1288, 1288,    0, 1288,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1292, 1288, 1288,    0, 1288,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1288,    0, 1288,
    0, 1288, 1288, 1288,    0, 1288,    0,    0, 1288, 1288,
    0,    0,    0,    0,    0,    0,    0,    0, 1288,    0,
    0,    0,    0, 1114, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1288,    0,    0, 1288,    0,    0,    0,    0,    0,
    0, 1292, 1292, 1292, 1292, 1292,    0,    0,    0,    0,
 1288,    0,    0,    0,    0,    0, 1288, 1288,    0,    0,
    0, 1288,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1288, 1288, 1292, 1288, 1292,    0,    0,    0,
    0, 1288,    0,    0, 1288,    0, 1288, 1288, 1288, 1288,
    0, 1288,    0, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1288, 1288,    0, 1288, 1288, 1288,    0,    0,    0,    0,
 1288, 1288, 1288, 1288, 1288,    0, 1288,    0,    0, 1288,
 1288, 1288, 1288, 1288, 1288, 1288,    0,    0,    0, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0, 1288,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0,
 1288, 1288, 1288, 1288, 1288, 1288,    0, 1288, 1288, 1288,
 1288,    0, 1288,    0, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288,    0, 1288, 1288, 1288, 1288,    0, 1288, 1288,
 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288, 1288,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1292,    0, 1292, 1292,    0,
    0,    0,    0,    0, 1292,    0,    0,    0,    0,    0,
 1292,    0,    0,    0,    0, 1292,    0,    0, 1292,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1292,    0,    0,    0,    0, 1292, 1292,    0,
    0, 1292,    0,    0,    0,    0,    0,    0, 1292,    0,
 1292, 1292,    0,    0, 1292,    0,    0,    0, 1292,    0,
 1292,    0, 1292,    0, 1292,    0,    0,    0,    0, 1292,
 1292,    0, 1292,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1293, 1292, 1292,    0,
 1292,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1292,    0, 1292,    0, 1292, 1292, 1292,    0, 1292,    0,
    0, 1292, 1292,    0,    0,    0,    0,    0,    0,    0,
    0, 1292,    0,    0,    0,    0, 1115, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1292,    0,    0, 1292,    0,    0,
    0,    0,    0,    0, 1293, 1293, 1293, 1293, 1293,    0,
    0,    0,    0, 1292,    0,    0,    0,    0,    0, 1292,
 1292,    0,    0,    0, 1292,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1292, 1292, 1293, 1292, 1293,
    0,    0,    0,    0, 1292,    0,    0, 1292,    0, 1292,
 1292, 1292, 1292,    0, 1292,    0, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1292, 1292,    0, 1292, 1292, 1292,    0,
    0,    0,    0, 1292, 1292, 1292, 1292, 1292,    0, 1292,
    0,    0, 1292, 1292, 1292, 1292, 1292, 1292, 1292,    0,
    0,    0, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
    0, 1292,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292,    0, 1292, 1292, 1292, 1292, 1292, 1292,    0,
 1292, 1292, 1292, 1292,    0, 1292,    0, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292,    0, 1292, 1292, 1292, 1292,
    0, 1292, 1292, 1292, 1292, 1292,    0, 1292, 1292, 1292,
 1292, 1292,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1293,    0,
 1293, 1293,    0,    0,    0,    0,    0, 1293,    0,    0,
    0,    0,    0, 1293,    0,    0,    0,    0, 1293,    0,
    0, 1293,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1293,    0,    0,    0,    0,
 1293, 1293,    0,    0, 1293,    0,    0,    0,    0,    0,
    0, 1293,    0, 1293, 1293,    0,    0, 1293,    0,    0,
    0, 1293,    0, 1293,    0, 1293,    0, 1293,    0,    0,
    0,    0, 1293, 1293,    0, 1293,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1294,
 1293, 1293,    0, 1293,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1293,    0, 1293,    0, 1293, 1293, 1293,
    0, 1293,    0,    0, 1293, 1293,    0,    0,    0,    0,
    0,    0,    0,    0, 1293,    0,    0,    0,    0, 1116,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1293,    0,    0,
 1293,    0,    0,    0,    0,    0,    0, 1294, 1294, 1294,
 1294, 1294,    0,    0,    0,    0, 1293,    0,    0,    0,
    0,    0, 1293, 1293,    0,    0,    0, 1293,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1293, 1293,
 1294, 1293, 1294,    0,    0,    0,    0, 1293,    0,    0,
 1293,    0, 1293, 1293, 1293, 1293,    0, 1293,    0, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1293, 1293,    0, 1293,
 1293, 1293,    0,    0,    0,    0, 1293, 1293, 1293, 1293,
 1293,    0, 1293,    0,    0, 1293, 1293, 1293, 1293, 1293,
 1293, 1293,    0,    0,    0, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293,    0, 1293,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1293,    0, 1293, 1293, 1293, 1293,
 1293, 1293,    0, 1293, 1293, 1293, 1293,    0, 1293,    0,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,    0, 1293,
 1293, 1293, 1293,    0, 1293, 1293, 1293, 1293, 1293,    0,
 1293, 1293, 1293, 1293, 1293,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1294,    0, 1294, 1294,    0,    0,    0,    0,    0,
 1294,    0,    0,    0,    0,    0, 1294,    0,    0,    0,
    0, 1294,    0,    0, 1294,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1294,    0,
    0,    0,    0, 1294, 1294,    0,    0, 1294,    0,    0,
    0,    0,    0,    0, 1294,    0, 1294, 1294,    0,    0,
 1294,    0,    0,    0, 1294,    0, 1294,    0, 1294,    0,
 1294,    0,    0,    0,    0, 1294, 1294,    0, 1294,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1296, 1294, 1294,    0, 1294,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1294,    0, 1294,    0,
 1294, 1294, 1294,    0, 1294,    0,    0, 1294, 1294,    0,
    0,    0,    0,    0,    0,    0,    0, 1294,    0,    0,
    0,    0, 1117, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1294,    0,    0, 1294,    0,    0,    0,    0,    0,    0,
 1296, 1296, 1296, 1296, 1296,    0,    0,    0,    0, 1294,
    0,    0,    0,    0,    0, 1294, 1294,    0,    0,    0,
 1294,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1294, 1294, 1296, 1294, 1296,    0,    0,    0,    0,
 1294,    0,    0, 1294,    0, 1294, 1294, 1294, 1294,    0,
 1294,    0, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1294,
 1294,    0, 1294, 1294, 1294,    0,    0,    0,    0, 1294,
 1294, 1294, 1294, 1294,    0, 1294,    0,    0, 1294, 1294,
 1294, 1294, 1294, 1294, 1294,    0,    0,    0, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294,    0, 1294,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,    0, 1294,
 1294, 1294, 1294, 1294, 1294,    0, 1294, 1294, 1294, 1294,
    0, 1294,    0, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294,    0, 1294, 1294, 1294, 1294,    0, 1294, 1294, 1294,
 1294, 1294,    0, 1294, 1294, 1294, 1294, 1294,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296,    0, 1296, 1296,    0,    0,
    0,    0,    0, 1296,    0,    0,    0,    0,    0, 1296,
    0,    0,    0,    0, 1296,    0,    0, 1296,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1296,    0,    0,    0,    0, 1296, 1296,    0,    0,
 1296,    0,    0,    0,    0,    0,    0, 1296,    0, 1296,
 1296,    0,    0, 1296,    0,    0,    0, 1296,    0, 1296,
    0, 1296,    0, 1296,    0,    0,    0,    0, 1296, 1296,
    0, 1296,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1298, 1296, 1296,    0, 1296,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1296,
    0, 1296,    0, 1296, 1296, 1296,    0, 1296,    0,    0,
 1296, 1296,    0,    0,    0,    0,    0,    0,    0,    0,
 1296,    0,    0,    0,    0, 1119, 1298, 1298, 1298, 1298,
 1298, 1298, 1298, 1296,    0,    0, 1296,    0,    0,    0,
    0,    0,    0, 1298, 1298, 1298, 1298, 1298,    0,    0,
    0,    0, 1296,    0,    0,    0,    0,    0, 1296, 1296,
    0,    0,    0, 1296,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296, 1296, 1298, 1296, 1298,    0,
    0,    0,    0, 1296,    0,    0, 1296,    0, 1296, 1296,
 1296, 1296,    0, 1296,    0, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1296, 1296,    0, 1296, 1296, 1296,    0,    0,
    0,    0, 1296, 1296, 1296, 1296, 1296,    0, 1296,    0,
    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296,    0,    0,
    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,    0,
 1296,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296,    0, 1296, 1296, 1296, 1296, 1296, 1296,    0, 1296,
 1296, 1296, 1296,    0, 1296,    0, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296,    0,
 1296, 1296, 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296,
 1296,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1298,    0, 1298,
 1298,    0,    0,    0,    0,    0, 1298,    0,    0,    0,
    0,    0, 1298,    0,    0,    0,    0, 1298,    0,    0,
 1298,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1298,    0,    0,    0,    0, 1298,
 1298,    0,    0, 1298,    0,    0,    0,    0,    0,    0,
 1298,    0, 1298, 1298,    0,    0, 1298,    0,    0,    0,
 1298,    0, 1298,    0, 1298,    0, 1298,    0,    0,    0,
    0, 1298, 1298,    0, 1298,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1299, 1298,
 1298,    0, 1298,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1298,    0, 1298,    0, 1298, 1298, 1298,    0,
 1298,    0,    0, 1298, 1298,    0,    0,    0,    0,    0,
    0,    0,    0, 1298,    0,    0,    0,    0, 1120, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1298,    0,    0, 1298,
    0,    0,    0,    0,    0,    0, 1299, 1299, 1299, 1299,
 1299,    0,    0,    0,    0, 1298,    0,    0,    0,    0,
    0, 1298, 1298,    0,    0,    0, 1298,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1298, 1298, 1299,
 1298, 1299,    0,    0,    0,    0, 1298,    0,    0, 1298,
    0, 1298, 1298, 1298, 1298,    0, 1298,    0, 1298, 1298,
 1298, 1298, 1298, 1298, 1298, 1298,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1298, 1298,    0, 1298, 1298,
 1298,    0,    0,    0,    0, 1298, 1298, 1298, 1298, 1298,
    0, 1298,    0,    0, 1298, 1298, 1298, 1298, 1298, 1298,
 1298,    0,    0,    0, 1298, 1298, 1298, 1298, 1298, 1298,
 1298, 1298,    0, 1298,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
 1298, 1298, 1298, 1298,    0, 1298, 1298, 1298, 1298, 1298,
 1298,    0, 1298, 1298, 1298, 1298,    0, 1298,    0, 1298,
 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
 1298, 1298, 1298, 1298, 1298, 1298, 1298,    0, 1298, 1298,
 1298, 1298,    0, 1298, 1298, 1298, 1298, 1298,    0, 1298,
 1298, 1298, 1298, 1298,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1299,    0, 1299, 1299,    0,    0,    0,    0,    0, 1299,
    0,    0,    0,    0,    0, 1299,    0,    0,    0,    0,
 1299,    0,    0, 1299,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1299,    0,    0,
    0,    0, 1299, 1299,    0,    0, 1299,    0,    0,    0,
    0,    0,    0, 1299,    0, 1299, 1299,    0,    0, 1299,
    0,    0,    0, 1299,    0, 1299,    0, 1299,    0, 1299,
    0,    0,    0,    0, 1299, 1299,    0, 1299,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1300, 1299, 1299,    0, 1299,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1299,    0, 1299,    0, 1299,
 1299, 1299,    0, 1299,    0,    0, 1299, 1299,    0,    0,
    0,    0,    0,    0,    0,    0, 1299,    0,    0,    0,
    0, 1121, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1299,
    0,    0, 1299,    0,    0,    0,    0,    0,    0, 1300,
 1300, 1300, 1300, 1300,    0,    0,    0,    0, 1299,    0,
    0,    0,    0,    0, 1299, 1299,    0,    0,    0, 1299,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1299, 1299, 1300, 1299, 1300,    0,    0,    0,    0, 1299,
    0,    0, 1299,    0, 1299, 1299, 1299, 1299,    0, 1299,
    0, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1299, 1299,
    0, 1299, 1299, 1299,    0,    0,    0,    0, 1299, 1299,
 1299, 1299, 1299,    0, 1299,    0,    0, 1299, 1299, 1299,
 1299, 1299, 1299, 1299,    0,    0,    0, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299,    0, 1299,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299,    0, 1299, 1299,
 1299, 1299, 1299, 1299,    0, 1299, 1299, 1299, 1299,    0,
 1299,    0, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
    0, 1299, 1299, 1299, 1299,    0, 1299, 1299, 1299, 1299,
 1299,    0, 1299, 1299, 1299, 1299, 1299,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1300,    0, 1300, 1300,    0,    0,    0,
    0,    0, 1300,    0,    0,    0,    0,    0, 1300,    0,
    0,    0,    0, 1300,    0,    0, 1300,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1300,    0,    0,    0,    0, 1300, 1300,    0,    0, 1300,
    0,    0,    0,    0,    0,    0, 1300,    0, 1300, 1300,
    0,    0, 1300,    0,    0,    0, 1300,    0, 1300,    0,
 1300,    0, 1300,    0,    0,    0,    0, 1300, 1300,    0,
 1300,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1301, 1300, 1300,    0, 1300,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1300,    0,
 1300,    0, 1300, 1300, 1300,    0, 1300,    0,    0, 1300,
 1300,    0,    0,    0,    0,    0,    0,    0,    0, 1300,
    0,    0,    0,    0, 1122, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1300,    0,    0, 1300,    0,    0,    0,    0,
    0,    0, 1301, 1301, 1301, 1301, 1301,    0,    0,    0,
    0, 1300,    0,    0,    0,    0,    0, 1300, 1300,    0,
    0,    0, 1300,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1300, 1300, 1301, 1300, 1301,    0,    0,
    0,    0, 1300,    0,    0, 1300,    0, 1300, 1300, 1300,
 1300,    0, 1300,    0, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1300, 1300,    0, 1300, 1300, 1300,    0,    0,    0,
    0, 1300, 1300, 1300, 1300, 1300,    0, 1300,    0,    0,
 1300, 1300, 1300, 1300, 1300, 1300, 1300,    0,    0,    0,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,    0, 1300,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
    0, 1300, 1300, 1300, 1300, 1300, 1300,    0, 1300, 1300,
 1300, 1300,    0, 1300,    0, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300,    0, 1300, 1300, 1300, 1300,    0, 1300,
 1300, 1300, 1300, 1300,    0, 1300, 1300, 1300, 1300, 1300,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1301,    0, 1301, 1301,
    0,    0,    0,    0,    0, 1301,    0,    0,    0,    0,
    0, 1301,    0,    0,    0,    0, 1301,    0,    0, 1301,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1301,    0,    0,    0,    0, 1301, 1301,
    0,    0, 1301,    0,    0,    0,    0,    0,    0, 1301,
    0, 1301, 1301,    0,    0, 1301,    0,    0,    0, 1301,
    0, 1301,    0, 1301,    0, 1301,    0,    0,    0,    0,
 1301, 1301,    0, 1301,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1304, 1301, 1301,
    0, 1301,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1301,    0, 1301,    0, 1301, 1301, 1301,    0, 1301,
    0,    0, 1301, 1301,    0,    0,    0,    0,    0,    0,
    0,    0, 1301,    0,    0,    0,    0, 1123, 1304, 1304,
 1304, 1304, 1304, 1304, 1304, 1301,    0,    0, 1301,    0,
    0,    0,    0,    0,    0, 1304, 1304, 1304, 1304, 1304,
    0,    0,    0,    0, 1301,    0,    0,    0,    0,    0,
 1301, 1301,    0,    0,    0, 1301,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1301, 1301, 1304, 1301,
 1304,    0,    0,    0,    0, 1301,    0,    0, 1301,    0,
 1301, 1301, 1301, 1301,    0, 1301,    0, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1301, 1301,    0, 1301, 1301, 1301,
    0,    0,    0,    0, 1301, 1301, 1301, 1301, 1301,    0,
 1301,    0,    0, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
    0,    0,    0, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301,    0, 1301,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301,    0, 1301, 1301, 1301, 1301, 1301, 1301,
    0, 1301, 1301, 1301, 1301,    0, 1301,    0, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301,    0, 1301, 1301, 1301,
 1301,    0, 1301, 1301, 1301, 1301, 1301,    0, 1301, 1301,
 1301, 1301, 1301,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1304,
    0, 1304, 1304,    0,    0,    0,    0,    0, 1304,    0,
    0,    0,    0,    0, 1304,    0,    0,    0,    0, 1304,
    0,    0, 1304,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1304,    0,    0,    0,
    0, 1304, 1304,    0,    0, 1304,    0,    0,    0,    0,
    0,    0, 1304,    0, 1304, 1304,    0,    0, 1304,    0,
    0,    0, 1304,    0, 1304,    0, 1304,    0, 1304,    0,
    0,    0,    0, 1304, 1304,    0, 1304,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1306, 1304, 1304,    0, 1304,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1304,    0, 1304,    0, 1304, 1304,
 1304,    0, 1304,    0,    0, 1304, 1304,    0,    0,    0,
    0,    0,    0,    0,    0, 1304,    0,    0,    0,    0,
 1124, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1304,    0,
    0, 1304,    0,    0,    0,    0,    0,    0, 1306, 1306,
 1306, 1306, 1306,    0,    0,    0,    0, 1304,    0,    0,
    0,    0,    0, 1304, 1304,    0,    0,    0, 1304,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1304,
 1304, 1306, 1304, 1306,    0,    0,    0,    0, 1304,    0,
    0, 1304,    0, 1304, 1304, 1304, 1304,    0, 1304,    0,
 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1304, 1304,    0,
 1304, 1304, 1304,    0,    0,    0,    0, 1304, 1304, 1304,
 1304, 1304,    0, 1304,    0,    0, 1304, 1304, 1304, 1304,
 1304, 1304, 1304,    0,    0,    0, 1304, 1304, 1304, 1304,
 1304, 1304, 1304, 1304,    0, 1304,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1304, 1304, 1304, 1304, 1304,
 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
 1304, 1304, 1304, 1304, 1304, 1304,    0, 1304, 1304, 1304,
 1304, 1304, 1304,    0, 1304, 1304, 1304, 1304,    0, 1304,
    0, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,    0,
 1304, 1304, 1304, 1304,    0, 1304, 1304, 1304, 1304, 1304,
    0, 1304, 1304, 1304, 1304, 1304,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1306,    0, 1306, 1306,    0,    0,    0,    0,
    0, 1306,    0,    0,    0,    0,    0, 1306,    0,    0,
    0,    0, 1306,    0,    0, 1306,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1306,
    0,    0,    0,    0, 1306, 1306,    0,    0, 1306,    0,
    0,    0,    0,    0,    0, 1306,    0, 1306, 1306,    0,
    0, 1306,    0,    0,    0, 1306,    0, 1306,    0, 1306,
    0, 1306,    0,    0,    0,    0, 1306, 1306,    0, 1306,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1307, 1306, 1306,    0, 1306,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1306,    0, 1306,
    0, 1306, 1306, 1306,    0, 1306,    0,    0, 1306, 1306,
    0,    0,    0,    0,    0,    0,    0,    0, 1306,    0,
    0,    0,    0, 1125, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1306,    0,    0, 1306,    0,    0,    0,    0,    0,
    0, 1307, 1307, 1307, 1307, 1307,    0,    0,    0,    0,
 1306,    0,    0,    0,    0,    0, 1306, 1306,    0,    0,
    0, 1306,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1306, 1306, 1307, 1306, 1307,    0,    0,    0,
    0, 1306,    0,    0, 1306,    0, 1306, 1306, 1306, 1306,
    0, 1306,    0, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
 1306,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1306, 1306,    0, 1306, 1306, 1306,    0,    0,    0,    0,
 1306, 1306, 1306, 1306, 1306,    0, 1306,    0,    0, 1306,
 1306, 1306, 1306, 1306, 1306, 1306,    0,    0,    0, 1306,
 1306, 1306, 1306, 1306, 1306, 1306, 1306,    0, 1306,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1306, 1306,
 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,    0,
 1306, 1306, 1306, 1306, 1306, 1306,    0, 1306, 1306, 1306,
 1306,    0, 1306,    0, 1306, 1306, 1306, 1306, 1306, 1306,
 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
 1306, 1306,    0, 1306, 1306, 1306, 1306,    0, 1306, 1306,
 1306, 1306, 1306,    0, 1306, 1306, 1306, 1306, 1306,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1307,    0, 1307, 1307,    0,
    0,    0,    0,    0, 1307,    0,    0,    0,    0,    0,
 1307,    0,    0,    0,    0, 1307,    0,    0, 1307,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1307,    0,    0,    0,    0, 1307, 1307,    0,
    0, 1307,    0,    0,    0,    0,    0,    0, 1307,    0,
 1307, 1307,    0,    0, 1307,    0,    0,    0, 1307,    0,
 1307,    0, 1307,    0, 1307,    0,    0,    0,    0, 1307,
 1307,    0, 1307,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1310, 1307, 1307,    0,
 1307,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1307,    0, 1307,    0, 1307, 1307, 1307,    0, 1307,    0,
    0, 1307, 1307,    0,    0,    0,    0,    0,    0,    0,
    0, 1307,    0,    0,    0,    0, 1126, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1307,    0,    0, 1307,    0,    0,
    0,    0,    0,    0, 1310, 1310, 1310, 1310, 1310,    0,
    0,    0,    0, 1307,    0,    0,    0,    0,    0, 1307,
 1307,    0,    0,    0, 1307,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1307, 1307, 1310, 1307, 1310,
    0,    0,    0,    0, 1307,    0,    0, 1307,    0, 1307,
 1307, 1307, 1307,    0, 1307,    0, 1307, 1307, 1307, 1307,
 1307, 1307, 1307, 1307,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1307, 1307,    0, 1307, 1307, 1307,    0,
    0,    0,    0, 1307, 1307, 1307, 1307, 1307,    0, 1307,
    0,    0, 1307, 1307, 1307, 1307, 1307, 1307, 1307,    0,
    0,    0, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
    0, 1307,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1307,    0, 1307, 1307, 1307, 1307, 1307, 1307,    0,
 1307, 1307, 1307, 1307,    0, 1307,    0, 1307, 1307, 1307,
 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307, 1307,
 1307, 1307, 1307, 1307, 1307,    0, 1307, 1307, 1307, 1307,
    0, 1307, 1307, 1307, 1307, 1307,    0, 1307, 1307, 1307,
 1307, 1307,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1310,    0,
 1310, 1310,    0,    0,    0,    0,    0, 1310,    0,    0,
    0,    0,    0, 1310,    0,    0,    0,    0, 1310,    0,
    0, 1310,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1310,    0,    0,    0,    0,
 1310, 1310,    0,    0, 1310,    0,    0,    0,    0,    0,
    0, 1310,    0, 1310, 1310,    0,    0, 1310,    0,    0,
    0, 1310,    0, 1310,    0, 1310,    0, 1310,    0,    0,
    0,    0, 1310, 1310,    0, 1310,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1312,
 1310, 1310,    0, 1310,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1310,    0, 1310,    0, 1310, 1310, 1310,
    0, 1310,    0,    0, 1310, 1310,    0,    0,    0,    0,
    0,    0,    0,    0, 1310,    0,    0,    0,    0, 1128,
 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1310,    0,    0,
 1310,    0,    0,    0,    0,    0,    0, 1312, 1312, 1312,
 1312, 1312,    0,    0,    0,    0, 1310,    0,    0,    0,
    0,    0, 1310, 1310,    0,    0,    0, 1310,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1310, 1310,
 1312, 1310, 1312,    0,    0,    0,    0, 1310,    0,    0,
 1310,    0, 1310, 1310, 1310, 1310,    0, 1310,    0, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1310, 1310,    0, 1310,
 1310, 1310,    0,    0,    0,    0, 1310, 1310, 1310, 1310,
 1310,    0, 1310,    0,    0, 1310, 1310, 1310, 1310, 1310,
 1310, 1310,    0,    0,    0, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310,    0, 1310,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310,    0, 1310, 1310, 1310, 1310,
 1310, 1310,    0, 1310, 1310, 1310, 1310,    0, 1310,    0,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,    0, 1310,
 1310, 1310, 1310,    0, 1310, 1310, 1310, 1310, 1310,    0,
 1310, 1310, 1310, 1310, 1310,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1312,    0, 1312, 1312,    0,    0,    0,    0,    0,
 1312,    0,    0,    0,    0,    0, 1312,    0,    0,    0,
    0, 1312,    0,    0, 1312,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1312,    0,
    0,    0,    0, 1312, 1312,    0,    0, 1312,    0,    0,
    0,    0,    0,    0, 1312,    0, 1312, 1312,    0,    0,
 1312,    0,    0,    0, 1312,    0, 1312,    0, 1312,    0,
 1312,    0,    0,    0,    0, 1312, 1312,    0, 1312,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1314, 1312, 1312,    0, 1312,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1312,    0, 1312,    0,
 1312, 1312, 1312,    0, 1312,    0,    0, 1312, 1312,    0,
    0,    0,    0,    0,    0,    0,    0, 1312,    0,    0,
    0,    0, 1129, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
 1312,    0,    0, 1312,    0,    0,    0,    0,    0,    0,
 1314, 1314, 1314, 1314, 1314,    0,    0,    0,    0, 1312,
    0,    0,    0,    0,    0, 1312, 1312,    0,    0,    0,
 1312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1312, 1312, 1314, 1312, 1314,    0,    0,    0,    0,
 1312,    0,    0, 1312,    0, 1312, 1312, 1312, 1312,    0,
 1312,    0, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1312,
 1312,    0, 1312, 1312, 1312,    0,    0,    0,    0, 1312,
 1312, 1312, 1312, 1312,    0, 1312,    0,    0, 1312, 1312,
 1312, 1312, 1312, 1312, 1312,    0,    0,    0, 1312, 1312,
 1312, 1312, 1312, 1312, 1312, 1312,    0, 1312,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1312, 1312, 1312,
 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,    0, 1312,
 1312, 1312, 1312, 1312, 1312,    0, 1312, 1312, 1312, 1312,
    0, 1312,    0, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
 1312,    0, 1312, 1312, 1312, 1312,    0, 1312, 1312, 1312,
 1312, 1312,    0, 1312, 1312, 1312, 1312, 1312,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1314,    0, 1314, 1314,    0,    0,
    0,    0,    0, 1314,    0,    0,    0,    0,    0, 1314,
    0,    0,    0,    0, 1314,    0,    0, 1314,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1314,    0,    0,    0,    0, 1314, 1314,    0,    0,
 1314,    0,    0,    0,    0,    0,    0, 1314,    0, 1314,
 1314,    0,    0, 1314,    0,    0,    0, 1314,    0, 1314,
    0, 1314,    0, 1314,    0,    0,    0,    0, 1314, 1314,
    0, 1314,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1315, 1314, 1314,    0, 1314,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1314,
    0, 1314,    0, 1314, 1314, 1314,    0, 1314,    0,    0,
 1314, 1314,    0,    0,    0,    0,    0,    0,    0,    0,
 1314,    0,    0,    0,    0, 1130, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1314,    0,    0, 1314,    0,    0,    0,
    0,    0,    0, 1315, 1315, 1315, 1315, 1315,    0,    0,
    0,    0, 1314,    0,    0,    0,    0,    0, 1314, 1314,
    0,    0,    0, 1314,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1314, 1314, 1315, 1314, 1315,    0,
    0,    0,    0, 1314,    0,    0, 1314,    0, 1314, 1314,
 1314, 1314,    0, 1314,    0, 1314, 1314, 1314, 1314, 1314,
 1314, 1314, 1314,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1314, 1314,    0, 1314, 1314, 1314,    0,    0,
    0,    0, 1314, 1314, 1314, 1314, 1314,    0, 1314,    0,
    0, 1314, 1314, 1314, 1314, 1314, 1314, 1314,    0,    0,
    0, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,    0,
 1314,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
 1314,    0, 1314, 1314, 1314, 1314, 1314, 1314,    0, 1314,
 1314, 1314, 1314,    0, 1314,    0, 1314, 1314, 1314, 1314,
 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
 1314, 1314, 1314, 1314,    0, 1314, 1314, 1314, 1314,    0,
 1314, 1314, 1314, 1314, 1314,    0, 1314, 1314, 1314, 1314,
 1314,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1315,    0, 1315,
 1315,    0,    0,    0,    0,    0, 1315,    0,    0,    0,
    0,    0, 1315,    0,    0,    0,    0, 1315,    0,    0,
 1315,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1315,    0,    0,    0,    0, 1315,
 1315,    0,    0, 1315,    0,    0,    0,    0,    0,    0,
 1315,    0, 1315, 1315,    0,    0, 1315,    0,    0,    0,
 1315,    0, 1315,    0, 1315,    0, 1315,    0,    0,    0,
    0, 1315, 1315,    0, 1315,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1316, 1315,
 1315,    0, 1315,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1315,    0, 1315,    0, 1315, 1315, 1315,    0,
 1315,    0,    0, 1315, 1315,    0,    0,    0,    0,    0,
    0,    0,    0, 1315,    0,    0,    0,    0, 1131, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1315,    0,    0, 1315,
    0,    0,    0,    0,    0,    0, 1316, 1316, 1316, 1316,
 1316,    0,    0,    0,    0, 1315,    0,    0,    0,    0,
    0, 1315, 1315,    0,    0,    0, 1315,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1315, 1315, 1316,
 1315, 1316,    0,    0,    0,    0, 1315,    0,    0, 1315,
    0, 1315, 1315, 1315, 1315,    0, 1315,    0, 1315, 1315,
 1315, 1315, 1315, 1315, 1315, 1315,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1315, 1315,    0, 1315, 1315,
 1315,    0,    0,    0,    0, 1315, 1315, 1315, 1315, 1315,
    0, 1315,    0,    0, 1315, 1315, 1315, 1315, 1315, 1315,
 1315,    0,    0,    0, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315,    0, 1315,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1315,    0, 1315, 1315, 1315, 1315, 1315,
 1315,    0, 1315, 1315, 1315, 1315,    0, 1315,    0, 1315,
 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
 1315, 1315, 1315, 1315, 1315, 1315, 1315,    0, 1315, 1315,
 1315, 1315,    0, 1315, 1315, 1315, 1315, 1315,    0, 1315,
 1315, 1315, 1315, 1315,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1316,    0, 1316, 1316,    0,    0,    0,    0,    0, 1316,
    0,    0,    0,    0,    0, 1316,    0,    0,    0,    0,
 1316,    0,    0, 1316,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1316,    0,    0,
    0,    0, 1316, 1316,    0,    0, 1316,    0,    0,    0,
    0,    0,    0, 1316,    0, 1316, 1316,    0,    0, 1316,
    0,    0,    0, 1316,    0, 1316,    0, 1316,    0, 1316,
    0,    0,    0,    0, 1316, 1316,    0, 1316,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1317, 1316, 1316,    0, 1316,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1316,    0, 1316,    0, 1316,
 1316, 1316,    0, 1316,    0,    0, 1316, 1316,    0,    0,
    0,    0,    0,    0,    0,    0, 1316,    0,    0,    0,
    0, 1133, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1316,
    0,    0, 1316,    0,    0,    0,    0,    0,    0, 1317,
 1317, 1317, 1317, 1317,    0,    0,    0,    0, 1316,    0,
    0,    0,    0,    0, 1316, 1316,    0,    0,    0, 1316,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1316, 1316, 1317, 1316, 1317,    0,    0,    0,    0, 1316,
    0,    0, 1316,    0, 1316, 1316, 1316, 1316,    0, 1316,
    0, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1316, 1316,
    0, 1316, 1316, 1316,    0,    0,    0,    0, 1316, 1316,
 1316, 1316, 1316,    0, 1316,    0,    0, 1316, 1316, 1316,
 1316, 1316, 1316, 1316,    0,    0,    0, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316,    0, 1316,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1316, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1316,    0, 1316, 1316,
 1316, 1316, 1316, 1316,    0, 1316, 1316, 1316, 1316,    0,
 1316,    0, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
    0, 1316, 1316, 1316, 1316,    0, 1316, 1316, 1316, 1316,
 1316,    0, 1316, 1316, 1316, 1316, 1316,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1317,    0, 1317, 1317,    0,    0,    0,
    0,    0, 1317,    0,    0,    0,    0,    0, 1317,    0,
    0,    0,    0, 1317,    0,    0, 1317,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1317,    0,    0,    0,    0, 1317, 1317,    0,    0, 1317,
    0,    0,    0,    0,    0,    0, 1317,    0, 1317, 1317,
    0,    0, 1317,    0,    0,    0, 1317,    0, 1317,    0,
 1317,    0, 1317,    0,    0,    0,    0, 1317, 1317,    0,
 1317,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1318, 1317, 1317,    0, 1317,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1317,    0,
 1317,    0, 1317, 1317, 1317,    0, 1317,    0,    0, 1317,
 1317,    0,    0,    0,    0,    0,    0,    0,    0, 1317,
    0,    0,    0,    0, 1134, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1317,    0,    0, 1317,    0,    0,    0,    0,
    0,    0, 1318, 1318, 1318, 1318, 1318,    0,    0,    0,
    0, 1317,    0,    0,    0,    0,    0, 1317, 1317,    0,
    0,    0, 1317,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1317, 1317, 1318, 1317, 1318,    0,    0,
    0,    0, 1317,    0,    0, 1317,    0, 1317, 1317, 1317,
 1317,    0, 1317,    0, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1317, 1317,    0, 1317, 1317, 1317,    0,    0,    0,
    0, 1317, 1317, 1317, 1317, 1317,    0, 1317,    0,    0,
 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0,    0,    0,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0, 1317,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
    0, 1317, 1317, 1317, 1317, 1317, 1317,    0, 1317, 1317,
 1317, 1317,    0, 1317,    0, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317,    0, 1317,
 1317, 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317, 1317,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1318,    0, 1318, 1318,
    0,    0,    0,    0,    0, 1318,    0,    0,    0,    0,
    0, 1318,    0,    0,    0,    0, 1318,    0,    0, 1318,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1318,    0,    0,    0,    0, 1318, 1318,
    0,    0, 1318,    0,    0,    0,    0,    0,    0, 1318,
    0, 1318, 1318,    0,    0, 1318,    0,    0,    0, 1318,
    0, 1318,    0, 1318,    0, 1318,    0,    0,    0,    0,
 1318, 1318,    0, 1318,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1319, 1318, 1318,
    0, 1318,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1318,    0, 1318,    0, 1318, 1318, 1318,    0, 1318,
    0,    0, 1318, 1318,    0,    0,    0,    0,    0,    0,
    0,    0, 1318,    0,    0,    0,    0, 1135, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1318,    0,    0, 1318,    0,
    0,    0,    0,    0,    0, 1319, 1319, 1319, 1319, 1319,
    0,    0,    0,    0, 1318,    0,    0,    0,    0,    0,
 1318, 1318,    0,    0,    0, 1318,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1318, 1318, 1319, 1318,
 1319,    0,    0,    0,    0, 1318,    0,    0, 1318,    0,
 1318, 1318, 1318, 1318,    0, 1318,    0, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1318, 1318,    0, 1318, 1318, 1318,
    0,    0,    0,    0, 1318, 1318, 1318, 1318, 1318,    0,
 1318,    0,    0, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
    0,    0,    0, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318,    0, 1318,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318,    0, 1318, 1318, 1318, 1318, 1318, 1318,
    0, 1318, 1318, 1318, 1318,    0, 1318,    0, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318,    0, 1318, 1318, 1318,
 1318,    0, 1318, 1318, 1318, 1318, 1318,    0, 1318, 1318,
 1318, 1318, 1318,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1319,
    0, 1319, 1319,    0,    0,    0,    0,    0, 1319,    0,
    0,    0,    0,    0, 1319,    0,    0,    0,    0, 1319,
    0,    0, 1319,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1319,    0,    0,    0,
    0, 1319, 1319,    0,    0, 1319,    0,    0,    0,    0,
    0,    0, 1319,    0, 1319, 1319,    0,    0, 1319,    0,
    0,    0, 1319,    0, 1319,    0, 1319,    0, 1319,    0,
    0,    0,    0, 1319, 1319,    0, 1319,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1320, 1319, 1319,    0, 1319,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1319,    0, 1319,    0, 1319, 1319,
 1319,    0, 1319,    0,    0, 1319, 1319,    0,    0,    0,
    0,    0,    0,    0,    0, 1319,    0,    0,    0,    0,
 1136, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1319,    0,
    0, 1319,    0,    0,    0,    0,    0,    0, 1320, 1320,
 1320, 1320, 1320,    0,    0,    0,    0, 1319,    0,    0,
    0,    0,    0, 1319, 1319,    0,    0,    0, 1319,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1319,
 1319, 1320, 1319, 1320,    0,    0,    0,    0, 1319,    0,
    0, 1319,    0, 1319, 1319, 1319, 1319,    0, 1319,    0,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1319, 1319,    0,
 1319, 1319, 1319,    0,    0,    0,    0, 1319, 1319, 1319,
 1319, 1319,    0, 1319,    0,    0, 1319, 1319, 1319, 1319,
 1319, 1319, 1319,    0,    0,    0, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319,    0, 1319,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319,    0, 1319, 1319, 1319,
 1319, 1319, 1319,    0, 1319, 1319, 1319, 1319,    0, 1319,
    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,    0,
 1319, 1319, 1319, 1319,    0, 1319, 1319, 1319, 1319, 1319,
    0, 1319, 1319, 1319, 1319, 1319,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1320,    0, 1320, 1320,    0,    0,    0,    0,
    0, 1320,    0,    0,    0,    0,    0, 1320,    0,    0,
    0,    0, 1320,    0,    0, 1320,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1320,
    0,    0,    0,    0, 1320, 1320,    0,    0, 1320,    0,
    0,    0,    0,    0,    0, 1320,    0, 1320, 1320,    0,
    0, 1320,    0,    0,    0, 1320,    0, 1320,    0, 1320,
    0, 1320,    0,    0,    0,    0, 1320, 1320,    0, 1320,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1321, 1320, 1320,    0, 1320,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1320,    0, 1320,
    0, 1320, 1320, 1320,    0, 1320,    0,    0, 1320, 1320,
    0,    0,    0,    0,    0,    0,    0,    0, 1320,    0,
    0,    0,    0, 1137, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1320,    0,    0, 1320,    0,    0,    0,    0,    0,
    0, 1321, 1321, 1321, 1321, 1321,    0,    0,    0,    0,
 1320,    0,    0,    0,    0,    0, 1320, 1320,    0,    0,
    0, 1320,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1320, 1320, 1321, 1320, 1321,    0,    0,    0,
    0, 1320,    0,    0, 1320,    0, 1320, 1320, 1320, 1320,
    0, 1320,    0, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1320, 1320,    0, 1320, 1320, 1320,    0,    0,    0,    0,
 1320, 1320, 1320, 1320, 1320,    0, 1320,    0,    0, 1320,
 1320, 1320, 1320, 1320, 1320, 1320,    0,    0,    0, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0, 1320,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0,
 1320, 1320, 1320, 1320, 1320, 1320,    0, 1320, 1320, 1320,
 1320,    0, 1320,    0, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320,    0, 1320, 1320, 1320, 1320,    0, 1320, 1320,
 1320, 1320, 1320,    0, 1320, 1320, 1320, 1320, 1320,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1321,    0, 1321, 1321,    0,
    0,    0,    0,    0, 1321,    0,    0,    0,    0,    0,
 1321,    0,    0,    0,    0, 1321,    0,    0, 1321,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1321,    0,    0,    0,    0, 1321, 1321,    0,
    0, 1321,    0,    0,    0,    0,    0,    0, 1321,    0,
 1321, 1321,    0,    0, 1321,    0,    0,    0, 1321,    0,
 1321,    0, 1321,    0, 1321,    0,    0,    0,    0, 1321,
 1321,    0, 1321,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1323, 1321, 1321,    0,
 1321,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1321,    0, 1321,    0, 1321, 1321, 1321,    0, 1321,    0,
    0, 1321, 1321,    0,    0,    0,    0,    0,    0,    0,
    0, 1321,    0,    0,    0,    0, 1138, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1321,    0,    0, 1321,    0,    0,
    0,    0,    0,    0, 1323, 1323, 1323, 1323, 1323,    0,
    0,    0,    0, 1321,    0,    0,    0,    0,    0, 1321,
 1321,    0,    0,    0, 1321,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1321, 1321, 1323, 1321, 1323,
    0,    0,    0,    0, 1321,    0,    0, 1321,    0, 1321,
 1321, 1321, 1321,    0, 1321,    0, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1321, 1321,    0, 1321, 1321, 1321,    0,
    0,    0,    0, 1321, 1321, 1321, 1321, 1321,    0, 1321,
    0,    0, 1321, 1321, 1321, 1321, 1321, 1321, 1321,    0,
    0,    0, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
    0, 1321,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321,    0, 1321, 1321, 1321, 1321, 1321, 1321,    0,
 1321, 1321, 1321, 1321,    0, 1321,    0, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321,    0, 1321, 1321, 1321, 1321,
    0, 1321, 1321, 1321, 1321, 1321,    0, 1321, 1321, 1321,
 1321, 1321,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1323,    0,
 1323, 1323,    0,    0,    0,    0,    0, 1323,    0,    0,
    0,    0,    0, 1323,    0,    0,    0,    0, 1323,    0,
    0, 1323,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1323,    0,    0,    0,    0,
 1323, 1323,    0,    0, 1323,    0,    0,    0,    0,    0,
    0, 1323,    0, 1323, 1323,    0,    0, 1323,    0,    0,
    0, 1323,    0, 1323,    0, 1323,    0, 1323,    0,    0,
    0,    0, 1323, 1323,    0, 1323,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1324,
 1323, 1323,    0, 1323,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1323,    0, 1323,    0, 1323, 1323, 1323,
    0, 1323,    0,    0, 1323, 1323,    0,    0,    0,    0,
    0,    0,    0,    0, 1323,    0,    0,    0,    0, 1139,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1323,    0,    0,
 1323,    0,    0,    0,    0,    0,    0, 1324, 1324, 1324,
 1324, 1324,    0,    0,    0,    0, 1323,    0,    0,    0,
    0,    0, 1323, 1323,    0,    0,    0, 1323,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1323, 1323,
 1324, 1323, 1324,    0,    0,    0,    0, 1323,    0,    0,
 1323,    0, 1323, 1323, 1323, 1323,    0, 1323,    0, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1323, 1323,    0, 1323,
 1323, 1323,    0,    0,    0,    0, 1323, 1323, 1323, 1323,
 1323,    0, 1323,    0,    0, 1323, 1323, 1323, 1323, 1323,
 1323, 1323,    0,    0,    0, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323,    0, 1323,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323,    0, 1323, 1323, 1323, 1323,
 1323, 1323,    0, 1323, 1323, 1323, 1323,    0, 1323,    0,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,    0, 1323,
 1323, 1323, 1323,    0, 1323, 1323, 1323, 1323, 1323,    0,
 1323, 1323, 1323, 1323, 1323,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1324,    0, 1324, 1324,    0,    0,    0,    0,    0,
 1324,    0,    0,    0,    0,    0, 1324,    0,    0,    0,
    0, 1324,    0,    0, 1324,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1324,    0,
    0,    0,    0, 1324, 1324,    0,    0, 1324,    0,    0,
    0,    0,    0,    0, 1324,    0, 1324, 1324,    0,    0,
 1324,    0,    0,    0, 1324,    0, 1324,    0, 1324,    0,
 1324,    0,    0,    0,    0, 1324, 1324,    0, 1324,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1325, 1324, 1324,    0, 1324,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1324,    0, 1324,    0,
 1324, 1324, 1324,    0, 1324,    0,    0, 1324, 1324,    0,
    0,    0,    0,    0,    0,    0,    0, 1324,    0,    0,
    0,    0, 1140, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1324,    0,    0, 1324,    0,    0,    0,    0,    0,    0,
 1325, 1325, 1325, 1325, 1325,    0,    0,    0,    0, 1324,
    0,    0,    0,    0,    0, 1324, 1324,    0,    0,    0,
 1324,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1324, 1324, 1325, 1324, 1325,    0,    0,    0,    0,
 1324,    0,    0, 1324,    0, 1324, 1324, 1324, 1324,    0,
 1324,    0, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1324,
 1324,    0, 1324, 1324, 1324,    0,    0,    0,    0, 1324,
 1324, 1324, 1324, 1324,    0, 1324,    0,    0, 1324, 1324,
 1324, 1324, 1324, 1324, 1324,    0,    0,    0, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324,    0, 1324,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,    0, 1324,
 1324, 1324, 1324, 1324, 1324,    0, 1324, 1324, 1324, 1324,
    0, 1324,    0, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324,    0, 1324, 1324, 1324, 1324,    0, 1324, 1324, 1324,
 1324, 1324,    0, 1324, 1324, 1324, 1324, 1324,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1325,    0, 1325, 1325,    0,    0,
    0,    0,    0, 1325,    0,    0,    0,    0,    0, 1325,
    0,    0,    0,    0, 1325,    0,    0, 1325,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1325,    0,    0,    0,    0, 1325, 1325,    0,    0,
 1325,    0,    0,    0,    0,    0,    0, 1325,    0, 1325,
 1325,    0,    0, 1325,    0,    0,    0, 1325,    0, 1325,
    0, 1325,    0, 1325,    0,    0,    0,    0, 1325, 1325,
    0, 1325,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1327, 1325, 1325,    0, 1325,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1325,
    0, 1325,    0, 1325, 1325, 1325,    0, 1325,    0,    0,
 1325, 1325,    0,    0,    0,    0,    0,    0,    0,    0,
 1325,    0,    0,    0,    0, 1141, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1325,    0,    0, 1325,    0,    0,    0,
    0,    0,    0, 1327, 1327, 1327, 1327, 1327,    0,    0,
    0,    0, 1325,    0,    0,    0,    0,    0, 1325, 1325,
    0,    0,    0, 1325,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1325, 1325, 1327, 1325, 1327,    0,
    0,    0,    0, 1325,    0,    0, 1325,    0, 1325, 1325,
 1325, 1325,    0, 1325,    0, 1325, 1325, 1325, 1325, 1325,
 1325, 1325, 1325,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1325, 1325,    0, 1325, 1325, 1325,    0,    0,
    0,    0, 1325, 1325, 1325, 1325, 1325,    0, 1325,    0,
    0, 1325, 1325, 1325, 1325, 1325, 1325, 1325,    0,    0,
    0, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,    0,
 1325,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1325,    0, 1325, 1325, 1325, 1325, 1325, 1325,    0, 1325,
 1325, 1325, 1325,    0, 1325,    0, 1325, 1325, 1325, 1325,
 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1325, 1325, 1325, 1325,    0, 1325, 1325, 1325, 1325,    0,
 1325, 1325, 1325, 1325, 1325,    0, 1325, 1325, 1325, 1325,
 1325,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1327,    0, 1327,
 1327,    0,    0,    0,    0,    0, 1327,    0,    0,    0,
    0,    0, 1327,    0,    0,    0,    0, 1327,    0,    0,
 1327,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1327,    0,    0,    0,    0, 1327,
 1327,    0,    0, 1327,    0,    0,    0,    0,    0,    0,
 1327,    0, 1327, 1327,    0,    0, 1327,    0,    0,    0,
 1327,    0, 1327,    0, 1327,    0, 1327,    0,    0,    0,
    0, 1327, 1327,    0, 1327,    0,    0,    0,    0,    0,
    0,    0,    0, 1241,    0,    0,    0,    0,    0, 1327,
 1327,    0, 1327,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1327,    0, 1327,    0, 1327, 1327, 1327,    0,
 1327,    0,    0, 1327, 1327,    0,    0,    0,    0,    0,
    0,    0,    0, 1327, 1241, 1241, 1241, 1241, 1241, 1241,
 1241,    0,    0,    0,    0,    0, 1327,    0,    0, 1327,
    0, 1241, 1241, 1241, 1241, 1241,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1327,    0,    0,    0,    0,
    0, 1327, 1327,    0,    0,    0, 1327,    0,    0,    0,
    0,    0,    0,    0, 1241,    0, 1241, 1327, 1327,    0,
 1327,    0,    0,    0,    0,    0, 1327,    0,    0, 1327,
    0, 1327, 1327, 1327, 1327,    0, 1327,    0, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1327, 1327,    0, 1327, 1327,
 1327,    0,    0,    0,    0, 1327, 1327, 1327, 1327, 1327,
    0, 1327,    0,    0, 1327, 1327, 1327, 1327, 1327, 1327,
 1327,    0,    0,    0, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327,    0, 1327,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327,    0, 1327, 1327, 1327, 1327, 1327,
 1327,    0, 1327, 1327, 1327, 1327,    0, 1327,    0, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327,    0, 1327, 1327,
 1327, 1327,    0, 1327, 1327, 1327, 1327, 1327,    0, 1327,
 1327, 1327, 1327, 1327,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1241,    0, 1241, 1241,    0,
    0,    0,    0,    0, 1241,    0,    0,    0,    0,    0,
 1241,    0,    0,    0,    0, 1241,    0,    0, 1241,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1241,    0,    0,    0,    0, 1241, 1241,    0,
    0, 1241,    0,    0,    0,    0,    0,    0, 1241,    0,
 1241, 1241,    0,    0, 1241,    0,    0,    0, 1241,    0,
 1241,    0, 1241,    0, 1241,    0,    0,    0,    0, 1241,
 1241,    0, 1241,    0,    0,    0,    0,    0,    0,    0,
    0, 1289,    0,    0,    0,    0,    0, 1241, 1241,    0,
 1241,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1241,    0, 1241,    0, 1241, 1241, 1241,    0, 1241,    0,
    0, 1241, 1241,    0,    0,    0,    0,    0,    0,    0,
    0, 1241, 1289, 1289, 1289, 1289, 1289, 1289, 1289,    0,
    0,    0,    0,    0, 1241,    0,    0, 1241,    0, 1289,
 1289, 1289, 1289, 1289,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1241,    0,    0,    0,    0,    0, 1241,
 1241,    0,    0,    0, 1241,    0,    0,    0,    0,    0,
    0,    0, 1289,    0, 1289, 1241, 1241,    0, 1241,    0,
    0,    0,    0,    0, 1241,    0,    0, 1241,    0, 1241,
 1241, 1241, 1241,    0, 1241,    0, 1241, 1241, 1241, 1241,
 1241, 1241, 1241, 1241,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1241, 1241,    0, 1241, 1241, 1241,    0,
    0,    0,    0, 1241, 1241, 1241, 1241, 1241,    0, 1241,
    0,    0, 1241, 1241, 1241, 1241, 1241, 1241, 1241,    0,
    0,    0, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241,
    0, 1241,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241,
 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241,
 1241, 1241,    0, 1241, 1241, 1241, 1241, 1241, 1241,    0,
 1241, 1241, 1241, 1241,    0, 1241,    0, 1241, 1241, 1241,
 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241, 1241,
 1241, 1241, 1241, 1241, 1241,    0, 1241, 1241, 1241, 1241,
    0, 1241, 1241, 1241, 1241, 1241,    0, 1241, 1241, 1241,
 1241, 1241,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1289,    0, 1289, 1289,    0,    0,    0,
    0,    0, 1289,    0,    0,    0,    0,    0, 1289,    0,
    0,    0,    0, 1289,    0,    0, 1289,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1289,    0,    0,    0,    0, 1289, 1289,    0,    0, 1289,
    0,    0,    0,    0,    0,    0, 1289,    0, 1289, 1289,
    0,    0, 1289,    0,    0,    0, 1289,    0, 1289,    0,
 1289,    0, 1289,    0,    0,    0,    0, 1289, 1289,    0,
 1289,    0,    0,    0,    0,    0,    0,    0,    0, 1290,
    0,    0,    0,    0,    0, 1289, 1289,    0, 1289,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1289,    0,
 1289,    0, 1289, 1289, 1289,    0, 1289,    0,    0, 1289,
 1289,    0,    0,    0,    0,    0,    0,    0,    0, 1289,
 1290, 1290, 1290, 1290, 1290, 1290, 1290,    0,    0,    0,
    0,    0, 1289,    0,    0, 1289,    0, 1290, 1290, 1290,
 1290, 1290,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1289,    0,    0,    0,    0,    0, 1289, 1289,    0,
    0,    0, 1289,    0,    0,    0,    0,    0,    0,    0,
 1290,    0, 1290, 1289, 1289,    0, 1289,    0,    0,    0,
    0,    0, 1289,    0,    0, 1289,    0, 1289, 1289, 1289,
 1289,    0, 1289,    0, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1289, 1289,    0, 1289, 1289, 1289,    0,    0,    0,
    0, 1289, 1289, 1289, 1289, 1289,    0, 1289,    0,    0,
 1289, 1289, 1289, 1289, 1289, 1289, 1289,    0,    0,    0,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,    0, 1289,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
    0, 1289, 1289, 1289, 1289, 1289, 1289,    0, 1289, 1289,
 1289, 1289,    0, 1289,    0, 1289, 1289, 1289, 1289, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289, 1289,    0, 1289, 1289, 1289, 1289,    0, 1289,
 1289, 1289, 1289, 1289,    0, 1289, 1289, 1289, 1289, 1289,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1290,    0, 1290, 1290,    0,    0,    0,    0,    0,
 1290,    0,    0,    0,    0,    0, 1290,    0,    0,    0,
    0, 1290,    0,    0, 1290,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1290,    0,
    0,    0,    0, 1290, 1290,    0,    0, 1290,    0,    0,
    0,    0,    0,    0, 1290,    0, 1290, 1290,    0,    0,
 1290,    0,    0,    0, 1290,    0, 1290,    0, 1290,    0,
 1290,    0,    0,    0,    0, 1290, 1290,    0, 1290,    0,
    0,    0,    0,    0,    0,    0,    0, 1308,    0,    0,
    0,    0,    0, 1290, 1290,    0, 1290,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1290,    0, 1290,    0,
 1290, 1290, 1290,    0, 1290,    0,    0, 1290, 1290,    0,
    0,    0,    0,    0,    0,    0,    0, 1290, 1308, 1308,
 1308, 1308, 1308, 1308, 1308,    0,    0,    0,    0,    0,
 1290,    0,    0, 1290,    0, 1308, 1308, 1308, 1308, 1308,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1290,
    0,    0,    0,    0,    0, 1290, 1290,    0,    0,    0,
 1290,    0,    0,    0,    0,    0,    0,    0, 1308,    0,
 1308, 1290, 1290,    0, 1290,    0,    0,    0,    0,    0,
 1290,    0,    0, 1290,    0, 1290, 1290, 1290, 1290,    0,
 1290,    0, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1290,
 1290,    0, 1290, 1290, 1290,    0,    0,    0,    0, 1290,
 1290, 1290, 1290, 1290,    0, 1290,    0,    0, 1290, 1290,
 1290, 1290, 1290, 1290, 1290,    0,    0,    0, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290,    0, 1290,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,    0, 1290,
 1290, 1290, 1290, 1290, 1290,    0, 1290, 1290, 1290, 1290,
    0, 1290,    0, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290,    0, 1290, 1290, 1290, 1290,    0, 1290, 1290, 1290,
 1290, 1290,    0, 1290, 1290, 1290, 1290, 1290,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1308,
    0, 1308, 1308,    0,    0,    0,    0,    0, 1308,    0,
    0,    0,    0,    0, 1308,    0,    0,    0,    0, 1308,
    0,    0, 1308,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1308,    0,    0,    0,
    0, 1308, 1308,    0,    0, 1308,    0,    0,    0,    0,
    0,    0, 1308,    0, 1308, 1308,    0,    0, 1308,    0,
    0,    0, 1308,    0, 1308,    0, 1308,    0, 1308,    0,
    0,    0,    0, 1308, 1308,    0, 1308,    0,    0,    0,
    0,    0,    0,    0,    0, 1210,    0,    0,    0,    0,
    0, 1308, 1308,    0, 1308,    0,    0,    0,    0,  282,
    0,    0,    0,    0, 1308,    0, 1308,    0, 1308, 1308,
 1308,    0, 1308,    0,    0, 1308, 1308,    0,    0,    0,
    0,    0,    0,    0,    0, 1308, 1210, 1210, 1210, 1210,
 1210, 1224, 1210,    0,    0,    0,    0,    0, 1308,    0,
  282, 1308,    0,  282, 1210, 1210, 1210, 1210,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1308,  282,    0,
    0,    0,    0, 1308, 1308,    0,    0,    0, 1308,    0,
    0,    0,    0,    0,    0,    0, 1210,    0, 1210, 1308,
 1308,    0, 1308,    0,    0,    0,    0,    0, 1308,    0,
    0, 1308,    0, 1308, 1308, 1308, 1308,    0, 1308,    0,
 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1308, 1308,    0,
 1308, 1308, 1308,    0,    0,    0,    0, 1308, 1308, 1308,
 1308, 1308,    0, 1308,    0,    0, 1308, 1308, 1308, 1308,
 1308, 1308, 1308,    0,    0,    0, 1308, 1308, 1308, 1308,
 1308, 1308, 1308, 1308,    0, 1308,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308, 1308, 1308, 1308,    0, 1308, 1308, 1308,
 1308, 1308, 1308,    0, 1308, 1308, 1308, 1308,    0, 1308,
    0, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,    0,
 1308, 1308, 1308, 1308,    0, 1308, 1308, 1308, 1308, 1308,
    0, 1308, 1308, 1308, 1308, 1308,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1210,    0, 1210,
 1210,    0,    0,    0,    0,    0, 1210,    0,    0,    0,
    0,    0, 1210,    0,    0,    0,    0, 1210,    0,    0,
 1210,    0,    0,    0,    0,  282,  282,    0,    0,    0,
    0,    0,    0,  282, 1210,    0, 1210,    0,    0, 1210,
 1210,    0,    0, 1210,    0,    0,    0,    0,    0,    0,
 1210,    0, 1210, 1210,    0,    0, 1210,    0,    0,    0,
 1210,    0, 1210,    0, 1210,    0, 1210,    0,    0,    0,
    0, 1210, 1210,    0, 1210,    0,    0,    0,    0,    0,
    0,    0,    0, 1246,    0,    0,    0,    0,    0, 1210,
 1210,    0, 1210,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1210,    0, 1210,    0, 1210, 1210, 1210,    0,
 1210,    0,    0, 1210, 1210,    0,    0,    0,    0,    0,
  282,    0,    0, 1210, 1246, 1246, 1246, 1246, 1246, 1246,
 1246,    0,    0,    0,    0,    0, 1210,    0,    0, 1210,
    0,  282, 1246, 1246, 1246, 1246,    0,  282,    0,    0,
    0,    0,    0,    0,    0, 1210,    0,    0,    0,    0,
    0, 1210, 1210,    0,    0,    0, 1210,    0,    0,    0,
    0,    0,    0,    0, 1246,    0, 1246, 1210, 1210,    0,
 1210,  282,    0,    0,    0,    0, 1210,    0,    0, 1210,
    0, 1210, 1210, 1210, 1210,    0, 1210,    0, 1210, 1210,
 1210, 1210, 1210, 1210, 1210, 1210,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1210, 1210,    0, 1210, 1210,
 1210,    0,    0,    0,    0, 1210, 1210, 1210, 1210, 1210,
    0, 1210,    0,    0, 1210, 1210, 1210, 1210, 1210, 1210,
 1210,  282,    0,    0, 1210, 1210, 1210, 1210, 1210, 1210,
 1210, 1210,    0, 1210,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
 1210, 1210, 1210, 1210,    0, 1210, 1210, 1210, 1210, 1210,
 1210,    0, 1210, 1210, 1210, 1210,    0, 1210,    0, 1210,
 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
 1210, 1210, 1210, 1210, 1210, 1210, 1210,    0, 1210, 1210,
 1210, 1210,    0, 1210, 1210, 1210, 1210, 1210,    0, 1210,
 1210, 1210, 1210, 1210,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1246,    0, 1246, 1246,    0,
    0,    0,    0,    0, 1246,    0,    0,    0,    0,    0,
 1246,    0,    0,    0,    0, 1246,    0,    0, 1246,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1246,    0,    0,    0,    0, 1246, 1246,    0,
    0, 1246,    0,    0,    0,    0,    0,    0, 1246,    0,
 1246, 1246,    0,    0, 1246,    0,    0,    0, 1246,    0,
 1246,    0, 1246,    0, 1246,    0,    0,    0,    0, 1246,
 1246,    0, 1246,    0,    0,    0,    0,    0,    0,    0,
    0, 1242,    0,    0,    0,    0,    0, 1246, 1246,    0,
 1246,    0,    0,    0,    0,  283,    0,    0,    0,    0,
 1246,    0, 1246,    0, 1246, 1246, 1246,    0, 1246,    0,
    0, 1246, 1246,    0,    0,    0,    0,    0,    0,    0,
    0, 1246, 1242, 1242, 1242, 1242, 1242, 1242, 1242,    0,
    0,    0,    0,    0, 1246,    0,  283, 1246,    0,  283,
 1242, 1242, 1242, 1242,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1246,  283,    0,    0,    0,    0, 1246,
 1246,    0,    0,    0, 1246,    0,    0,    0,    0,    0,
    0,    0, 1242,    0, 1242, 1246, 1246,    0, 1246,    0,
    0,    0,    0,    0, 1246,    0,    0, 1246,    0, 1246,
 1246, 1246, 1246,    0, 1246,    0, 1246, 1246, 1246, 1246,
 1246, 1246, 1246, 1246,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1246, 1246,    0, 1246, 1246, 1246,    0,
    0,    0,    0, 1246, 1246, 1246, 1246, 1246,    0, 1246,
    0,    0, 1246, 1246, 1246, 1246, 1246, 1246, 1246,    0,
    0,    0, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
    0, 1246,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
 1246, 1246,    0, 1246, 1246, 1246, 1246, 1246, 1246,    0,
 1246, 1246, 1246, 1246,    0, 1246,    0, 1246, 1246, 1246,
 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246, 1246,
 1246, 1246, 1246, 1246, 1246,    0, 1246, 1246, 1246, 1246,
    0, 1246, 1246, 1246, 1246, 1246,    0, 1246, 1246, 1246,
 1246, 1246,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1242,    0, 1242, 1242,    0,    0,    0,
    0,    0, 1242,    0,    0,    0,    0,    0, 1242,    0,
    0,    0,    0, 1242,    0,    0, 1242,    0,    0,    0,
    0,  283,  283,    0,    0,    0,    0,    0,    0,  283,
 1242,    0,    0,    0,    0, 1242, 1242,    0,    0, 1242,
    0,    0,    0,    0,    0,    0, 1242,    0, 1242, 1242,
    0,    0, 1242,    0,    0,    0, 1242,    0, 1242,    0,
 1242,    0, 1242,    0,    0,    0,    0, 1242, 1242,    0,
 1242,    0,    0,    0,    0,    0,    0,    0,    0, 1257,
    0,    0,    0,    0,    0, 1242, 1242,    0, 1242,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1242,    0,
 1242,    0, 1242, 1242, 1242,    0, 1242,    0,    0, 1242,
 1242,    0,    0,    0,    0,    0,  283,    0,    0, 1242,
 1257, 1257, 1257, 1257, 1257, 1257, 1257,    0,    0,    0,
    0,    0, 1242,    0,    0, 1242,    0,  283, 1257, 1257,
 1257, 1257,    0,  283,    0,    0,    0,    0,    0,    0,
    0, 1242,    0,    0,    0,    0,    0, 1242, 1242,    0,
    0,    0, 1242,    0,    0,    0,    0,    0,    0,    0,
 1257,    0, 1257, 1242, 1242,    0, 1242,  283,    0,    0,
    0,    0, 1242,    0,    0, 1242,    0, 1242, 1242, 1242,
 1242,    0, 1242,    0, 1242, 1242, 1242, 1242, 1242, 1242,
 1242, 1242,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1242, 1242,    0, 1242, 1242, 1242,    0,    0,    0,
    0, 1242, 1242, 1242, 1242, 1242,    0, 1242,    0,    0,
 1242, 1242, 1242, 1242, 1242, 1242, 1242,  283,    0,    0,
 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,    0, 1242,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1242,
 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
    0, 1242, 1242, 1242, 1242, 1242, 1242,    0, 1242, 1242,
 1242, 1242,    0, 1242,    0, 1242, 1242, 1242, 1242, 1242,
 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
 1242, 1242, 1242,    0, 1242, 1242, 1242, 1242,    0, 1242,
 1242, 1242, 1242, 1242,    0, 1242, 1242, 1242, 1242, 1242,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1257,    0, 1257, 1257,    0,    0,    0,    0,    0,
 1257,    0,    0,    0,    0,    0, 1257,    0,    0,    0,
    0, 1257,    0,    0, 1257,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1257,    0,
    0,    0,    0, 1257, 1257,    0,    0, 1257,    0,    0,
    0,    0,    0,    0, 1257,    0, 1257, 1257,    0,    0,
 1257,    0,    0,    0, 1257,    0, 1257,    0, 1257,    0,
 1257,    0,    0,    0,    0, 1257, 1257,    0, 1257,    0,
    0,    0,    0,    0,    0,    0,    0, 1262,    0,    0,
    0,    0,    0, 1257, 1257,    0, 1257,    0,    0,    0,
    0,  584,    0,    0,    0,    0, 1257,    0, 1257,    0,
 1257, 1257, 1257,    0, 1257,    0,    0, 1257, 1257,    0,
    0,    0,    0,    0,    0,    0,    0, 1257, 1262, 1262,
 1262, 1262, 1262, 1262, 1262,    0,    0,    0,    0,    0,
 1257,    0,  584, 1257,    0,  584, 1262, 1262, 1262, 1262,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1257,
  584,    0,    0,    0,    0, 1257, 1257,    0,    0,    0,
 1257,    0,    0,    0,    0,    0,    0,    0, 1262,    0,
 1262, 1257, 1257,    0, 1257,    0,    0,    0,    0,    0,
 1257,    0,    0, 1257,    0, 1257, 1257, 1257, 1257,    0,
 1257,    0, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1257,
 1257,    0, 1257, 1257, 1257,    0,    0,    0,    0, 1257,
 1257, 1257, 1257, 1257,    0, 1257,    0,    0, 1257, 1257,
 1257, 1257, 1257, 1257, 1257,    0,    0,    0, 1257, 1257,
 1257, 1257, 1257, 1257, 1257, 1257,    0, 1257,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1257, 1257, 1257,
 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,    0, 1257,
 1257, 1257, 1257, 1257, 1257,    0, 1257, 1257, 1257, 1257,
    0, 1257,    0, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
 1257,    0, 1257, 1257, 1257, 1257,    0, 1257, 1257, 1257,
 1257, 1257,    0, 1257, 1257, 1257, 1257, 1257,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1262,
    0, 1262, 1262,    0,    0,    0,    0,    0, 1262,    0,
    0,    0,    0,    0, 1262,    0,    0,    0,    0, 1262,
    0,    0, 1262,    0,    0,    0,    0,  584,  584,    0,
    0,    0,    0,    0,    0,  584, 1262,    0,    0,    0,
    0, 1262, 1262,    0,    0, 1262,    0,    0,  584,    0,
    0,    0, 1262,    0, 1262, 1262,    0,    0, 1262,    0,
    0,    0, 1262,    0, 1262,    0, 1262,    0, 1262,    0,
    0,    0,    0, 1262, 1262,    0, 1262,    0,    0,    0,
    0,    0,    0,    0,    0, 1291,    0,    0,    0,    0,
    0, 1262, 1262,    0, 1262,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1262,    0, 1262,    0, 1262, 1262,
 1262,    0, 1262,    0,    0, 1262, 1262,    0,    0,    0,
    0,    0,  584,    0,    0, 1262, 1291, 1291, 1291, 1291,
 1291, 1291, 1291,    0,    0,    0,    0,    0, 1262,    0,
    0, 1262,    0,  584, 1291, 1291, 1291, 1291,    0,  584,
    0,    0,    0,    0,    0,    0,    0, 1262,    0,    0,
    0,    0,    0, 1262, 1262,    0,    0,    0, 1262,    0,
    0,    0,    0,    0,    0,    0, 1291,    0, 1291, 1262,
 1262,    0, 1262,  584,    0,    0,    0,    0, 1262,    0,
    0, 1262,    0, 1262, 1262, 1262, 1262,    0, 1262,    0,
 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1262, 1262,    0,
 1262, 1262, 1262,    0,    0,    0,    0, 1262, 1262, 1262,
 1262, 1262,    0, 1262,    0,    0, 1262, 1262, 1262, 1262,
 1262, 1262, 1262,    0,    0,    0, 1262, 1262, 1262, 1262,
 1262, 1262, 1262, 1262,    0, 1262,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1262, 1262, 1262, 1262, 1262,
 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
 1262, 1262, 1262, 1262, 1262, 1262,    0, 1262, 1262, 1262,
 1262, 1262, 1262,    0, 1262, 1262, 1262, 1262,    0, 1262,
    0, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,
 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262, 1262,    0,
 1262, 1262, 1262, 1262,    0, 1262, 1262, 1262, 1262, 1262,
    0, 1262, 1262, 1262, 1262, 1262,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1291,    0, 1291,
 1291,    0,    0,    0,    0,    0, 1291,    0,    0,    0,
    0,    0, 1291,    0,    0,    0,    0, 1291,    0,    0,
 1291,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1291,    0,    0,    0,    0, 1291,
 1291,    0,    0, 1291,    0,    0,    0,    0,    0,    0,
 1291,    0, 1291, 1291,    0,    0, 1291,    0,    0,    0,
 1291,    0, 1291,    0, 1291,    0, 1291,    0,    0,    0,
    0, 1291, 1291,    0, 1291,    0,    0,    0,    0,    0,
    0,    0,    0, 1297,    0,    0,    0,    0,    0, 1291,
 1291,    0, 1291,    0,    0,    0,    0,  623,    0,    0,
    0,    0, 1291,    0, 1291,    0, 1291, 1291, 1291,    0,
 1291,    0,    0, 1291, 1291,    0,    0,    0,    0,    0,
    0,    0,    0, 1291, 1297, 1297, 1297, 1297, 1297, 1297,
 1297,    0,    0,    0,    0,    0, 1291,    0,  623, 1291,
    0,  623, 1297, 1297, 1297, 1297,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1291,  623,    0,    0,    0,
    0, 1291, 1291,    0,    0,    0, 1291,    0,    0,    0,
    0,    0,    0,    0, 1297,    0, 1297, 1291, 1291,    0,
 1291,    0,    0,    0,    0,    0, 1291,    0,    0, 1291,
    0, 1291, 1291, 1291, 1291,    0, 1291,    0, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1291, 1291,    0, 1291, 1291,
 1291,    0,    0,    0,    0, 1291, 1291, 1291, 1291, 1291,
    0, 1291,    0,    0, 1291, 1291, 1291, 1291, 1291, 1291,
 1291,    0,    0,    0, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291,    0, 1291,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1291, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291,    0, 1291, 1291, 1291, 1291, 1291,
 1291,    0, 1291, 1291, 1291, 1291,    0, 1291,    0, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291,    0, 1291, 1291,
 1291, 1291,    0, 1291, 1291, 1291, 1291, 1291,    0, 1291,
 1291, 1291, 1291, 1291,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1297,    0, 1297, 1297,    0,
    0,    0,    0,    0, 1297,    0,    0,    0,    0,    0,
 1297,    0,    0,    0,    0, 1297,    0,    0, 1297,    0,
    0,    0,    0,  623,  623,    0,    0,    0,    0,    0,
    0,  623, 1297,    0,    0,    0,    0, 1297, 1297,    0,
    0, 1297,    0,    0,  623,    0,    0,    0, 1297,    0,
 1297, 1297,    0,    0, 1297,    0,    0,    0, 1297,    0,
 1297,    0, 1297,    0, 1297,    0,    0,    0,    0, 1297,
 1297,    0, 1297,    0,    0,    0,    0,    0,    0,    0,
    0,  996,    0,    0,    0,    0,    0, 1297, 1297,    0,
 1297,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1297,    0, 1297,    0, 1297, 1297, 1297,    0, 1297,    0,
    0, 1297, 1297,    0,    0,    0,    0,    0,  623,    0,
    0, 1297,  996,  996,  996,  996,  996,    0,  996,    0,
    0,    0,    0,    0, 1297,    0,    0, 1297,    0,  623,
  996,  996,  996,  996,    0,  623,    0,    0,    0,    0,
    0,    0,    0, 1297,    0,    0,    0,    0,    0, 1297,
 1297,    0,    0,    0, 1297,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  996, 1297, 1297,    0, 1297,  623,
    0,    0,    0,    0, 1297,    0,    0, 1297,    0, 1297,
 1297, 1297, 1297,    0, 1297,    0, 1297, 1297, 1297, 1297,
 1297, 1297, 1297, 1297,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1297, 1297,    0, 1297, 1297, 1297,    0,
    0,    0,    0, 1297, 1297, 1297, 1297, 1297,    0, 1297,
    0,    0, 1297, 1297, 1297, 1297, 1297, 1297, 1297,    0,
    0,    0, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297,
    0, 1297,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297,
 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297,
 1297, 1297,    0, 1297, 1297, 1297, 1297, 1297, 1297,    0,
 1297, 1297, 1297, 1297,    0, 1297,    0, 1297, 1297, 1297,
 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297, 1297,
 1297, 1297, 1297, 1297, 1297,    0, 1297, 1297, 1297, 1297,
    0, 1297, 1297, 1297, 1297, 1297,    0, 1297, 1297, 1297,
 1297, 1297,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  996,    0,  996,  996,    0,    0,    0,
    0,    0,  996,    0,    0,    0,    0,    0,  996,    0,
    0,    0,    0,  996,    0,    0,  996,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  996,    0,    0,    0,    0,  996,  996,    0,    0,  996,
    0,    0,    0,    0,    0,    0,  996,    0,  996,  996,
    0,    0,  996,    0,    0,    0,  996,    0,  996,    0,
  996,    0,  996,    0,    0,    0,    0,  996,  996,    0,
  996,    0,    0,    0,    0,    0,    0,    0,    0, 1009,
    0,    0,    0,    0,    0,  996,  996,    0,  996,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  996,    0,
  996,    0,  996,  996,  996,    0,  996,    0,    0,  996,
  996,    0,    0,    0,    0,    0,    0,    0,    0,  996,
 1009, 1009, 1009, 1009, 1009,    0, 1009,    0,    0,    0,
    0,    0,  996,    0,    0,  996,    0,    0, 1009, 1009,
 1009, 1009,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  996,    0,    0,    0,    0,    0,  996,  996,    0,
    0,    0,  996,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1009,  996,  996,    0,  996,    0,    0,    0,
    0,    0,  996,    0,    0,  996,    0,  996,  996,  996,
  996,    0,  996,    0,  996,  996,  996,  996,  996,  996,
  996,  996,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  996,  996,    0,  996,  996,  996,    0,    0,    0,
    0,  996,  996,  996,  996,  996,    0,  996,    0,    0,
  996,  996,  996,  996,  996,  996,  996,    0,    0,    0,
  996,  996,  996,  996,  996,  996,  996,  996,    0,  996,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  996,
  996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
    0,  996,  996,  996,  996,  996,  996,    0,  996,  996,
  996,  996,    0,  996,    0,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
  996,  996,  996,    0,  996,  996,  996,  996,    0,  996,
  996,  996,  996,  996,    0,  996,  996,  996,  996,  996,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1009,    0, 1009, 1009,    0,    0,    0,    0,    0,
 1009,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1009,    0,    0, 1009,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1009,    0,
    0,    0,    0, 1009, 1009,    0,    0, 1009,    0,    0,
    0,    0,    0,    0, 1009,    0, 1009, 1009,    0,    0,
 1009,    0,    0,    0, 1009,    0, 1009,    0, 1009,    0,
 1009,    0,    0,    0,    0, 1009, 1009,    0, 1009,    0,
    0,    0,    0,    0,    0,    0,    0, 1007,    0,    0,
    0,    0,  912, 1009, 1009,    0, 1009,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1009,    0, 1009,    0,
 1009, 1009, 1009,    0, 1009,    0,    0, 1009, 1009,    0,
    0,    0,    0,    0,    0,    0,    0, 1009, 1007, 1007,
 1007, 1007, 1007,  912, 1007,    0,  912,    0,    0,    0,
 1009,    0,    0, 1009,    0,    0, 1007, 1007, 1007, 1007,
    0,  912,    0,    0,    0,    0,    0,    0,    0, 1009,
    0,    0,    0,    0,    0, 1009, 1009,    0,    0,    0,
 1009,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1007, 1009, 1009,    0, 1009,    0,    0,    0,    0,    0,
 1009,    0,    0, 1009,    0, 1009, 1009, 1009, 1009,    0,
 1009,    0, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1009,
 1009,    0, 1009, 1009, 1009,    0,    0,    0,    0, 1009,
 1009, 1009, 1009, 1009,    0, 1009,    0,    0, 1009, 1009,
 1009, 1009, 1009, 1009, 1009,    0,    0,    0, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009,    0, 1009,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1009, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,    0, 1009,
 1009, 1009, 1009, 1009, 1009,    0, 1009, 1009, 1009, 1009,
    0, 1009,    0, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009,    0, 1009, 1009, 1009, 1009,    0, 1009, 1009, 1009,
 1009, 1009,    0, 1009, 1009, 1009, 1009, 1009,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1007,
    0, 1007, 1007,    0,    0,    0,    0,    0, 1007,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  912,  912,
    0,    0, 1007,    0,    0,    0,  912,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1007,    0,    0,    0,
    0, 1007, 1007,    0,    0, 1007,    0,    0,    0,    0,
    0,    0, 1007,    0, 1007, 1007,    0,    0, 1007,    0,
    0,    0, 1007,    0, 1007,    0, 1007,    0, 1007,    0,
    0,    0,    0, 1007, 1007,    0, 1007,    0,    0,    0,
    0,    0,    0,    0,    0, 1006,    0,    0,    0,    0,
    0, 1007, 1007,    0, 1007,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1007,    0, 1007,    0, 1007, 1007,
 1007,    0, 1007,  912,    0, 1007, 1007,  912,    0,    0,
    0,    0,    0,    0,    0, 1007, 1006, 1006, 1006, 1006,
 1006,    0, 1006,    0,  912,    0,    0,    0, 1007,    0,
  912, 1007,    0,    0, 1006, 1006, 1006, 1006,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1007,    0,    0,
    0,    0,    0, 1007, 1007,    0,    0,    0, 1007,    0,
    0,    0,    0,    0,  912,    0,    0,    0, 1006, 1007,
 1007,    0, 1007,    0,    0,    0,    0,    0, 1007,    0,
    0, 1007,    0, 1007, 1007, 1007, 1007,    0, 1007,    0,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1007, 1007,    0,
 1007, 1007, 1007,    0,    0,    0,    0, 1007, 1007, 1007,
 1007, 1007,    0, 1007,  912,    0, 1007, 1007, 1007, 1007,
 1007, 1007, 1007,    0,    0,    0, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007,    0, 1007,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007,    0, 1007, 1007, 1007,
 1007, 1007, 1007,    0, 1007, 1007, 1007, 1007,    0, 1007,
    0, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,    0,
 1007, 1007, 1007, 1007,    0, 1007, 1007, 1007, 1007, 1007,
    0, 1007, 1007, 1007, 1007, 1007,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1006,    0, 1006,
 1006,    0,    0,    0,    0,    0, 1006,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1006,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1006,    0,    0,    0,    0, 1006,
 1006,    0,    0, 1006,    0,    0,    0,    0,    0,    0,
 1006,    0, 1006, 1006,    0,    0, 1006,    0,    0,    0,
 1006,    0, 1006,    0, 1006,    0, 1006,    0,    0,    0,
    0, 1006, 1006,    0, 1006,    0,    0,    0,    0,    0,
    0,    0,    0, 1012,    0,    0,    0,    0,    0, 1006,
 1006,    0, 1006,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1006,    0, 1006,    0, 1006, 1006, 1006,    0,
 1006,    0,    0, 1006, 1006,    0,    0,    0,    0,    0,
    0,    0,    0, 1006, 1012, 1012, 1012, 1012, 1012,    0,
 1012,    0,    0,    0,    0,    0, 1006,    0,    0, 1006,
    0,    0, 1012, 1012, 1012, 1012,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1006,    0,    0,    0,    0,
    0, 1006, 1006,    0,    0,    0, 1006,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1012, 1006, 1006,    0,
 1006,    0,    0,    0,    0,    0, 1006,    0,    0, 1006,
    0, 1006, 1006, 1006, 1006,    0, 1006,    0, 1006, 1006,
 1006, 1006, 1006, 1006, 1006, 1006,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1006, 1006,    0, 1006, 1006,
 1006,    0,    0,    0,    0, 1006, 1006, 1006, 1006, 1006,
    0, 1006,    0,    0, 1006, 1006, 1006, 1006, 1006, 1006,
 1006,    0,    0,    0, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006,    0, 1006,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006,    0, 1006, 1006, 1006, 1006, 1006,
 1006,    0, 1006, 1006, 1006, 1006,    0, 1006,    0, 1006,
 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006, 1006, 1006,    0, 1006, 1006,
 1006, 1006,    0, 1006, 1006, 1006, 1006, 1006,    0, 1006,
 1006, 1006, 1006, 1006,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1012,    0, 1012, 1012,    0,
    0,    0,    0,    0, 1012,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1012,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1012,    0,    0,    0,    0, 1012, 1012,    0,
    0, 1012,    0,    0,    0,    0,    0,    0, 1012,    0,
 1012, 1012,    0,    0, 1012,    0,    0,    0, 1012,    0,
 1012,    0, 1012,    0, 1012,    0,    0,    0,    0, 1012,
 1012,    0, 1012,    0,    0,    0,    0,    0,    0,    0,
    0, 1013,    0,    0,    0,    0,    0, 1012, 1012,    0,
 1012,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1012,    0, 1012,    0, 1012, 1012, 1012,    0, 1012,    0,
    0, 1012, 1012,    0,    0,    0,    0,    0,    0,    0,
    0, 1012, 1013, 1013, 1013, 1013, 1013,    0, 1013,    0,
    0,    0,    0,    0, 1012,    0,    0, 1012,    0,    0,
 1013, 1013, 1013, 1013,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1012,    0,    0,    0,    0,    0, 1012,
 1012,    0,    0,    0, 1012,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1013, 1012, 1012,    0, 1012,    0,
    0,    0,    0,    0, 1012,    0,    0, 1012,    0, 1012,
 1012, 1012, 1012,    0, 1012,    0, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1012, 1012,    0, 1012, 1012, 1012,    0,
    0,    0,    0, 1012, 1012, 1012, 1012, 1012,    0, 1012,
    0,    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012,    0,
    0,    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
    0, 1012,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012,    0, 1012, 1012, 1012, 1012, 1012, 1012,    0,
 1012, 1012, 1012, 1012,    0, 1012,    0, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012,    0, 1012, 1012, 1012, 1012,
    0, 1012, 1012, 1012, 1012, 1012,    0, 1012, 1012, 1012,
 1012, 1012,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1013,    0, 1013, 1013,    0,    0,    0,
    0,    0, 1013,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1013,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1013,    0,    0,    0,    0, 1013, 1013,    0,    0, 1013,
    0,    0,    0,    0,    0,    0, 1013,    0, 1013, 1013,
    0,    0, 1013,    0,    0,    0, 1013,    0, 1013,    0,
 1013,    0, 1013,    0,    0,    0,    0, 1013, 1013,    0,
 1013,    0,    0,    0,    0,    0,    0, 1008,    0,    0,
    0,    0,    0,    0,    0, 1013, 1013,    0, 1013,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1013,    0,
 1013,    0, 1013, 1013, 1013,    0, 1013,    0,    0, 1013,
 1013,    0,    0,    0,    0,    0,    0,    0, 1008, 1013,
 1008, 1008, 1008,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1013,    0,    0, 1013, 1008, 1008, 1008, 1008,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1013,    0,    0,    0,    0,    0, 1013, 1013,    0,
    0,    0, 1013,    0,    0,    0,    0,    0,    0,    0,
 1008,    0,    0, 1013, 1013,    0, 1013,    0,    0,    0,
    0,    0, 1013,    0,    0, 1013,    0, 1013, 1013, 1013,
 1013,    0, 1013,    0, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1013, 1013,    0, 1013, 1013, 1013,    0,    0,    0,
    0, 1013, 1013, 1013, 1013, 1013,    0, 1013,    0,    0,
 1013, 1013, 1013, 1013, 1013, 1013, 1013,    0,    0,    0,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,    0, 1013,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
    0, 1013, 1013, 1013, 1013, 1013, 1013,    0, 1013, 1013,
 1013, 1013,    0, 1013,    0, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013,    0, 1013, 1013, 1013, 1013,    0, 1013,
 1013, 1013, 1013, 1013,    0, 1013, 1013, 1013, 1013, 1013,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1008,
    0, 1008, 1008,    0,    0,    0,    0,    0, 1008,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1008,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1008,    0,    0,    0,
    0, 1008, 1008,    0,    0, 1008,    0,    0,    0,    0,
    0,    0, 1008,    0, 1008, 1008,    0,    0, 1008,    0,
    0,    0, 1008,    0, 1008,    0, 1008,    0, 1008,    0,
    0,    0,    0, 1008, 1008,    0, 1008,    0,    0,    0,
    0,    0,    0, 1011,    0,    0,    0,    0,    0,    0,
    0, 1008, 1008,    0, 1008,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1008,    0, 1008,    0, 1008, 1008,
 1008,    0, 1008,    0,    0, 1008, 1008,    0,    0,    0,
    0,    0,    0,    0, 1011, 1008, 1011, 1011, 1011,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1008,    0,
    0, 1008, 1011, 1011, 1011, 1011,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1008,    0,    0,
    0,    0,    0, 1008, 1008,    0,    0,    0, 1008,    0,
    0,    0,    0,    0,    0,    0, 1011,    0,    0, 1008,
 1008,    0, 1008,    0,    0,    0,    0,    0, 1008,    0,
    0, 1008,    0, 1008, 1008, 1008, 1008,    0, 1008,    0,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1008, 1008,    0,
 1008, 1008, 1008,    0,    0,    0,    0, 1008, 1008, 1008,
 1008, 1008,    0, 1008,    0,    0, 1008, 1008, 1008, 1008,
 1008, 1008, 1008,    0,    0,    0, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008,    0, 1008,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1008, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008,    0, 1008, 1008, 1008,
 1008, 1008, 1008,    0, 1008, 1008, 1008, 1008,    0, 1008,
    0, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,    0,
 1008, 1008, 1008, 1008,    0, 1008, 1008, 1008, 1008, 1008,
    0, 1008, 1008, 1008, 1008, 1008,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1011,    0, 1011, 1011,    0,
    0,    0,    0,    0, 1011,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1011,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  811,    0, 1011,    0,    0,    0,    0, 1011, 1011,    0,
    0, 1011,    0,    0,    0,    0,    0,    0, 1011,    0,
 1011, 1011,    0,    0, 1011,    0,    0,    0, 1011,    0,
 1011,    0, 1011,    0, 1011,    0,    0,    0,    0, 1011,
 1011,  811, 1011,    0,  811,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1011, 1011,  811,
 1011,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1011,    0, 1011,    0, 1011, 1011, 1011,    0, 1011,    0,
    0, 1011, 1011,    0,    0,    0,    0,    0,    0,    0,
    0, 1011,    0, 1302,  995,  993,    0,  994,    0,  996,
    0,    0,    0,    0, 1011,    0,    0, 1011,    0,    0,
    0,    0, 1232, 1231, 1233,    0,    0,    0,    0,    0,
    0,    0,    0, 1011,    0,    0,    0,    0,    0, 1011,
 1011,    0,    0,    0, 1011,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1011, 1011,    0, 1011,    0,
    0,    0,    0,    0, 1011,    0,    0, 1011,    0, 1011,
 1011, 1011, 1011,    0, 1011,    0, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1011, 1011,    0, 1011, 1011, 1011,    0,
    0,    0,    0, 1011, 1011, 1011, 1011, 1011,    0, 1011,
    0,    0, 1011, 1011, 1011, 1011, 1011, 1011, 1011,    0,
    0,    0, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
    0, 1011,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011,    0, 1011, 1011, 1011, 1011, 1011, 1011,    0,
 1011, 1011, 1011, 1011,  811, 1011,    0, 1011, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011, 1011,    0, 1011, 1011, 1011, 1011,
    0, 1011, 1011, 1011, 1011, 1011,    0, 1011, 1011, 1011,
 1011, 1011,  782,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  811,    0,    0,  811,    0,
    0,    0,    0, 1219,    0,  811,    0,  811,    0,  991,
    0,  811,    0,    0,  992,    0,  811, 1220,    0,  811,
    0,    0,  782,  782,    0,    0,  782,    0,    0,    0,
    0,    0,    0,    0,  811,    0,    0,    0,    0,    0,
    0,  782,    0,    0,    0,    0,    0,  811,    0,    0,
    0,    0,    0, 1221,    0,  811,    0,    0,    0,  811,
    0, 1222,    0,    0,    0,    0,    0,    0,  811, 1223,
    0,    0,    0,    0,    0,    0,    0,  995,  993,    0,
  994,    0,  996,    0,  811,    0,    0, 1224,    0, 1225,
    0,    0,    0,    0,    0, 1232, 1231, 1233,    0,    0,
    0, 1226,    0, 1227, 1228, 1229,    0,    0,    0,    0,
    0,  811,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  811,    0,  811,    0,    0,    0,    0,
    0,  811,    0,    0,  811,    0,  811,  811,  811,  811,
    0,  811,    0,    0,    0,    0,    0,    0,    0,  811,
  811,    0, 1230,    0,    0,    0,    0,    0,    0,    0,
  811,  811,    0,  811,  811,  811,    0,    0,    0,    0,
  811,  811,  811,  811,  811,    0,  811,    0,    0,  811,
  811,  811,  811,  811,  811,  811,    0,    0,    0,  811,
  811,  811,  811,  811,  811,  811,  811,    0,  811,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  811,  811,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,  811,  811,  811,  811,  811,  811,  811,  811,    0,
  811,  811,  811,  811,  811,  811,    0,  811,  811,  811,
  811,    0,  811,    0,  811,  811,  811,  811,  811,  811,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,  811,    0,  811,  811,  811,  811,  809,  811,  811,
  811,  811,  811,    0,  811,  811,  811,  811,  811,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  782,    0,    0,
  782,    0,    0,    0,    0,    0, 1219,  782,  809,  782,
    0,  809,  991,  782,    0,    0,    0,  992,  782,    0,
 1220,  782,    0,    0,    0,    0,  809,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  782,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  782,
    0,    0,    0,    0,    0,    0, 1221,  782,    0,    0,
    0,  782,    0,    0, 1222,    0,    0,    0,    0,    0,
  782,    0, 1223,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  782,    0,    0,    0,
 1224,    0, 1225,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1226,    0, 1227, 1228, 1229,    0,
    0,    0,    0,  782,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  782,    0,  782,    0,    0,
    0,    0,    0,  782,    0,    0,  782,    0,  782,  782,
  782,  782,    0,  782,    0,    0,    0,    0,    0,    0,
    0,  782,  782,    0,    0, 1230,    0,    0,    0,    0,
    0,    0,  782,  782,    0,  782,  782,  782,    0,    0,
    0,    0,  782,  782,  782,  782,  782,    0,  782,    0,
    0,  782,  782,  782,  782,  782,  782,  782,    0,    0,
    0,  782,  782,  782,  782,  782,  782,  782,  782,    0,
  782,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,    0,  782,  782,  782,  782,  782,  782,    0,  782,
  782,  782,  782,    0,  782,    0,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,    0,  782,  782,  782,  782,    0,
  782,  782,  782,  782,  782,    0,  782,  782,  782,  782,
  782,    0,  809,    0,    0,  809,    0,    0,    0,    0,
    0,    0,  809,    0,  809,    0,    0,    0,  809,    0,
    0,    0,    0,  809,    0,    0,  809,    0,  650,    0,
    0,    0,    0,    0,    0,  980,    0,    0,    0,    0,
  640,  809,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  809,    0,    0,    0,    0,    0,
    0,    0,  809,    0,    0,    0,  809,    0,    0,  650,
    0,    0,  650,    0,    0,  809,  980,    0,    0,  980,
    0,  640,    0,    0,  640,    0,    0,  650,    0,  650,
    0,  809,    0,    0,  980,    0,    0,    0,    0,  640,
    0,  640,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  809,  650,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  809,  640,  809,    0,    0,    0,    0,    0,  782,    0,
    0,  782,    0,  782,  782,  782,  782,    0,  782,    0,
    0,    0,    0,    0,    0,    0,  782,  782,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  782,  782,    0,
  782,  782,  782,    0,    0,    0,    0,  782,  782,  809,
  782,  782,    0,  782,    0,    0,  782,  782,  782,  782,
  782,  782,  782,    0,    0,    0,  809,  782,  782,  782,
  809,  782,  782,  782,    0,  782,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,    0,  782,  782,  782,
  782,  782,  782,    0,  782,  782,  782,  782,    0,  782,
    0,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,    0,
  782,  782,  782,  782,  625,  782,  782,  782,  782,  782,
    0,  782,  782,  782,  782,  782,  650,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  980,  640,    0,
    0,  650,    0,    0,  650,  650,    0,    0,    0,  650,
    0,    0,  650,  640,    0,  625,  640,  640,  625,    0,
    0,  640,    0,    0,  640,  650,    0,    0,    0,    0,
    0,  650,    0,  625,  650,  625,    0,  640,    0,    0,
    0,    0,    0,  640,    0,    0,  640,    0,    0,    0,
  980,    0,    0,  980,    0,    0,    0,    0,    0,    0,
  980,    0,  980,    0,    0,  625,  980,    0,    0,    0,
    0,  980,    0,    0,  980,    0,  650,  964,    0,    0,
  653,    0,  654,    0,    0,    0,    0,    0,  640,  980,
    0,    0,    0,    0,    0,  656,    0,    0,    0,  650,
  657,    0,  980,    0,    0,    0,    0,    0,    0,    0,
  980,  640,    0,  980,  980,    0,    0,    0,    0,    0,
  650,    0,    0,  980,    0,    0,  650,    0,    0,    0,
  650,    0,  640,    0,    0,    0,    0,  650,  640,  980,
    0,    0,  640,    0,    0,    0,    0,    0,    0,  640,
    0,    0,    0,    0,    0,  650,    0,    0,    0,    0,
  650,  980,    0,    0,    0,    0,  980,  640,  253,    0,
    0,  253,  640,    0,    0,    0,    0,  980,  980,    0,
  980,    0,    0,    0,  253,  650,    1,    0,  253,  650,
    0,  253,    0,    0,    0,    0,    0,  640,    0,    0,
    0,  640,    0,    0,    2,    0,    0,    0,    0,    0,
    0,    0,    3,    0,    0,    0,    0,    0,    0,    4,
    0,    5,    0,    6,    0,    0,    0,  980,    7,    0,
    0,  253,  625,    0,    0,    8,    0,  253,  253,  253,
    0,  253,  253,  253,  980,  253,    0,  625,  980,    9,
  625,  625,    0,    0,   95,  625,    0,    0,  625,   10,
    0,   96,  253,  980,  253,   97,   98,    0,    0,    0,
    0,  625,    0,    0,   99,    0,    0,  625,    0,    0,
  625,    0,    0,    0,    0,  100,    0,   11,  650,    0,
    0,    0,    0,  253,    0,    0,    0,    0,   83,    0,
  640,    0,    0,    0,  560,    0,    0,    0,    0,    0,
  253,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   12,  625,  562,    0,    0,    0,    0,   13,  563,
  564,   14,  253,    0,   15,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  625,  101,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  565,   16,    0,
  566,    0,  102,    0,    0,    0,  625,  253,  253,    0,
   17,    0,  625,    0,    0,    0,  625,  103,    0,    0,
    0,  104,    0,  625,  253,  567,    0,  568,  569,    0,
    0,  570,  105,    0,    0,    0,    0,  571,    0,    0,
  572,  625,    0,    0,    0,    0,  625,   18,    0,  928,
    0,  106,  653,    0,  654,    0,    0,    0,    0,    0,
    0,    0,   19,   20,    0,    0,  573,  656,    0,    0,
    0,  625,  657,    0,    0,  625,    0,    0,    0,    0,
    0,  574,    0,    0,   21,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  575,    0,    0,    0,    0,
    0,  576,    0,    0,    0,    0,    0,  107,    0,    0,
  108,  577,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  578,  579,  580,  581,  336,
  337,  120,    0,  121,  122,  123,  124,    0,  125,  582,
 1257, 1258, 1259, 1260, 1261, 1262, 1291, 1292,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  128,  592,    0,
  130,  131,  132,  593,  594,    0,  595,  596,  597,    0,
  135,  136,  598,  137,  625,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  599,  147,
    0,  600,  149,  150,    0,  151,    0,  601,  602,  603,
    0,  604,  605,    0,  606,  152,  153,  154,  155,  156,
  157,  607,  159,  608,  161,  609,  610,  611,  612,  613,
  614,  615,  616,  617,  618,  619,    0,  620,  621,  622,
  623,  624,  625,    0,  626,  627,  628,  182,    0,  629,
    0,  630,  631,  632,  633,  634,  189,  190,  635, 1293,
  636,  637,  638,  196,  639,  198,  640,  200,  641,    0,
  642,  643,  644,  645,    0,  646,  647,  648,  209,  649,
    0,  650,  651,  213,  652, 1294,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,  921,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  922,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
  923,  928,    0,    0,  653,    0,  654,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  573,  656,
    0,    0,    0,    0,  657,    0,    0,    0,    0,    0,
    0,    0,    0,  574,    0,    0,    0,    0,    0,    0,
    0,  924,    0,    0,    0,    0,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  925,  926,  927,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,    0,  650,  651,  213,  652,  215,  560,    0,
    0,    0,    0,    0,    0,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  562,    0,    0,
    0,    0,    0,  563,  564,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  922,    0,    0,    0,    0,    0,    0,    0,
    0,  565,    0,    0,  566,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  567,
    0,  568,  569,    0,    0,  570,    0,    0,    0,    0,
    0,  571,    0,    0,  572,    0,    0,    0,    0,    0,
    0,    0,  923,  928,    0,    0,  653,    0,  654,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  573,  656,    0,    0,    0,    0,  657,    0,    0,    0,
    0,    0,    0,    0,    0,  574,    0,    0,    0,    0,
    0,    0,    0,  924,    0,    0,    0,    0,    0,  575,
    0,    0,    0,    0,    0,  576,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   17,    0,    0,  578,
  579,  580,  581,  336,  337,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  128,  592,    0,  130,  131,  132,  593,  594,    0,
  595,  596,  597,    0,  135,  136,  598,  137,    0,    0,
  138,  139,  925,  926,  927,  143,  144,    0,    0,    0,
    0,  145,  599,  147,    0,  600,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  625,    0,  626,  627,
  628,  182,    0,  629,    0,  630,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641,    0,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
  560,    0,    0,    0,    0,    0,    0,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  562,
    0,    0,    0,    0,    0,  563,  564,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  922,    0,    0,    0,    0,    0,
    0,    0,    0,  565,    0,    0,  566,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  567,    0,  568,  569,    0,    0,  570,    0,    0,
    0,    0,    0,  571,    0,    0,  572,    0,    0,    0,
    0,    0,    0,    0,  923,  964,    0,    0,  653,    0,
  654,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  573,  656,    0,    0,    0,    0,  657,    0,
    0,    0,    0,    0,    0,    0,    0,  574,    0,    0,
    0,    0,    0,    0,    0,  924,    0,    0,    0,    0,
    0,  575,    0,    0,    0,    0,    0,  576,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  577,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  578,  579,  580,  581,  336,  337,  120,    0,  121,
  122,  123,  124,    0,  125,  582,    0,    0,    0,    0,
    0,    0,  126,  127,  583,  584,  585,  586,  587,  588,
  589,  590,  591,  128,  592,    0,  130,  131,  132,  593,
  594,    0,  595,  596,  597,    0,  135,  136,  598,  137,
    0,    0,  138,  139,  925,  926,  927,  143,  144,    0,
    0,    0,    0,  145,  599,  147,    0,  600,  149,  150,
    0,  151,    0,  601,  602,  603,    0,  604,  605,    0,
  606,  152,  153,  154,  155,  156,  157,  607,  159,  608,
  161,  609,  610,  611,  612,  613,  614,  615,  616,  617,
  618,  619,    0,  620,  621,  622,  623,  624,  625,    0,
  626,  627,  628,  182,    0,  629,    0,  630,  631,  632,
  633,  634,  189,  190,  635,  192,  636,  637,  638,  196,
  639,  198,  640,  200,  641,    0,  642,  643,  644,  645,
    0,  646,  647,  648,  209,  649,    0,  650,  651,  213,
  652,  215,  560,    0,    0,    0,    0,    0,    0,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  562,    0,    0,    0,    0,    0,  563,  564,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  565,    0,    0,  566,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  567,    0,  568,  569,    0,    0,  570,
    0,    0,    0,    0,    0,  571,    0,    0,  572,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  964,    0,    0,  653,    0,  654,
    0,    0,    0,    0,  573,    0,    0,    0,    0,    0,
    0,    0,  656,    0,    0,    0,    0,  657,    0,  574,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  575,    0,    0,    0,    0,    0,  576,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  578,  579,  580,  581,  336,  337,  120,
    0,  121,  122,  123,  124,    0,  125,  582,    0,    0,
    0,    0,    0,    0,  126,  127,  583,  584,  585,  586,
  587,  588,  589,  590,  591,  128,  592,    0,  130,  131,
  132,  593,  594,    0,  595,  596,  597,    0,  135,  136,
  598,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  599,  147,    0,  600,
  149,  150, 1286,  151,    0,  601,  602,  603, 1287,  604,
  605, 1288,  606,  152,  153,  154,  155,  156,  157,  607,
  159,  608,  161,  609,  610,  611,  612,  613,  614,  615,
  616,  617,  618,  619,    0,  620,  621,  622,  623,  624,
  625,    0,  626,  627,  628,  182,    0,  629,    0,  630,
  631,  632,  633,  634,  189,  190,  635,  192,  636,  637,
  638,  196,  639,  198,  640,  200,  641,    0,  642,  643,
  644,  645,    0,  646,  647,  648,  209,  649,    0,  650,
  651,  213,  652,  215, 1520,    0,    0, 1521,    0,    0,
    0,  560,    0,    0,    0,    0,    0,    0,  561,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  562,    0,    0,    0,    0,    0,  563,  564,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  565,    0,    0,  566,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  567,    0,  568,  569,    0,    0,  570,    0,
    0,    0,    0,    0,  571,    0,    0,  572,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  964,    0,    0,  653,    0,  654,    0,
    0,    0,    0,  573,    0,    0,    0,    0,    0,    0,
    0,  656,    0,    0,    0,    0,  657,    0,  574,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1522,    0,  575,    0,    0,    0,    0,    0,  576,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  577,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  578,  579,  580,  581,  336,  337,  120,    0,
  121,  122,  123,  124,    0,  125,  582,    0,    0,    0,
    0,    0,    0,  126,  127,  583,  584,  585,  586,  587,
  588,  589,  590,  591,  128,  592,    0,  130,  131,  132,
  593,  594,    0,  595,  596,  597,    0,  135,  136,  598,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  599,  147,    0,  600,  149,
  150,    0,  151,    0,  601,  602,  603,    0,  604,  605,
    0,  606,  152,  153,  154,  155,  156,  157,  607,  159,
  608,  161,  609,  610,  611,  612,  613,  614,  615,  616,
  617,  618,  619,    0,  620,  621,  622,  623,  624,  625,
    0,  626,  627,  628,  182,    0,  629,    0,  630,  631,
  632,  633,  634,  189,  190,  635,  192,  636,  637,  638,
  196,  639,  198,  640,  200,  641,    0,  642,  643,  644,
  645,    0,  646,  647,  648,  209,  649,    0,  650,  651,
  213,  652,  215, 1531,    0,    0, 1521,    0,    0,    0,
  560,    0,    0,    0,    0,    0,    0,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  562,
    0,    0,    0,    0,    0,  563,  564,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  565,    0,    0,  566,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  567,    0,  568,  569,    0,    0,  570,    0,    0,
    0,    0,    0,  571,    0,    0,  572,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  653,    0,  654,    0,    0,
    0,    0,  573,    0,    0,    0,    0,    0,    0,    0,
  656,    0,    0,    0,    0,  657,    0,  574,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1522,
    0,  575,    0,    0,    0,    0,    0,  576,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  577,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  578,  579,  580,  581,  336,  337,  120,    0,  121,
  122,  123,  124,    0,  125,  582,    0,    0,    0,    0,
    0,    0,  126,  127,  583,  584,  585,  586,  587,  588,
  589,  590,  591,  128,  592,    0,  130,  131,  132,  593,
  594,    0,  595,  596,  597,    0,  135,  136,  598,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  599,  147,    0,  600,  149,  150,
    0,  151,    0,  601,  602,  603,    0,  604,  605,    0,
  606,  152,  153,  154,  155,  156,  157,  607,  159,  608,
  161,  609,  610,  611,  612,  613,  614,  615,  616,  617,
  618,  619,    0,  620,  621,  622,  623,  624,  625,    0,
  626,  627,  628,  182,    0,  629,    0,  630,  631,  632,
  633,  634,  189,  190,  635,  192,  636,  637,  638,  196,
  639,  198,  640,  200,  641,    0,  642,  643,  644,  645,
    0,  646,  647,  648,  209,  649,    0,  650,  651,  213,
  652,  215, 1535,    0,    0, 1521,    0,    0,    0,  560,
    0,    0,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  562,    0,
    0,    0,    0,    0,  563,  564,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  565,    0,    0,  566,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  567,    0,  568,  569,    0,    0,  570,    0,    0,    0,
    0,    0,  571,    0,    0,  572,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  964,    0,    0,  653,    0,  654,    0,    0,    0,
    0,  573,    0,    0,    0,    0,    0,    0,    0,  656,
    0,    0,    0,    0,  657,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1522,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  577,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582,    0,    0,    0,    0,    0,
    0,  126,  127,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635,  192,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,    0,  650,  651,  213,  652,
  215, 1543,    0,    0, 1521,    0,    0,    0,  560,    0,
    0,    0,    0,    0,    0,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  562,    0,    0,
    0,    0,    0,  563,  564,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  565,    0,    0,  566,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  567,
    0,  568,  569,    0,    0,  570,    0,    0,    0,    0,
    0,  571,    0,    0,  572,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  964,    0,    0,  653,    0,  654,    0,    0,    0,    0,
  573,    0,    0,    0,    0,    0,    0,    0,  656,    0,
    0,    0,    0,  657,    0,  574,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1522,    0,  575,
    0,    0,    0,    0,    0,  576,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  578,
  579,  580,  581,  336,  337,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  128,  592,    0,  130,  131,  132,  593,  594,    0,
  595,  596,  597,    0,  135,  136,  598,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  599,  147,    0,  600,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  625,    0,  626,  627,
  628,  182,    0,  629,    0,  630,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641,    0,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
 1546,    0,    0, 1521,    0,    0,    0,  560,    0,    0,
    0,    0,    0,    0,  561,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  562,    0,    0,    0,
    0,    0,  563,  564,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  565,    0,    0,  566,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  567,    0,
  568,  569,    0,    0,  570,    0,    0,    0,    0,    0,
  571,    0,    0,  572,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  964,
    0,    0,  653,    0,  654,    0,    0,    0,    0,  573,
    0,    0,    0,    0,    0,    0,    0,  656,    0,    0,
    0,    0,  657,    0,  574,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1522,    0,  575,    0,
    0,    0,    0,    0,  576,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  577,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  578,  579,
  580,  581,  336,  337,  120,    0,  121,  122,  123,  124,
    0,  125,  582,    0,    0,    0,    0,    0,    0,  126,
  127,  583,  584,  585,  586,  587,  588,  589,  590,  591,
  128,  592,    0,  130,  131,  132,  593,  594,    0,  595,
  596,  597,    0,  135,  136,  598,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  599,  147,    0,  600,  149,  150,    0,  151,    0,
  601,  602,  603,    0,  604,  605,    0,  606,  152,  153,
  154,  155,  156,  157,  607,  159,  608,  161,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,  619,    0,
  620,  621,  622,  623,  624,  625,    0,  626,  627,  628,
  182,    0,  629,    0,  630,  631,  632,  633,  634,  189,
  190,  635,  192,  636,  637,  638,  196,  639,  198,  640,
  200,  641,    0,  642,  643,  644,  645,    0,  646,  647,
  648,  209,  649,    0,  650,  651,  213,  652,  215, 1551,
    0,    0, 1521,    0,    0,    0,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,    0,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  964,    0,
    0,  653,    0,  654,    0,    0,    0,    0,  573,    0,
    0,    0,    0,    0,    0,    0,  656,    0,    0,    0,
    0,  657,    0,  574,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1522,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,    0,  650,  651,  213,  652,  215, 1554,    0,
    0, 1521,    0,    0,    0,  560,    0,    0,    0,    0,
    0,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  562,    0,    0,    0,    0,    0,
  563,  564,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  565,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  567,    0,  568,  569,
    0,    0,  570,    0,    0,    0,    0,    0,  571,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  964,    0,    0,
  653,    0,  654,    0,    0,    0,    0,  573,    0,    0,
    0,    0,    0,    0,    0,  656,    0,    0,    0,    0,
  657,    0,  574,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1522,    0,  575,    0,    0,    0,
    0,    0,  576,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  577,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  578,  579,  580,  581,
  336,  337,  120,    0,  121,  122,  123,  124,    0,  125,
  582,    0,    0,    0,    0,    0,    0,  126,  127,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  128,  592,
    0,  130,  131,  132,  593,  594,    0,  595,  596,  597,
    0,  135,  136,  598,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  599,
  147,    0,  600,  149,  150,    0,  151,    0,  601,  602,
  603,    0,  604,  605,    0,  606,  152,  153,  154,  155,
  156,  157,  607,  159,  608,  161,  609,  610,  611,  612,
  613,  614,  615,  616,  617,  618,  619,    0,  620,  621,
  622,  623,  624,  625,    0,  626,  627,  628,  182,    0,
  629,    0,  630,  631,  632,  633,  634,  189,  190,  635,
  192,  636,  637,  638,  196,  639,  198,  640,  200,  641,
    0,  642,  643,  644,  645,    0,  646,  647,  648,  209,
  649,    0,  650,  651,  213,  652,  215, 1557,    0,    0,
 1521,    0,    0,    0,  560,    0,    0,    0,    0,    0,
    0,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  793,    0,  562,    0,    0,    0,    0,    0,  563,
  564,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  565,    0,    0,
  566,  793,  793,    0,    0,  793,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  793,    0,    0,    0,    0,  567,    0,  568,  569,    0,
    0,  570,    0,    0,    0,    0,    0,  571,    0,    0,
  572,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  764,    0,  764,  764,    0,  764,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  573,    0,  764,    0,
    0,    0,    0,  764,    0,    0,    0,    0,    0,    0,
    0,  574,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1522,    0,  575,    0,    0,    0,    0,
    0,  576,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  577,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  578,  579,  580,  581,  336,
  337,  120,    0,  121,  122,  123,  124,    0,  125,  582,
    0,    0,    0,    0,    0,    0,  126,  127,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  128,  592,    0,
  130,  131,  132,  593,  594,    0,  595,  596,  597,    0,
  135,  136,  598,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  599,  147,
    0,  600,  149,  150,    0,  151,    0,  601,  602,  603,
    0,  604,  605,    0,  606,  152,  153,  154,  155,  156,
  157,  607,  159,  608,  161,  609,  610,  611,  612,  613,
  614,  615,  616,  617,  618,  619,    0,  620,  621,  622,
  623,  624,  625,    0,  626,  627,  628,  182,    0,  629,
    0,  630,  631,  632,  633,  634,  189,  190,  635,  192,
  636,  637,  638,  196,  639,  198,  640,  200,  641,    0,
  642,  643,  644,  645,    0,  646,  647,  648,  209,  649,
  764,  650,  651,  213,  652,  215,  793,  764,    0,  793,
    0,    0,    0,    0,  764,    0,  793,    0,  793,    0,
    0,    0,  793,    0,    0,    0,  764,  793,    0,    0,
  793,    0,  764,  764,    0,    0,    0,    0,    0,    0,
  764,    0,    0,    0,    0,  793,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  793,    0,
  764,    0,    0,  764,    0,    0,  793,    0,    0,    0,
  793,    0,    0,    0,    0,    0,    0,    0,    0,  793,
    0,    0,    0,    0,    0,    0,    0,    0,  764,    0,
  764,  764,    0,    0,  764,  793,    0,    0,    0,    0,
  764,    0,    0,  764,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  653,    0,  654,    0,    0,
    0,    0,  793,    0,    0,    0,    0,    0,    0,  764,
  656,    0,    0,    0,  793,  657,  793,    0,    0,    0,
    0,    0,    0,    0,  764,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  764,    0,
    0,    0,    0,    0,  764,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  764,    0,    0,    0,    0,    0,
    0,    0,    0,  793,    0,    0,    0,    0,  764,  764,
  764,  764,  764,  764,  764,    0,  764,  764,  764,  764,
  793,  764,  764,    0,  793,    0,    0,    0,    0,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,    0,  764,  764,    0,  764,  764,    0,  764,
  764,  764,    0,  764,  764,  764,  764,    0,    0,  764,
  764,  764,  764,  764,  764,  764,    0,    0,    0,    0,
  764,  764,  764,    0,  764,  764,  764,    0,  764,    0,
  764,  764,  764,    0,  764,  764,    0,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,    0,
  764,  764,  764,  764,  764,  764,    0,  764,  764,  764,
  764,    0,  764,    0,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,    0,  764,  764,  764,  764,    0,  764,  764,
  764,  764,  764,    0,  764,  764,  764,  764,  764,  560,
    0,    0,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  562,    0,
    0,    0,    0,    0,  563,  564,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  565,    0,    0,  566,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  567,    0,  568,  569,    0,    0,  570,    0,    0,    0,
    0,    0,  571,    0,    0,  572,    0,    0,    0,    0,
    0,    0,    0,    0,  964,    0,    0,  653,    0,  654,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  573,  656,    0,    0,    0,    0,  657,    0,    0,
    0,    0,    0,    0,    0,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  577,    0,    0,    0,
    0,    0,    0,    0,  963,    0,    0,    0,    0,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582,    0,    0,    0,    0,    0,
    0,  126,  127,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635,  192,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,    0,  650,  651,  213,  652,
  215,  560,    0,    0,    0,    0,    0,    0,  561,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  562,    0,    0,    0,    0,    0,  563,  564,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  565,    0,    0,  566,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  567,    0,  568,  569,    0,    0,  570,    0,
    0,    0,    0,    0,  571,    0,    0,  572,    0,    0,
    0,    0,    0,    0,    0,    0,  964,    0, 1089,  653,
    0,  654,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  573,  656,    0,    0,    0,    0,  657,
    0,    0,    0,    0,    0,    0,    0,    0,  574,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  575,    0,    0,    0,    0,    0,  576,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  577,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   17,
    0,    0,  578,  579,  580,  581,  336,  337,  120,    0,
  121,  122,  123,  124,    0,  125,  582,    0,    0,    0,
    0,    0,    0,  126,  127,  583,  584,  585,  586,  587,
  588,  589,  590,  591,  128,  592,    0,  130,  131,  132,
  593,  594,    0,  595,  596,  597,    0,  135,  136,  598,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  599,  147,    0,  600,  149,
  150,    0,  151,    0,  601,  602,  603,    0,  604,  605,
    0,  606,  152,  153,  154,  155,  156,  157,  607,  159,
  608,  161,  609,  610,  611,  612,  613,  614,  615,  616,
  617,  618,  619,    0,  620,  621,  622,  623,  624,  625,
    0,  626,  627,  628,  182,    0,  629,    0,  630,  631,
  632,  633,  634,  189,  190,  635,  192,  636,  637,  638,
  196,  639,  198,  640,  200,  641,    0,  642,  643,  644,
  645,    0,  646,  647,  648,  209,  649,    0,  650,  651,
  213,  652,  215,  560,    0,    0,    0,    0,    0,    0,
  561,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  562,    0,    0,    0,    0,    0,  563,  564,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  565,    0,    0,  566,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  567,    0,  568,  569,    0,    0,
  570,    0,    0,    0,    0,    0,  571,    0,    0,  572,
    0,    0,    0,    0,    0,    0,    0,    0,  964, 1324,
    0,  653,    0,  654,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  573,  656,    0,    0,    0,
    0,  657,    0,    0,    0,    0,    0,    0,    0,    0,
  574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  575,    0,    0,    0,    0,    0,
  576,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  577,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  578,  579,  580,  581,  336,  337,
  120,    0,  121,  122,  123,  124,    0,  125,  582,    0,
    0,    0,    0,    0,    0,  126,  127,  583,  584,  585,
  586,  587,  588,  589,  590,  591,  128,  592,    0,  130,
  131,  132,  593,  594,    0,  595,  596,  597,    0,  135,
  136,  598,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  599,  147,    0,
  600,  149,  150,    0,  151,    0,  601,  602,  603,    0,
  604,  605,    0,  606,  152,  153,  154,  155,  156,  157,
  607,  159,  608,  161,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,  619,    0,  620,  621,  622,  623,
  624,  625,    0,  626,  627,  628,  182,    0,  629,    0,
  630,  631,  632,  633,  634,  189,  190,  635,  192,  636,
  637,  638,  196,  639,  198,  640,  200,  641,    0,  642,
  643,  644,  645,    0,  646,  647,  648,  209,  649,    0,
  650,  651,  213,  652,  215,  560,    0,    0,    0,    0,
    0,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  562,    0,    0,    0,    0,    0,
  563,  564,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  565,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  567,    0,  568,  569,
    0,    0,  570,    0,    0,    0,    0,    0,  571,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,    0,
  964,    0,    0,  653,    0,  654,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  573,  656,    0,
    0,    0,    0,  657,    0,    0,    0,    0,    0,    0,
    0,    0,  574,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  575,    0,    0,    0,
    0,    0,  576,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  577,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  578,  579,  580,  581,
  336,  337,  120,    0,  121,  122,  123,  124,    0,  125,
  582,    0,    0,    0,    0,    0,    0,  126,  127,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  128,  592,
    0,  130,  131,  132,  593,  594,    0,  595,  596,  597,
    0,  135,  136,  598,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  599,
  147,    0,  600,  149,  150,    0,  151,    0,  601,  602,
  603,    0,  604,  605,    0,  606,  152,  153,  154,  155,
  156,  157,  607,  159,  608,  161,  609,  610,  611,  612,
  613,  614,  615,  616,  617,  618,  619,    0,  620,  621,
  622,  623,  624,  625,    0,  626,  627,  628,  182,    0,
  629,    0,  630,  631,  632,  633,  634,  189,  190,  635,
  192,  636,  637,  638,  196,  639,  198,  640,  200,  641,
    0,  642,  643,  644,  645,    0,  646,  647,  648,  209,
  649,    0,  650,  651,  213,  652,  215,  560,    0,    0,
    0,    0,    0,    0,  561,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  562,    0,    0,    0,
    0,    0,  563,  564,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  565,    0,    0,  566,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  567,    0,
  568,  569,    0,    0,  570,    0,    0,    0,    0,    0,
  571,    0,    0,  572,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  653,    0,  654,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  573,
  656,    0,    0,    0,    0,  657,    0,    0,    0,    0,
    0,    0,    0,    0,  574,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  575,    0,
    0,    0,    0,    0,  576,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  577,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1549,    0,    0,  578,  579,
  580,  581,  336,  337,  120,    0,  121,  122,  123,  124,
    0,  125,  582,    0,    0,    0,    0,    0,    0,  126,
  127,  583,  584,  585,  586,  587,  588,  589,  590,  591,
  128,  592,    0,  130,  131,  132,  593,  594,    0,  595,
  596,  597,    0,  135,  136,  598,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  599,  147,    0,  600,  149,  150,    0,  151,    0,
  601,  602,  603,    0,  604,  605,    0,  606,  152,  153,
  154,  155,  156,  157,  607,  159,  608,  161,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,  619,    0,
  620,  621,  622,  623,  624,  625,    0,  626,  627,  628,
  182,    0,  629,    0,  630,  631,  632,  633,  634,  189,
  190,  635,  192,  636,  637,  638,  196,  639,  198,  640,
  200,  641,    0,  642,  643,  644,  645,    0,  646,  647,
  648,  209,  649,    0,  650,  651,  213,  652,  215,  560,
    0,    0,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  562,    0,
    0,    0,    0,    0,  563,  564,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1603,
    0,    0,  565,    0,    0,  566,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  567,    0,  568,  569,    0,    0,  570,    0,    0,    0,
    0,    0,  571,    0,    0,  572,    0,    0,    0,    0,
    0,    0,    0,    0,  964,    0,    0,  653,    0,  654,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  573,  656,    0,    0,    0,    0,  657,    0,    0,
    0,    0,    0,    0,    0,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  577,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582,    0,    0,    0,    0,    0,
    0,  126,  127,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635,  192,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,    0,  650,  651,  213,  652,
  215,  560,    0,    0,    0,    0,    0,    0,  561,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  562,    0,    0,    0,    0,    0,  563,  564,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  565,    0,    0,  566,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  567,    0,  568,  569,    0,    0,  570,    0,
    0,    0,    0,    0,  571,    0,    0,  572,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  766,    0,  766,
  766,    0,  766,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  573,    0,  766,    0,    0,    0,    0,
  766,    0,    0,    0,    0,    0,    0,    0,  574,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  575,    0,    0,    0,    0,    0,  576,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  577,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1789,
    0,    0,  578,  579,  580,  581,  336,  337,  120,    0,
  121,  122,  123,  124,    0,  125,  582,    0,    0,    0,
    0,    0,    0,  126,  127,  583,  584,  585,  586,  587,
  588,  589,  590,  591,  128,  592,    0,  130,  131,  132,
  593,  594,    0,  595,  596,  597,    0,  135,  136,  598,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  599,  147,    0,  600,  149,
  150,    0,  151,    0,  601,  602,  603,    0,  604,  605,
    0,  606,  152,  153,  154,  155,  156,  157,  607,  159,
  608,  161,  609,  610,  611,  612,  613,  614,  615,  616,
  617,  618,  619,    0,  620,  621,  622,  623,  624,  625,
    0,  626,  627,  628,  182,    0,  629,    0,  630,  631,
  632,  633,  634,  189,  190,  635,  192,  636,  637,  638,
  196,  639,  198,  640,  200,  641,    0,  642,  643,  644,
  645,    0,  646,  647,  648,  209,  649,  766,  650,  651,
  213,  652,  215,    0,  766, 1208,    0,    0,  858,    0,
    0,  766,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1209,    0,  766,    0,  859,    0,    0,  860,  766,
  766,    0,    0,    0,    0,    0,    0,  766,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  766,    0,    0,
  766,    0,    0,    0,    0,    0,    0,    0,  861,    0,
    0,    0,    0,    0,  862,  863,  864,    0,  865,  866,
  867,    0,  868,    0,    0,  766,    0,  766,  766,    0,
    0,  766,    0,    0,    0,    0,    0,  766,    0,  869,
  766,  870,    0,    0,    0,    0,    0,    0,    0, 1201,
    0, 1201, 1201,    0, 1201,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  766, 1201,    0,    0,
  871,    0, 1201,    0,    0,    0,    0,    0,    0,    0,
    0,  766,    0,    0,    0,    0,    0,  872,    0,    0,
    0,    0,    0,    0,    0,  766,    0,    0,    0,    0,
    0,  766,    0,    0,    0,    0,    0,    0,    0,  873,
    0,  766,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  766,  766,  766,  766,  766,
  766,  766,    0,  766,  766,  766,  766,    0,  766,  766,
    0,    0,    0,    0,  874,  875,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,    0,
  766,  876,    0,  766,  766,    0,  766,  766,  766,    0,
  766,  766,  766,  766,    0,    0,  766,  766,  766,  766,
  766,  766,  766,    0,    0,    0,    0,  766,  766,  766,
    0,  766,  766,  766,    0,  766,    0,  766,  766,  766,
    0,  766,  766,    0,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,    0,  766,  766,  766,
  766,  766,  766,    0,  766,  766,  766,  766,    0,  766,
    0,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,    0,
  766,  766,  766,  766,    0,  766,  766,  766,  766,  766,
    0,  766,  766,  766,  766,  766, 1201,    0,    0,    0,
    0,    0,    0, 1201,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1201,    0,    0,    0,    0,
    0, 1201, 1201,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1201,
    0,    0, 1201,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1201,    0, 1201,
 1201,    0,    0, 1201,    0,    0,    0,    0,    0, 1201,
    0,    0, 1201,    0,    0,    0,    0,    0,    0,    0,
    0,  655,    0,    0,  653,    0,  654,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1201,  656,
    0,    0,    0,    0,  657,    0,    0,    0,    0,    0,
    0,    0,    0, 1201,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1201,    0,    0,
    0,    0,    0, 1201,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1201,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1201, 1201, 1201,
 1201, 1201, 1201, 1201,    0, 1201, 1201, 1201, 1201,    0,
 1201, 1201,    0,    0,    0,    0,    0,    0, 1201, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
 1201,    0, 1201, 1201, 1201, 1201, 1201,    0, 1201, 1201,
 1201,    0, 1201, 1201, 1201, 1201,    0,    0, 1201, 1201,
 1201, 1201, 1201, 1201, 1201,    0,    0,    0,    0, 1201,
 1201, 1201,    0, 1201, 1201, 1201,    0, 1201,    0, 1201,
 1201, 1201,    0, 1201, 1201,    0, 1201, 1201, 1201, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201,    0, 1201,
 1201, 1201, 1201, 1201, 1201,    0, 1201, 1201, 1201, 1201,
    0, 1201,    0, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
 1201,    0, 1201, 1201, 1201, 1201,    0, 1201, 1201, 1201,
 1201, 1201,    0, 1201, 1201, 1201, 1201, 1201,  560,    0,
    0,    0,    0,    0,    0,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  562,    0,    0,
    0,    0,    0,  563,  564,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  565,    0,    0,  566,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  567,
    0,  568,  569,    0,    0,  570,    0,    0,    0,    0,
    0,  571,    0,    0,  572,    0,    0,    0,    0,    0,
    0,    0,    0,  964,    0,    0,  653,    0,  654,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  573,  656,    0,    0,    0,    0,  657,    0,    0,    0,
    0,    0,    0,    0,    0,  574,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  575,
    0,    0,    0,    0,    0,  576,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  578,
  579,  580,  581,  336,  337,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  128,  592,    0,  130,  131,  132,  593,  594,    0,
  595,  596,  597,    0,  135,  136,  598,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  599,  147,    0,  600,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  625,    0,  626,  627,
  628,  182,    0,  629,    0,  630,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641,    0,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
  560,    0,    0,    0,    0,    0,    0,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  562,
    0,    0,    0,    0,    0,  563,  564,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  565,    0,    0,  566,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  567,    0,  568,  569,    0,    0,  570,    0,    0,
    0,    0,    0,  571,    0,    0,  572,    0,    0,    0,
    0,    0,    0,    0,    0, 1201,    0,    0, 1201,    0,
 1201,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  573, 1201,    0,    0,    0,    0, 1201,    0,
    0,    0,    0,    0,    0,    0,    0,  574,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  575,    0,    0,    0,    0,    0,  576,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  577,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  578,  579,  580,  581,  336,  337,  120,    0,  121,
  122,  123,  124,    0,  125,  582,    0,    0,    0,    0,
    0,    0,  126,  127,  583,  584,  585,  586,  587,  588,
  589,  590,  591,  128,  592,    0,  130,  131,  132,  593,
  594,    0,  595,  596,  597,    0,  135,  136,  598,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  599,  147,    0,  600,  149,  150,
    0,  151,    0,  601,  602,  603,    0,  604,  605,    0,
  606,  152,  153,  154,  155,  156,  157,  607,  159,  608,
  161,  609,  610,  611,  612,  613,  614,  615,  616,  617,
  618,  619,    0,  620,  621,  622,  623,  624,  625,    0,
  626,  627,  628,  182,    0,  629,    0,  630,  631,  632,
  633,  634,  189,  190,  635,  192,  636,  637,  638,  196,
  639,  198,  640,  200,  641, 1313,  642,  643,  644,  645,
    0,  646,  647,  648,  209,  649,    0,  650,  651,  213,
  652,  215, 1201,  656,    0,    0,    0,    0,    0, 1201,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1201,    0,    0,    0,    0,    0, 1201, 1201,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1201,    0,    0, 1201,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1201,    0, 1201, 1201,    0,    0, 1201,
    0,    0,    0,    0,    0, 1201,    0,    0, 1201,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1201,    0,    0,    0,    0,    0,
    0,    0,    0, 1032,    0,    0,    0,    0,    0, 1201,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1201,    0,    0,    0,    0,    0, 1201,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1201,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
    0, 1201, 1201, 1201, 1201,    0, 1201, 1201,    0,    0,
    0,    0,    0,    0, 1201, 1201, 1201, 1201, 1201, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201,    0, 1201, 1201,
 1201, 1201, 1201,    0, 1201, 1201, 1201,    0, 1201, 1201,
 1201, 1201,    0,    0, 1201, 1201, 1201, 1201, 1201, 1201,
 1201,    0,    0,    0,    0, 1201, 1201, 1201,    0, 1201,
 1201, 1201,    0, 1201,    0, 1201, 1201, 1201,    0, 1201,
 1201,    0, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
 1201, 1201, 1201, 1201,    0, 1201, 1201, 1201, 1201, 1201,
 1201,  399, 1201, 1201, 1201, 1201,    0, 1201,    0, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201, 1201,
 1201, 1201, 1201, 1201, 1201, 1201, 1201,    0, 1201, 1201,
 1201, 1201,    0, 1201, 1201, 1201, 1201, 1201,    0, 1201,
 1201, 1201, 1201, 1201,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  119,    0,    0,  120,
    0,  121,  122,  123,  124,    0,  125,    0,    0,    0,
    0,    0,    0,    0,  126,  127,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  128,  129,    0,  130,  131,
  132,    0,    0,    0,    0,  133,  134,    0,  135,  136,
 1032,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  146,  147,    0,  148,
  149,  150,    0,  151,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
  169,  170,  171,  172,    0,  173,  174,  175,  176,  177,
  178,    0,  179,  180,  181,  182,    0,  183,    0,  184,
  185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
  195,  196,  197,  198,  199,  200,  201,    0,  202,  203,
  204,  205, 1118,  206,  207,  208,  209,  210,   17,  211,
  212,  213,  214,  215,  119,    0,    0,  120,    0,  121,
  122,  123,  124,    0,  125,    0,    0,    0,    0,    0,
    0,    0,  126,  127,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  128,  129,    0,  130,  131,  132,    0,
    0,    0,    0,  133,  134,    0,  135,  136,    0,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144, 1320,
    0,    0,    0,  145,  146,  147,    0,  148,  149,  150,
    0,  151,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  152,  153,  154,  155,  156,  157,  158,  159,  160,
  161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
  171,  172,    0,  173,  174,  175,  176,  177,  178,    0,
  179,  180,  181,  182,    0,  183,    0,  184,  185,  186,
  187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
  197,  198,  199,  200,  201,    0,  202,  203,  204,  205,
    0,  206,  207,  208,  209,  210,    0,  211,  212,  213,
  214,  215,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,    0,    0,    0,    0,    0,    0,    0,
  126,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,    0,
    0,  133,  134,    0,  135,  136,    0,  137, 1320,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,    0,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
 1319,  119,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,    0,    0,    0,    0,    0,    0,    0,  126,
  127,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  128,  129,    0,  130,  131,  132,    0,    0,    0,    0,
  133,  134,    0,  135,  136,    0,  137,    0,  779,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  146,  147,    0,  148,  149,  150,    0,  151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,    0,
  173,  174,  175,  176,  177,  178,    0,  179,  180,  181,
  182,    0,  183,    0,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,    0,  202,  203,  204,  205,    0,  206,  207,
  208,  209,  210,    0,  211,  212,  213,  214,  215,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  119,    0,
    0,  120,    0,  121,  122,  123,  124,    0,  125,    0,
    0,    0,    0,    0,    0,    0,  126,  127,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  128,  129,    0,
  130,  131,  132,    0,    0,    0,    0,  133,  134,   88,
  135,  136,    0,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  146,  147,
    0,  148,  149,  150,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  152,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,  169,  170,  171,  172,    0,  173,  174,  175,
  176,  177,  178,    0,  179,  180,  181,  182,    0,  183,
    0,  184,  185,  186,  187,  188,  189,  190,  191,  192,
  193,  194,  195,  196,  197,  198,  199,  200,  201,    0,
  202,  203,  204,  205,    0,  206,  207,  208,  209,  210,
    0,  211,  212,  213,  214,  215,    0,  119,    0,    0,
  120,    0,  121,  122,  123,  124,    0,  125,    0,    0,
    0,  779,    0,    0,    0,  126,  127,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,  129,    0,  130,
  131,  132,    0,    0,    0,    0,  133,  134,    0,  135,
  136,    0,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,  656,    0,    0,    0,  145,  146,  147,    0,
  148,  149,  150,    0,  151,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,    0,  173,  174,  175,  176,
  177,  178,    0,  179,  180,  181,  182,    0,  183,    0,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201,    0,  202,
  203,  204,  205,    0,  206,  207,  208,  209,  210,    0,
  211,  212,  213,  214,  215,  782,    0,    0,  782,    0,
  782,  782,  782,  782,    0,  782,    0,    0,    0,    0,
    0,    0,    0,  782,  782,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  782,  782,    0,  782,  782,  782,
    0,    0,    0,    0,  782,  782,    0,  782,  782,    0,
  782,    0,    0,  782,  782,  782,  782,  782,  782,  782,
    0,    0,    0,    0,  782,  782,  782,    0,  782,  782,
  782,    0,  782,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,    0,  782,  782,  782,  782,  782,  782,
    0,  782,  782,  782,  782,    0,  782,    0,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,    0,  782,  782,  782,
  782,    0,  782,  782,  782,  782,  782,    0,  782,  782,
  782,  782,  782,   87,    0,  119,    0,    0,  120,    0,
  121,  122,  123,  124,    0,  125,    0,    0,    0,    0,
    0,    0,    0,  126,  127,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  128,  129,    0,  130,  131,  132,
    0,    0,    0,    0,  133,  134,    0,  135,  136,    0,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  146,  147,    0,  148,  149,
  150,    0,  151,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  152,  153,  154,  155,  156,  157,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
  170,  171,  172,    0,  173,  174,  175,  176,  177,  178,
    0,  179,  180,  181,  182,    0,  183,    0,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,    0,  202,  203,  204,
  205,    0,  206,  207,  208,  209,  210,    0,  211,  212,
  213,  214,  215,    0,    0,  119,    0,    0,  120,    0,
  121,  122,  123,  124,    0,  125,    0,    0,    0,    0,
    0,    0,    0,  126,  127,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  128,  129,    0,  130,  131,  132,
    0,    0,    0,    0,  133,  134,    0,  135,  136,    0,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  146,  147,    0,  148,  149,
  150,    0,  151,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  152,  153,  154,  155,  156,  157,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
  170,  171,  172,    0,  173,  174,  175,  176,  177,  178,
    0,  179,  180,  181,  182,  990,  183,    0,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,    0,  202,  203,  204,
  205,    0,  206,  207,  208,  209,  210,    0,  211,  212,
  213,  214,  215,    0,    0,    0,    0, 1249, 1249,  990,
 1249, 1249, 1249,    0,    0,    0,    0,    0,  253,    0,
    0,  253,    0,    0,  990, 1249, 1249, 1249,    0,    0,
    0,    0,    0,    0,  253,    0,    0,    0,  253,    0,
    0,  253,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  857,    0,    0,  858, 1249,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  859,    0,    0,  860,    0,    0,    0,    0,
    0,  253,    0,    0,    0,    0,    0,  253,  253,  253,
    0,  253,  253,  253,  991,  253,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  253,    0,  253,  861,    0,    0,    0,    0,
    0,  862,  863,  864,    0,  865,  866,  867,    0,  868,
    0,    0,    0,    0,    0,    0, 1250, 1250,  991, 1250,
 1250, 1250,    0,  253,    0,    0,  869,    0,  870,    0,
    0,    0,    0,  991, 1250, 1250, 1250,    0,    0,    0,
  253,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  871,    0,    0,
    0,    0,  253,    0,    0, 1250,    0,    0,    0,    0,
    0,    0,    0,    0,  872,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  873,  253,  253,    0,
    0,    0,    0,    0,    0,    0,  623,  990,    0,    0,
    0,    0,    0,    0,  253,    0, 1249,    0,    0,    0,
    0,    0, 1249,    0,    0,    0,    0, 1249,    0,    0,
 1249,  874,  875,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  623,  876,  992,
  623,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  990,    0,    0,  990,    0,  623, 1249,  623,    0,    0,
  990,    0,  990,    0, 1249,    0,  990,    0,    0,    0,
    0,  990, 1249,    0,  990,    0,    0,    0,    0,    0,
    0, 1251, 1251,  992, 1251, 1251, 1251,    0,    0,  990,
 1249,    0, 1249,    0,    0,    0,    0,    0,  992, 1251,
 1251, 1251,  990,    0, 1249,    0, 1249, 1249, 1249,    0,
  990,    0,    0,  990,  990,    0,    0,    0,    0,    0,
    0,    0,    0,  990,    0,    0,  991,    0,    0,    0,
 1251,    0,    0,    0,    0, 1250,    0,    0,    0,  990,
    0, 1250,    0,    0,    0,    0, 1250,    0,    0, 1250,
    0,    0,    0,    0,    0, 1249,    0,    0,  947,    0,
    0,  990,    0,    0,    0,    0,  990,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  990,  990,  991,
  990,    0,  991,    0,    0, 1250,    0,  154,    0,  991,
  154,  991,    0, 1250,    0,  991,    0,    0,    0,  947,
  991, 1250,  947,  991,    0,    0,    0,  154,    0,    0,
  154,    0,    0,    0,    0,    0,    0,  947,  991, 1250,
    0, 1250,    0,    0,    0,    0,    0,  990,    0,    0,
    0,  991,    0, 1250,    0, 1250, 1250, 1250,  948,  991,
    0,    0,  991,  991,  990,    0,    0,    0,  990,    0,
  154,    0,  991,    0,  623,    0,  154,  154,  154,    0,
  154,  154,  154,  990,  154,    0,    0,    0,  991,  623,
    0,    0,    0,  623,    0,    0,    0,    0,    0,  948,
    0,  154,  948,  154, 1250,    0,    0,    0,    0,    0,
  991,    0,    0,  623,    0,  991,    0,  948,    0,  623,
    0,  992,  623,    0,    0,    0,  991,  991,    0,  991,
 1251,    0,  154,    0,    0,    0, 1251,    0,    0,    0,
    0, 1251,    0,    0, 1251,    0,    0,    0,    0,  154,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  623,    0,    0,    0,    0,    0,
    0,  154,    0,    0,  992,    0,  991,  992,    0,    0,
 1251,    0,    0,    0,  992,    0,  992,  623, 1251,    0,
  992,    0,    0,  991,    0,  992, 1251,  991,  992,    0,
    0,  974,    0,    0,    0,    0,  154,  154,    0,    0,
    0,    0,  991,  992, 1251,    0, 1251,    0,  623,    0,
    0,  951,    0,  154,    0,  623,  992,    0, 1251,    0,
 1251, 1251, 1251,    0,  992,    0,    0,  992,  992,    0,
  947,    0,  974,  623,    0,  974,    0,  992,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  974,    0,  951,  992,    0,  951,    0,    0,    0,    0,
    0,    0,    0,  623,    0,    0,    0,  623,    0, 1251,
  951,    0,    0,    0,    0,  992,    0,    0,    0,    0,
  992,    0,    0,  947,    0,    0,  947,    0,    0,    0,
    0,  992,  992,  947,  992,  947,    0,    0,    0,  947,
    0,    0,    0,    0,  947,    0,    0,  947,    0,    0,
  948,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  947,    0,    0,    0,    0,    0,    0,    0,
  949,    0,    0,    0,    0,  947,    0,    0,    0,    0,
    0,  992,    0,  947,    0,    0,  947,  947,    0,    0,
    0,    0,    0,    0,    0,    0,  947,    0,  992,    0,
    0,    0,  992,  948,    0,    0,  948,    0,    0,    0,
    0,  949,  947,  948,  949,  948,    0,  992,    0,  948,
    0,    0,    0,    0,  948,    0,    0,  948,    0,  949,
    0,    0,    0,    0,  947,    0,    0,    0,    0,  947,
    0,    0,  948,    0,    0,    0,    0,    0,    0,    0,
  947,  947,    0,  947,    0,  948,    0,    0,    0,    0,
    0,    0,    0,  948,    0,    0,  948,  948,  950,    0,
    0,    0,    0,    0,    0,    0,  948,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  948,  974,    0,    0,    0,    0,    0,    0,
  947,    0,    0,    0,    0,    0,    0,    0,    0,  950,
    0,    0,  950,  951,  948,    0,    0,  947,    0,  948,
    0,  947,    0,    0,    0,    0,    0,  950,    0,    0,
  948,  948,    0,  948,    0,    0,  947,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  974,    0,    0,  974,
    0,    0,    0,    0,    0,    0,  974,    0,  974,    0,
    0,    0,  974,    0,    0,    0,  951,  974,    0,  951,
  974,    0,    0,    0,    0,    0,  951,    0,  951,    0,
  948,    0,  951,    0,    0,  974,    0,  951,    0,    0,
  951,    0,    0,    0,    0,    0,    0,  948,  974,    0,
    0,  948,    0,    0,  982,  951,  974,    0,    0,  974,
  974,    0,    0,    0,    0,    0,  948,    0,  951,  974,
    0,    0,    0,    0,    0,    0,  951,    0,    0,  951,
  951,    0,  949,    0,    0,  974,    0,    0,    0,  951,
    0,    0,    0,    0,    0,  982,    0,    0,  982,    0,
    0,    0,    0,    0,    0,  951,    0,  974,    0,    0,
    0,    0,  974,  982,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  974,  974,    0,  974,  951,    0,    0,
    0,    0,  951,    0,    0,  949,    0,    0,  949,    0,
    0,    0,    0,  951,  951,  949,  951,  949,    0,    0,
    0,  949,    0,    0,    0,    0,  949,    0,    0,  949,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  974,  949,    0,  944,    0,    0,    0,
  950,    0,    0,    0,    0,    0,    0,  949,    0,    0,
  974,    0,    0,  951,  974,  949,    0,    0,  949,  949,
    0,    0,    0,    0,    0,    0,    0,    0,  949,  974,
  951,  945,    0,    0,  951,    0,    0,  944,    0,    0,
  944,    0,    0,    0,  949,    0,    0,    0,    0,  951,
    0,    0,    0,  950,    0,  944,  950,    0,    0,    0,
    0,    0,    0,  950,    0,  950,  949,    0,    0,  950,
    0,  949,  945,    0,  950,  945,    0,  950,    0,    0,
    0,  253,  949,  949,  253,  949,    0,    0,    0,  946,
  945,    0,  950,    0,    0,    0,    0,    0,    0,    0,
    0,  253,    0,    0,  253,  950,    0,    0,    0,    0,
    0,    0,    0,  950,    0,    0,  950,  950,    0,    0,
    0,    0,    0,    0,    0,    0,  950,    0,    0,    0,
  946,    0,  949,  946,    0,    0,  982,    0,    0,    0,
    0,    0,  950,    0,  253,    0,    0,    0,  946,  949,
  253,  253,  253,  949,  253,  253,  253,    0,  253,    0,
    0,    0,    0,    0,  950,    0,    0,    0,  949,  950,
    0,    0,    0,    0,    0,  253,    0,  253,    0,    0,
  950,  950,    0,  950,    0,    0,    0,    0,    0,  982,
    0,    0,  982,    0,    0,    0,    0,    0,    0,  982,
    0,  982,    0,    0,    0,  982,  253,    0,    0,    0,
  982,    0,    0,  982,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  253,    0,    0,    0,    0,  982,    0,
  950,    0,    0,  981,    0,    0,    0,    0,    0,    0,
    0,  982,    0,    0,    0,  253,    0,  950,    0,  982,
    0,  950,  982,  982,    0,    0,    0,    0,  944,    0,
    0,    0,  982,    0,    0,  975,  950,    0,    0,    0,
    0,    0,    0,    0,  981,    0,    0,  981,  982,    0,
  253,  253,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  981,  945,    0,  983,    0,  253,    0,    0,
  982,    0,    0,    0,    0,  982,  975,    0,    0,  975,
    0,  944,    0,    0,  944,    0,  982,  982,    0,  982,
    0,  944,    0,  944,  975,    0,    0,  944,    0,    0,
    0,    0,  944,    0,    0,  944,  983,    0,    0,  983,
    0,    0,    0,    0,    0,    0,  945,    0,    0,  945,
  944,  946,    0,    0,  983,    0,  945,    0,  945,    0,
    0,    0,  945,  944,    0,    0,  982,  945,    0,    0,
  945,  944,    0,    0,  944,  944,    0,    0,    0,    0,
    0,    0,    0,  982,  944,  945,    0,  982,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  945,    0,
  944,    0,  982,    0,  946,    0,  945,  946,    0,  945,
  945,    0,    0,    0,  946,    0,  946,    0,    0,  945,
  946,    0,  944,    0,    0,  946,    0,  944,  946,    0,
    0,    0,    0,    0,    0,  945,    0,    0,  944,  944,
  984,  944,    0,  946,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  946,  945,    0,    0,
    0,    0,  945,    0,  946,    0,    0,  946,  946,    0,
  972,    0,    0,  945,  945,    0,  945,  946,    0,    0,
    0,  984,    0,    0,  984,    0,    0,    0,  944,    0,
    0,    0,    0,  946,    0,  981,    0,    0,    0,  984,
    0,    0,  970,    0,    0,  944,    0,    0,    0,  944,
    0,  972,    0,    0,  972,  946,    0,    0,    0,    0,
  946,    0,    0,  945,  944,    0,    0,  975,    0,  972,
    0,  946,  946,    0,  946,    0,    0,    0,    0,    0,
  945,    0,    0,  970,  945,    0,  970,    0,  981,    0,
    0,  981,    0,    0,    0,    0,    0,  983,  981,  945,
  981,  970,    0,    0,  981,    0,    0,    0,    0,  981,
    0,    0,  981,    0,    0,    0,    0,    0,    0,    0,
  975,  946,    0,  975,    0,    0,    0,  981,    0,    0,
  975,    0,  975,    0,    0,    0,  975,    0,  946,    0,
  981,  975,  946,    0,  975,    0,    0,    0,  981,    0,
  983,  981,  981,  983,    0,    0,    0,  946,    0,  975,
  983,  981,  983,    0,    0,    0,  983,    0,    0,    0,
    0,  983,  975,    0,  983,    0,    0,  981,    0,    0,
  975,    0,    0,  975,  975,  976,    0,    0,    0,  983,
    0,    0,    0,  975,    0,    0,    0,    0,    0,  981,
    0,    0,  983,    0,  981,    0,    0,    0,    0,  975,
  983,    0,    0,  983,  983,  981,  981,    0,  981,    0,
    0,    0,    0,  983,    0,    0,  976,    0,    0,  976,
    0,  975,    0,    0,    0,    0,  975,    0,    0,  983,
    0,    0,  984,    0,  976,    0,    0,  975,  975,    0,
  975,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  983,    0,    0,    0,  981,  983,    0,    0,    0,
    0,    0,  972,    0,    0,    0,    0,  983,  983,  985,
  983,    0,  981,    0,    0,    0,  981,    0,    0,    0,
    0,    0,    0,    0,    0,  984,    0,  975,  984,    0,
    0,  981,    0,    0,  970,  984,    0,  984,    0,    0,
    0,  984,    0,    0,  975,    0,  984,    0,  975,  984,
  985,    0,    0,  985,    0,  972,    0,  983,  972,    0,
    0,    0,    0,  975,  984,  972,    0,  972,  985,    0,
    0,  972,    0,    0,  983,    0,  972,  984,  983,  972,
    0,    0,    0,    0,    0,  984,    0,  970,  984,  984,
  970,    0,    0,  983,  972,    0,    0,  970,  984,  970,
    0,    0,  971,  970,    0,    0,    0,  972,  970,    0,
    0,  970,    0,    0,  984,  972,    0,    0,  972,  972,
    0,    0,    0,    0,    0,    0,  970,    0,  972,    0,
    0,    0,    0,    0,    0,    0,  984,    0,    0,  970,
    0,  984,    0,  971,  972,    0,  971,  970,  973,    0,
  970,  970,  984,  984,    0,  984,    0,    0,    0,    0,
  970,  971,    0,    0,    0,    0,  972,    0,    0,    0,
    0,  972,    0,    0,    0,    0,  970,  976,    0,    0,
    0,    0,  972,  972,    0,  972,    0,    0,    0,  973,
    0,    0,  973,    0,    0,    0,    0,    0,  970,    0,
    0,    0,  984,  970,    0,    0,    0,  973,    0,    0,
    0,    0,    0,    0,  970,  970,    0,  970,    0,  984,
    0,    0,    0,  984,    0,    0,    0,    0,    0,    0,
  976,    0,  972,  976,    0,    0,    0,    0,  984,    0,
  976,    0,  976,    0,    0,    0,  976,    0,    0,  972,
    0,  976,    0,  972,  976,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  970,    0,    0,    0,  972,  976,
  977,  985,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  970,  976,    0,    0,  970,    0,    0,    0,    0,
  976,    0,    0,  976,  976,    0,    0,    0,    0,    0,
  970,    0,    0,  976,    0,    0,    0,    0,    0,    0,
    0,  977,    0,    0,  977,    0,    0,    0,    0,  976,
    0,    0,    0,    0,  985,    0,    0,  985,    0,  977,
    0,    0,    0,    0,  985,    0,  985,    0,    0,    0,
  985,  976,    0,    0,    0,  985,  976,    0,  985,    0,
  928,    0,    0,    0,    0,    0,    0,  976,  976,    0,
  976,    0,    0,  985,  971,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  985,    0,    0,    0,
    0,    0,    0,    0,  985,    0,    0,  985,  985,    0,
    0,  928,    0,    0,  928,    0,    0,  985,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  976,    0,  928,
  973,    0,    0,  985,    0,    0,    0,  971,    0,    0,
  971,    0,    0,    0,  976,    0,    0,  971,  976,  971,
  795,    0,    0,  971,    0,  985,    0,    0,  971,    0,
  985,  971,    0,  976,    0,    0,    0,    0,    0,    0,
    0,  985,  985,    0,  985,    0,  971,    0,    0,    0,
    0,    0,    0,  973,    0,    0,  973,    0,    0,  971,
    0,  795,    0,  973,  795,  973,  806,  971,    0,  973,
  971,  971,    0,    0,  973,    0,    0,  973,    0,  795,
  971,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  985,  973,    0,    0,    0,  971,    0,    0,    0,
    0,    0,    0,    0,    0,  973,    0,  806,  985,    0,
  806,    0,  985,  973,    0,    0,  973,  973,  971,    0,
    0,    0,  977,  971,    0,  806,  973,  985,    0,    0,
    0,    0,    0,    0,  971,  971,    0,  971,    0,    0,
    0,    0,  973,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  973,    0,    0,    0,    0,  973,
    0,    0,    0,    0,    0,  977,    0,    0,  977,    0,
  973,  973,    0,  973,  971,  977,    0,  977,    0,    0,
    0,  977,    0,    0,    0,    0,  977,    0,    0,  977,
    0,  971,    0,    0,    0,  971,    0,    0,    0,    0,
    0,    0,    0,    0,  977,    0,    0,    0,    0,    0,
  971,    0,    0,    0,    0,    0,    0,  977,    0,    0,
  973,    0,    0,    0,    0,  977,    0,    0,  977,  977,
    0,    0,    0,    0,    0,    0,    0,  973,  977,    0,
    0,  973,    0,    0,    0,  928,    0,    0,  928,    0,
    0,    0,    0,    0,  977,  928,  973,  928,    0,    0,
    0,  928,    0,    0,    0,    0,  928,    0,    0,  928,
    0,    0,    0,    0,    0,    0,  977,    0,    0,    0,
    0,  977,    0,    0,  928,    0,    0,    0,    0,    0,
    0,    0,  977,  977,    0,  977,    0,  928,    0,    0,
    0,    0,    0,    0,    0,  928,    0,    0,  928,  928,
    0,    0,    0,    0,    0,    0,    0,    0,  928,    0,
    0,    0,    0,    0,    0,  795,    0,    0,  795,    0,
    0,    0,    0,    0,  928,  795,    0,  795,    0,    0,
    0,  795,  977,    0,    0,    0,  795,    0,    0,  795,
    0,    0,    0,    0,    0,    0,  928,    0,  112,  977,
    0,  928,    0,  977,  795,    0,    0,    0,    0,    0,
    0,  806,  928,  928,  806,  928,    0,  795,  977,    0,
    0,  806,    0,  806,    0,  795,    0,  806,    0,  795,
    0,    0,  806,    0,    0,  806,  113,    0,  795,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  114,    0,
  806,    0,    0,    0,  795,    0,    0,    0,    0,    0,
    0,    0,  928,  806,    0,    0,    0,    0,    0,    0,
    0,  806,  115,    0,    0,  806,    0,    0,    0,  928,
    0,  795,    0,  928,  806,    0,    0,    0,    0,    0,
    0,    0,    0,  795,    0,  795,    0,    0,  928,    0,
  806,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  806,    0,    0,
    0,    0,    0,    0,    0,    0,  116,    0,    0,  806,
    0,  806,  795,    0,    0,    0,  117,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  795,
    0,    0,    0,  795,    0,    0,    0,    0,    0,    0,
    0,  118,    0,    0,    0,    0,    0,    0,  795,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  806,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0,  125,
    0,    0,    0,    0,    0,  806,    0,  126,  127,  806,
    0,    0,    0,   51,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,  806,    0,    0,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147,   51,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,   51,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,   51,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
    0,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   51,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   51,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   51,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   53,    0,    0,   53,    0,   53,
   53,   53,   53,    0,   53,    0,    0,    0,    0,    0,
    0,    0,   53,   53,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   53,   53,    0,   53,   53,   53,    0,
    0,    0,    0,   53,   53,    0,   53,   53,    0,   53,
    0,    0,   53,   53,   53,   53,   53,   53,   53,    0,
    0,    0,    0,   53,   53,   53,    0,   53,   53,   53,
    0,   53,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,    0,   53,   53,   53,   53,   53,   53,    0,
   53,   53,   53,   53,    0,   53,    0,   53,   53,   53,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,   53,  366,   53,   53,   53,   53,
    0,   53,   53,   53,   53,   53,    0,   53,   53,   53,
   53,   53,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  366,    0,    0,    0,    0,    0,    0,
  366,    0,    0,    0,  366,  366,    0,  366,    0,    0,
  366,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  366,    0,    0,    0,    0,    0,  366,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  366,    0,    0,    0,  366,
    0,    0,    0,    0,    0,    0,    0,  366,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  366,  366,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  366,
    0,    0,    0,  366,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  366,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  366,    0,
    0,    0,    0,    0,    0,    0,    0,  366,    0,  366,
  366,    0,    0,    0,    0,    0,  366,    0,    0,  366,
    0,  366,  366,  366,  366,    0,  366,  366,    0,    0,
    0,    0,    0,    0,  366,  366,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  366,  366,    0,  366,  366,
  366,    0,    0,    0,    0,  366,  366,    0,  366,  366,
    0,  366,    0,    0,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,    0,  366,  366,  366,    0,  366,
  366,  366,    0,  366,    0,  366,  366,  366,    0,  366,
  366,    0,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,    0,  366,  366,  366,  366,  366,
  366,    0,  366,  366,  366,  366,    0,  366,    0,  366,
  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,  366,  334,  366,  366,
  366,  366,    0,  366,  366,  366,  366,  366,    0,  366,
  366,  366,  366,  366,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  334,    0,    0,    0,    0,
    0,    0,  329,    0,    0,    0,  334,  334,    0,  334,
    0,    0,  334,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  334,    0,    0,    0,    0,
    0,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  334,    0,    0,
    0,  334,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  334,  334,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  334,    0,    0,    0,  334,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  334,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  334,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  334,  334,    0,    0,    0,    0,    0,  334,    0,
    0,  334,    0,  334,  334,  334,  334,    0,  334,  334,
    0,    0,    0,    0,    0,    0,  334,  334,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  334,  334,    0,
  334,  334,  334,    0,    0,    0,    0,  334,  334,    0,
  334,  334,    0,  334,    0,    0,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,    0,  334,  334,  334,
    0,  334,  334,  334,    0,  334,    0,  334,  334,  334,
    0,  334,  334,    0,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,    0,  334,  334,  334,
  334,  334,  334,    0,  334,  334,  334,  334,    0,  334,
    0,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,    0,  334,  334,  334,  334,  334,
    0,  334,  334,  334,  334,  334,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  334,    0,    0,
    0,    0,    0,    0,  327,    0,    0,    0,  334,  334,
    0,  334,    0,    0,  334,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  334,    0,    0,
    0,    0,    0,  334,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,  334,    0,    0,    0,    0,    0,    0,
    0,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  334,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  334,    0,    0,    0,  334,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  334,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  334,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  334,  334,    0,    0,    0,    0,    0,
  334,    0,    0,  334,    0,  334,  334,  334,  334,    0,
  334,  334,    0,    0,    0,    0,    0,    0,  334,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
  334,    0,  334,  334,  334,    0,    0,    0,    0,  334,
  334,    0,  334,  334,    0,  334,    0,    0,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,    0,  334,
  334,  334,    0,  334,  334,  334,    0,  334,    0,  334,
  334,  334,    0,  334,  334,    0,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,    0,  334,
  334,  334,  334,  334,  334,    0,  334,  334,  334,  334,
    0,  334,    0,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334, 2024,  334,  334,  334,  334,    0,  334,  334,  334,
  334,  334,    0,  334,  334,  334,  334,  334,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    6,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2233, 2234,    0, 2235,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2236,
    0,    0,    0,    0,    0, 2237,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  568,    0,    0,    0,  570,    0,    0,    0,    0,
    0,    0,    0,   11,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  573, 2238,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  574,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2239,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   16,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   17,    0,    0,    0,
    0,    0,  581,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2240,  592,    0,  130,  131,  132,    0,    0,    0,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138, 2241,  140,  141,  142,  143,  144, 2242, 2243, 2244,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  178,    0,  626,  627,
  628,  182,    0,  629,    0,  184,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641,    0,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
  857,    0,    0,  858,    0,    0,    0,    0,    0, 1118,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  859,    0,    0,  860,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  861,    0,    0,    0,    0,    0,  862,
  863,  864,    0,  865,  866,  867,    0,  868,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  869,    0,  870,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  871,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  872,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  873,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0,  125,
    0,    0,    0,    0,    0,    0,    0,  126,  127,  874,
  875,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,  876,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147,    0,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181, 1119,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
    0,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215, 1210,    0,    0,
 1210,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1212,    0, 1210,    0,    0,
 1210,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1210,    0,    0,    0,    0,    0, 1210, 1210, 1210,    0,
 1210, 1210, 1210,    0, 1210,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1210,    0, 1210,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1210,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1210,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1210,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1210,    0,    0, 1210,
    0, 1210, 1210, 1210, 1210,    0, 1210,    0,    0,    0,
    0,    0,    0,    0, 1210, 1210, 1210, 1210,    0,    0,
    0,    0,    0,    0,    0, 1210, 1210,    0, 1210, 1210,
 1210,    0,    0, 1210,    0, 1210, 1210,    0, 1210, 1210,
    0, 1210,    0,    0, 1210, 1210, 1210, 1210, 1210, 1210,
 1210,    0,    0,    0,    0, 1210, 1210, 1210,    0, 1210,
 1210, 1210,    0, 1210,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
 1210, 1210, 1210, 1210,    0, 1210, 1210, 1210, 1210, 1210,
 1210,    0, 1210, 1210, 1210, 1210,    0, 1210,    0, 1210,
 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
 1210, 1210, 1210, 1210, 1210, 1210, 1210,    0, 1210, 1210,
 1210, 1210,    0, 1210, 1210, 1210, 1210, 1210,    0, 1210,
 1210, 1210, 1210, 1210,  857,    0,    0,  858,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  859,    0,    0,  860,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  861,    0,    0,
    0,    0,    0,  862,  863,  864,    0,  865,  866,  867,
    0,  868,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  869,    0,
  870,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  871,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  872,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  873,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,    0,    0,  120,    0,  121,  122,
  123,  124,    0, 1004,    0,    0,    0,    0,    0,    0,
    0,  126,  127,  874,  875,    0,    0,    0,    0,    0,
    0,    0,  128,  129,    0,  130,  131,  132,    0,    0,
  876,    0,  133,  134,    0,  135,  136,    0,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  146,  147,    0,  148,  149,  150,    0,
  151,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,    0,  173,  174,  175,  176,  177,  178,    0,  179,
  180,  181,  182,    0,  183,    0,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,    0,  202,  203,  204,  205,    0,
  206,  207,  208,  209,  210,    0,  211,  212,  213,  214,
  215,  857,    0,    0,  858,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  859,    0,    0,  860,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  861,    0,    0,    0,    0,    0,
  862,  863,  864,    0,  865,  866,  867,    0,  868,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  869,    0,  870,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  871,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  872,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  824,    0,    0,    0,  873,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
  874,  875,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,  876,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,  830,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,  119,    0,
    0,  120,    0,  121,  122,  123,  124,    0,  125,    0,
    0,    0,    0,    0,    0,    0,  126,  127,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  128,  129,    0,
  130,  131,  132,    0,    0,    0,    0,  133,  134,    0,
  135,  136,    0,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  146,  147,
    0,  148,  149,  150,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  152,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,  169,  170,  171,  172,    0,  173,  174,  175,
  176,  177,  178,    0,  179,  180,  181,  182,    0,  183,
    0,  184,  185,  186,  187,  188,  189,  190,  191,  192,
  193,  194,  195,  196,  197,  198,  199,  200,  201,    0,
  202,  203,  204,  205,    0,  206,  207,  208,  209,  210,
    0,  211,  212,  213,  214,  215,    0,    0,  119,    0,
    0,  120,    0,  121,  122,  123,  124,    0,  125, 1487,
    0,    0,    0,    0,    0,    0,  126,  127,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  128,  129,    0,
  130,  131,  132,    0,    0,    0,    0,  133,  134,    0,
  135,  136,    0,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  146,  147,
    0,  148,  149,  150,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  152,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,  169,  170,  171,  172,    0,  173,  174,  175,
  176,  177,  178,    0,  179,  180,  181,  182,    0,  183,
    0,  184,  185,  186,  187,  188,  189,  190,  191,  192,
  193,  194,  195,  196,  197,  198,  199,  200,  201,    0,
  202,  203,  204,  205,    0,  206,  207,  208,  209,  210,
    0,  211,  212,  213,  214,  215,    0,  119,    0,    0,
  120,    0,  121,  122,  123,  124,    0,  125,    0,    0,
    0,    0,    0,    0,    0,  126,  127,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,  129,    0,  130,
  131,  132,    0,    0,    0,    0,  133,  134,    0,  135,
  136,    0,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  146,  147, 1629,
  148,  149,  150,    0,  151,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,    0,  173,  174,  175,  176,
  177,  178,    0,  179,  180,  181,  182,    0,  183,    0,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201, 1630,  202,
  203,  204,  205,    0,  206,  207,  208,  209,  210,    0,
  211,  212,  213,  214,  215,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1631,    0,    0,    0,    0, 1632,    0,
    0,    0,    0,    0, 1633,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  119,    0,    0,  120,    0,
  121,  122,  123, 1634,    0,  125,    0,    0,    0,    0,
    0,    0,    0,  126,  127,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  128,  129,    0,  130,  131,  132,
    0,    0,    0,    0,  133,  134,    0,  135,  136,    0,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  146,  147,    0,  148,  149,
  150,    0,  151,    0,    0,    0,    0,    0,    0,    0,
 1236,    0,  152,  153,  154,  155,  156,  157,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
  170,  171,  172, 1237,  173,  174,  175,  176,  177,  178,
    0,  179,  180,  181,  182,    0,  183,    0,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,    0,  202,  203,  204,
  205,    0,  206,  207,  208,  209,  210,    0,  211,  212,
  213,  214,  215,    0,    0,    0,    0,    0, 1238,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,    0,    0,    0,    0,    0,    0,    0,
  126,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,    0,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,  237,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,    0,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,  712,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,  119,    0,
    0,  120,    0,  121,  122,  123,  124,    0,  125,    0,
    0,    0,    0,    0,    0,    0,  126,  127,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  128,  129,    0,
  130,  131,  132,    0,    0,    0,    0,  133,  134,    0,
  135,  136,    0,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  146,  147,
    0,  148,  149,  150,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  152,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,  169,  170,  171,  172,    0,  173,  174,  175,
  176,  177,  178,    0,  179,  180,  181,  182,    0,  183,
    0,  184,  185,  186,  187,  188,  189,  190,  191,  192,
  193,  194,  195,  196,  197,  198,  199,  200,  201,    0,
  202,  203,  204,  205,    0,  206,  207,  208,  209,  210,
    0,  211,  212,  213,  214,  215,  119,    0,    0,  120,
  266,  121,  122,  123,  124,  267,  125,  268,  269,  270,
  271,  272,  273,  274,  126,  127,  275,  276,  277,  278,
  279,    0,    0,  280,  281,  128,  129,  282,  130,  131,
  132,  283,  284,  285,  286,  133,  134,  287,  135,  136,
  288,  137,  289,  290,  138,  139,  140,  141,  142,  143,
  144,  291,  292,  293,  294,  145,  146,  147,  295,  148,
  149,  150,  296,  151,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
  169,  170,  171,  172,  306,  173,  174,  175,  176,  177,
  178,  307,  179,  180,  181,  182,  308,  183,  309,  184,
  185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
  195,  196,  197,  198,  199,  200,  201,  310,  202,  203,
  204,  205,  311,  206,  207,  208,  209,  210,  312,  211,
  212,  213,  214,  215,  538,    0,    0,  538,  538,  538,
  538,  538,  538,    0,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,    0,
    0,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,    0,    0,    0,    0,    0,    0,    0,
  126,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,    0,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,  242,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,    0,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,  119,    0,
    0,  120,    0,  121,  122,  123,  124,    0, 1810,    0,
    0,    0,    0,    0,    0,    0,  126,  127,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  128,  129,    0,
  130,  131,  132,    0,    0,    0,    0,  133,  134,    0,
  135,  136,    0,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  146,  147,
    0,  148,  149,  150,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  152,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,  169,  170,  171,  172,    0,  173,  174,  175,
  176,  177,  178,    0,  179,  180,  181,  182,    0,  183,
    0,  184,  185,  186,  187,  188,  189,  190,  191,  192,
  193,  194,  195,  196,  197,  198,  199,  200,  201,    0,
  202,  203,  204,  205,    0,  206,  207,  208,  209,  210,
    0,  211,  212,  213,  214,  215,   30,    0,    0,   30,
    0,   30,   30,   30,   30,    0,   30,    0,    0,    0,
    0,    0,    0,    0,   30,   30,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   30,   30,    0,   30,   30,
   30,    0,    0,    0,    0,   30,   30,    0,   30,   30,
    0,   30,    0,    0,   30,   30,   30,   30,   30,   30,
   30,    0,    0,    0,    0,   30,   30,   30,    0,   30,
   30,   30,    0,   30,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,    0,   30,   30,   30,   30,   30,
   30,    0,   30,   30,   30,   30,    0,   30,    0,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,    0,   30,   30,
   30,   30,    0,   30,   30,   30,   30,   30,    0,   30,
   30,   30,   30,   30,  666,    0,    0,  666,    0,  666,
  666,  666,  666,    0,  666,    0,    0,    0,    0,    0,
    0,    0,  666,  666,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  666,  666,    0,  666,  666,  666,    0,
    0,    0,    0,  666,  666,    0,  666,  666,    0,  666,
    0,    0,  666,  666,  666,  666,  666,  666,  666,    0,
    0,    0,    0,  666,  666,  666,    0,  666,  666,  666,
    0,  666,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  666,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,    0,  666,  666,  666,  666,  666,  666,    0,
  666,  666,  666,  666,    0,  666,    0,  666,  666,  666,
  666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,  666,  666,  666,    0,  666,  666,  666,  666,
    0,  666,  666,  666,  666,  666,    0,  666,  666,  666,
  666,  666,  319,    0,    0,  319,    0,  319,  319,  319,
  319,    0,  319,    0,    0,    0,    0,    0,    0,    0,
  319,  319,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  319,  319,    0,  319,  319,  319,    0,    0,    0,
    0,  319,  319,    0,  319,  319,    0,  319,    0,    0,
  319,  319,  319,  319,  319,  319,  319,    0,    0,    0,
    0,  319,  319,  319,    0,  319,  319,  319,    0,  319,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
    0,  319,  319,  319,  319,  319,  319,    0,  319,  319,
  319,  319,    0,  319,    0,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  319,    0,  319,  319,  319,  319,    0,  319,
  319,  319,  319,  319,    0,  319,  319,  319,  319,  319,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,    0,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,
};
static int yycheck[] = {                                       9,
    4,   72,   17,  118,    0,   62,   16,   17,   81,   19,
   71,  105,   78,  655,   70,  484,  485,  701,   76,   63,
   71,  498,  778,   64,   16,   96,  820,  102,  535,  535,
  535,   75,  998,  106, 1064,  998,   77,  405,  104, 1106,
  548, 1106, 1112,  100,  102, 1031,  108,  484,  485,   59,
   60, 1066,   62,   63,   64,   65,   66,  101, 1313,  531,
  905,   71,   72,   73, 1106,   75,  110,   77,   78,  358,
   80,   81,   82,   83, 1106,   66,  945, 1067,  502, 1241,
  733,  527,   92, 1106,   94,   95,   96, 1016,   98,   99,
  100,  101,  987,  103,  104,  105,  106,  107,  108,  825,
  110,  923,   94,  500,  512,  721,  928,  813,   99, 1032,
  756,  103,    0,  480, 1090, 1077,  107, 1334, 1626,  916,
  351, 1106,  511,    0, 1094, 1015, 1385,  256,   63,    0,
  722, 1464,   41,  541,   44,    0,  820,   44,    0,   41,
    0,  963,   44, 1701,    0,   45,   45,   40,  970,   44,
    0,    0,    0, 1115,  279, 1419,   41,  251, 1644,   45,
    0,   40,   42,   43, 1126,   45,  455,   47,   40,    0,
   63,   59,  878, 1340,  225,    0,  247,  228,   44, 1459,
   41,   41,   59,   61,  250,  226,   40, 1446,   59,   40,
  843,   41,    0,   41,   59,  242,   44,   59,   45,   59,
   44,   44, 1070,   59,  248,    0, 1083,    0,  249,   59,
   59,   59,   63, 1477,    0,  225,  226,  227,  228,   59,
  451,    0,  232,   40,  234,   44, 1660,  242,   59, 1191,
    0, 1076,  242,  298,   59,  227,    0,  247,  248,  249,
  250,  251,    0,  234,  281,  360,  256,    0,    0,  268,
   91,   59,    0,    0,    0,    0,    0,    0,   45,  767,
  316,  324,   41,  371,   59,   44,   59,   41,    0, 1074,
   94,   41,    0,   59,  264,  394,   63,  264,    0,   44,
   59,  406,  280,  268,    0,  264,   61,   41,   41,   59,
   44,  347,   44,  257,    0,   59,  446,  315,    0,  257,
  262,   59,   41, 1645,  304,  305,   59,   59,    0,  319,
  816,   59,   59,   59,   59,   59,   59, 1001,  825,  825,
  825,  298,  276,  298,   44,  370,  272,   59,    0,  801,
  260,   59,  809,  264,  563,   41,  259,   59,   44,   41,
 1698, 1902,  457,   59,  712,  396,  269, 1313,  399,  449,
 1313,  828,   44,   59,  270,  997,  764,   59,  587,  334,
 1002, 1003,  730,  420,  409,  375,  330,   59,    0,   41,
  300,  273,  330,  383,  359, 1717,  476,  262,  376, 1355,
  296, 1065,  854,  424, 1945,  375,  396,   59,  375,  399,
  408,  510,  455,  444,  450,  405,  406,  277, 1203,  446,
    0,  262,  282,  227,  306, 1334, 1335, 1671,  845,   41,
  420,  456, 1234, 1235,  424, 1121,  378,  371,  258,  297,
 1382,  264,  441,  402,   41,  297,  444,   59,  443,  444,
  270,  446,  430,  443,  275, 1304,  446,  447,  978,  979,
 1032,   41,  442,    0,  375, 1879,  348, 1727, 1154,  447,
  501, 1613,  375, 1129, 1276,  315,  433,  297,   41,   59,
  511,  569,  513,  303,  515,  305,  537,  518,  593,  479,
  480, 1394,  528,  539,  530, 1734,  336, 1741,  264, 1696,
 1072, 1740,  370, 1742,   41,    0,  336,   44,  262,  545,
 1419,  501,  336,  378,  538,  552, 1663, 1664,  317,    0,
  402,  511,   59,  513,  344,  515,  547, 1669,  518, 1378,
  551,  259, 2070, 1390,  449,  580,  264,  378, 1735,  379,
 1173,  269,  297,  560,   44, 1393,   41,  537,  538,  539,
  379,    0,    0,    0,  277,  445,  443,  547, 1360,  388,
  550,  551,  552, 1012,   59,  555, 2032,    0, 1477,  449,
  449,  555,  297, 1911,  449,  457,  449, 1583,   59,  438,
 1586,  427,  315,  449,  452,  453,  336,  306,  422,  386,
  401,  431,   41,   41,   41, 1908,  476,    0, 1564,  317,
  442,  297, 1387,  336, 1406,  445,  379,  452,  453,  445,
   59,   59,   59,  401,  338,  445,  375,  317,  449,  344,
  509,  489,  449,  732,  378,  400,   59,  896, 1200,  315,
  375, 1048,  344,  315, 2172,  904,  344,  364,   41, 1874,
  445,   44, 1214,  325, 1216,  327,  370,  375,  344,  476,
  336, 1476, 1891, 1892,  336, 2143,   59, 1482, 1144,  361,
    0,  389, 1326,  315,  492,  262,  656,  535,  402,  509,
 1616,  528,  396, 1616,  400,  399, 1024,  528,   44,  655,
  509, 2219,  449,  894,  336,  505,   42,  711,  528,  710,
  721,  415,  336, 1890, 1650,  445, 1940,  379,  719,  528,
 1960,  427, 1190,  315,  725,  264,  388,  379,  576,  747,
 1198,  701,  445,  445,  452,  453,  388,  441,  578,   59,
  710,  711,  712, 1345,  336,  344,  721, 1349, 1505,  719,
  751, 1417, 1354,  492,  724,  725,  509, 1084,  774, 1156,
  730, 1427,  732,  306, 1113,  766,  722,  778,  769,  431,
 1947, 1347, 1702, 1623, 2292,  528,  336,  273, 1661,  445,
  298,  751, 1671,  445, 1500,  509, 1143,  803,  297, 1395,
  442,  443,  496, 1429, 1430, 1295,  766,  258,  315,  769,
  505,  378,  818,   59,  528,   61,    0, 1696,  778,  270,
 1732,  846,  516,  445,  825,  528,  280, 1483,  309,  336,
 1188,  301, 1206,    0,  303,  529, 1075,  493,  846,  505,
  394,    0,  848,  370, 1386,  344,  297,  352,  315,  317,
  315, 1827,  303,  509,  305, 1831, 1735,  509,  270,  264,
  820,  264, 1741,  445,  824,  825,  497,  509,  262,   44,
  830,  336,  528,  402, 1500,   59,  528,    0, 1673,  303,
 2089, 2090,  304,  305,  296,    0,  528,  893,    0,  260,
 1910,  297,   59,  344,  900,  901,  315,  379,  315,  284,
   59,  352,  903,  276,  277,    0,  528,  351,  281,  272,
 1930,  284,  297,  394,  379,  420,  505,  336,  336,  336,
  276, 2088,  262,  388,  297,  433, 1384,  509,    0,  300,
 1775,  310,   41, 1525,  260,   44,   59,  283,  445, 1875,
  409,  334,  348,  903,   59,  499,  528,   59,  429,  431,
   59,  959,   61, 1889,  264,   42, 2062, 2063, 1874,  427,
   47, 1874,  489,    0,   59,  301,  431,  263,  375,  420,
  375,  457,  375,  336,  300,   41,  430,  444,   44,  991,
  445,  298,  928, 1617,  378,  409,  389,   59,   42,   43,
  950,   45,  461,   47,  275,   61, 2108,  262,  371,    0,
  435, 1593,  509,    0,   41, 1401,  505,   44,  535,  950,
  445, 1890, 1013,  309, 1015,  371, 1017,  334,  964,  392,
  442,  528,   59, 1896,  320,  398,  445,  445,  445, 2005,
  344,  991,  426,  998,  304,  305,  392,  461,  378,  483,
  433, 1001,  398,  258,  509, 2062, 2063, 2062, 2063,  576,
 1044,  297, 1043, 1013,  505, 1015,   93, 1017,   59,  432,
  341, 1940,   59,  528, 1024, 1066,  445, 1058, 1947, 1060,
 2062, 2063, 1032, 1074,  483, 1462,  432, 1083,  257,  389,
 2062, 2063, 1478, 1043, 1044,  259, 1032,  262,  303, 2062,
 2063, 1435,  509,  277, 1100,  269,    0,  264, 1058,  265,
 1060, 1066,  442,  512, 1110, 1065,  452,  453, 2313,  528,
 1070,  528, 1113,  378, 1074, 1140,  433, 1720, 2200, 2059,
 1723,  428,  418,    0, 1084,  273, 1072, 2062, 2063, 1503,
   59,   44, 1140,  299,  348, 1811,  315,    0,  452,  453,
 1141, 1485,  315, 1144,  396, 1153, 1941, 1966,    0,  264,
 2355,  330, 2357, 1113, 2359,   59, 1162,    0, 1183, 1184,
 1185,  426, 1170,  415,  276,  277, 2371,  333,  277,  264,
  396,  303,  442,    0,  408, 1183, 1184, 1185,   41,  338,
   93, 1141,   59,  395, 1144,  319, 2206,  560,  297, 1201,
  277,  298,  264, 1567,  409,  282,   59,  396, 1189,  411,
  348,  375, 1203,  378, 1164,  309, 2026,   59,  375, 2088,
 1164,  370,  427, 1204,   41,  338,   59,   44, 2324, 2325,
    0,  447,  389,  277, 1643, 1644, 1645,  334,  282, 1189,
  400,  297,   59, 2315,    0, 2200, 1475,  396,  452,  453,
  399, 1201,  549, 1203, 1204, 2327,  461,  370,  447,  556,
 1906, 1907, 1212, 1213, 1200,  261,  415,  389, 1212,  371,
  375,   41,  371,  264,   44,  257,   93,  264, 1214,    0,
 1216, 1451, 2044,  396,  389, 1733,  399,  409, 2214,   59,
  375,   61,  441,  271,  449,    0, 2058,  300, 1468,  395,
  394,  398,  415,   59,  389,  427, 1888,  285, 1954,  336,
  265,  408, 1689,  375, 1691, 2285,    0, 2324, 2325, 2324,
 2325, 1629,    0,  276, 1632, 1327, 1738,  389,  441,  276,
 1280,  425,    0,  315,    0,  429,  433,   41,   59,  461,
   44, 1675, 2324, 2325,  299,  348,  440,  496,  330, 1280,
  596,  329, 2324, 2325,   59,   59, 1347,   61, 1313, 1736,
   44, 2324, 2325,  316, 1811, 1811, 1811,  516,    0,  316,
  264,    0,  322,  260,  401,   59, 1326, 1327, 1712,  357,
  529,   59,  339,  496,  375,   44,  449,    0,  375, 1339,
 1340,   59, 1347,   59, 1390,  319, 1387,  264,  389, 2324,
 2325,  277,  389,  516,  318,  362,  282, 2313,   40,   41,
 2313, 1745,   44,  300, 2148,  300,  529,  331,    0,  463,
  464,  465,  466,  467,  468,  469,  470,   59,   41,   61,
   59,   44, 2242, 2243,   93,    0,  260, 1387,  319,  392,
  354,    0,  420, 1393, 1394,  392,   59,  484,  400, 2355,
 1386, 2357, 2355, 2359, 2357, 1470, 2359,  494,  257,   91,
  417,  276,  315,  348, 2160, 2371,    0,  561, 2371,  284,
    0,  421, 1470,    0,  327,  427,  300,   59,  428,  432,
  352,  375,    0,  336,    0,  432,  371, 1502,  258, 1480,
  404,   44,   40, 1508,   59,  389, 1913, 1493,  260,  595,
   59, 1451, 2312, 1484, 1502,  275,  276,  277,  375, 1500,
 1508,  281, 1456,  385,  284,  387,  315,   40, 1468,  336,
    0,  333,  389,    0, 2148,   59,  379,  297,  572,   59,
 1480,  330,   59,  303, 1484,  388,    0,  409,  300,    0,
   93,   59,  449,   59, 2306,  260,   42,   43,  563,   45,
 1500,   47,    0,   44,  598,  367,    0,  653,  654,  655,
 1894,   41,  434,  393,   44,    0, 1567,  379, 2378,  476,
    0, 1905,  587,  277,    0, 1909, 1567,  375,  431,   59,
 1914,    0,   59, 2345,  401,  300,   42,   43,   44,   45,
   46,   47,  445,  297,    0,   59,    0,   41,   59, 1633,
   44,  371,   93,   42,   43,  377,   45,    0,   47, 1943,
 1944,   59, 1946, 1563, 1948,   59,  375, 1567,  260,    0,
   44, 1634,  392, 2032,   59, 1631,  258,  377,  398,   59,
  375, 1563, 1623,   59,  333,   91,    0,  407,  383,  409,
   59,  273,  334,  275,  276,  277, 1630,    0,   41,  281,
    0,   44,  284,   59,  264,   59,  509,  427,  300,  313,
  314, 1616,  432,  276,  277,  297,   59, 1617,  452,  453,
  338,  303,  338, 1623,  306,  528,  258,   41,   59, 1629,
 1630, 1631, 1632, 1633, 1634,    0,  782,   41,  270,  785,
   44,  461,    0, 1674,  790,   59,    0,  793, 1653,  409,
    0,  797,  370, 1653,   44,   41,   59,  318,   44,   59,
 1660, 1661,   40, 1663, 1664,  297,  348, 2051, 2052, 2053,
  331,  303,   46,  305, 1674,  318,   41,  318,  396,   44,
  396,  399,    0,  399,   58,    0,  596,   61,  331,  371,
  331,  408,  258,  354,   59,   41,  339,  415,   44,  415,
 1746,   59,  383,  384,  270,   59,  367,  433,  371,   59,
  392,  354,  344,  354,  375,   61,  398, 1763,  435,  333,
  402, 1715, 1768,  441,  367,  441,  367,  409,  445,  392,
 2362,  277,  456,  445,  458,  398,  282,  303,   40,  305,
  560,   59,  516,  404,   59,  427,  276,  277,  415,   41,
  432,  281,   44,  367,  284,   41,  452,  453,   44,   42,
   43,  404,   45,  404,   47,  379,    0,  297,  452,  432,
   41,  277,  264,   44,   41,  457,  282,   44,  496,  461,
  496,  313,  928, 1358,   42,   43, 1361,   45,  277,   47,
  484,  485,  258,  282, 2178, 2179, 2180,  315,  516, 2183,
  516,  947, 1802,   41,  270,  951,   44,   41,  954,   41,
   44,  529,   44,  529,   42,   43,  962,   45,  964,   47,
 1802,  315,  968,  969,  425,   59,  972,  973,  974,  975,
  976,  977,  978,  327,  980, 2147,  982,  303,  794,  305,
  796,  371,  336,  297, 1863, 1864,  992,  993,  994,  995,
  996,  997,  513, 2228, 1000, 2230, 1002, 1003,  448,  449,
  450,  333,  392, 1863, 1864,  332,    0,  443,  398, 1874,
  513, 1876,  513,  505,   41,  425, 1876,   44,  560, 1879,
   41,  427,  402,   44, 1915,  379,  476,  477,   41,  258,
  344,   44,  261,  394,  388,  336, 1896,  946,  352,  948,
  492,  315,  432,  952,  953,   41,  955,   41,   44,  317,
   44, 1942,    0,  327,  315, 1915,   42,   43,  315,   45,
  375,   47,  336, 1069,  375,   59,   41,   61,    0,   44,
  497,  385,  981,  387,  303,  356,   41,  431,  427,   44,
   41,  427, 1942,   44, 1995,  533, 1993,   41,    0,  532,
   44,  445,   40,   41, 1995,  409,   44,  463,  464,  465,
  466,  467,  468,  469,  470,  379,   46, 1863, 1864,   41,
 2075,   59,   44,   61,  388, 2026,  425,  530,   58,   59,
  434,   61,  264,   41,  336, 2026,   44,   59,   41,   41,
 1990,   44,   44, 1993,  277, 1995,  425,   41,  409,  282,
   44,   46,   41,   91,  376,   44,  319,   59, 1990,   61,
 2322,  337,  374,   58,   59,  509,   61,  431,  496,  277,
  273,   41,   42,   43,  282,   45, 2026,   47,  509, 2076,
  560,  445,    0,  504,  528,  505,   42,   43, 2069,   45,
  504,   47,  276,  277,   41,   41,  297,   44,   44,  277,
  284,  505, 2364,  336,  282, 2101,  306,   41,   41, 2105,
   44,   44, 2374,  297, 2376,  460,  572, 2379, 2173, 2069,
 2382,  329,    0, 1219, 1220, 1221, 2076,   44, 1224, 1225,
 1226,  445, 1228, 1229, 1230, 1231, 1232, 1233,   61,  317,
   41,   59,  598,   44,  283,  509, 1242, 1243,   40, 1245,
   41, 1247,  365,   44, 1250, 1251, 1252, 1253,    0, 1255,
 1256,  388,   41,   41,  528,   44,   44,   41,  264, 2160,
   44,   40,   40,   40,  258,   40, 1272, 2127, 1274,  452,
   40,   59,   40,   40,   40,   40,   40,  371,  452,   40,
  452,  275,  276,  277, 1290,   40,   40,  281, 2148,   41,
  284,  277,   44, 1299, 1300,   40,  282,   40,  392, 2200,
 2160,  351,   40,  297,  398,   40,   40,   59,   40,  303,
  258,   40, 2233,   44,   40,   42,   43,  318,   45,   91,
   47,   42,   43,   40,   45,  273,   47,  275,  276,  277,
  331,   40,   40,  281,   40, 2200,  284,   40,  432, 1345,
 2200,  401,   46, 1349,  276,  277,  258,   40, 1354,  297,
  336,   40,  284,  354, 2200,  303, 2277,   40,  306,   61,
  435,  264,  394,  531,  276,  277,  367,  439, 2228,  281,
 2230,   44,  284, 2233,  375,  419,  315,  371,   46,   61,
   40, 2241, 2242, 2243,   40,  297, 2287,  264,  337,   46,
 1396,  303, 1398, 1399,  344,  276,  260,  277,  392,  344,
  348,  344,  282,  404,  398, 1224,  364, 1226,  389, 1228,
 1229,  277, 1231, 1232, 1233,  409,  282, 2277, 2278,  264,
  427,  389, 2287,  371,  449, 2279,  275,  344,  438,  438,
   40,  391,   40,  427,  298,  345,   91,  317,  432,  371,
   40,   40,  264,  317,  392,   40,  310,  375, 2313,  402,
  398,  317, 2312,   44,  402,  381,   40,    0,    0,  371,
  392,  409,   40,  374,    0,  379,  398,  461,  442, 2315,
  334,   41,  374,  315,  277,  371,  275,   63,  455,  427,
  392, 2327,  314,  427,  432,  427,  398,  528,  276,  277,
 2355,  492, 2357,   40, 2359,   40,  284,  409,   41,   41,
  432,   44,  439,   44,  445,   41, 2371,   40,  264,  457,
   40,  337,  513,  461,   40,  427,   59,   59, 2378, 1525,
  432,   44,  317,   59,  276,  277,    0,   44,   44,  273,
   40,  340, 1538, 1539,  398, 1541, 1542,  537,  297,  378,
  340,  378,  378, 1549,  408,  407,  409,   40,    0,  461,
  277,  379,   40,   40,  409,  282,  277,  362,  352,   40,
  388,  282,   41,   41,   44, 1571,  560,   41,  317,  433,
  277, 1577,   44,   44, 1580,   41, 1582, 1583,   46,  348,
 1586,  409, 1588,  371,  377,   59, 1592, 1593, 1594,   41,
  317,   41,   44,   41,  315, 1601,   41, 1603,  361,  380,
 1606, 1607, 1608, 1609,  392,  317, 1612,   59,  443,  339,
  398,  339,  560,  266,  435,  443,  317,  493,  264,  371,
  492,  264,  413,  451,   41,   58,  454,   41,  456,  457,
  458,  459,   41,  461,   42,   43,   41,   45,  264,   47,
  392,  469,  470,   40,  432,  576,  398,  445,  560,  386,
   41,   41,  480,  481,  306,  483,  484,  485,  591,  306,
   40,   40,  490,  491,  492,  493,  494,  317,  496,   40,
   40,  499,  500,  501,  502,  503,  504,  505,   40,   40,
  432,  509,  510,  511,  512,   45,  514,  515,  516,   40,
  518,   40,   40, 1699,   41,   42,   43,   40,   45,   40,
   47,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   40,  550,  551,  552,  553,  554,  555,   40,  557,
  558,  559,  560,   40,  562,   40,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   40,  583,  584,  585,  586,  262,
  588,  589,  590,  591,  592, 1771,  594,  595,  596,  597,
  598, 1777,  315,  315,  305,  426, 1782,  296,  427,  315,
  445,   44,  325, 1789,  327,   44,  339,   42,   43,  325,
   45,  327,   47,  336,  336,   40,  339,   44,  325,  284,
  336,   42,   43,   44,   45,   46,   47,   42,   43,  383,
   45,  398,   47,  378,   41,   42,   43,   44,   45,  378,
   47, 1827,  378,  378,  378, 1831,  378,   41,  449,   41,
  276, 1837, 1838,   40,  317,  375,  379,  379, 1844,   41,
   41,  315,   41,  379,   41,  388,  388,   41,   44,  374,
   91,  325,  388,  327,  305,  426,   41,  265,   41,  270,
  437,  324,  336,  315,  427,  327,  442,  442,  333,  277,
  273,  433,  433,  325,  282,  327,  334,  298,  334,  298,
   41,    0, 1888,   41,  336,  377,   41,  339,  431,  431,
  279,  299,   41,   42,   43,  431,   45,  364,   47,  348,
  443,   41,  445,  445,  364,  379,   41,  443,   41,  445,
   41,   41,   41,   41,  388,   41,   42,   43,   41,   45,
   41,   47,   41,   42,   43,   44,   45,  379,   47,   41,
  277,   41,  292,   41,   41,  282,  388,   41,   41,   41,
   59,   60,   61,   62,   40,  377,   41,   42,   43,   41,
   45,  569,   47,   42,   43,  371,   45,  431,   47,   40,
  320,   41,  426, 1969,  569,  340,  509,  509,  315, 1975,
 1976,  445,  305,  509,   93,  457,  333,   59,  433,  431,
  290,  442,  338,  426,   44,  528,  528,  570,  348,  375,
   44,  443,  528,  445,  509, 2001,  509,   41,   40, 2005,
  315,  375,  334, 2009,   41,  409,  375,   40, 2014, 2015,
 2016, 2017, 2018,  336,  370,  336,   59, 2023,   58,   40,
  298,  433,  277,   42,   43,   41,   45,  282,   47,   40,
   44,  454,  336,  435,  336,  509,  277,   41,   40,  426,
  396,  282,  277,  399,  301,  499,  304,  282,  290,  301,
  277, 2057,    0,  308,  528,  282,  408,  509,  418,  415,
  333,   41,   42,   43,  375,   45,  375,   47,  408,  264,
   40,  264,  264,  308,  434,  402,  528,  408,   41,   42,
   43,  449,   45,   40,   47,  441,   44,  442,  448,  449,
  450,   41,  452,  453, 2100,  339,  435,  317,   40,  339,
   40,   42,   43,   44,   45,   46,   47,   41,  264,  426,
   41,  471,  472,  473,  474,  475,  476,  477,  478,  479,
   42,   43,   44,   45,   46,   47,  486,  487,  277,  449,
   41,  449,   41,  282,   41,  495,   41,   41,   41,  258,
  496,   41,   41,  262,   59,  264,  265,   59,  305,   59,
   91,  277,  271,   59,  301,  528,  282,  276,  277,  485,
  516,   59,   59,  282,   59,  284,  285,   59,   59,   91,
   40,   44,  370,  529,   41,  264,   41,   41,   41,  370,
  299, 2200,  277,  528,  303,  304,  305,  282,  277,  308,
 2196,  528, 2198,  282,  728, 2200,  315, 2200,  317,  318,
 2200, 2200,  321, 2200,  231,  231,  325, 1641,  327, 2215,
  329, 1024,  331, 1044,  232, 1505,  730,  336,  337,  407,
  339,  912,  463,  464,  465,  466,  467,  468,  469,  470,
  406, 1207, 2238, 1503,    0,  354,  355,   98,  357, 1212,
 1164,   82, 1500, 1479, 1931,  264, 1913, 1177,  367, 1494,
  369,  532,  371,  372,  373, 1404,  375,  854,  277,  378,
  379, 1480, 1895,  282,  453,  513, 1911,  513, 2217,  388,
 1123, 2221,  830,  392, 2220,   41, 2294, 1335,   44,  398,
 2241, 2204,  401, 1113, 2323,  404,  518, 1676, 1013, 1180,
  409,  496,  503,   59,  832,   61,   14,  277, 2304, 2305,
 1724,  420,  282,  891, 1172,  233,  431,  426,  427,  735,
  740, 1058,  431,  432,  277,   42,   43,   44,   45,  282,
   47, 2036,  487,  442,  443,   91,  445, 1396, 1359, 2215,
  944,  572,  451, 1032, 1990,  454,  277,  456,  457,  458,
  459,  282,  461, 1802,  463,  464,  465,  466,  467,  468,
  469,  470, 2358, 1398, 1883,  277, 2362,  598, 1882, 2287,
  282,  480,  481,  756,  483,  484,  485, 2213, 2200, 2200,
 1042,  490,  491,  492,  493,  494, 1364,  496,  587, 1540,
  499,  500,  501,  502,  503,  504,  505, 1407, 1611, 1588,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,    0,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   42,   43,  258,   45,   -1,   47,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,  273,   -1,  275,
  276,  277,   -1,   -1,   -1,  281,   -1,   -1,  284,   -1,
   -1,  291,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,  297,  302,   91,   -1,   93,   -1,  303,   -1,  309,
  306,  463,  464,  465,  466,  467,  468,  469,  470,  275,
  277,   -1,  322,   -1,   -1,  282,   -1,   41,   42,   43,
   -1,   45,  291,   47,   -1,  291,   41,   42,   43,   -1,
   45,   -1,   47,  302,   -1,   -1,  302,   -1,   -1,   -1,
  309,   -1,  348,  309,  313,   -1,   -1,  313,  314,   -1,
   -1,   41,   42,   43,   -1,   45,  322,   47,   -1,   -1,
   -1,   -1,   -1,   -1,  333,  371,   -1,  333,  378,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  394,   -1,  392,   -1,   -1,   -1,
   -1,  572,  398,   -1,   -1,   -1,  402,  277,   -1,   -1,
  410,   -1,  282,  409,   -1,   -1,   -1,   -1,   -1,   -1,
  572,   -1,   -1,    0,   -1,  425,   -1,  598,   -1,  429,
  386,  427,  432,   -1,   -1,  394,  432,   -1,  394,   -1,
  440,   -1,   -1,   -1,   -1,   -1,  598,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  459,
   -1,  457,   -1,   -1,   41,  461,  425,   44,   -1,  425,
  429,   -1,   -1,  429,  262,   -1,  264,  265,   -1,   -1,
  262,   -1,   59,  271,  440,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,  277,   -1,  285,   -1,   -1,
  282,   -1,   -1,  459,  460,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,  515,  304,  305,  518,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,  515,   -1,   -1,  515,
   -1,  561,  518,  277,  560,    0,  354,  355,  282,  357,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   41,   42,   43,   -1,   45,  277,   47,   -1,
  388,   -1,  282,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,  277,  404,   -1,   -1,   -1,
  282,   -1,   -1,   58,   59,   60,   61,   62,   42,   43,
   44,   45,  420,   47,   -1,   -1,   -1,   -1,  426,  427,
   41,   42,   43,  431,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,  277,   -1,   41,   42,   43,  282,   45,
   -1,   47,  480,  481,   -1,  483,  484,  485,   -1,  276,
  277,   -1,  490,  491,  492,  493,  494,  284,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,  371,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,  398,   -1,   -1,   -1,   -1,   -1,  262,  277,  264,
  265,   -1,   -1,  282,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,  432,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  299,   -1,   -1,   -1,  282,  304,
  305,   -1,   -1,  308,   -1,   -1,  277,   -1,   -1,   -1,
  315,  282,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,  492,   -1,   -1,    0,  354,
  355,  277,  357,   -1,   -1,   -1,  282,   -1,   -1,   41,
   42,   43,  367,   45,  369,   47,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   41,   42,   43,   -1,   45,
   -1,   47,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,  277,   -1,  404,
   -1,   -1,  282,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   42,   43,   44,   45,  420,   47,   -1,   -1,   -1,
   -1,  426,  427,   41,   42,   43,  431,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,  572,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   41,   42,
   43,  598,   45,   -1,   47,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,  277,  264,  265,   -1,   -1,  282,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  277,  299,   -1,   -1,
   -1,  282,  304,  305,   -1,   -1,  308,   -1,   -1,  277,
   -1,   -1,   -1,  315,  282,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,    0,  354,  355,  277,  357,   -1,   -1,   -1,  282,
   -1,   -1,   41,   42,   43,  367,   45,  369,   47,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   41,   42,
   43,   -1,   45,   -1,   47,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
  277,   -1,  404,   -1,   -1,  282,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   42,   43,   44,   45,  420,   47,
   -1,   -1,   -1,   -1,  426,  427,   41,   42,   43,  431,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   41,   42,   43,
  277,   45,   -1,   47,   -1,  282,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  277,  583,  584,  585,  586,  282,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,  277,  264,  265,   -1,   -1,  282,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  277,
  299,   -1,   -1,   -1,  282,  304,  305,   -1,   -1,  308,
   -1,   -1,  277,   -1,   -1,   -1,  315,  282,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,    0,  354,  355,  277,  357,   -1,
   -1,   -1,  282,   -1,   -1,   41,   42,   43,  367,   45,
  369,   47,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   41,   42,   43,   -1,   45,   -1,   47,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,  277,   -1,  404,   42,   43,  282,   45,
   -1,   47,   58,   59,   60,   61,   62,   42,   43,   44,
   45,  420,   47,   -1,   -1,   -1,   -1,  426,  427,   41,
   42,   43,  431,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   42,   43,  277,   45,   -1,   47,   -1,  282,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,  277,  583,  584,  585,  586,  282,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,  277,  264,  265,
   -1,   -1,  282,   -1,   -1,  271,  262,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,
   -1,   -1,  277,  299,   -1,   -1,   -1,  282,  304,  305,
   -1,   -1,  308,   -1,   -1,  277,   -1,   -1,   -1,  315,
  282,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,    0,  354,  355,
  277,  357,   -1,   -1,   -1,  282,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   42,   43,   44,   45,   -1,
   47,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,  277,   -1,  404,   -1,
   -1,  282,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,  277,  583,  584,  585,
  586,  282,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
  277,  264,  265,   -1,   -1,  282,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1, 1772, 1773,   -1,
   -1,  271,   -1,   -1,   -1, 1780, 1781,  277, 1783, 1784,
   -1,   -1,  282,   -1,   -1,  285, 1791, 1792, 1793, 1794,
   -1, 1796, 1797, 1798, 1799, 1800, 1801,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,  404,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   41,  404,   -1,   44,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   59,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,  276,  277,   -1,   -1,   -1,
   -1,   -1,   -1,  284,  299,   -1,  301,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
  371,   -1,   -1,  388,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,  392,   59,   60,   61,   62,   -1,  398,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,  442,  443,   -1,
  445,  432,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,  492,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   41,  404,   -1,   44,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   59,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,  284,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,  371,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   -1,  392,   59,   60,
   61,   62,   -1,  398,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,  432,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,  492,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   41,  404,   -1,   44,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   59,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,  276,  277,   -1,
   -1,   -1,   -1,   -1,   -1,  284,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,  297,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,  371,   -1,   -1,  388,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   -1,  392,   59,   60,   61,   62,   -1,  398,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,  442,
  443,   -1,  445,  432,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   41,  404,
   -1,   44,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   59,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,  276,  277,   -1,   -1,   -1,   -1,   -1,
   -1,  284,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,  297,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,  371,   -1,
   -1,  388,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,  392,
   59,   60,   61,   62,   -1,  398,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,  442,  443,   -1,  445,  432,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   -1,   -1,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   41,   42,
   43,   44,   45,   41,   47,   -1,   44,   -1,   -1,   -1,
  401,   -1,   -1,  404,   -1,   -1,   59,   60,   61,   62,
   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,   -1,  285,   -1,   -1,   -1,  284,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,  371,   -1,  378,  379,  375,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   41,   42,   43,   44,
   45,   -1,   47,   -1,  392,   -1,   -1,   -1,  401,   -1,
  398,  404,   -1,   -1,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,  432,   -1,   -1,   -1,   93,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,  492,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,  388,
   43,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,  388,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   41,  339,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,  355,   59,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,  264,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,
   -1,   -1,   -1,  271,   -1,  325,   -1,  327,   -1,  277,
   -1,  331,   -1,   -1,  282,   -1,  336,  285,   -1,  339,
   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,
   -1,   -1,   -1,  321,   -1,  375,   -1,   -1,   -1,  379,
   -1,  329,   -1,   -1,   -1,   -1,   -1,   -1,  388,  337,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,  404,   -1,   -1,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   60,   61,   62,   -1,   -1,
   -1,  369,   -1,  371,  372,  373,   -1,   -1,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  443,   -1,  445,   -1,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,  420,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,    0,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,
  318,   -1,   -1,   -1,   -1,   -1,  271,  325,   41,  327,
   -1,   44,  277,  331,   -1,   -1,   -1,  282,  336,   -1,
  285,  339,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  375,   -1,   -1,
   -1,  379,   -1,   -1,  329,   -1,   -1,   -1,   -1,   -1,
  388,   -1,  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  369,   -1,  371,  372,  373,   -1,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  443,   -1,  445,   -1,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,   -1,
   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,  331,   -1,
   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
    0,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  375,   -1,   -1,   -1,  379,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,  388,   41,   -1,   -1,   44,
   -1,   41,   -1,   -1,   44,   -1,   -1,   59,   -1,   61,
   -1,  404,   -1,   -1,   59,   -1,   -1,   -1,   -1,   59,
   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  431,   91,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  443,   91,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,    0,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  258,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,  258,   -1,
   -1,  273,   -1,   -1,  276,  277,   -1,   -1,   -1,  281,
   -1,   -1,  284,  273,   -1,   41,  276,  277,   44,   -1,
   -1,  281,   -1,   -1,  284,  297,   -1,   -1,   -1,   -1,
   -1,  303,   -1,   59,  306,   61,   -1,  297,   -1,   -1,
   -1,   -1,   -1,  303,   -1,   -1,  306,   -1,   -1,   -1,
  315,   -1,   -1,  318,   -1,   -1,   -1,   -1,   -1,   -1,
  325,   -1,  327,   -1,   -1,   91,  331,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,   -1,  348,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,  348,  354,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,  371,
   63,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  375,  371,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
  392,   -1,   -1,  388,   -1,   -1,  398,   -1,   -1,   -1,
  402,   -1,  392,   -1,   -1,   -1,   -1,  409,  398,  404,
   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,  409,
   -1,   -1,   -1,   -1,   -1,  427,   -1,   -1,   -1,   -1,
  432,  426,   -1,   -1,   -1,   -1,  431,  427,  272,   -1,
   -1,  275,  432,   -1,   -1,   -1,   -1,  442,  443,   -1,
  445,   -1,   -1,   -1,  288,  457,  261,   -1,  292,  461,
   -1,  295,   -1,   -1,   -1,   -1,   -1,  457,   -1,   -1,
   -1,  461,   -1,   -1,  279,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,
   -1,  296,   -1,  298,   -1,   -1,   -1,  492,  303,   -1,
   -1,  335,  258,   -1,   -1,  310,   -1,  341,  342,  343,
   -1,  345,  346,  347,  509,  349,   -1,  273,  513,  324,
  276,  277,   -1,   -1,  302,  281,   -1,   -1,  284,  334,
   -1,  309,  366,  528,  368,  313,  314,   -1,   -1,   -1,
   -1,  297,   -1,   -1,  322,   -1,   -1,  303,   -1,   -1,
  306,   -1,   -1,   -1,   -1,  333,   -1,  362,  560,   -1,
   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,  402,   -1,
  560,   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,
  414,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  396,  348,  286,   -1,   -1,   -1,   -1,  403,  292,
  293,  406,  436,   -1,  409,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  371,  394,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,  433,   -1,
  323,   -1,  410,   -1,   -1,   -1,  392,  471,  472,   -1,
  445,   -1,  398,   -1,   -1,   -1,  402,  425,   -1,   -1,
   -1,  429,   -1,  409,  488,  348,   -1,  350,  351,   -1,
   -1,  354,  440,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,  427,   -1,   -1,   -1,   -1,  432,  482,   -1,   40,
   -1,  459,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  497,  498,   -1,   -1,  389,   58,   -1,   -1,
   -1,  457,   63,   -1,   -1,  461,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,  519,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,  515,   -1,   -1,
  518,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
  463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,  560,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,  289,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  371,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  412,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  267,   -1,
   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  371,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  412,   -1,   -1,   -1,   -1,   -1,  418,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,  448,
  449,  450,  451,  452,  453,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,  481,   -1,  483,  484,  485,  486,  487,   -1,
  489,  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  371,   40,   -1,   -1,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  412,   -1,   -1,   -1,   -1,
   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,  453,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,  481,   -1,  483,  484,  485,  486,
  487,   -1,  489,  490,  491,   -1,  493,  494,  495,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,
   -1,   -1,   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  484,
  485,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,  517,  518,   -1,  520,  521,  522,  523,  524,
  525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  260,   -1,   -1,  263,   -1,   -1,
   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  416,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  448,  449,  450,  451,  452,  453,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,   -1,  483,  484,  485,
  486,  487,   -1,  489,  490,  491,   -1,  493,  494,  495,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  260,   -1,   -1,  263,   -1,   -1,   -1,
  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,
   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,   -1,   63,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  416,
   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,  453,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,  481,   -1,  483,  484,  485,  486,
  487,   -1,  489,  490,  491,   -1,  493,  494,  495,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,
   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   -1,   -1,   -1,   -1,   63,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,
   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,
   -1,   -1,   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,  418,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,  453,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,  481,   -1,  483,  484,  485,  486,  487,   -1,
  489,  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  260,   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,  389,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,
   -1,   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,  485,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  260,
   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,
   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  260,   -1,
   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,
   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,  485,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  260,   -1,   -1,
  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   40,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,   -1,   58,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
  260,  594,  595,  596,  597,  598,  315,  267,   -1,  318,
   -1,   -1,   -1,   -1,  274,   -1,  325,   -1,  327,   -1,
   -1,   -1,  331,   -1,   -1,   -1,  286,  336,   -1,   -1,
  339,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
  300,   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  320,   -1,   -1,  323,   -1,   -1,  375,   -1,   -1,   -1,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,  404,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,  389,
   58,   -1,   -1,   -1,  443,   63,  445,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  492,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
  509,  461,  462,   -1,  513,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,   -1,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  267,
   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,
   -1,   -1,  448,  449,  450,  451,  452,  453,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,   -1,  483,  484,  485,
  486,  487,   -1,  489,  490,  491,   -1,  493,  494,  495,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,
  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,
  454,   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,  481,   -1,  483,
  484,  485,  486,  487,   -1,  489,  490,  491,   -1,  493,
  494,  495,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,
  524,  525,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,
   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,  485,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,
   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,  485,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  267,
   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  317,
   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  389,   -1,   58,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,
   -1,   -1,  448,  449,  450,  451,  452,  453,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,   -1,  483,  484,  485,
  486,  487,   -1,  489,  490,  491,   -1,  493,  494,  495,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,  260,  594,  595,
  596,  597,  598,   -1,  267,  272,   -1,   -1,  275,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  288,   -1,  286,   -1,  292,   -1,   -1,  295,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,  300,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,   -1,   -1,   -1,  341,  342,  343,   -1,  345,  346,
  347,   -1,  349,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,  366,
  363,  368,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,
  397,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  436,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,  471,  472,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  488,   -1,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  267,   -1,
   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,  453,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,  481,   -1,  483,  484,  485,  486,  487,   -1,
  489,  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,  453,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,  481,   -1,  483,  484,  485,  486,
  487,   -1,  489,  490,  491,   -1,  493,  494,  495,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   40,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  267,   58,   -1,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  484,
  485,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   40,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,
   40,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,  281,  588,  589,  590,  591,  592,  445,  594,
  595,  596,  597,  598,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   42,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   42,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  293,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   44,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,   45,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,  317,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   58,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  449,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,    0,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,  272,   -1,
   -1,  275,   -1,   -1,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,  288,   -1,   -1,   -1,  292,   -1,
   -1,  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  272,   -1,   -1,  275,   91,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  292,   -1,   -1,  295,   -1,   -1,   -1,   -1,
   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,  342,  343,
   -1,  345,  346,  347,    0,  349,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  366,   -1,  368,  335,   -1,   -1,   -1,   -1,
   -1,  341,  342,  343,   -1,  345,  346,  347,   -1,  349,
   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,   44,   45,
   46,   47,   -1,  397,   -1,   -1,  366,   -1,  368,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,
  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,
   -1,   -1,  436,   -1,   -1,   91,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  436,  471,  472,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  262,   -1,   -1,
   -1,   -1,   -1,   -1,  488,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,  471,  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,  488,    0,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,   -1,  318,   -1,   59,  321,   61,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   42,   43,   44,   45,   46,   47,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   59,   60,
   61,   62,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,  262,   -1,   -1,   -1,
   91,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,  404,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,    0,   -1,
   -1,  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,  315,
  445,   -1,  318,   -1,   -1,  321,   -1,  272,   -1,  325,
  275,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   41,
  336,  337,   44,  339,   -1,   -1,   -1,  292,   -1,   -1,
  295,   -1,   -1,   -1,   -1,   -1,   -1,   59,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,  492,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,    0,  375,
   -1,   -1,  378,  379,  509,   -1,   -1,   -1,  513,   -1,
  335,   -1,  388,   -1,  258,   -1,  341,  342,  343,   -1,
  345,  346,  347,  528,  349,   -1,   -1,   -1,  404,  273,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,   -1,   41,
   -1,  366,   44,  368,  420,   -1,   -1,   -1,   -1,   -1,
  426,   -1,   -1,  297,   -1,  431,   -1,   59,   -1,  303,
   -1,  262,  306,   -1,   -1,   -1,  442,  443,   -1,  445,
  271,   -1,  397,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,  414,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,   -1,   -1,   -1,   -1,
   -1,  436,   -1,   -1,  315,   -1,  492,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,  371,  329,   -1,
  331,   -1,   -1,  509,   -1,  336,  337,  513,  339,   -1,
   -1,    0,   -1,   -1,   -1,   -1,  471,  472,   -1,   -1,
   -1,   -1,  528,  354,  355,   -1,  357,   -1,  402,   -1,
   -1,    0,   -1,  488,   -1,  409,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
  262,   -1,   41,  427,   -1,   44,   -1,  388,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   41,  404,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  457,   -1,   -1,   -1,  461,   -1,  420,
   59,   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,
  431,   -1,   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,
   -1,  442,  443,  325,  445,  327,   -1,   -1,   -1,  331,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,   -1,
  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,   -1,
   -1,  492,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,  509,   -1,
   -1,   -1,  513,  315,   -1,   -1,  318,   -1,   -1,   -1,
   -1,   41,  404,  325,   44,  327,   -1,  528,   -1,  331,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,   59,
   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   -1,  445,   -1,  367,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  375,   -1,   -1,  378,  379,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,  262,   -1,   -1,   -1,   -1,   -1,   -1,
  492,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,  262,  426,   -1,   -1,  509,   -1,  431,
   -1,  513,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,
  442,  443,   -1,  445,   -1,   -1,  528,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,
   -1,   -1,   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,
   -1,   -1,  331,   -1,   -1,   -1,  315,  336,   -1,  318,
  339,   -1,   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,
  492,   -1,  331,   -1,   -1,  354,   -1,  336,   -1,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,  509,  367,   -1,
   -1,  513,   -1,   -1,    0,  354,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,  528,   -1,  367,  388,
   -1,   -1,   -1,   -1,   -1,   -1,  375,   -1,   -1,  378,
  379,   -1,  262,   -1,   -1,  404,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,  426,   -1,   -1,
   -1,   -1,  431,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   -1,  445,  426,   -1,   -1,
   -1,   -1,  431,   -1,   -1,  315,   -1,   -1,  318,   -1,
   -1,   -1,   -1,  442,  443,  325,  445,  327,   -1,   -1,
   -1,  331,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  492,  354,   -1,    0,   -1,   -1,   -1,
  262,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,
  509,   -1,   -1,  492,  513,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,  528,
  509,    0,   -1,   -1,  513,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,  528,
   -1,   -1,   -1,  315,   -1,   59,  318,   -1,   -1,   -1,
   -1,   -1,   -1,  325,   -1,  327,  426,   -1,   -1,  331,
   -1,  431,   41,   -1,  336,   44,   -1,  339,   -1,   -1,
   -1,  272,  442,  443,  275,  445,   -1,   -1,   -1,    0,
   59,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  292,   -1,   -1,  295,  367,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   41,   -1,  492,   44,   -1,   -1,  262,   -1,   -1,   -1,
   -1,   -1,  404,   -1,  335,   -1,   -1,   -1,   59,  509,
  341,  342,  343,  513,  345,  346,  347,   -1,  349,   -1,
   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,  528,  431,
   -1,   -1,   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,
  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  315,
   -1,   -1,  318,   -1,   -1,   -1,   -1,   -1,   -1,  325,
   -1,  327,   -1,   -1,   -1,  331,  397,   -1,   -1,   -1,
  336,   -1,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,  354,   -1,
  492,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,   -1,   -1,  436,   -1,  509,   -1,  375,
   -1,  513,  378,  379,   -1,   -1,   -1,   -1,  262,   -1,
   -1,   -1,  388,   -1,   -1,    0,  528,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,  404,   -1,
  471,  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,  262,   -1,    0,   -1,  488,   -1,   -1,
  426,   -1,   -1,   -1,   -1,  431,   41,   -1,   -1,   44,
   -1,  315,   -1,   -1,  318,   -1,  442,  443,   -1,  445,
   -1,  325,   -1,  327,   59,   -1,   -1,  331,   -1,   -1,
   -1,   -1,  336,   -1,   -1,  339,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,
  354,  262,   -1,   -1,   59,   -1,  325,   -1,  327,   -1,
   -1,   -1,  331,  367,   -1,   -1,  492,  336,   -1,   -1,
  339,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  509,  388,  354,   -1,  513,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  404,   -1,  528,   -1,  315,   -1,  375,  318,   -1,  378,
  379,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,  388,
  331,   -1,  426,   -1,   -1,  336,   -1,  431,  339,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,  442,  443,
    0,  445,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,  426,   -1,   -1,
   -1,   -1,  431,   -1,  375,   -1,   -1,  378,  379,   -1,
    0,   -1,   -1,  442,  443,   -1,  445,  388,   -1,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,  492,   -1,
   -1,   -1,   -1,  404,   -1,  262,   -1,   -1,   -1,   59,
   -1,   -1,    0,   -1,   -1,  509,   -1,   -1,   -1,  513,
   -1,   41,   -1,   -1,   44,  426,   -1,   -1,   -1,   -1,
  431,   -1,   -1,  492,  528,   -1,   -1,  262,   -1,   59,
   -1,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  509,   -1,   -1,   41,  513,   -1,   44,   -1,  315,   -1,
   -1,  318,   -1,   -1,   -1,   -1,   -1,  262,  325,  528,
  327,   59,   -1,   -1,  331,   -1,   -1,   -1,   -1,  336,
   -1,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  315,  492,   -1,  318,   -1,   -1,   -1,  354,   -1,   -1,
  325,   -1,  327,   -1,   -1,   -1,  331,   -1,  509,   -1,
  367,  336,  513,   -1,  339,   -1,   -1,   -1,  375,   -1,
  315,  378,  379,  318,   -1,   -1,   -1,  528,   -1,  354,
  325,  388,  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,
   -1,  336,  367,   -1,  339,   -1,   -1,  404,   -1,   -1,
  375,   -1,   -1,  378,  379,    0,   -1,   -1,   -1,  354,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,  426,
   -1,   -1,  367,   -1,  431,   -1,   -1,   -1,   -1,  404,
  375,   -1,   -1,  378,  379,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   41,   -1,   -1,   44,
   -1,  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,  404,
   -1,   -1,  262,   -1,   59,   -1,   -1,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  426,   -1,   -1,   -1,  492,  431,   -1,   -1,   -1,
   -1,   -1,  262,   -1,   -1,   -1,   -1,  442,  443,    0,
  445,   -1,  509,   -1,   -1,   -1,  513,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  492,  318,   -1,
   -1,  528,   -1,   -1,  262,  325,   -1,  327,   -1,   -1,
   -1,  331,   -1,   -1,  509,   -1,  336,   -1,  513,  339,
   41,   -1,   -1,   44,   -1,  315,   -1,  492,  318,   -1,
   -1,   -1,   -1,  528,  354,  325,   -1,  327,   59,   -1,
   -1,  331,   -1,   -1,  509,   -1,  336,  367,  513,  339,
   -1,   -1,   -1,   -1,   -1,  375,   -1,  315,  378,  379,
  318,   -1,   -1,  528,  354,   -1,   -1,  325,  388,  327,
   -1,   -1,    0,  331,   -1,   -1,   -1,  367,  336,   -1,
   -1,  339,   -1,   -1,  404,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,  388,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  426,   -1,   -1,  367,
   -1,  431,   -1,   41,  404,   -1,   44,  375,    0,   -1,
  378,  379,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,
  388,   59,   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,  404,  262,   -1,   -1,
   -1,   -1,  442,  443,   -1,  445,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,  426,   -1,
   -1,   -1,  492,  431,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   -1,  445,   -1,  509,
   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  492,  318,   -1,   -1,   -1,   -1,  528,   -1,
  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,  509,
   -1,  336,   -1,  513,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  492,   -1,   -1,   -1,  528,  354,
    0,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  509,  367,   -1,   -1,  513,   -1,   -1,   -1,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
  528,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,   59,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,
  331,  426,   -1,   -1,   -1,  336,  431,   -1,  339,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   -1,
  445,   -1,   -1,  354,  262,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  492,   -1,   59,
  262,   -1,   -1,  404,   -1,   -1,   -1,  315,   -1,   -1,
  318,   -1,   -1,   -1,  509,   -1,   -1,  325,  513,  327,
    0,   -1,   -1,  331,   -1,  426,   -1,   -1,  336,   -1,
  431,  339,   -1,  528,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   -1,  445,   -1,  354,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,   -1,  367,
   -1,   41,   -1,  325,   44,  327,    0,  375,   -1,  331,
  378,  379,   -1,   -1,  336,   -1,   -1,  339,   -1,   59,
  388,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  492,  354,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,   41,  509,   -1,
   44,   -1,  513,  375,   -1,   -1,  378,  379,  426,   -1,
   -1,   -1,  262,  431,   -1,   59,  388,  528,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   -1,  445,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,
  442,  443,   -1,  445,  492,  325,   -1,  327,   -1,   -1,
   -1,  331,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
   -1,  509,   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  528,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,
  492,   -1,   -1,   -1,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  509,  388,   -1,
   -1,  513,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,
   -1,   -1,   -1,   -1,  404,  325,  528,  327,   -1,   -1,
   -1,  331,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,
   -1,  431,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   -1,  445,   -1,  367,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,
   -1,   -1,   -1,   -1,  404,  325,   -1,  327,   -1,   -1,
   -1,  331,  492,   -1,   -1,   -1,  336,   -1,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,  426,   -1,  260,  509,
   -1,  431,   -1,  513,  354,   -1,   -1,   -1,   -1,   -1,
   -1,  315,  442,  443,  318,  445,   -1,  367,  528,   -1,
   -1,  325,   -1,  327,   -1,  375,   -1,  331,   -1,  379,
   -1,   -1,  336,   -1,   -1,  339,  298,   -1,  388,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,
  354,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  492,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  375,  334,   -1,   -1,  379,   -1,   -1,   -1,  509,
   -1,  431,   -1,  513,  388,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  443,   -1,  445,   -1,   -1,  528,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  398,   -1,   -1,  443,
   -1,  445,  492,   -1,   -1,   -1,  408,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  509,
   -1,   -1,   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,  528,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  492,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,  509,   -1,  469,  470,  513,
   -1,   -1,   -1,  260,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,  528,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,  298,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,  310,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,  334,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  398,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  408,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  433,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,  270,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,   -1,   -1,   -1,   -1,   -1,
  305,   -1,   -1,   -1,  309,  310,   -1,  312,   -1,   -1,
  315,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  328,   -1,   -1,   -1,   -1,   -1,  334,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  350,   -1,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  362,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  389,  390,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,  408,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  423,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  433,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,   -1,  444,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,  506,  507,  508,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,  270,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,   -1,   -1,   -1,
   -1,   -1,  305,   -1,   -1,   -1,  309,  310,   -1,  312,
   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  328,   -1,   -1,   -1,   -1,
   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  350,   -1,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  362,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,  390,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,  408,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  423,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  444,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,  506,  507,  508,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  270,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,   -1,
   -1,   -1,   -1,   -1,  305,   -1,   -1,   -1,  309,  310,
   -1,  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,   -1,   -1,
   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  350,
   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  362,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,  390,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,  408,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  423,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  444,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,  506,  507,  508,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,  270,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  309,  310,   -1,  312,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,
   -1,   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  350,   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  362,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  389,  390,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  423,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,  506,  507,  508,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  292,   -1,   -1,  295,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,
  342,  343,   -1,  345,  346,  347,   -1,  349,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  436,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,  488,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  272,   -1,   -1,
  275,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  290,   -1,  292,   -1,   -1,
  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,   -1,   -1,   -1,  341,  342,  343,   -1,
  345,  346,  347,   -1,  349,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  366,   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  414,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  436,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,  471,  472,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,  488,   -1,  490,  491,   -1,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  272,   -1,   -1,  275,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  292,   -1,   -1,  295,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,
   -1,   -1,   -1,  341,  342,  343,   -1,  345,  346,  347,
   -1,  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,
  368,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  436,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
  488,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  292,   -1,   -1,  295,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,
  341,  342,  343,   -1,  345,  346,  347,   -1,  349,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  284,   -1,   -1,   -1,  436,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,  488,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,  284,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,  313,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,  325,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,  394,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  429,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  339,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,  362,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,  417,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  378,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,  434,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  451,   -1,   -1,  454,
  455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
  465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
  475,   -1,   -1,  478,  479,  480,  481,  482,  483,  484,
  485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
  495,  496,  497,  498,  499,  500,  501,  502,  503,  504,
  505,  506,  507,  508,  509,  510,  511,  512,  513,  514,
  515,  516,  517,  518,  519,  520,  521,  522,  523,  524,
  525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
  555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,  582,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  592,  593,  594,
  595,  596,  597,  598,  451,   -1,   -1,  454,  455,  456,
  457,  458,  459,   -1,  461,  462,  463,  464,  465,  466,
  467,  468,  469,  470,  471,  472,  473,  474,  475,   -1,
   -1,  478,  479,  480,  481,  482,  483,  484,  485,  486,
  487,  488,  489,  490,  491,  492,  493,  494,  495,  496,
  497,  498,  499,  500,  501,  502,  503,  504,  505,  506,
  507,  508,  509,  510,  511,  512,  513,  514,  515,  516,
  517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,  549,  550,  551,  552,  553,  554,  555,  556,
  557,  558,  559,  560,  561,  562,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,  582,  583,  584,  585,  586,
  587,  588,  589,  590,  591,  592,  593,  594,  595,  596,
  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,  582,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,
};
static int yyctable[] = {                                     -1,
  782,  814,   -1,  484,  766,   -1,  485,  766,   -1,  485,
  764,   -1,  954, 1127,   -1, 1054,  700,   -1, 1060,  715,
   -1,  990, 1249,   -1,  991, 1250,   -1,  992, 1251,   -1,
 1302, 1032,   -1,  782,  809,   -1,  152,  793,   -1,
};
#define YYFINAL 22
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 600
#if YYDEBUG
static char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,
"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ACTIVE","ADD","AFTER","ALL","ALTER","AND","ANY",
"AS","ASC","AT","AVG","AUTO","BEFORE","BEGIN","BETWEEN","BLOB","BY","CAST",
"CHARACTER","CHECK","COLLATE","COMMA","COMMIT","COMMITTED","COMPUTED",
"CONCATENATE","CONDITIONAL","CONSTRAINT","CONTAINING","COUNT","CREATE",
"CSTRING","CURRENT","CURSOR","DATABASE","DATE","DB_KEY","KW_DEBUG","DECIMAL",
"DECLARE","DEFAULT","KW_DELETE","DESC","DISTINCT","DO","DOMAIN","DROP","ELSE",
"END","ENTRY_POINT","EQL","ESCAPE","EXCEPTION","EXECUTE","EXISTS","EXIT",
"EXTERNAL","FILTER","FOR","FOREIGN","FROM","FULL","FUNCTION","GDSCODE","GEQ",
"GENERATOR","GEN_ID","GRANT","GROUP","GTR","HAVING","IF","KW_IN","INACTIVE",
"INNER","INPUT_TYPE","INDEX","INSERT","INTEGER","INTO","IS","ISOLATION","JOIN",
"KEY","KW_CHAR","KW_DEC","KW_DOUBLE","KW_FILE","KW_FLOAT","KW_INT","KW_LONG",
"KW_NULL","KW_NUMERIC","KW_UPPER","KW_VALUE","LENGTH","LPAREN","LEFT","LEQ",
"LEVEL","LIKE","LSS","MANUAL","MAXIMUM","MAX_SEGMENT","MERGE","MINIMUM",
"MODULE_NAME","NAMES","NATIONAL","NATURAL","NCHAR","NEQ","NO","NOT","NOT_GTR",
"NOT_LSS","OF","ON","ONLY","OPTION","OR","ORDER","OUTER","OUTPUT_TYPE",
"OVERFLOW","PAGE","PAGES","KW_PAGE_SIZE","PARAMETER","PASSWORD","PLAN",
"POSITION","POST_EVENT","PRECISION","PRIMARY","PRIVILEGES","PROCEDURE",
"PROTECTED","READ","REAL","REFERENCES","RESERVING","RETAIN","RETURNING_VALUES",
"RETURNS","REVOKE","RIGHT","RPAREN","ROLLBACK","SEGMENT","SELECT","SET",
"SHADOW","KW_SHARED","SINGULAR","KW_SIZE","SMALLINT","SNAPSHOT","SOME","SORT",
"SQLCODE","STABILITY","STARTING","STATISTICS","SUB_TYPE","SUSPEND","SUM",
"TABLE","THEN","TO","TRANSACTION","TRIGGER","UNCOMMITTED","UNION","UNIQUE",
"UPDATE","USER","VALUES","VARCHAR","VARIABLE","VARYING","VERSION","VIEW","WAIT",
"WHEN","WHERE","WHILE","WITH","WORK","WRITE","FLOAT_NUMBER","NUMBER","NUMERIC",
"SYMBOL","STRING","INTRODUCER","ACTION","ADMIN","CASCADE","FREE_IT","RESTRICT",
"ROLE","COLUMN","TYPE","EXTRACT","YEAR","MONTH","DAY","HOUR","MINUTE","SECOND",
"WEEKDAY","YEARDAY","TIME","TIMESTAMP","CURRENT_DATE","CURRENT_TIME",
"CURRENT_TIMESTAMP","NUMBER64BIT","SCALEDINT","CURRENT_USER","CURRENT_ROLE",
"KW_BREAK","SUBSTRING","RECREATE","KW_DESCRIPTOR","FIRST","SKIP",
"CURRENT_CONNECTION","CURRENT_TRANSACTION","BIGINT","CASE","NULLIF","COALESCE",
"USING","NULLS","LAST","ROW_COUNT","LOCK","SAVEPOINT","RELEASE","STATEMENT",
"LEAVE","INSERTING","UPDATING","DELETING","BACKUP","KW_DIFFERENCE","OPEN",
"CLOSE","FETCH","ROWS","BLOCK","IIF","SCALAR_ARRAY","CROSS","NEXT","SEQUENCE",
"RESTART","BOTH","COLLATION","COMMENT","BIT_LENGTH","CHAR_LENGTH",
"CHARACTER_LENGTH","LEADING","KW_LOWER","OCTET_LENGTH","TRAILING","TRIM",
"RETURNING","KW_IGNORE","LIMBO","UNDO","REQUESTS","TIMEOUT","ABS","ACCENT",
"ACOS","ALWAYS","ASCII_CHAR","ASCII_VAL","ASIN","ATAN","ATAN2","BIN_AND",
"BIN_OR","BIN_SHL","BIN_SHR","BIN_XOR","CEIL","CONNECT","COS","COSH","COT",
"DATEADD","DATEDIFF","DECODE","DISCONNECT","EXP","FLOOR","GEN_UUID","GENERATED",
"GLOBAL","HASH","INSENSITIVE","LIST","LN","LOG","LOG10","LPAD","MATCHED",
"MATCHING","MAXVALUE","MILLISECOND","MINVALUE","MOD","OVERLAY","PAD","PI",
"PLACING","POWER","PRESERVE","RAND","RECURSIVE","REPLACE","REVERSE","ROUND",
"RPAD","SENSITIVE","SIGN","SIN","SINH","SPACE","SQRT","START","TAN","TANH",
"TEMPORARY","TRUNC","WEEK","UMINUS","UPLUS",
};
static char *yyrule[] = {
"$accept : top",
"top : statement",
"top : statement ';'",
"statement : alter",
"statement : blob_io",
"statement : comment",
"statement : commit",
"statement : create",
"statement : create_or_alter",
"statement : declare",
"statement : delete",
"statement : drop",
"statement : grant",
"statement : insert",
"statement : merge",
"statement : exec_procedure",
"statement : exec_block",
"statement : recreate",
"statement : revoke",
"statement : rollback",
"statement : savepoint",
"statement : select",
"statement : set",
"statement : update",
"statement : update_or_insert",
"statement : KW_DEBUG signed_short_integer",
"grant : GRANT privileges ON table_noise simple_table_name TO non_role_grantee_list grant_option",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO non_role_grantee_list grant_option",
"grant : GRANT role_name_list TO role_grantee_list role_admin_option",
"table_noise : TABLE",
"table_noise :",
"privileges : ALL",
"privileges : ALL PRIVILEGES",
"privileges : privilege_list",
"privilege_list : privilege",
"privilege_list : privilege_list ',' privilege",
"proc_privileges : EXECUTE",
"privilege : SELECT",
"privilege : INSERT",
"privilege : KW_DELETE",
"privilege : UPDATE column_parens_opt",
"privilege : REFERENCES column_parens_opt",
"grant_option : WITH GRANT OPTION",
"grant_option :",
"role_admin_option : WITH ADMIN OPTION",
"role_admin_option :",
"simple_proc_name : symbol_procedure_name",
"revoke : REVOKE rev_grant_option privileges ON table_noise simple_table_name FROM non_role_grantee_list",
"revoke : REVOKE rev_grant_option proc_privileges ON PROCEDURE simple_proc_name FROM non_role_grantee_list",
"revoke : REVOKE rev_admin_option role_name_list FROM role_grantee_list",
"rev_grant_option : GRANT OPTION FOR",
"rev_grant_option :",
"rev_admin_option : ADMIN OPTION FOR",
"rev_admin_option :",
"non_role_grantee_list : grantee_list",
"non_role_grantee_list : user_grantee_list",
"grantee_list : grantee",
"grantee_list : grantee_list ',' grantee",
"grantee_list : grantee_list ',' user_grantee",
"grantee_list : user_grantee_list ',' grantee",
"grantee : PROCEDURE symbol_procedure_name",
"grantee : TRIGGER symbol_trigger_name",
"grantee : VIEW symbol_view_name",
"grantee : ROLE symbol_role_name",
"user_grantee_list : user_grantee",
"user_grantee_list : user_grantee_list ',' user_grantee",
"user_grantee : symbol_user_name",
"user_grantee : USER symbol_user_name",
"user_grantee : GROUP symbol_user_name",
"role_name_list : role_name",
"role_name_list : role_name_list ',' role_name",
"role_name : symbol_role_name",
"role_grantee_list : role_grantee",
"role_grantee_list : role_grantee_list ',' role_grantee",
"role_grantee : symbol_user_name",
"role_grantee : USER symbol_user_name",
"declare : DECLARE declare_clause",
"declare_clause : FILTER filter_decl_clause",
"declare_clause : EXTERNAL FUNCTION udf_decl_clause",
"udf_decl_clause : symbol_UDF_name arg_desc_list1 RETURNS return_value1 ENTRY_POINT sql_string MODULE_NAME sql_string",
"udf_data_type : simple_type",
"udf_data_type : BLOB",
"udf_data_type : CSTRING '(' pos_short_integer ')' charset_clause",
"arg_desc_list1 :",
"arg_desc_list1 : arg_desc_list",
"arg_desc_list1 : '(' arg_desc_list ')'",
"arg_desc_list : arg_desc",
"arg_desc_list : arg_desc_list ',' arg_desc",
"arg_desc : init_data_type udf_data_type param_mechanism",
"param_mechanism :",
"param_mechanism : BY KW_DESCRIPTOR",
"param_mechanism : BY SCALAR_ARRAY",
"param_mechanism : KW_NULL",
"return_value1 : return_value",
"return_value1 : '(' return_value ')'",
"return_value : init_data_type udf_data_type return_mechanism",
"return_value : PARAMETER pos_short_integer",
"return_mechanism :",
"return_mechanism : BY KW_VALUE",
"return_mechanism : BY KW_DESCRIPTOR",
"return_mechanism : FREE_IT",
"return_mechanism : BY KW_DESCRIPTOR FREE_IT",
"filter_decl_clause : symbol_filter_name INPUT_TYPE blob_filter_subtype OUTPUT_TYPE blob_filter_subtype ENTRY_POINT sql_string MODULE_NAME sql_string",
"blob_filter_subtype : symbol_blob_subtype_name",
"blob_filter_subtype : signed_short_integer",
"create : CREATE create_clause",
"create_clause : EXCEPTION exception_clause",
"create_clause : unique_opt order_direction INDEX symbol_index_name ON simple_table_name index_definition",
"create_clause : PROCEDURE procedure_clause",
"create_clause : TABLE table_clause",
"create_clause : GLOBAL TEMPORARY TABLE gtt_table_clause",
"create_clause : TRIGGER trigger_clause",
"create_clause : VIEW view_clause",
"create_clause : GENERATOR generator_clause",
"create_clause : SEQUENCE generator_clause",
"create_clause : DATABASE db_clause",
"create_clause : DOMAIN domain_clause",
"create_clause : SHADOW shadow_clause",
"create_clause : ROLE role_clause",
"create_clause : COLLATION collation_clause",
"recreate : RECREATE recreate_clause",
"recreate_clause : PROCEDURE rprocedure_clause",
"recreate_clause : TABLE rtable_clause",
"recreate_clause : GLOBAL TEMPORARY TABLE gtt_recreate_clause",
"recreate_clause : VIEW rview_clause",
"recreate_clause : TRIGGER rtrigger_clause",
"recreate_clause : EXCEPTION rexception_clause",
"create_or_alter : CREATE OR ALTER replace_clause",
"replace_clause : PROCEDURE replace_procedure_clause",
"replace_clause : TRIGGER replace_trigger_clause",
"replace_clause : EXCEPTION replace_exception_clause",
"exception_clause : symbol_exception_name sql_string",
"rexception_clause : symbol_exception_name sql_string",
"replace_exception_clause : symbol_exception_name sql_string",
"alter_exception_clause : symbol_exception_name sql_string",
"unique_opt : UNIQUE",
"unique_opt :",
"index_definition : column_list",
"index_definition : column_parens",
"index_definition : computed_by '(' begin_trigger value end_trigger ')'",
"shadow_clause : pos_short_integer manual_auto conditional sql_string first_file_length sec_shadow_files",
"manual_auto : MANUAL",
"manual_auto : AUTO",
"manual_auto :",
"conditional :",
"conditional : CONDITIONAL",
"first_file_length :",
"first_file_length : LENGTH equals long_integer page_noise",
"sec_shadow_files :",
"sec_shadow_files : db_file_list",
"db_file_list : db_file",
"db_file_list : db_file_list db_file",
"domain_clause : column_def_name as_opt data_type begin_trigger domain_default_opt end_default_opt domain_constraint_clause collate_clause",
"as_opt : AS",
"as_opt :",
"domain_default : DEFAULT begin_trigger default_value",
"domain_default_opt : domain_default",
"domain_default_opt :",
"domain_constraint_clause : domain_constraint_list",
"domain_constraint_clause :",
"domain_constraint_list : domain_constraint_def",
"domain_constraint_list : domain_constraint_list domain_constraint_def",
"domain_constraint_def : domain_constraint",
"domain_constraint : null_constraint",
"domain_constraint : check_constraint",
"null_constraint : NOT KW_NULL",
"check_constraint : CHECK begin_trigger '(' search_condition ')' end_trigger",
"generator_clause : symbol_generator_name",
"role_clause : symbol_role_name",
"collation_clause : symbol_collation_name FOR symbol_character_set_name collation_sequence_definition collation_attribute_list_opt collation_specific_attribute_opt",
"collation_sequence_definition : FROM symbol_collation_name",
"collation_sequence_definition : FROM EXTERNAL '(' sql_string ')'",
"collation_sequence_definition :",
"collation_attribute_list_opt :",
"collation_attribute_list_opt : collation_attribute_list",
"collation_attribute_list : collation_attribute",
"collation_attribute_list : collation_attribute_list collation_attribute",
"collation_attribute : collation_pad_attribute",
"collation_attribute : collation_case_attribute",
"collation_attribute : collation_accent_attribute",
"collation_pad_attribute : NO PAD",
"collation_pad_attribute : PAD SPACE",
"collation_case_attribute : CASE SENSITIVE",
"collation_case_attribute : CASE INSENSITIVE",
"collation_accent_attribute : ACCENT SENSITIVE",
"collation_accent_attribute : ACCENT INSENSITIVE",
"collation_specific_attribute_opt :",
"collation_specific_attribute_opt : sql_string",
"db_clause : db_name db_initial_desc1 db_rem_desc1",
"equals :",
"equals : '='",
"db_name : sql_string",
"db_initial_desc1 :",
"db_initial_desc1 : db_initial_desc",
"db_initial_desc : db_initial_option",
"db_initial_desc : db_initial_desc db_initial_option",
"db_initial_option : KW_PAGE_SIZE equals pos_short_integer",
"db_initial_option : LENGTH equals long_integer page_noise",
"db_initial_option : USER sql_string",
"db_initial_option : PASSWORD sql_string",
"db_initial_option : SET NAMES sql_string",
"db_rem_desc1 :",
"db_rem_desc1 : db_rem_desc",
"db_rem_desc : db_rem_option",
"db_rem_desc : db_rem_desc db_rem_option",
"db_rem_option : db_file",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name",
"db_rem_option : KW_DIFFERENCE KW_FILE sql_string",
"db_file : file1 sql_string file_desc1",
"file1 : KW_FILE",
"file_desc1 :",
"file_desc1 : file_desc",
"file_desc : file_clause",
"file_desc : file_desc file_clause",
"file_clause : STARTING file_clause_noise long_integer",
"file_clause : LENGTH equals long_integer page_noise",
"file_clause_noise :",
"file_clause_noise : AT",
"file_clause_noise : AT PAGE",
"page_noise :",
"page_noise : PAGE",
"page_noise : PAGES",
"table_clause : simple_table_name external_file '(' table_elements ')'",
"rtable_clause : simple_table_name external_file '(' table_elements ')'",
"gtt_table_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_recreate_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_scope : ON COMMIT PRESERVE ROWS",
"gtt_scope : ON COMMIT KW_DELETE ROWS",
"gtt_scope :",
"external_file : EXTERNAL KW_FILE sql_string",
"external_file : EXTERNAL sql_string",
"external_file :",
"table_elements : table_element",
"table_elements : table_elements ',' table_element",
"table_element : column_def",
"table_element : table_constraint_definition",
"column_def : column_def_name data_type_or_domain domain_default_opt end_default_opt column_constraint_clause collate_clause",
"column_def : column_def_name non_array_type def_computed",
"column_def : column_def_name def_computed",
"def_computed : computed_clause '(' begin_trigger value end_trigger ')'",
"computed_clause : computed_by",
"computed_clause : GENERATED ALWAYS AS",
"computed_by : COMPUTED BY",
"computed_by : COMPUTED",
"data_type_or_domain : data_type begin_trigger",
"data_type_or_domain : simple_column_name begin_string",
"collate_clause : COLLATE symbol_collation_name",
"collate_clause :",
"column_def_name : simple_column_name",
"simple_column_def_name : simple_column_name",
"data_type_descriptor : init_data_type data_type",
"data_type_descriptor : TYPE OF column_def_name",
"data_type_descriptor : column_def_name",
"init_data_type :",
"default_value : constant",
"default_value : current_user",
"default_value : current_role",
"default_value : internal_info",
"default_value : null_value",
"default_value : datetime_value_expression",
"column_constraint_clause :",
"column_constraint_clause : column_constraint_list",
"column_constraint_list : column_constraint_def",
"column_constraint_list : column_constraint_list column_constraint_def",
"column_constraint_def : constraint_name_opt column_constraint",
"column_constraint : null_constraint",
"column_constraint : check_constraint",
"column_constraint : REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"column_constraint : UNIQUE constraint_index_opt",
"column_constraint : PRIMARY KEY constraint_index_opt",
"table_constraint_definition : constraint_name_opt table_constraint",
"constraint_name_opt : CONSTRAINT symbol_constraint_name",
"constraint_name_opt :",
"table_constraint : unique_constraint",
"table_constraint : primary_constraint",
"table_constraint : referential_constraint",
"table_constraint : check_constraint",
"unique_constraint : UNIQUE column_parens constraint_index_opt",
"primary_constraint : PRIMARY KEY column_parens constraint_index_opt",
"referential_constraint : FOREIGN KEY column_parens REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"constraint_index_opt : USING order_direction INDEX symbol_index_name",
"constraint_index_opt :",
"referential_trigger_action : update_rule",
"referential_trigger_action : delete_rule",
"referential_trigger_action : delete_rule update_rule",
"referential_trigger_action : update_rule delete_rule",
"referential_trigger_action :",
"update_rule : ON UPDATE referential_action",
"delete_rule : ON KW_DELETE referential_action",
"referential_action : CASCADE",
"referential_action : SET DEFAULT",
"referential_action : SET KW_NULL",
"referential_action : NO ACTION",
"procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"rprocedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"replace_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"alter_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"input_parameters : '(' input_proc_parameters ')'",
"input_parameters :",
"output_parameters : RETURNS '(' output_proc_parameters ')'",
"output_parameters :",
"input_proc_parameters : input_proc_parameter",
"input_proc_parameters : input_proc_parameters ',' input_proc_parameter",
"input_proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause begin_trigger default_par_opt end_default_opt",
"output_proc_parameters : proc_parameter",
"output_proc_parameters : output_proc_parameters ',' proc_parameter",
"proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause",
"default_par_opt : DEFAULT begin_trigger default_value",
"default_par_opt : '=' begin_trigger default_value",
"default_par_opt :",
"local_declaration_list : local_declarations",
"local_declaration_list :",
"local_declarations : local_declaration",
"local_declarations : local_declarations local_declaration",
"local_declaration : stmt_start_line stmt_start_column DECLARE var_decl_opt local_declaration_item ';'",
"local_declaration_item : var_declaration_item",
"local_declaration_item : cursor_declaration_item",
"var_declaration_item : column_def_name domain_or_non_array_type collate_clause var_init_opt",
"var_decl_opt : VARIABLE",
"var_decl_opt :",
"var_init_opt : DEFAULT default_value",
"var_init_opt : '=' default_value",
"var_init_opt :",
"cursor_declaration_item : symbol_cursor_name CURSOR FOR '(' select ')'",
"proc_block : proc_statement",
"proc_block : full_proc_block",
"full_proc_block : stmt_start_line stmt_start_column BEGIN full_proc_block_body END",
"full_proc_block_body : proc_statements",
"full_proc_block_body : proc_statements excp_hndl_statements",
"full_proc_block_body :",
"proc_statements : proc_block",
"proc_statements : proc_statements proc_block",
"proc_statement : stmt_start_line stmt_start_column simple_proc_statement ';'",
"proc_statement : stmt_start_line stmt_start_column complex_proc_statement",
"stmt_start_line :",
"stmt_start_column :",
"simple_proc_statement : assignment",
"simple_proc_statement : insert",
"simple_proc_statement : merge",
"simple_proc_statement : update",
"simple_proc_statement : update_or_insert",
"simple_proc_statement : delete",
"simple_proc_statement : singleton_select",
"simple_proc_statement : exec_procedure",
"simple_proc_statement : exec_sql",
"simple_proc_statement : exec_into",
"simple_proc_statement : exec_function",
"simple_proc_statement : excp_statement",
"simple_proc_statement : raise_statement",
"simple_proc_statement : post_event",
"simple_proc_statement : cursor_statement",
"simple_proc_statement : breakleave",
"simple_proc_statement : SUSPEND",
"simple_proc_statement : EXIT",
"complex_proc_statement : if_then_else",
"complex_proc_statement : while",
"complex_proc_statement : for_select",
"complex_proc_statement : for_exec_into",
"excp_statement : EXCEPTION symbol_exception_name",
"excp_statement : EXCEPTION symbol_exception_name value",
"raise_statement : EXCEPTION",
"exec_sql : EXECUTE STATEMENT value",
"for_select : label_opt FOR select INTO variable_list cursor_def DO proc_block",
"for_exec_into : label_opt FOR EXECUTE STATEMENT value INTO variable_list DO proc_block",
"exec_into : EXECUTE STATEMENT value INTO variable_list",
"if_then_else : IF '(' search_condition ')' THEN proc_block ELSE proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block",
"post_event : POST_EVENT value event_argument_opt",
"event_argument_opt :",
"singleton_select : select INTO variable_list",
"variable : ':' symbol_variable_name",
"variable_list : variable",
"variable_list : column_name",
"variable_list : variable_list ',' column_name",
"variable_list : variable_list ',' variable",
"while : label_opt WHILE '(' search_condition ')' DO proc_block",
"label_opt : symbol_label_name ':'",
"label_opt :",
"breakleave : KW_BREAK",
"breakleave : LEAVE",
"breakleave : LEAVE symbol_label_name",
"cursor_def : AS CURSOR symbol_cursor_name",
"cursor_def :",
"excp_hndl_statements : excp_hndl_statement",
"excp_hndl_statements : excp_hndl_statements excp_hndl_statement",
"excp_hndl_statement : WHEN errors DO proc_block",
"errors : err",
"errors : errors ',' err",
"err : SQLCODE signed_short_integer",
"err : GDSCODE symbol_gdscode_name",
"err : EXCEPTION symbol_exception_name",
"err : ANY",
"cursor_statement : open_cursor",
"cursor_statement : fetch_cursor",
"cursor_statement : close_cursor",
"open_cursor : OPEN symbol_cursor_name",
"close_cursor : CLOSE symbol_cursor_name",
"fetch_cursor : FETCH fetch_opt symbol_cursor_name INTO variable_list",
"fetch_opt :",
"exec_procedure : EXECUTE PROCEDURE symbol_procedure_name proc_inputs proc_outputs_opt",
"proc_inputs : value_list",
"proc_inputs : '(' value_list ')'",
"proc_inputs :",
"proc_outputs_opt : RETURNING_VALUES variable_list",
"proc_outputs_opt : RETURNING_VALUES '(' variable_list ')'",
"proc_outputs_opt :",
"exec_block : EXECUTE BLOCK block_input_params output_parameters AS local_declaration_list full_proc_block",
"block_input_params : '(' block_parameters ')'",
"block_input_params :",
"block_parameters : block_parameter",
"block_parameters : block_parameters ',' block_parameter",
"block_parameter : proc_parameter '=' parameter",
"view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"rview_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"begin_string :",
"begin_trigger :",
"end_trigger :",
"end_default_opt :",
"check_opt : WITH CHECK OPTION",
"check_opt :",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"trigger_active : ACTIVE",
"trigger_active : INACTIVE",
"trigger_active :",
"trigger_type : trigger_type_prefix trigger_type_suffix",
"trigger_type : ON trigger_db_type",
"trigger_db_type : CONNECT",
"trigger_db_type : DISCONNECT",
"trigger_db_type : TRANSACTION START",
"trigger_db_type : TRANSACTION COMMIT",
"trigger_db_type : TRANSACTION ROLLBACK",
"trigger_type_prefix : BEFORE",
"trigger_type_prefix : AFTER",
"trigger_type_suffix : INSERT",
"trigger_type_suffix : UPDATE",
"trigger_type_suffix : KW_DELETE",
"trigger_type_suffix : INSERT OR UPDATE",
"trigger_type_suffix : INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR INSERT",
"trigger_type_suffix : UPDATE OR KW_DELETE",
"trigger_type_suffix : KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR UPDATE",
"trigger_type_suffix : INSERT OR UPDATE OR KW_DELETE",
"trigger_type_suffix : INSERT OR KW_DELETE OR UPDATE",
"trigger_type_suffix : UPDATE OR INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR INSERT OR UPDATE",
"trigger_type_suffix : KW_DELETE OR UPDATE OR INSERT",
"trigger_position : POSITION nonneg_short_integer",
"trigger_position :",
"trigger_action : AS begin_trigger local_declaration_list full_proc_block",
"alter : ALTER alter_clause",
"alter_clause : EXCEPTION alter_exception_clause",
"alter_clause : TABLE simple_table_name alter_ops",
"alter_clause : TRIGGER alter_trigger_clause",
"alter_clause : PROCEDURE alter_procedure_clause",
"alter_clause : DATABASE init_alter_db alter_db",
"alter_clause : DOMAIN alter_column_name alter_domain_ops",
"alter_clause : INDEX alter_index_clause",
"alter_clause : SEQUENCE alter_sequence_clause",
"alter_clause : EXTERNAL FUNCTION alter_udf_clause",
"alter_domain_ops : alter_domain_op",
"alter_domain_ops : alter_domain_ops alter_domain_op",
"alter_domain_op : SET domain_default end_trigger",
"alter_domain_op : ADD CONSTRAINT check_constraint",
"alter_domain_op : ADD check_constraint",
"alter_domain_op : DROP DEFAULT",
"alter_domain_op : DROP CONSTRAINT",
"alter_domain_op : TO simple_column_name",
"alter_domain_op : TYPE init_data_type non_array_type",
"alter_ops : alter_op",
"alter_ops : alter_ops ',' alter_op",
"alter_op : DROP simple_column_name drop_behaviour",
"alter_op : DROP CONSTRAINT symbol_constraint_name",
"alter_op : ADD column_def",
"alter_op : ADD table_constraint_definition",
"alter_op : col_opt simple_column_name POSITION pos_short_integer",
"alter_op : col_opt alter_column_name TO simple_column_name",
"alter_op : col_opt alter_col_name TYPE alter_data_type_or_domain",
"alter_op : col_opt alter_col_name SET domain_default end_trigger",
"alter_op : col_opt alter_col_name DROP DEFAULT",
"alter_column_name : keyword_or_column",
"keyword_or_column : valid_symbol_name",
"keyword_or_column : ADMIN",
"keyword_or_column : COLUMN",
"keyword_or_column : EXTRACT",
"keyword_or_column : YEAR",
"keyword_or_column : MONTH",
"keyword_or_column : DAY",
"keyword_or_column : HOUR",
"keyword_or_column : MINUTE",
"keyword_or_column : SECOND",
"keyword_or_column : TIME",
"keyword_or_column : TIMESTAMP",
"keyword_or_column : CURRENT_DATE",
"keyword_or_column : CURRENT_TIME",
"keyword_or_column : CURRENT_TIMESTAMP",
"keyword_or_column : CURRENT_USER",
"keyword_or_column : CURRENT_ROLE",
"keyword_or_column : RECREATE",
"keyword_or_column : CURRENT_CONNECTION",
"keyword_or_column : CURRENT_TRANSACTION",
"keyword_or_column : BIGINT",
"keyword_or_column : CASE",
"keyword_or_column : RELEASE",
"keyword_or_column : ROW_COUNT",
"keyword_or_column : SAVEPOINT",
"keyword_or_column : OPEN",
"keyword_or_column : CLOSE",
"keyword_or_column : FETCH",
"keyword_or_column : ROWS",
"keyword_or_column : USING",
"keyword_or_column : CROSS",
"keyword_or_column : BIT_LENGTH",
"keyword_or_column : BOTH",
"keyword_or_column : CHAR_LENGTH",
"keyword_or_column : CHARACTER_LENGTH",
"keyword_or_column : COMMENT",
"keyword_or_column : LEADING",
"keyword_or_column : KW_LOWER",
"keyword_or_column : OCTET_LENGTH",
"keyword_or_column : TRAILING",
"keyword_or_column : TRIM",
"keyword_or_column : CONNECT",
"keyword_or_column : DISCONNECT",
"keyword_or_column : GLOBAL",
"keyword_or_column : INSENSITIVE",
"keyword_or_column : RECURSIVE",
"keyword_or_column : SENSITIVE",
"keyword_or_column : START",
"col_opt : ALTER",
"col_opt : ALTER COLUMN",
"alter_data_type_or_domain : non_array_type",
"alter_data_type_or_domain : simple_column_name",
"alter_col_name : simple_column_name",
"drop_behaviour : RESTRICT",
"drop_behaviour : CASCADE",
"drop_behaviour :",
"alter_index_clause : symbol_index_name ACTIVE",
"alter_index_clause : symbol_index_name INACTIVE",
"alter_sequence_clause : symbol_generator_name RESTART WITH signed_long_integer",
"alter_sequence_clause : symbol_generator_name RESTART WITH NUMBER64BIT",
"alter_sequence_clause : symbol_generator_name RESTART WITH '-' NUMBER64BIT",
"alter_udf_clause : symbol_UDF_name entry_op module_op",
"entry_op : ENTRY_POINT sql_string",
"entry_op :",
"module_op : MODULE_NAME sql_string",
"module_op :",
"init_alter_db :",
"alter_db : db_alter_clause",
"alter_db : alter_db db_alter_clause",
"db_alter_clause : ADD db_file_list",
"db_alter_clause : ADD KW_DIFFERENCE KW_FILE sql_string",
"db_alter_clause : DROP KW_DIFFERENCE KW_FILE",
"db_alter_clause : BEGIN BACKUP",
"db_alter_clause : END BACKUP",
"alter_trigger_clause : symbol_trigger_name trigger_active new_trigger_type trigger_position begin_trigger new_trigger_action end_trigger",
"new_trigger_type : trigger_type",
"new_trigger_type :",
"new_trigger_action : trigger_action",
"new_trigger_action :",
"drop : DROP drop_clause",
"drop_clause : EXCEPTION symbol_exception_name",
"drop_clause : INDEX symbol_index_name",
"drop_clause : PROCEDURE symbol_procedure_name",
"drop_clause : TABLE symbol_table_name",
"drop_clause : TRIGGER symbol_trigger_name",
"drop_clause : VIEW symbol_view_name",
"drop_clause : FILTER symbol_filter_name",
"drop_clause : DOMAIN symbol_domain_name",
"drop_clause : EXTERNAL FUNCTION symbol_UDF_name",
"drop_clause : SHADOW pos_short_integer",
"drop_clause : ROLE symbol_role_name",
"drop_clause : GENERATOR symbol_generator_name",
"drop_clause : SEQUENCE symbol_generator_name",
"drop_clause : COLLATION symbol_collation_name",
"data_type : non_array_type",
"data_type : array_type",
"domain_or_non_array_type : domain_or_non_array_type_name",
"domain_or_non_array_type : domain_or_non_array_type_name NOT KW_NULL",
"domain_or_non_array_type_name : non_array_type",
"domain_or_non_array_type_name : domain_type",
"domain_type : TYPE OF symbol_column_name",
"domain_type : symbol_column_name",
"non_array_type : simple_type",
"non_array_type : blob_type",
"array_type : non_charset_simple_type '[' array_spec ']'",
"array_type : character_type '[' array_spec ']' charset_clause",
"array_spec : array_range",
"array_spec : array_spec ',' array_range",
"array_range : signed_long_integer",
"array_range : signed_long_integer ':' signed_long_integer",
"simple_type : non_charset_simple_type",
"simple_type : character_type charset_clause",
"non_charset_simple_type : national_character_type",
"non_charset_simple_type : numeric_type",
"non_charset_simple_type : float_type",
"non_charset_simple_type : BIGINT",
"non_charset_simple_type : integer_keyword",
"non_charset_simple_type : SMALLINT",
"non_charset_simple_type : DATE",
"non_charset_simple_type : TIME",
"non_charset_simple_type : TIMESTAMP",
"integer_keyword : INTEGER",
"integer_keyword : KW_INT",
"blob_type : BLOB blob_subtype blob_segsize charset_clause",
"blob_type : BLOB '(' unsigned_short_integer ')'",
"blob_type : BLOB '(' unsigned_short_integer ',' signed_short_integer ')'",
"blob_type : BLOB '(' ',' signed_short_integer ')'",
"blob_segsize : SEGMENT KW_SIZE unsigned_short_integer",
"blob_segsize :",
"blob_subtype : SUB_TYPE signed_short_integer",
"blob_subtype : SUB_TYPE symbol_blob_subtype_name",
"blob_subtype :",
"charset_clause : CHARACTER SET symbol_character_set_name",
"charset_clause :",
"national_character_type : national_character_keyword '(' pos_short_integer ')'",
"national_character_type : national_character_keyword",
"national_character_type : national_character_keyword VARYING '(' pos_short_integer ')'",
"character_type : character_keyword '(' pos_short_integer ')'",
"character_type : character_keyword",
"character_type : varying_keyword '(' pos_short_integer ')'",
"varying_keyword : VARCHAR",
"varying_keyword : CHARACTER VARYING",
"varying_keyword : KW_CHAR VARYING",
"character_keyword : CHARACTER",
"character_keyword : KW_CHAR",
"national_character_keyword : NCHAR",
"national_character_keyword : NATIONAL CHARACTER",
"national_character_keyword : NATIONAL KW_CHAR",
"numeric_type : KW_NUMERIC prec_scale",
"numeric_type : decimal_keyword prec_scale",
"prec_scale :",
"prec_scale : '(' signed_long_integer ')'",
"prec_scale : '(' signed_long_integer ',' signed_long_integer ')'",
"decimal_keyword : DECIMAL",
"decimal_keyword : KW_DEC",
"float_type : KW_FLOAT precision_opt",
"float_type : KW_LONG KW_FLOAT precision_opt",
"float_type : REAL",
"float_type : KW_DOUBLE PRECISION",
"precision_opt : '(' nonneg_short_integer ')'",
"precision_opt :",
"set : set_transaction",
"set : set_generator",
"set : set_statistics",
"set_generator : SET GENERATOR symbol_generator_name TO signed_long_integer",
"set_generator : SET GENERATOR symbol_generator_name TO NUMBER64BIT",
"set_generator : SET GENERATOR symbol_generator_name TO '-' NUMBER64BIT",
"savepoint : set_savepoint",
"savepoint : release_savepoint",
"savepoint : undo_savepoint",
"set_savepoint : SAVEPOINT symbol_savepoint_name",
"release_savepoint : RELEASE SAVEPOINT symbol_savepoint_name release_only_opt",
"release_only_opt : ONLY",
"release_only_opt :",
"undo_savepoint : ROLLBACK optional_work TO optional_savepoint symbol_savepoint_name",
"optional_savepoint : SAVEPOINT",
"optional_savepoint :",
"commit : COMMIT optional_work optional_retain",
"rollback : ROLLBACK optional_work optional_retain",
"optional_work : WORK",
"optional_work :",
"optional_retain : RETAIN opt_snapshot",
"optional_retain :",
"opt_snapshot : SNAPSHOT",
"opt_snapshot :",
"set_transaction : SET TRANSACTION tran_opt_list_m",
"tran_opt_list_m : tran_opt_list",
"tran_opt_list_m :",
"tran_opt_list : tran_opt",
"tran_opt_list : tran_opt_list tran_opt",
"tran_opt : access_mode",
"tran_opt : lock_wait",
"tran_opt : isolation_mode",
"tran_opt : tra_misc_options",
"tran_opt : tra_timeout",
"tran_opt : tbl_reserve_options",
"access_mode : READ ONLY",
"access_mode : READ WRITE",
"lock_wait : WAIT",
"lock_wait : NO WAIT",
"isolation_mode : ISOLATION LEVEL iso_mode",
"isolation_mode : iso_mode",
"iso_mode : snap_shot",
"iso_mode : READ UNCOMMITTED version_mode",
"iso_mode : READ COMMITTED version_mode",
"snap_shot : SNAPSHOT",
"snap_shot : SNAPSHOT TABLE",
"snap_shot : SNAPSHOT TABLE STABILITY",
"version_mode : VERSION",
"version_mode : NO VERSION",
"version_mode :",
"tra_misc_options : NO AUTO UNDO",
"tra_misc_options : KW_IGNORE LIMBO",
"tra_misc_options : RESTART REQUESTS",
"tra_timeout : LOCK TIMEOUT nonneg_short_integer",
"tbl_reserve_options : RESERVING restr_list",
"lock_type : KW_SHARED",
"lock_type : PROTECTED",
"lock_type :",
"lock_mode : READ",
"lock_mode : WRITE",
"restr_list : restr_option",
"restr_list : restr_list ',' restr_option",
"restr_option : table_list table_lock",
"table_lock : FOR lock_type lock_mode",
"table_lock :",
"table_list : simple_table_name",
"table_list : table_list ',' simple_table_name",
"set_statistics : SET STATISTICS INDEX symbol_index_name",
"comment : COMMENT ON ddl_type0 IS ddl_desc",
"comment : COMMENT ON ddl_type1 symbol_ddl_name IS ddl_desc",
"comment : COMMENT ON ddl_type2 symbol_ddl_name ddl_subname IS ddl_desc",
"ddl_type0 : DATABASE",
"ddl_type1 : DOMAIN",
"ddl_type1 : TABLE",
"ddl_type1 : VIEW",
"ddl_type1 : PROCEDURE",
"ddl_type1 : TRIGGER",
"ddl_type1 : EXTERNAL FUNCTION",
"ddl_type1 : FILTER",
"ddl_type1 : EXCEPTION",
"ddl_type1 : GENERATOR",
"ddl_type1 : SEQUENCE",
"ddl_type1 : INDEX",
"ddl_type1 : ROLE",
"ddl_type1 : CHARACTER SET",
"ddl_type1 : COLLATION",
"ddl_type2 : COLUMN",
"ddl_type2 : PARAMETER",
"ddl_subname : '.' symbol_ddl_name",
"ddl_desc : sql_string",
"ddl_desc : KW_NULL",
"select : select_expr for_update_clause lock_clause",
"for_update_clause : FOR UPDATE for_update_list",
"for_update_clause :",
"for_update_list : OF column_list",
"for_update_list :",
"lock_clause : WITH LOCK",
"lock_clause :",
"select_expr : with_clause select_expr_body order_clause rows_clause",
"with_clause : WITH RECURSIVE with_list",
"with_clause : WITH with_list",
"with_clause :",
"with_list : with_item",
"with_list : with_item ',' with_list",
"with_item : symbol_table_alias_name derived_column_list AS '(' select_expr ')'",
"column_select : with_clause select_expr_body order_clause rows_clause",
"column_singleton : with_clause select_expr_body order_clause rows_clause",
"select_expr_body : query_term",
"select_expr_body : select_expr_body UNION distinct_noise query_term",
"select_expr_body : select_expr_body UNION ALL query_term",
"query_term : query_spec",
"query_spec : SELECT limit_clause distinct_clause select_list from_clause where_clause group_clause having_clause plan_clause",
"limit_clause : first_clause skip_clause",
"limit_clause : first_clause",
"limit_clause : skip_clause",
"limit_clause :",
"first_clause : FIRST long_integer",
"first_clause : FIRST '(' value ')'",
"first_clause : FIRST parameter",
"skip_clause : SKIP long_integer",
"skip_clause : SKIP '(' value ')'",
"skip_clause : SKIP parameter",
"distinct_clause : DISTINCT",
"distinct_clause : all_noise",
"select_list : select_items",
"select_list : '*'",
"select_items : select_item",
"select_items : select_items ',' select_item",
"select_item : value",
"select_item : value as_noise symbol_item_alias_name",
"as_noise : AS",
"as_noise :",
"from_clause : FROM from_list",
"from_list : table_reference",
"from_list : from_list ',' table_reference",
"table_reference : joined_table",
"table_reference : table_primary",
"table_primary : table_proc",
"table_primary : derived_table",
"table_primary : '(' joined_table ')'",
"derived_table : '(' select_expr ')' as_noise correlation_name derived_column_list",
"correlation_name : symbol_table_alias_name",
"correlation_name :",
"derived_column_list : '(' alias_list ')'",
"derived_column_list :",
"alias_list : symbol_item_alias_name",
"alias_list : alias_list ',' symbol_item_alias_name",
"joined_table : cross_join",
"joined_table : natural_join",
"joined_table : qualified_join",
"cross_join : table_reference CROSS JOIN table_primary",
"natural_join : table_reference NATURAL join_type JOIN table_primary",
"qualified_join : table_reference join_type JOIN table_reference join_specification",
"join_specification : join_condition",
"join_specification : named_columns_join",
"join_condition : ON search_condition",
"named_columns_join : USING '(' column_list ')'",
"table_proc : symbol_procedure_name table_proc_inputs as_noise symbol_table_alias_name",
"table_proc : symbol_procedure_name table_proc_inputs",
"table_proc_inputs : '(' value_list ')'",
"table_proc_inputs :",
"table_name : simple_table_name",
"table_name : symbol_table_name as_noise symbol_table_alias_name",
"simple_table_name : symbol_table_name",
"join_type : INNER",
"join_type : LEFT outer_noise",
"join_type : RIGHT outer_noise",
"join_type : FULL outer_noise",
"join_type :",
"outer_noise : OUTER",
"outer_noise :",
"group_clause : GROUP BY group_by_list",
"group_clause :",
"group_by_list : group_by_item",
"group_by_list : group_by_list ',' group_by_item",
"group_by_item : value",
"having_clause : HAVING search_condition",
"having_clause :",
"where_clause : WHERE search_condition",
"where_clause :",
"plan_clause : PLAN plan_expression",
"plan_clause :",
"plan_expression : plan_type '(' plan_item_list ')'",
"plan_type : JOIN",
"plan_type : SORT MERGE",
"plan_type : MERGE",
"plan_type : SORT",
"plan_type :",
"plan_item_list : plan_item",
"plan_item_list : plan_item ',' plan_item_list",
"plan_item : table_or_alias_list access_type",
"plan_item : plan_expression",
"table_or_alias_list : symbol_table_name",
"table_or_alias_list : symbol_table_name table_or_alias_list",
"access_type : NATURAL",
"access_type : INDEX '(' index_list ')'",
"access_type : ORDER symbol_index_name extra_indices_opt",
"index_list : symbol_index_name",
"index_list : symbol_index_name ',' index_list",
"extra_indices_opt : INDEX '(' index_list ')'",
"extra_indices_opt :",
"order_clause : ORDER BY order_list",
"order_clause :",
"order_list : order_item",
"order_list : order_list ',' order_item",
"order_item : value order_direction nulls_clause",
"order_direction : ASC",
"order_direction : DESC",
"order_direction :",
"nulls_clause : NULLS nulls_placement",
"nulls_clause :",
"nulls_placement : FIRST",
"nulls_placement : LAST",
"rows_clause : ROWS value",
"rows_clause : ROWS value TO value",
"rows_clause :",
"insert : INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' returning_clause",
"insert : INSERT INTO simple_table_name ins_column_parens_opt select_expr returning_clause",
"insert : INSERT INTO simple_table_name DEFAULT VALUES returning_clause",
"merge : MERGE INTO table_name USING table_reference ON search_condition merge_when_clause",
"merge_when_clause : merge_when_matched_clause merge_when_not_matched_clause",
"merge_when_clause : merge_when_not_matched_clause merge_when_matched_clause",
"merge_when_clause : merge_when_matched_clause",
"merge_when_clause : merge_when_not_matched_clause",
"merge_when_matched_clause : WHEN MATCHED THEN merge_update_specification",
"merge_when_not_matched_clause : WHEN NOT MATCHED THEN merge_insert_specification",
"merge_update_specification : UPDATE SET assignments",
"merge_insert_specification : INSERT ins_column_parens_opt VALUES '(' value_list ')'",
"delete : delete_searched",
"delete : delete_positioned",
"delete_searched : KW_DELETE FROM table_name where_clause plan_clause order_clause rows_clause returning_clause",
"delete_positioned : KW_DELETE FROM table_name cursor_clause",
"update : update_searched",
"update : update_positioned",
"update_searched : UPDATE table_name SET assignments where_clause plan_clause order_clause rows_clause returning_clause",
"update_positioned : UPDATE table_name SET assignments cursor_clause",
"update_or_insert : UPDATE OR INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' update_or_insert_matching_opt returning_clause",
"update_or_insert_matching_opt : MATCHING ins_column_parens",
"update_or_insert_matching_opt :",
"returning_clause : RETURNING value_list",
"returning_clause : RETURNING value_list INTO variable_list",
"returning_clause :",
"cursor_clause : WHERE CURRENT OF symbol_cursor_name",
"assignments : assignment",
"assignments : assignments ',' assignment",
"assignment : update_column_name '=' value",
"exec_function : udf",
"exec_function : non_aggregate_function",
"blob_io : READ BLOB simple_column_name FROM simple_table_name filter_clause_io segment_clause_io",
"blob_io : INSERT BLOB simple_column_name INTO simple_table_name filter_clause_io segment_clause_io",
"filter_clause_io : FILTER FROM blob_subtype_value_io TO blob_subtype_value_io",
"filter_clause_io : FILTER TO blob_subtype_value_io",
"filter_clause_io :",
"blob_subtype_value_io : blob_subtype_io",
"blob_subtype_value_io : parameter",
"blob_subtype_io : signed_short_integer",
"segment_clause_io : MAX_SEGMENT segment_length_io",
"segment_clause_io :",
"segment_length_io : unsigned_short_integer",
"segment_length_io : parameter",
"column_parens_opt : column_parens",
"column_parens_opt :",
"column_parens : '(' column_list ')'",
"column_list : simple_column_name",
"column_list : column_list ',' simple_column_name",
"ins_column_parens_opt : ins_column_parens",
"ins_column_parens_opt :",
"ins_column_parens : '(' ins_column_list ')'",
"ins_column_list : update_column_name",
"ins_column_list : ins_column_list ',' update_column_name",
"column_name : simple_column_name",
"column_name : symbol_table_alias_name '.' symbol_column_name",
"column_name : symbol_table_alias_name '.' '*'",
"simple_column_name : symbol_column_name",
"update_column_name : simple_column_name",
"update_column_name : symbol_table_alias_name '.' symbol_column_name",
"search_condition : predicate",
"search_condition : search_condition OR search_condition",
"search_condition : search_condition AND search_condition",
"search_condition : NOT search_condition",
"predicate : comparison_predicate",
"predicate : distinct_predicate",
"predicate : between_predicate",
"predicate : like_predicate",
"predicate : in_predicate",
"predicate : null_predicate",
"predicate : quantified_predicate",
"predicate : exists_predicate",
"predicate : containing_predicate",
"predicate : starting_predicate",
"predicate : singular_predicate",
"predicate : trigger_action_predicate",
"predicate : '(' search_condition ')'",
"comparison_predicate : value '=' value",
"comparison_predicate : value '<' value",
"comparison_predicate : value '>' value",
"comparison_predicate : value GEQ value",
"comparison_predicate : value LEQ value",
"comparison_predicate : value NOT_GTR value",
"comparison_predicate : value NOT_LSS value",
"comparison_predicate : value NEQ value",
"quantified_predicate : value '=' ALL '(' column_select ')'",
"quantified_predicate : value '<' ALL '(' column_select ')'",
"quantified_predicate : value '>' ALL '(' column_select ')'",
"quantified_predicate : value GEQ ALL '(' column_select ')'",
"quantified_predicate : value LEQ ALL '(' column_select ')'",
"quantified_predicate : value NOT_GTR ALL '(' column_select ')'",
"quantified_predicate : value NOT_LSS ALL '(' column_select ')'",
"quantified_predicate : value NEQ ALL '(' column_select ')'",
"quantified_predicate : value '=' some '(' column_select ')'",
"quantified_predicate : value '<' some '(' column_select ')'",
"quantified_predicate : value '>' some '(' column_select ')'",
"quantified_predicate : value GEQ some '(' column_select ')'",
"quantified_predicate : value LEQ some '(' column_select ')'",
"quantified_predicate : value NOT_GTR some '(' column_select ')'",
"quantified_predicate : value NOT_LSS some '(' column_select ')'",
"quantified_predicate : value NEQ some '(' column_select ')'",
"some : SOME",
"some : ANY",
"distinct_predicate : value IS DISTINCT FROM value",
"distinct_predicate : value IS NOT DISTINCT FROM value",
"between_predicate : value BETWEEN value AND value",
"between_predicate : value NOT BETWEEN value AND value",
"like_predicate : value LIKE value",
"like_predicate : value NOT LIKE value",
"like_predicate : value LIKE value ESCAPE value",
"like_predicate : value NOT LIKE value ESCAPE value",
"in_predicate : value KW_IN in_predicate_value",
"in_predicate : value NOT KW_IN in_predicate_value",
"containing_predicate : value CONTAINING value",
"containing_predicate : value NOT CONTAINING value",
"starting_predicate : value STARTING value",
"starting_predicate : value NOT STARTING value",
"starting_predicate : value STARTING WITH value",
"starting_predicate : value NOT STARTING WITH value",
"exists_predicate : EXISTS '(' select_expr ')'",
"singular_predicate : SINGULAR '(' select_expr ')'",
"null_predicate : value IS KW_NULL",
"null_predicate : value IS NOT KW_NULL",
"trigger_action_predicate : INSERTING",
"trigger_action_predicate : UPDATING",
"trigger_action_predicate : DELETING",
"in_predicate_value : table_subquery",
"in_predicate_value : '(' value_list ')'",
"table_subquery : '(' column_select ')'",
"value : column_name",
"value : array_element",
"value : function",
"value : u_constant",
"value : parameter",
"value : variable",
"value : cast_specification",
"value : case_expression",
"value : next_value_expression",
"value : udf",
"value : '-' value",
"value : '+' value",
"value : value '+' value",
"value : value CONCATENATE value",
"value : value COLLATE symbol_collation_name",
"value : value '-' value",
"value : value '*' value",
"value : value '/' value",
"value : '(' value ')'",
"value : '(' column_singleton ')'",
"value : current_user",
"value : current_role",
"value : internal_info",
"value : DB_KEY",
"value : symbol_table_alias_name '.' DB_KEY",
"value : KW_VALUE",
"value : datetime_value_expression",
"value : null_value",
"datetime_value_expression : CURRENT_DATE",
"datetime_value_expression : CURRENT_TIME sec_precision_opt",
"datetime_value_expression : CURRENT_TIMESTAMP sec_precision_opt",
"sec_precision_opt : '(' nonneg_short_integer ')'",
"sec_precision_opt :",
"array_element : column_name '[' value_list ']'",
"value_list_opt : value_list",
"value_list_opt :",
"value_list : value",
"value_list : value_list ',' value",
"constant : u_constant",
"constant : '-' u_numeric_constant",
"u_numeric_constant : NUMERIC",
"u_numeric_constant : NUMBER",
"u_numeric_constant : FLOAT_NUMBER",
"u_numeric_constant : NUMBER64BIT",
"u_numeric_constant : SCALEDINT",
"u_constant : u_numeric_constant",
"u_constant : sql_string",
"u_constant : DATE STRING",
"u_constant : TIME STRING",
"u_constant : TIMESTAMP STRING",
"parameter : '?'",
"current_user : USER",
"current_user : CURRENT_USER",
"current_role : CURRENT_ROLE",
"internal_info : CURRENT_CONNECTION",
"internal_info : CURRENT_TRANSACTION",
"internal_info : GDSCODE",
"internal_info : SQLCODE",
"internal_info : ROW_COUNT",
"sql_string : STRING",
"sql_string : INTRODUCER STRING",
"signed_short_integer : nonneg_short_integer",
"signed_short_integer : '-' neg_short_integer",
"nonneg_short_integer : NUMBER",
"neg_short_integer : NUMBER",
"pos_short_integer : nonneg_short_integer",
"unsigned_short_integer : NUMBER",
"signed_long_integer : long_integer",
"signed_long_integer : '-' long_integer",
"long_integer : NUMBER",
"function : aggregate_function",
"function : non_aggregate_function",
"non_aggregate_function : numeric_value_function",
"non_aggregate_function : string_value_function",
"non_aggregate_function : system_function_expression",
"aggregate_function : COUNT '(' '*' ')'",
"aggregate_function : COUNT '(' all_noise value ')'",
"aggregate_function : COUNT '(' DISTINCT value ')'",
"aggregate_function : SUM '(' all_noise value ')'",
"aggregate_function : SUM '(' DISTINCT value ')'",
"aggregate_function : AVG '(' all_noise value ')'",
"aggregate_function : AVG '(' DISTINCT value ')'",
"aggregate_function : MINIMUM '(' all_noise value ')'",
"aggregate_function : MINIMUM '(' DISTINCT value ')'",
"aggregate_function : MAXIMUM '(' all_noise value ')'",
"aggregate_function : MAXIMUM '(' DISTINCT value ')'",
"aggregate_function : LIST '(' all_noise value delimiter_opt ')'",
"aggregate_function : LIST '(' DISTINCT value delimiter_opt ')'",
"delimiter_opt : ',' value",
"delimiter_opt :",
"numeric_value_function : extract_expression",
"numeric_value_function : length_expression",
"extract_expression : EXTRACT '(' timestamp_part FROM value ')'",
"length_expression : bit_length_expression",
"length_expression : char_length_expression",
"length_expression : octet_length_expression",
"bit_length_expression : BIT_LENGTH '(' value ')'",
"char_length_expression : CHAR_LENGTH '(' value ')'",
"char_length_expression : CHARACTER_LENGTH '(' value ')'",
"octet_length_expression : OCTET_LENGTH '(' value ')'",
"system_function_expression : system_function_std_syntax '(' value_list_opt ')'",
"system_function_expression : system_function_special_syntax",
"system_function_std_syntax : ABS",
"system_function_std_syntax : ACOS",
"system_function_std_syntax : ASCII_CHAR",
"system_function_std_syntax : ASCII_VAL",
"system_function_std_syntax : ASIN",
"system_function_std_syntax : ATAN",
"system_function_std_syntax : ATAN2",
"system_function_std_syntax : BIN_AND",
"system_function_std_syntax : BIN_OR",
"system_function_std_syntax : BIN_SHL",
"system_function_std_syntax : BIN_SHR",
"system_function_std_syntax : BIN_XOR",
"system_function_std_syntax : CEIL",
"system_function_std_syntax : COS",
"system_function_std_syntax : COSH",
"system_function_std_syntax : COT",
"system_function_std_syntax : EXP",
"system_function_std_syntax : FLOOR",
"system_function_std_syntax : GEN_UUID",
"system_function_std_syntax : HASH",
"system_function_std_syntax : LEFT",
"system_function_std_syntax : LN",
"system_function_std_syntax : LOG",
"system_function_std_syntax : LOG10",
"system_function_std_syntax : LPAD",
"system_function_std_syntax : MAXVALUE",
"system_function_std_syntax : MINVALUE",
"system_function_std_syntax : MOD",
"system_function_std_syntax : PI",
"system_function_std_syntax : POSITION",
"system_function_std_syntax : POWER",
"system_function_std_syntax : RAND",
"system_function_std_syntax : REPLACE",
"system_function_std_syntax : REVERSE",
"system_function_std_syntax : RIGHT",
"system_function_std_syntax : ROUND",
"system_function_std_syntax : RPAD",
"system_function_std_syntax : SIGN",
"system_function_std_syntax : SIN",
"system_function_std_syntax : SINH",
"system_function_std_syntax : SQRT",
"system_function_std_syntax : TAN",
"system_function_std_syntax : TANH",
"system_function_std_syntax : TRUNC",
"system_function_special_syntax : DATEADD '(' value timestamp_part TO value ')'",
"system_function_special_syntax : DATEADD '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part FROM value TO value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value FOR value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value ')'",
"system_function_special_syntax : POSITION '(' value KW_IN value ')'",
"string_value_function : substring_function",
"string_value_function : trim_function",
"string_value_function : KW_UPPER '(' value ')'",
"string_value_function : KW_LOWER '(' value ')'",
"substring_function : SUBSTRING '(' value FROM value string_length_opt ')'",
"string_length_opt : FOR value",
"string_length_opt :",
"trim_function : TRIM '(' trim_specification value FROM value ')'",
"trim_function : TRIM '(' value FROM value ')'",
"trim_function : TRIM '(' trim_specification FROM value ')'",
"trim_function : TRIM '(' value ')'",
"trim_specification : BOTH",
"trim_specification : TRAILING",
"trim_specification : LEADING",
"udf : symbol_UDF_call_name '(' value_list ')'",
"udf : symbol_UDF_call_name '(' ')'",
"cast_specification : CAST '(' value AS data_type_descriptor ')'",
"case_expression : case_abbreviation",
"case_expression : case_specification",
"case_abbreviation : NULLIF '(' value ',' value ')'",
"case_abbreviation : IIF '(' search_condition ',' value ',' value ')'",
"case_abbreviation : COALESCE '(' value ',' value_list ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ',' value ')'",
"case_specification : simple_case",
"case_specification : searched_case",
"simple_case : CASE case_operand simple_when_clause END",
"simple_case : CASE case_operand simple_when_clause ELSE case_result END",
"simple_when_clause : WHEN when_operand THEN case_result",
"simple_when_clause : simple_when_clause WHEN when_operand THEN case_result",
"searched_case : CASE searched_when_clause END",
"searched_case : CASE searched_when_clause ELSE case_result END",
"searched_when_clause : WHEN search_condition THEN case_result",
"searched_when_clause : searched_when_clause WHEN search_condition THEN case_result",
"when_operand : value",
"case_operand : value",
"case_result : value",
"decode_pairs : value ',' value",
"decode_pairs : decode_pairs ',' value ',' value",
"next_value_expression : NEXT KW_VALUE FOR symbol_generator_name",
"next_value_expression : GEN_ID '(' symbol_generator_name ',' value ')'",
"timestamp_part : YEAR",
"timestamp_part : MONTH",
"timestamp_part : DAY",
"timestamp_part : HOUR",
"timestamp_part : MINUTE",
"timestamp_part : SECOND",
"timestamp_part : MILLISECOND",
"timestamp_part : WEEK",
"timestamp_part : WEEKDAY",
"timestamp_part : YEARDAY",
"all_noise : ALL",
"all_noise :",
"distinct_noise : DISTINCT",
"distinct_noise :",
"null_value : KW_NULL",
"symbol_UDF_call_name : SYMBOL",
"symbol_UDF_name : valid_symbol_name",
"symbol_blob_subtype_name : valid_symbol_name",
"symbol_character_set_name : valid_symbol_name",
"symbol_collation_name : valid_symbol_name",
"symbol_column_name : valid_symbol_name",
"symbol_constraint_name : valid_symbol_name",
"symbol_cursor_name : valid_symbol_name",
"symbol_domain_name : valid_symbol_name",
"symbol_exception_name : valid_symbol_name",
"symbol_filter_name : valid_symbol_name",
"symbol_gdscode_name : valid_symbol_name",
"symbol_generator_name : valid_symbol_name",
"symbol_index_name : valid_symbol_name",
"symbol_item_alias_name : valid_symbol_name",
"symbol_label_name : valid_symbol_name",
"symbol_ddl_name : valid_symbol_name",
"symbol_procedure_name : valid_symbol_name",
"symbol_role_name : valid_symbol_name",
"symbol_table_alias_name : valid_symbol_name",
"symbol_table_name : valid_symbol_name",
"symbol_trigger_name : valid_symbol_name",
"symbol_user_name : valid_symbol_name",
"symbol_variable_name : valid_symbol_name",
"symbol_view_name : valid_symbol_name",
"symbol_savepoint_name : valid_symbol_name",
"valid_symbol_name : SYMBOL",
"valid_symbol_name : non_reserved_word",
"non_reserved_word : ACTION",
"non_reserved_word : CASCADE",
"non_reserved_word : FREE_IT",
"non_reserved_word : RESTRICT",
"non_reserved_word : ROLE",
"non_reserved_word : TYPE",
"non_reserved_word : KW_BREAK",
"non_reserved_word : KW_DESCRIPTOR",
"non_reserved_word : SUBSTRING",
"non_reserved_word : COALESCE",
"non_reserved_word : LAST",
"non_reserved_word : LEAVE",
"non_reserved_word : LOCK",
"non_reserved_word : NULLIF",
"non_reserved_word : NULLS",
"non_reserved_word : STATEMENT",
"non_reserved_word : INSERTING",
"non_reserved_word : UPDATING",
"non_reserved_word : DELETING",
"non_reserved_word : FIRST",
"non_reserved_word : SKIP",
"non_reserved_word : BLOCK",
"non_reserved_word : BACKUP",
"non_reserved_word : KW_DIFFERENCE",
"non_reserved_word : IIF",
"non_reserved_word : SCALAR_ARRAY",
"non_reserved_word : WEEKDAY",
"non_reserved_word : YEARDAY",
"non_reserved_word : SEQUENCE",
"non_reserved_word : NEXT",
"non_reserved_word : RESTART",
"non_reserved_word : COLLATION",
"non_reserved_word : RETURNING",
"non_reserved_word : KW_IGNORE",
"non_reserved_word : LIMBO",
"non_reserved_word : UNDO",
"non_reserved_word : REQUESTS",
"non_reserved_word : TIMEOUT",
"non_reserved_word : ABS",
"non_reserved_word : ACCENT",
"non_reserved_word : ACOS",
"non_reserved_word : ALWAYS",
"non_reserved_word : ASCII_CHAR",
"non_reserved_word : ASCII_VAL",
"non_reserved_word : ASIN",
"non_reserved_word : ATAN",
"non_reserved_word : ATAN2",
"non_reserved_word : BIN_AND",
"non_reserved_word : BIN_OR",
"non_reserved_word : BIN_SHL",
"non_reserved_word : BIN_SHR",
"non_reserved_word : BIN_XOR",
"non_reserved_word : CEIL",
"non_reserved_word : COS",
"non_reserved_word : COSH",
"non_reserved_word : COT",
"non_reserved_word : DATEADD",
"non_reserved_word : DATEDIFF",
"non_reserved_word : DECODE",
"non_reserved_word : EXP",
"non_reserved_word : FLOOR",
"non_reserved_word : GEN_UUID",
"non_reserved_word : GENERATED",
"non_reserved_word : HASH",
"non_reserved_word : LIST",
"non_reserved_word : LN",
"non_reserved_word : LOG",
"non_reserved_word : LOG10",
"non_reserved_word : LPAD",
"non_reserved_word : MATCHED",
"non_reserved_word : MATCHING",
"non_reserved_word : MAXVALUE",
"non_reserved_word : MILLISECOND",
"non_reserved_word : MINVALUE",
"non_reserved_word : MOD",
"non_reserved_word : OVERLAY",
"non_reserved_word : PAD",
"non_reserved_word : PI",
"non_reserved_word : PLACING",
"non_reserved_word : POWER",
"non_reserved_word : PRESERVE",
"non_reserved_word : RAND",
"non_reserved_word : REPLACE",
"non_reserved_word : REVERSE",
"non_reserved_word : ROUND",
"non_reserved_word : RPAD",
"non_reserved_word : SIGN",
"non_reserved_word : SIN",
"non_reserved_word : SINH",
"non_reserved_word : SPACE",
"non_reserved_word : SQRT",
"non_reserved_word : TAN",
"non_reserved_word : TANH",
"non_reserved_word : TEMPORARY",
"non_reserved_word : TRUNC",
"non_reserved_word : WEEK",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif

//
// YYPOSN is user-defined text position type.
//
#ifndef YYPOSN
#define YYPOSN int
#endif

#ifdef YYREDUCEPOSNFUNC
#define YYCALLREDUCEPOSN(e)   \
	if(reduce_posn) {     \
	  YYREDUCEPOSNFUNC(yyps->pos, &(yyps->psp)[1-yym], &(yyps->vsp)[1-yym], \
			   yym, yyps->psp - yyps->ps, yychar, yyposn, e);       \
	  reduce_posn = 0;    \
	}

#ifndef YYCALLREDUCEPOSNARG
#define YYCALLREDUCEPOSNARG yyps->val
#endif


#define YYPOSNARG(n) ((yyps->psp)[1-yym+(n)-1])
#define YYPOSNOUT    (yyps->pos)
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEVAL
#define YYDELETEVAL(v, n) 
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEPOSN
#define YYDELETEPOSN(v, n) 
#endif

#define yyclearin (yychar=(-1))

#define yyerrok (yyps->errflag=0)

#ifndef YYSTACKGROWTH
#define YYSTACKGROWTH 16
#endif

#ifndef YYDEFSTACKSIZE
#define YYDEFSTACKSIZE 12
#endif

#ifdef YYDEBUG
int yydebug;
#endif

int yynerrs;

/* These value/posn are taken from the lexer */
YYSTYPE yylval;
YYPOSN  yyposn;

/* These value/posn of the root non-terminal are returned to the caller */
YYSTYPE yyretlval;
YYPOSN  yyretposn;

#define YYABORT  goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#define YYVALID         do { if (yyps->save)          goto yyvalid; } while(0)
#define YYVALID_NESTED  do { if (yyps->save && \
                                 yyps->save->save==0) goto yyvalid; } while(0)

struct yyparsestate {
  yyparsestate *save;        // Previously saved parser state
  int           state;
  int           errflag;
  Yshort       *ssp;         // state stack pointer
  YYSTYPE      *vsp;         // value stack pointer
  YYPOSN       *psp;         // position stack pointer
  YYSTYPE       val;         // value as returned by actions
  YYPOSN        pos;         // position as returned by universal action
  Yshort       *ss;          // state stack base
  YYSTYPE      *vs;          // values stack base
  YYPOSN       *ps;          // position stack base
  int           lexeme;      // index of the conflict lexeme in the lexical queue
  unsigned int  stacksize;   // current maximum stack size
  Yshort        ctry;        // index in yyctable[] for this conflict
};

// Current parser state
static yyparsestate *yyps=0;

// yypath!=NULL: do the full parse, starting at *yypath parser state.
static yyparsestate *yypath=0;

// Base of the lexical value queue
static YYSTYPE *yylvals=0;

// Current posistion at lexical value queue
static YYSTYPE *yylvp=0;

// End position of lexical value queue
static YYSTYPE *yylve=0;

// The last allocated position at the lexical value queue
static YYSTYPE *yylvlim=0;

// Base of the lexical position queue
static YYPOSN *yylpsns=0;

// Current posistion at lexical position queue
static YYPOSN *yylpp=0;

// End position of lexical position queue
static YYPOSN *yylpe=0;

// The last allocated position at the lexical position queue
static YYPOSN *yylplim=0;

// Current position at lexical token queue
static Yshort *yylexp=0;

static Yshort *yylexemes=0;

//
// For use in generated program
//
#define yytrial (yyps->save)
#define yyvsp   (yyps->vsp)
#define yyval   (yyps->val)
#define yydepth (yyps->ssp - yyps->ss)


//
// Local prototypes.
//
int dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous);

int  YYLex1(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous);
int  yyexpand();
void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size);
void YYPCopy(YYPOSN  *to, YYPOSN  *from, int size);
void YYMoreStack(yyparsestate *yyps);
yyparsestate *YYNewState(int size);
void YYFreeState(yyparsestate *p);




/*
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		lex.c
 *	DESCRIPTION:	Lexical routine
 *
 */


void LEX_dsql_init (void)
{
/**************************************
 *
 *	L E X _ d s q l _ i n i t
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX for processing.  This is called only once
 *	per session.
 *
 **************************************/
	for (const TOK* token = KEYWORD_getTokens(); token->tok_string; ++token)
	{
		DSQL_SYM symbol = FB_NEW_RPT(*DSQL_permanent_pool, 0) dsql_sym;
		symbol->sym_string = (TEXT *) token->tok_string;
		symbol->sym_length = strlen(token->tok_string);
		symbol->sym_type = SYM_keyword;
		symbol->sym_keyword = token->tok_ident;
		symbol->sym_version = token->tok_version;
		dsql_str* str = FB_NEW_RPT(*DSQL_permanent_pool, symbol->sym_length) dsql_str;
		str->str_length = symbol->sym_length;
		strncpy((char*)str->str_data, (char*)symbol->sym_string, symbol->sym_length);
		symbol->sym_object = (void *) str;
		HSHD_insert(symbol);
	}
}


void LEX_string (
	const TEXT* string,
	USHORT	length,
	SSHORT	character_set)
{
/**************************************
 *
 *	L E X _ s t r i n g
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX to process a string.
 *
 **************************************/

	lex.line_start = lex.ptr = string;
	lex.end = string + length;
	lex.lines = 1;
	lex.att_charset = character_set;
	lex.line_start_bk = lex.line_start;
	lex.lines_bk = lex.lines;
	lex.param_number = 1;
	lex.prev_keyword = -1;
#ifdef DSQL_DEBUG
	if (DSQL_debug & 32)
		dsql_trace("Source DSQL string:\n%.*s", (int)length, string);
#endif
}


static const TEXT* lex_position (void)
{
/**************************************
 *
 *	l e x _ p o s i t i o n
 *
 **************************************
 *
 * Functional description
 *	Return the current position of LEX 
 *	in the input string.
 *
 **************************************/

	return lex.ptr;
}


#ifdef NOT_USED_OR_REPLACED
static bool long_int(dsql_nod* string,
					 SLONG *long_value)
{
/*************************************
 *
 *	l o n g _ i n t
 * 
 *************************************
 *
 * Functional description
 *	checks for all digits in the
 *	number and return an atol().
 *
 *************************************/

	for (const UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; 
		 classes(*p) & CHR_DIGIT; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	*long_value = atol(((dsql_str*) string)->str_data);

	return true;
}
#endif

static dsql_fld* make_field (dsql_nod* field_name)
{
/**************************************
 *
 *	m a k e _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Make a field block of given name.
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	if (field_name == NULL)
	{
		dsql_fld* field =
			FB_NEW_RPT(*tdsql->getDefaultPool(), sizeof (INTERNAL_FIELD_NAME)) dsql_fld;
		strcpy (field->fld_name, INTERNAL_FIELD_NAME);
		return field;
	}
	const dsql_str* string = (dsql_str*) field_name->nod_arg[1];
	dsql_fld* field =
		FB_NEW_RPT(*tdsql->getDefaultPool(), strlen ((SCHAR*) string->str_data)) dsql_fld;
	strcpy (field->fld_name, (TEXT*) string->str_data);
	field->fld_type_of_name = NULL;
	field->fld_explicit_collation = false;
	field->fld_not_nullable = false;
	field->fld_full_domain = false;

	return field;
}


static dsql_fil* make_file()
{
/**************************************
 *
 *	m a k e _ f i l e 
 *
 **************************************
 *
 * Functional description
 *	Make a file block
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();
		   
	dsql_fil* temp_file = FB_NEW(*tdsql->getDefaultPool()) dsql_fil;

	return temp_file;
}


static dsql_nod* make_list (dsql_nod* node)
{
/**************************************
 *
 *	m a k e _ l i s t
 *
 **************************************
 *
 * Functional description
 *	Collapse nested list nodes into single list.
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	if (node)
	{
		DsqlNodStack stack;
		stack_nodes(node, stack);
		USHORT l = stack.getCount();

		const dsql_nod* old = node;
		node = FB_NEW_RPT(*tdsql->getDefaultPool(), l) dsql_nod;
		node->nod_count = l;
		node->nod_type = nod_list;
		node->nod_line = (USHORT) lex.lines_bk;
		node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
		if (MemoryPool::blk_type(old) == dsql_type_nod)
		{
			node->nod_flags = old->nod_flags;
		}
		dsql_nod** ptr = node->nod_arg + node->nod_count;

		while (stack.hasData())
			*--ptr = stack.pop();
	}

	return node;
}


static dsql_nod* make_parameter (void)
{
/**************************************
 *
 *	m a k e _ p a r a m e t e r
 *
 **************************************
 *
 * Functional description
 *	Make parameter node
 *	Any change should also be made to function below
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), e_par_count) dsql_nod;
	node->nod_type = nod_parameter;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = e_par_count;
	node->nod_arg[e_par_index] = (dsql_nod*)(IPTR) lex.param_number++;

	return node;
}


static dsql_nod* make_node (NOD_TYPE	type,
						   int count,
						   ...)
{
/**************************************
 *
 *	m a k e _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type.
 *	Any change should also be made to function below
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


static dsql_nod* make_flag_node (NOD_TYPE	type,
								SSHORT	flag,
								int		count,
								...)
{
/**************************************
 *
 *	m a k e _ f l a g _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type. Set flag field
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_flags = flag;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


static void prepare_console_debug (int level, int *yydeb)
{
/*************************************
 *
 *	p r e p a r e _ c o n s o l e _ d e b u g
 * 
 *************************************
 *
 * Functional description
 *	Activate debug info. In WinNT, redirect the standard
 *	output so one can see the generated information.
 *	Feel free to add your platform specific code.
 *
 *************************************/
#ifdef DSQL_DEBUG
	DSQL_debug = level;
#endif
	if (level >> 8)
		*yydeb = level >> 8;
}

#ifdef NOT_USED_OR_REPLACED
static bool short_int(dsql_nod* string,
					  SLONG *long_value,
					  SSHORT range)
{
/*************************************
 *
 *	s h o r t _ i n t
 * 
 *************************************
 *
 * Functional description
 *	is the string a valid representation 
 *	of a positive short int?
 *
 *************************************/

	if (((dsql_str*) string)->str_length > 5) {
		return false;
	}

	for (UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; 
		classes(*p) & CHR_DIGIT; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	/* there are 5 or fewer digits, it's value may still be greater
	 * than 32767... */

	SCHAR buf[10];	
	buf[0] = ((dsql_str*) string)->str_data[0];
	buf[1] = ((dsql_str*) string)->str_data[1];
	buf[2] = ((dsql_str*) string)->str_data[2];
	buf[3] = ((dsql_str*) string)->str_data[3];
	buf[4] = ((dsql_str*) string)->str_data[4];
	buf[5] = '\0';

	*long_value = atoi (buf);

	bool return_value;

	switch (range) 
	{
		case POSITIVE:
			return_value = *long_value > SHRT_POS_MAX;
			break;
		case NEGATIVE:
			return_value = *long_value > SHRT_NEG_MAX;
			break;
		case UNSIGNED:
			return_value = *long_value > SHRT_UNSIGNED_MAX;
			break;
	}
	return !return_value;
}
#endif

static void stack_nodes (dsql_nod*	node,
						 DsqlNodStack& stack)
{
/**************************************
 *
 *	s t a c k _ n o d e s
 *
 **************************************
 *
 * Functional description
 *	Assist in turning a tree of misc nodes into a clean list.
 *
 **************************************/
	if (node->nod_type != nod_list)
	{
		stack.push(node);
		return;
	}

	/* To take care of cases where long lists of nodes are in a chain
	   of list nodes with exactly one entry, this algorithm will look
	   for a pattern of repeated list nodes with two entries, the first
	   being a list node and the second being a non-list node.   Such
	   a list will be reverse linked, and then re-reversed, stacking the
	   non-list nodes in the process.   The purpose of this is to avoid
	   massive recursion of this function. */

	dsql_nod* start_chain = node;
	dsql_nod* end_chain = NULL;
	dsql_nod* curr_node = node;
	dsql_nod* next_node = node->nod_arg[0];
	while ( curr_node->nod_count == 2 &&
			curr_node->nod_arg[0]->nod_type == nod_list &&
			curr_node->nod_arg[1]->nod_type != nod_list &&
			next_node->nod_arg[0]->nod_type == nod_list &&
			next_node->nod_arg[1]->nod_type != nod_list)
	{

		/* pattern was found so reverse the links and go to next node */

		dsql_nod* save_link = next_node->nod_arg[0];
		next_node->nod_arg[0] = curr_node;
		curr_node = next_node;
		next_node = save_link;
		end_chain = curr_node;
	}

	/* see if any chain was found */

	if (end_chain)
	{

		/* first, handle the rest of the nodes */
		/* note that next_node still points to the first non-pattern node */

		stack_nodes (next_node, stack);

		/* stack the non-list nodes and reverse the chain on the way back */
		
		curr_node = end_chain;
		while (true)
		{
			stack.push(curr_node->nod_arg[1]);
			if ( curr_node == start_chain)
				break;
			dsql_nod* save_link = curr_node->nod_arg[0];
			curr_node->nod_arg[0] = next_node;
			next_node = curr_node;
			curr_node = save_link;
		}
		return;
	}

	dsql_nod** ptr = node->nod_arg;
	for (const dsql_nod* const* const end = ptr + node->nod_count; ptr < end; ptr++)
		stack_nodes (*ptr, stack);
}

inline static int yylex (
	USHORT	client_dialect,
	USHORT	db_dialect,
	USHORT	parser_version,
	bool* stmt_ambiguous)
{
	lex.prev_keyword =
		lex.yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
	return lex.prev_keyword;
}

int LexerState::yylex (
	USHORT	client_dialect,
	USHORT	db_dialect,
	USHORT	parser_version,
	bool* stmt_ambiguous)
{
/**************************************
 *
 *	y y l e x
 *
 **************************************
 *
 * Functional description: lexer.
 *
 **************************************/
	UCHAR	tok_class;
	char  string[MAX_TOKEN_LEN];
	SSHORT	c;

	/* Find end of white space and skip comments */

	for (;;)
	{
		if (ptr >= end)
			return -1;

		c = *ptr++;

		/* Process comments */

		if (c == '\n') {
			lines++;
			line_start = ptr;
			continue;
		}

		if ((c == '-') && (*ptr == '-'))
		{
			
			/* single-line */
			
			ptr++;
			while (ptr < end) {
				if ((c = *ptr++) == '\n') {
					lines++;
					line_start = ptr /* + 1*/; /* CVC: +1 left out. */
					break;
				}
			}
			if (ptr >= end)
				return -1;
			continue;
		}
		else if ((c == '/') && (*ptr == '*'))
		{
			
			/* multi-line */
			
			const TEXT& start_block = ptr[-1];
			ptr++;
			while (ptr < end) {
				if ((c = *ptr++) == '*') {
					if (*ptr == '/')
						break;
				}
				if (c == '\n') {
					lines++;
					line_start = ptr /* + 1*/; /* CVC: +1 left out. */

				}
			}
			if (ptr >= end)
			{
				// I need this to report the correct beginning of the block,
				// since it's not a token really.
				last_token = &start_block;
				yyerror("unterminated block comment");
				return -1;
			}
			ptr++;
			continue;
		}

		tok_class = classes(c);

		if (!(tok_class & CHR_WHITE))
			break;
	}

	/* Depending on tok_class of token, parse token */

	last_token = ptr - 1;

	if (tok_class & CHR_INTRODUCER)
	{
		/* The Introducer (_) is skipped, all other idents are copied
		 * to become the name of the character set
		 */
		char* p = string;
		for (; ptr < end && classes(*ptr) & CHR_IDENT; ptr++)
		{
			if (ptr >= end)
				return -1;
			check_copy_incr(p, UPPER7(*ptr), string);
		}
		
		check_bound(p, string);
		*p = 0;

		/* make a string value to hold the name, the name 
		 * is resolved in pass1_constant */

		yylval = (dsql_nod*) (MAKE_string(string, p - string))->str_data;

		return INTRODUCER;
	}

	/* parse a quoted string, being sure to look for double quotes */

	if (tok_class & CHR_QUOTE)
	{
		char* buffer = string;
		size_t buffer_len = sizeof (string);
		const char* buffer_end = buffer + buffer_len - 1;
		char* p;
		for (p = buffer; ; ++p)
		{
			if (ptr >= end)
			{
				if (buffer != string)
					gds__free (buffer);
				yyerror("unterminated string");
				return -1;
			}
			// Care about multi-line constants and identifiers
			if (*ptr == '\n') {
				lines++;
				line_start = ptr + 1;
			}
			/* *ptr is quote - if next != quote we're at the end */
			if ((*ptr == c) && ((++ptr == end) || (*ptr != c)))
				break;
			if (p > buffer_end)
			{
				char* const new_buffer = (char*) gds__alloc (2 * buffer_len);
			/* FREE: at outer block */
				if (!new_buffer)		/* NOMEM: */
				{
					if (buffer != string)
						gds__free (buffer);
					return -1;
				}
				memcpy (new_buffer, buffer, buffer_len);
				if (buffer != string)
					gds__free (buffer);
				buffer = new_buffer;
				p = buffer + buffer_len;
				buffer_len = 2 * buffer_len;
				buffer_end = buffer + buffer_len - 1;
			}
			*p = *ptr++;
		}
		if (c == '"')
		{
			*stmt_ambiguous = true; /* string delimited by double quotes could be
					**   either a string constant or a SQL delimited
					**   identifier, therefore marks the SQL
					**   statement as ambiguous  */
			if (client_dialect == SQL_DIALECT_V6_TRANSITION)
			{
				if (buffer != string)
					gds__free (buffer);
				yyabandon (-104, isc_invalid_string_constant);
			}
			else if (client_dialect >= SQL_DIALECT_V6)
			{
				if ((p - buffer) >= MAX_TOKEN_LEN)
				{
					if (buffer != string)
						gds__free (buffer);
					yyabandon (-104, isc_token_too_long);
				}
				yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
				dsql_str* delimited_id_str = (dsql_str*) yylval;
				delimited_id_str->str_flags |= STR_delimited_id;
				if (buffer != string)
					gds__free (buffer);
				return SYMBOL;
			}
		}
		yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
		if (buffer != string)
			gds__free (buffer);
		return STRING;
	}
												 
/* 
 * Check for a numeric constant, which starts either with a digit or with
 * a decimal point followed by a digit.
 * 
 * This code recognizes the following token types:
 * 
 * NUMBER: string of digits which fits into a 32-bit integer
 * 
 * NUMBER64BIT: string of digits whose value might fit into an SINT64,
 *   depending on whether or not there is a preceding '-', which is to
 *   say that "9223372036854775808" is accepted here.
 *
 * SCALEDINT: string of digits and a single '.', where the digits
 *   represent a value which might fit into an SINT64, depending on
 *   whether or not there is a preceding '-'.
 *
 * FLOAT: string of digits with an optional '.', and followed by an "e"
 *   or "E" and an optionally-signed exponent.
 *
 * NOTE: we swallow leading or trailing blanks, but we do NOT accept
 *   embedded blanks:
 *
 * Another note: c is the first character which need to be considered,
 *   ptr points to the next character.
 */

	fb_assert(ptr <= end);

	if ((tok_class & CHR_DIGIT) ||
		((c == '.') && (ptr < end) && (classes(*ptr) & CHR_DIGIT)))
	{
		/* The following variables are used to recognize kinds of numbers. */

		bool have_error	 = false;	/* syntax error or value too large */
		bool have_digit	 = false;	/* we've seen a digit			  */
		bool have_decimal   = false;	/* we've seen a '.'				*/
		bool have_exp	   = false;	/* digit ... [eE]				  */
		bool have_exp_sign  = false; /* digit ... [eE] {+-]			 */
		bool have_exp_digit = false; /* digit ... [eE] ... digit		*/
		FB_UINT64 number		= 0;
		FB_UINT64 limit_by_10	= MAX_SINT64 / 10;

		for (--ptr ; ptr < end ; ptr++)
		{
			c = *ptr;
			if (have_exp_digit && (! (classes(c) & CHR_DIGIT)))
				/* First non-digit after exponent and digit terminates
				 the token. */
				break;
			else if (have_exp_sign && (! (classes(c) & CHR_DIGIT)))
			{
				/* only digits can be accepted after "1E-" */
				have_error = true;
				break;
			}
			else if (have_exp)
			{
				/* We've seen e or E, but nothing beyond that. */
				if ( ('-' == c) || ('+' == c) )
					have_exp_sign = true;
				else if ( classes(c) & CHR_DIGIT )
					/* We have a digit: we haven't seen a sign yet,
					but it's too late now. */
					have_exp_digit = have_exp_sign  = true;
				else
				{
					/* end of the token */
					have_error = true;
					break;
				}
			}
			else if ('.' == c)
			{
				if (!have_decimal)
					have_decimal = true;
				else
				{
					have_error = true;
					break;
				}
			}
			else if (classes(c) & CHR_DIGIT)
			{
				/* Before computing the next value, make sure there will be
				   no overflow.  */

				have_digit = true;

				if (number >= limit_by_10)
				{
				/* possibility of an overflow */
					if ((number > limit_by_10) || (c > '8'))
					{
						have_error = true;
						break;
					}
				}
				number = number * 10 + (c - '0');
			}
			else if ( (('E' == c) || ('e' == c)) && have_digit )
				have_exp = true;
			else
				/* Unexpected character: this is the end of the number. */
				break;
		}

		/* We're done scanning the characters: now return the right kind
		   of number token, if any fits the bill. */

		if (!have_error)
		{
			fb_assert(have_digit);

			if (have_exp_digit)
			{
				yylval = (dsql_nod*) MAKE_string(last_token, ptr - last_token);
				last_token_bk = last_token;
				line_start_bk = line_start;
				lines_bk = lines;

				return FLOAT_NUMBER;
			}
			else if (!have_exp)
			{

				/* We should return some kind (scaled-) integer type
				   except perhaps in dialect 1. */

				if (!have_decimal && (number <= MAX_SLONG))
				{
					yylval = (dsql_nod*) (IPTR) number;
					//printf ("parse.y %p %d\n", yylval, number);
					return NUMBER;
				}
				else
				{
					/* We have either a decimal point with no exponent
					   or a string of digits whose value exceeds MAX_SLONG:
					   the returned type depends on the client dialect,
					   so warn of the difference if the client dialect is
					   SQL_DIALECT_V6_TRANSITION.
					*/

					if (SQL_DIALECT_V6_TRANSITION == client_dialect)
					{
						/* Issue a warning about the ambiguity of the numeric
						 * numeric literal.  There are multiple calls because
						 * the message text exceeds the 119-character limit
						 * of our message database.
						 */
						ERRD_post_warning( isc_dsql_warning_number_ambiguous,
							   isc_arg_string,
							   ERR_string( last_token, ptr - last_token ),
							   isc_arg_end );
						ERRD_post_warning( isc_dsql_warning_number_ambiguous1,
							   isc_arg_end );
					}

					yylval = (dsql_nod*) MAKE_string(last_token, ptr - last_token);

					last_token_bk = last_token;
					line_start_bk = line_start;
					lines_bk = lines;

					if (client_dialect < SQL_DIALECT_V6_TRANSITION)
						return FLOAT_NUMBER;
					else if (have_decimal)
						return SCALEDINT;
					else
						return NUMBER64BIT;
				}
			} /* else if (!have_exp) */
		} /* if (!have_error) */

		/* we got some kind of error or overflow, so don't recognize this
		 * as a number: just pass it through to the next part of the lexer.
		 */
	}

	/* Restore the status quo ante, before we started our unsuccessful
	   attempt to recognize a number. */
	ptr = last_token;
	c   = *ptr++;
	/* We never touched tok_class, so it doesn't need to be restored. */

	/* end of number-recognition code */


	if (tok_class & CHR_LETTER)
	{
		char* p = string;
		check_copy_incr(p, UPPER (c), string);
		for (; ptr < end && classes(*ptr) & CHR_IDENT; ptr++)
		{
			if (ptr >= end)
				return -1;
			check_copy_incr(p, UPPER (*ptr), string);
		}

		check_bound(p, string);
		*p = 0;
		dsql_sym* sym =
			HSHD_lookup (NULL, (TEXT *) string, (SSHORT)(p - string), SYM_keyword, parser_version);
		if (sym && (sym->sym_keyword != COMMENT || prev_keyword == -1))
		{
			yylval = (dsql_nod*) sym->sym_object;
			last_token_bk = last_token;
			line_start_bk = line_start;
			lines_bk = lines;
			return sym->sym_keyword;
		}
		yylval = (dsql_nod*) MAKE_string(string, p - string);
		last_token_bk = last_token;
		line_start_bk = line_start;
		lines_bk = lines;
		return SYMBOL;
	}

	/* Must be punctuation -- test for double character punctuation */

	if (last_token + 1 < end)
	{
		dsql_sym* sym =
			HSHD_lookup (NULL, last_token, (SSHORT) 2, SYM_keyword, (USHORT) parser_version);
		if (sym)
		{
			++ptr;
			return sym->sym_keyword;
		}
	}
		
	/* Single character punctuation are simply passed on */

	return (UCHAR) c;
}


static void yyerror_detailed(const TEXT* error_string, int yychar, YYSTYPE&, YYPOSN&)
{
/**************************************
 *
 *	y y e r r o r _ d e t a i l e d
 *
 **************************************
 *
 * Functional description
 *	Print a syntax error.
 *
 **************************************/
	const TEXT* line_start = lex.line_start;
	SLONG lines = lex.lines;
	if (lex.last_token < lex.line_start)
	{
		line_start = lex.line_start_bk;
		lines--;
	}

	if (yychar < 1)
		ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104,
			isc_arg_gds, isc_command_end_err2,	/* Unexpected end of command */
			isc_arg_number, lines,
			isc_arg_number, (SLONG) (lex.last_token - line_start + 1),
			isc_arg_end);
	else
	{
		ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104,
			/* Token unknown - line %d, column %d */
			isc_arg_gds, isc_dsql_token_unk_err,
			isc_arg_number, (SLONG) lines,
			isc_arg_number, (SLONG) (lex.last_token - line_start + 1), /*CVC: +1*/
			/* Show the token */
			isc_arg_gds, isc_random,
			isc_arg_cstring, (int) (lex.ptr - lex.last_token), lex.last_token,
			isc_arg_end);
	}
}


// The argument passed to this function is ignored. Therefore, messages like
// "syntax error" and "yacc stack overflow" are never seen.
static void yyerror(const TEXT* error_string)
{
	YYSTYPE errt_value =  0;
	YYPOSN errt_posn = -1;
	yyerror_detailed(error_string, -1, errt_value, errt_posn);
}


static void yyabandon (SLONG		sql_code,
					   ISC_STATUS	error_symbol)
{
/**************************************
 *
 *	y y a b a n d o n
 *
 **************************************
 *
 * Functional description
 *	Abandon the parsing outputting the supplied string
 *
 **************************************/

	ERRD_post (isc_sqlerr, isc_arg_number, sql_code,
		isc_arg_gds, error_symbol, isc_arg_end);
}


//
// Parser function
//
int dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous) {
  int yym, yyn, yystate, yychar, yynewerrflag;
  yyparsestate *yyerrctx = NULL;
  int reduce_posn;

#if YYDEBUG
  char *yys;
  
  if ((yys = getenv("YYDEBUG"))) {
    yyn = *yys;
    if (yyn >= '0' && yyn <= '9')
      yydebug = yyn - '0'; 
  }
#endif
  
  yyps = YYNewState(YYDEFSTACKSIZE);
  yyps->save = 0;
  yynerrs = 0;
  yyps->errflag = 0;
  yychar = (-1);
  
  yyps->ssp = yyps->ss;
  yyps->vsp = yyps->vs;
  yyps->psp = yyps->ps;
  *(yyps->ssp) = yystate = 0;
  

  //
  // Main parsing loop
  //
 yyloop:
  if ((yyn = yydefred[yystate])) {
    goto yyreduce;
  }

  //
  // Read one token
  //
  if (yychar < 0) {
    if ((yychar = YYLex1(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) yychar = 0;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, reading %d (%s)", 
	     int(yydepth), yytrial, yystate, yychar, yys);
#ifdef YYDBPR
      printf("<");
      YYDBPR(yylval);
      printf(">");
#endif
      printf("\n"); 
    }
#endif
  }

  //
  // Do we have a conflict?
  //
  if ((yyn = yycindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    int ctry;

    if (yypath) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d: following successful trial parse\n", 
	       int(yydepth), yytrial, yystate);
      }
#endif
      // Switch to the next conflict context
      yyparsestate *save = yypath;
      yypath = save->save;
      ctry = save->ctry;
      if (save->state != yystate) 
        goto yyabort;
      YYFreeState(save); 

    } else {

#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d. ", 
	       int(yydepth), yytrial, yystate);
        if(yyps->save) {
          printf("ALREADY in conflict. Continue trial parse.");
        } else {
          printf("Start trial parse.");
        }
        printf("\n");
      }
#endif
      yyparsestate *save = YYNewState(yyps->ssp - yyps->ss);
      save->save    = yyps->save;
      save->state   = yystate;
      save->errflag = yyps->errflag;
      save->ssp     = save->ss + (yyps->ssp - yyps->ss);
      save->vsp     = save->vs + (yyps->vsp - yyps->vs);
      save->psp     = save->ps + (yyps->psp - yyps->ps);
      memcpy (save->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(save->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(save->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      ctry = yytable[yyn];
      if (yyctable[ctry] == -1) {
#if YYDEBUG
        if (yydebug && yychar >= 0)
          printf("yydebug[%p]: backtracking 1 token\n", yytrial);
#endif
        ctry++; 
      }
      save->ctry = ctry;
      if (!yyps->save) {
        // If this is a first conflict in the stack, start saving lexemes
        if (!yylexemes) {
          yylexemes = new Yshort[YYSTACKGROWTH];
          yylvals = new YYSTYPE[YYSTACKGROWTH];
          yylvlim = yylvals + YYSTACKGROWTH; 
          yylpsns = new YYPOSN[YYSTACKGROWTH];
          yylplim = yylpsns + YYSTACKGROWTH; 
        }
        if (yylvp == yylve) {
          yylvp = yylve = yylvals;
	  yylpp = yylpe = yylpsns;
          yylexp = yylexemes;
          if (yychar >= 0) {
            *yylve++ = yylval;
            *yylpe++ = yyposn;
            *yylexp = yychar;
            yychar = -1; 
          } 
        } 
      }
      if (yychar >= 0) {
        yylvp--, yylpp--, yylexp--;
        yychar = -1; 
      }
      save->lexeme = yylvp - yylvals;
      yyps->save = save; 
    }
    if (yytable[yyn] == ctry) {
#if YYDEBUG
      if (yydebug)
        printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
               int(yydepth), yytrial, yystate, yyctable[ctry]);
#endif
      if (yychar < 0)
        yylvp++, yylpp++, yylexp++;
      yychar = -1;
      if (yyps->errflag > 0) --yyps->errflag;
      yystate = yyctable[ctry];
      goto yyshift; 
    } else {
      yyn = yyctable[ctry];
      goto yyreduce; 
    } 
  }

  //
  // Is action a shift?
  //
  if ((yyn = yysindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
             int(yydepth), yytrial, yystate, yytable[yyn]);
#endif
    yychar = (-1);
    if (yyps->errflag > 0)  --yyps->errflag;
    yystate = yytable[yyn];
  yyshift:
    if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
      YYMoreStack(yyps);
    }
    *++(yyps->ssp) = yystate;
    *++(yyps->vsp) = yylval;
    *++(yyps->psp) = yyposn;
    goto yyloop;
  }
  if ((yyn = yyrindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    yyn = yytable[yyn];
    goto yyreduce;
  }

  //
  // Action: error
  //
  if (yyps->errflag) goto yyinrecovery;
  yynewerrflag = 1;
  goto yyerrhandler;
yyerrlab:
  yynewerrflag = 0;
yyerrhandler:
  while (yyps->save) { 
    int ctry; 
    yyparsestate *save = yyps->save;
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
             int(yydepth), yytrial, yystate, yyps->save->state, int(yylvp - yylvals - yyps->save->lexeme));
#endif
    // Memorize most forward-looking error state in case
    // it's really an error.
    if(yyerrctx==NULL || yyerrctx->lexeme<yylvp-yylvals) {
      // Free old saved error context state
      if(yyerrctx) YYFreeState(yyerrctx);
      // Create and fill out new saved error context state
      yyerrctx = YYNewState(yyps->ssp - yyps->ss);
      yyerrctx->save = yyps->save;
      yyerrctx->state = yystate;
      yyerrctx->errflag = yyps->errflag;
      yyerrctx->ssp = yyerrctx->ss + (yyps->ssp - yyps->ss);
      yyerrctx->vsp = yyerrctx->vs + (yyps->vsp - yyps->vs);
      yyerrctx->psp = yyerrctx->ps + (yyps->psp - yyps->ps);
      memcpy (yyerrctx->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(yyerrctx->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(yyerrctx->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      yyerrctx->lexeme = yylvp - yylvals;
    }
    yylvp  = yylvals   + save->lexeme;
    yylpp  = yylpsns   + save->lexeme;
    yylexp = yylexemes + save->lexeme;
    yychar = -1;
    yyps->ssp = yyps->ss + (save->ssp - save->ss);
    yyps->vsp = yyps->vs + (save->vsp - save->vs);
    yyps->psp = yyps->ps + (save->psp - save->ps);
    memcpy (yyps->ss, save->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
    YYSCopy(yyps->vs, save->vs,  yyps->vsp - yyps->vs + 1);
    YYPCopy(yyps->ps, save->ps,  yyps->psp - yyps->ps + 1);
    ctry = ++save->ctry;
    yystate = save->state;
    // We tried shift, try reduce now
    if ((yyn = yyctable[ctry]) >= 0) {
      goto yyreduce;
    }
    yyps->save = save->save;
    YYFreeState(save);
    //
    // Nothing left on the stack -- error
    //
    if (!yyps->save) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%p]: trial parse FAILED, entering ERROR mode\n", 
	       yytrial);
      }
#endif
      // Restore state as it was in the most forward-advanced error
      yylvp  = yylvals   + yyerrctx->lexeme;
      yylpp  = yylpsns   + yyerrctx->lexeme;
      yylexp = yylexemes + yyerrctx->lexeme;
      yychar = yylexp[-1];
      yylval = yylvp[-1];
      yyposn = yylpp[-1];
      yyps->ssp = yyps->ss + (yyerrctx->ssp - yyerrctx->ss);
      yyps->vsp = yyps->vs + (yyerrctx->vsp - yyerrctx->vs);
      yyps->psp = yyps->ps + (yyerrctx->psp - yyerrctx->ps);
      memcpy (yyps->ss, yyerrctx->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      YYSCopy(yyps->vs, yyerrctx->vs,  yyps->vsp - yyps->vs + 1);
      YYPCopy(yyps->ps, yyerrctx->ps,  yyps->psp - yyps->ps + 1);
      yystate = yyerrctx->state;
      YYFreeState(yyerrctx);
      yyerrctx = NULL;
    }
    yynewerrflag = 1; 
  }
  if (yynewerrflag) {
#ifdef YYERROR_DETAILED
    yyerror_detailed("syntax error", yychar, yylval, yyposn);
#else
    yyerror("syntax error");
#endif
  }
  ++yynerrs;
 yyinrecovery:
  if (yyps->errflag < 3) {
    yyps->errflag = 3;
    for (;;) {
      if ((yyn = yysindex[*(yyps->ssp)]) && 
	  (yyn += YYERRCODE) >= 0 &&
          yyn <= YYTABLESIZE && 
	  yycheck[yyn] == YYERRCODE) {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: state %d, ERROR recovery shifts to state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp), yytable[yyn]);
#endif
        /* Use label yyerrlab, so that compiler does not warn */
        if(yyps->errflag != yyps->errflag) goto yyerrlab;
        yystate = yytable[yyn];
        goto yyshift; 
      } else {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: ERROR recovery discards state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp));
#endif
        if (yyps->ssp <= yyps->ss) {
	  goto yyabort;
	}
	if(!yytrial) {
	  YYDELETEVAL(yyps->vsp[0],1);
	  YYDELETEPOSN(yyps->psp[0],1);
	}
        --(yyps->ssp);
        --(yyps->vsp);
        --(yyps->psp);
      }
    }
  } else {
    if (yychar == 0) goto yyabort;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, ERROR recovery discards token %d (%s)\n",
             int(yydepth), yytrial, yystate, yychar, yys); 
    }
#endif
    if(!yytrial) {
      YYDELETEVAL(yylval,0);
      YYDELETEPOSN(yyposn,0);
    }
    yychar = (-1);
    goto yyloop;
  }

  //
  // Reduce the rule
  //
yyreduce:
  yym = yylen[yyn];
#if YYDEBUG
  if (yydebug) {
    printf("yydebug[%d,%p]: state %d, reducing by rule %d (%s)",
           int(yydepth), yytrial, yystate, yyn, yyrule[yyn]);
#ifdef YYDBPR
    if (yym) {
      int i;
      printf("<");
      for (i=yym; i>0; i--) {
        if (i!=yym) printf(", ");
        YYDBPR((yyps->vsp)[1-i]);
      }
      printf(">");
    }
#endif
    printf("\n");
  }
#endif
  if (yyps->ssp + 1 - yym >= yyps->ss + yyps->stacksize) {
    YYMoreStack(yyps);
  }

  /* default action - assign last argument as in standard yacc */
  yyps->val = yyvsp[1 - yym];

  /* default reduced position is NULL -- no position at all.
     no position will be assigned at trial time and if no position handling is present */
  memset(&yyps->pos, 0, sizeof(yyps->pos));

  reduce_posn = TRUE;

  switch (yyn) {

case 1:
  if (!yytrial)
{ DSQL_parse = yyvsp[0]; }
break;
case 2:
  if (!yytrial)
{ DSQL_parse = yyvsp[-1]; }
break;
case 25:
  if (!yytrial)
{ prepare_console_debug ((IPTR) yyvsp[0], &yydebug);
			  yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 26:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 27:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 28:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					make_list(yyvsp[-3]), make_list(yyvsp[-1]), NULL, yyvsp[0]); }
break;
case 31:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 32:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 33:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 35:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 36:
  if (!yytrial)
{ yyval = make_list (make_node (nod_execute, (int) 0, NULL)); }
break;
case 37:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) 0, NULL); }
break;
case 38:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) 0, NULL); }
break;
case 39:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) 0, NULL); }
break;
case 40:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) 1, yyvsp[0]); }
break;
case 41:
  if (!yytrial)
{ yyval = make_node (nod_references, (int) 1, yyvsp[0]); }
break;
case 42:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 43:
  if (!yytrial)
{ yyval = NULL; }
break;
case 44:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 45:
  if (!yytrial)
{ yyval = NULL; }
break;
case 46:
  if (!yytrial)
{ yyval = make_node (nod_procedure_name, (int) 1, yyvsp[0]); }
break;
case 47:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 48:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 49:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					make_list(yyvsp[-2]), make_list(yyvsp[0]), NULL, yyvsp[-3]); }
break;
case 50:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 51:
  if (!yytrial)
{ yyval = NULL; }
break;
case 52:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 53:
  if (!yytrial)
{ yyval = NULL; }
break;
case 57:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 58:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 59:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 60:
  if (!yytrial)
{ yyval = make_node (nod_proc_obj, (int) 1, yyvsp[0]); }
break;
case 61:
  if (!yytrial)
{ yyval = make_node (nod_trig_obj, (int) 1, yyvsp[0]); }
break;
case 62:
  if (!yytrial)
{ yyval = make_node (nod_view_obj, (int) 1, yyvsp[0]); }
break;
case 63:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 65:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 66:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 67:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 2, yyvsp[0], NULL); }
break;
case 68:
  if (!yytrial)
{ yyval = make_node (nod_user_group, (int) 1, yyvsp[0]); }
break;
case 70:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 71:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 73:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 74:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 75:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 76:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 77:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 78:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 79:
  if (!yytrial)
{ yyval = make_node (nod_def_udf, (int) e_udf_count, 
				yyvsp[-7], yyvsp[-2], yyvsp[0], make_list (yyvsp[-6]), yyvsp[-4]); }
break;
case 81:
  if (!yytrial)
{ lex.g_field->fld_dtype = dtype_blob; }
break;
case 82:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_cstring; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-2]; }
break;
case 83:
  if (!yytrial)
{ yyval = NULL; }
break;
case 85:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 87:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 88:
  if (!yytrial)
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 89:
  if (!yytrial)
{ yyval = NULL; }
break;
case 90:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_descriptor); }
break;
case 91:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_scalar_array); }
break;
case 92:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_ref_with_null); }
break;
case 94:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 95:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 96:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
				NULL, MAKE_const_slong ((IPTR) yyvsp[0]));}
break;
case 97:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_reference); }
break;
case 98:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_value); }
break;
case 99:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_descriptor); }
break;
case 100:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * Jrd::FUN_reference); }
break;
case 101:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * Jrd::FUN_descriptor); }
break;
case 102:
  if (!yytrial)
{ yyval = make_node (nod_def_filter, (int) e_filter_count, 
						yyvsp[-8], yyvsp[-6], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 103:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 104:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 105:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 106:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 107:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 108:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 109:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 110:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 111:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 112:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 113:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 114:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 115:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 116:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 117:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 118:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 119:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 120:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 121:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 122:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 123:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 124:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 125:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 126:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 127:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 128:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 129:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 130:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 131:
  if (!yytrial)
{ yyval = make_node (nod_def_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 132:
  if (!yytrial)
{ yyval = make_node (nod_redef_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 133:
  if (!yytrial)
{ yyval = make_node (nod_replace_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 134:
  if (!yytrial)
{ yyval = make_node (nod_mod_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 135:
  if (!yytrial)
{ yyval = make_node (nod_unique, 0, NULL); }
break;
case 136:
  if (!yytrial)
{ yyval = NULL; }
break;
case 137:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 139:
  if (!yytrial)
{ yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 140:
  if (!yytrial)
{ yyval = make_node (nod_def_shadow, (int) e_shadow_count,
				 yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], make_list (yyvsp[0])); }
break;
case 141:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 142:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 143:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 144:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 145:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 146:
  if (!yytrial)
{ yyval = (dsql_nod*) 0;}
break;
case 147:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 148:
  if (!yytrial)
{ yyval = NULL; }
break;
case 151:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 152:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
										  yyvsp[-7], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 153:
  if (!yytrial)
{ yyval = NULL; }
break;
case 154:
  if (!yytrial)
{ yyval = NULL; }
break;
case 155:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 157:
  if (!yytrial)
{ yyval = NULL; }
break;
case 159:
  if (!yytrial)
{ yyval = NULL; }
break;
case 161:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 162:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, NULL, yyvsp[0]);}
break;
case 165:
  if (!yytrial)
{ yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 166:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count,
					NULL, NULL, yyvsp[-2], NULL, yyvsp[0]); }
break;
case 167:
  if (!yytrial)
{ yyval = make_node (nod_def_generator, (int) e_gen_count, yyvsp[0]); }
break;
case 168:
  if (!yytrial)
{ yyval = make_node (nod_def_role, (int) 1, yyvsp[0]); }
break;
case 169:
  if (!yytrial)
{ yyval = make_node (nod_def_collation, 
						(int) e_def_coll_count, yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 170:
  if (!yytrial)
{ yyval = make_node(nod_collation_from, 1, yyvsp[0]); }
break;
case 171:
  if (!yytrial)
{ yyval = make_node(nod_collation_from_external, 1, yyvsp[-1]); }
break;
case 172:
  if (!yytrial)
{ yyval = NULL; }
break;
case 173:
  if (!yytrial)
{ yyval = NULL; }
break;
case 176:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 180:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 181:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 182:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 183:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 184:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 185:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 186:
  if (!yytrial)
{ yyval = NULL; }
break;
case 187:
  if (!yytrial)
{ yyval = make_node(nod_collation_specific_attr, 1,
				MAKE_constant((dsql_str*)yyvsp[0], CONSTANT_STRING)); }
break;
case 188:
  if (!yytrial)
{ yyval = make_node (nod_def_database, (int) e_cdb_count,
				 yyvsp[-2], make_list(yyvsp[-1]), make_list (yyvsp[0]));}
break;
case 191:
  if (!yytrial)
{ yyval = (dsql_nod*) yyvsp[0]; }
break;
case 192:
  if (!yytrial)
{yyval = NULL;}
break;
case 195:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 196:
  if (!yytrial)
{ yyval = make_node (nod_page_size, 1, yyvsp[0]);}
break;
case 197:
  if (!yytrial)
{ yyval = make_node (nod_file_length, 1, yyvsp[-1]);}
break;
case 198:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 1, yyvsp[0]);}
break;
case 199:
  if (!yytrial)
{ yyval = make_node (nod_password, 1, yyvsp[0]);}
break;
case 200:
  if (!yytrial)
{ yyval = make_node (nod_lc_ctype, 1, yyvsp[0]);}
break;
case 201:
  if (!yytrial)
{yyval = NULL;}
break;
case 204:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 206:
  if (!yytrial)
{ yyval = make_node (nod_dfl_charset, 1, yyvsp[0]);}
break;
case 207:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, 1, yyvsp[0]); }
break;
case 208:
  if (!yytrial)
{ lex.g_file->fil_name = (dsql_str*) yyvsp[-1];
			  yyval = (dsql_nod*) make_node (nod_file_desc, (int) 1,
						(dsql_nod*) lex.g_file); }
break;
case 209:
  if (!yytrial)
{ lex.g_file  = make_file();}
break;
case 214:
  if (!yytrial)
{ lex.g_file->fil_start = (IPTR) yyvsp[0];}
break;
case 215:
  if (!yytrial)
{ lex.g_file->fil_length = (IPTR) yyvsp[-1];}
break;
case 222:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 223:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 224:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 225:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 226:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_PRESERVE_ROWS; }
break;
case 227:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 228:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 229:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 230:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 231:
  if (!yytrial)
{ yyval = NULL; }
break;
case 233:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 236:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0], yyvsp[-4], NULL); }
break;
case 237:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-2], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 238:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-1], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 239:
  if (!yytrial)
{ 
			lex.g_field->fld_flags |= FLD_computed;
			yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 244:
  if (!yytrial)
{ yyval = NULL; }
break;
case 245:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
											yyvsp[-1], NULL, NULL, NULL, NULL); }
break;
case 246:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 247:
  if (!yytrial)
{ yyval = NULL; }
break;
case 248:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 249:
  if (!yytrial)
{ lex.g_field = make_field (yyvsp[0]);
				  yyval = (dsql_nod*) lex.g_field; }
break;
case 250:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 251:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				yyval = yyvsp[0];
			}
break;
case 252:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				((dsql_fld*) yyvsp[0])->fld_full_domain = true;
				yyval = yyvsp[0];
			}
break;
case 253:
  if (!yytrial)
{ lex.g_field = make_field (NULL);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 260:
  if (!yytrial)
{ yyval = NULL; }
break;
case 263:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 264:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 267:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count,
						make_node (nod_list, (int) 1, lex.g_field_name), yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 268:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, NULL, yyvsp[0]); }
break;
case 269:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, NULL, yyvsp[0]); }
break;
case 270:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 271:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 272:
  if (!yytrial)
{ yyval = NULL ;}
break;
case 277:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, yyvsp[-1], yyvsp[0]); }
break;
case 278:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, yyvsp[-1], yyvsp[0]); }
break;
case 279:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count, yyvsp[-5], yyvsp[-3], 
					 yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 280:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					NULL, yyvsp[-2], yyvsp[0], NULL, NULL); }
break;
case 281:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 282:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], NULL);}
break;
case 283:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, NULL, yyvsp[0]);}
break;
case 284:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], yyvsp[-1]); }
break;
case 285:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[-1], yyvsp[0]);}
break;
case 286:
  if (!yytrial)
{ yyval = NULL;}
break;
case 287:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 288:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 289:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_CASCADE, (int) e_ref_trig_action_count, NULL);}
break;
case 290:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_DEFAULT, (int) e_ref_trig_action_count, NULL);}
break;
case 291:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_NULL, (int) e_ref_trig_action_count, NULL);}
break;
case 292:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_NONE, (int) e_ref_trig_action_count, NULL);}
break;
case 293:
  if (!yytrial)
{ yyval = make_node (nod_def_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 294:
  if (!yytrial)
{ yyval = make_node (nod_redef_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 295:
  if (!yytrial)
{ yyval = make_node (nod_replace_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 296:
  if (!yytrial)
{ yyval = make_node (nod_mod_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 297:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 298:
  if (!yytrial)
{ yyval = NULL; }
break;
case 299:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 300:
  if (!yytrial)
{ yyval = NULL; }
break;
case 302:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 303:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-5], yyvsp[-1], yyvsp[0], NULL, yyvsp[-3], NULL, NULL); }
break;
case 305:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 306:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-2], NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 307:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 308:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 309:
  if (!yytrial)
{ yyval = NULL; }
break;
case 310:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 311:
  if (!yytrial)
{ yyval = NULL; }
break;
case 313:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 314:
  if (!yytrial)
{
				yyval = yyvsp[-1];
				yyval->nod_line = (IPTR) yyvsp[-5];
				yyval->nod_column = (IPTR) yyvsp[-4];
			}
break;
case 317:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-3], yyvsp[0], NULL, NULL, yyvsp[-1], NULL, NULL); }
break;
case 318:
  if (!yytrial)
{ yyval = NULL; }
break;
case 319:
  if (!yytrial)
{ yyval = NULL; }
break;
case 320:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 321:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 322:
  if (!yytrial)
{ yyval = NULL; }
break;
case 323:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_EXPLICIT,
				(int) e_cur_count, yyvsp[-5], yyvsp[-1], NULL, NULL); }
break;
case 326:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]);
			}
break;
case 327:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[0]), NULL); }
break;
case 328:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[-1]), make_list (yyvsp[0])); }
break;
case 329:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, NULL, NULL);}
break;
case 331:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 332:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-3], yyvsp[-2], yyvsp[-1]);
			}
break;
case 333:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-2], yyvsp[-1], yyvsp[0]);
			}
break;
case 334:
  if (!yytrial)
{ yyval = (dsql_nod*) (IPTR) lex.lines_bk; }
break;
case 335:
  if (!yytrial)
{ 
			const USHORT column = (lex.last_token_bk - lex.line_start_bk + 1);
			yyval = (dsql_nod*) (IPTR) column;
		}
break;
case 352:
  if (!yytrial)
{ yyval = make_node (nod_return, (int) e_rtn_count, NULL); }
break;
case 353:
  if (!yytrial)
{ yyval = make_node (nod_exit, 0, NULL); }
break;
case 358:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[0], NULL); }
break;
case 359:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[-1], yyvsp[0]); }
break;
case 360:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, NULL, NULL); }
break;
case 361:
  if (!yytrial)
{ yyval = make_node (nod_exec_sql, (int) e_exec_sql_count, yyvsp[0]); }
break;
case 362:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-5],
					  make_list (yyvsp[-3]), yyvsp[-2], yyvsp[0], yyvsp[-7]); }
break;
case 363:
  if (!yytrial)
{ yyval = make_node (nod_exec_into, (int) e_exec_into_count, yyvsp[-4], yyvsp[0], make_list (yyvsp[-2]), yyvsp[-8]); }
break;
case 364:
  if (!yytrial)
{ yyval = make_node (nod_exec_into, (int) e_exec_into_count, yyvsp[-2], NULL, make_list (yyvsp[0]), NULL); }
break;
case 365:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 366:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 367:
  if (!yytrial)
{ yyval = make_node (nod_post, (int) e_pst_count, yyvsp[-1], yyvsp[0]); }
break;
case 368:
  if (!yytrial)
{ yyval = NULL; }
break;
case 369:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-2],
					  make_list (yyvsp[0]), NULL, NULL, NULL); }
break;
case 370:
  if (!yytrial)
{ yyval = make_node (nod_var_name, (int) e_vrn_count, 
							yyvsp[0]); }
break;
case 373:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 374:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 375:
  if (!yytrial)
{ yyval = make_node (nod_while, (int) e_while_count, yyvsp[-3], yyvsp[0], yyvsp[-6]); }
break;
case 376:
  if (!yytrial)
{ yyval = make_node (nod_label, (int) e_label_count, yyvsp[-1], NULL); }
break;
case 377:
  if (!yytrial)
{ yyval = NULL; }
break;
case 378:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 379:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 380:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count,
				make_node (nod_label, (int) e_label_count, yyvsp[0], NULL)); }
break;
case 381:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_FOR,
				(int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 382:
  if (!yytrial)
{ yyval = NULL; }
break;
case 384:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 385:
  if (!yytrial)
{ yyval = make_node (nod_on_error, (int) e_err_count,
					make_list (yyvsp[-2]), yyvsp[0]); }
break;
case 387:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 388:
  if (!yytrial)
{ yyval = make_node (nod_sqlcode, 1, yyvsp[0]); }
break;
case 389:
  if (!yytrial)
{ yyval = make_node (nod_gdscode, 1, yyvsp[0]); }
break;
case 390:
  if (!yytrial)
{ yyval = make_node (nod_exception, 1, yyvsp[0]); }
break;
case 391:
  if (!yytrial)
{ yyval = make_node (nod_default, 1, NULL); }
break;
case 395:
  if (!yytrial)
{ yyval = make_node (nod_cursor_open, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 396:
  if (!yytrial)
{ yyval = make_node (nod_cursor_close, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 397:
  if (!yytrial)
{ yyval = make_node (nod_cursor_fetch, (int) e_cur_stmt_count, yyvsp[-2], yyvsp[-3], make_list (yyvsp[0])); }
break;
case 398:
  if (!yytrial)
{ yyval = NULL; }
break;
case 399:
  if (!yytrial)
{ yyval = make_node (nod_exec_procedure, (int) e_exe_count,
					yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 400:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 401:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 402:
  if (!yytrial)
{ yyval = NULL; }
break;
case 403:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 404:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 405:
  if (!yytrial)
{ yyval = NULL; }
break;
case 406:
  if (!yytrial)
{ yyval = make_node (nod_exec_block,
						  (int) e_exe_blk_count, 
					          yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], make_node (nod_all, (int) 0, NULL)); }
break;
case 407:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 408:
  if (!yytrial)
{ yyval = NULL; }
break;
case 410:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 411:
  if (!yytrial)
{ yyval = make_node (nod_param_val, e_prm_val_count, yyvsp[-2], yyvsp[0]); }
break;
case 412:
  if (!yytrial)
{ yyval = make_node (nod_def_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 413:
  if (!yytrial)
{ yyval = make_node (nod_redef_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 414:
  if (!yytrial)
{ lex.beginning = lex_position(); }
break;
case 415:
  if (!yytrial)
{ lex.beginning = lex.last_token; }
break;
case 416:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_string(lex.beginning,
					lex_position() - lex.beginning); }
break;
case 417:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_string(lex.beginning, 
					(yychar <= 0 ? lex_position() : lex.last_token) - lex.beginning); 
			}
break;
case 418:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 419:
  if (!yytrial)
{ yyval = 0; }
break;
case 420:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 421:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 422:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 423:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 424:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 425:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 426:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 427:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 428:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 429:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 430:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 431:
  if (!yytrial)
{ yyval = NULL; }
break;
case 432:
  if (!yytrial)
{ yyval = MAKE_trigger_type (yyvsp[-1], yyvsp[0]); }
break;
case 433:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 434:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_CONNECT); }
break;
case 435:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_DISCONNECT); }
break;
case 436:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_START); }
break;
case 437:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_COMMIT); }
break;
case 438:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_ROLLBACK); }
break;
case 439:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 440:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 441:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 0, 0)); }
break;
case 442:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 0, 0)); }
break;
case 443:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 0, 0)); }
break;
case 444:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 0)); }
break;
case 445:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 0)); }
break;
case 446:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 0)); }
break;
case 447:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 0)); }
break;
case 448:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 0)); }
break;
case 449:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 0)); }
break;
case 450:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 3)); }
break;
case 451:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 2)); }
break;
case 452:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 3)); }
break;
case 453:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 1)); }
break;
case 454:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 2)); }
break;
case 455:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 1)); }
break;
case 456:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 457:
  if (!yytrial)
{ yyval = NULL; }
break;
case 458:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) e_trg_act_count, yyvsp[-1], yyvsp[0]); }
break;
case 459:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 460:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 461:
  if (!yytrial)
{ yyval = make_node (nod_mod_relation, (int) e_alt_count, 
						yyvsp[-1], make_list (yyvsp[0])); }
break;
case 462:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 463:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 464:
  if (!yytrial)
{ yyval = make_node (nod_mod_database, (int) e_adb_count,
				make_list (yyvsp[0])); }
break;
case 465:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain, (int) e_alt_count,
										  yyvsp[-1], make_list (yyvsp[0])); }
break;
case 466:
  if (!yytrial)
{ yyval = make_node (nod_mod_index, (int) e_mod_idx_count, yyvsp[0]); }
break;
case 467:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 468:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 470:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 471:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 472:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 473:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 474:
  if (!yytrial)
{yyval = make_node (nod_del_default, (int) 0, NULL); }
break;
case 475:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, NULL); }
break;
case 476:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 477:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain_type, 2, yyvsp[-1]); }
break;
case 479:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 480:
  if (!yytrial)
{ yyval = make_node (nod_del_field, 2, yyvsp[-1], yyvsp[0]); }
break;
case 481:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, yyvsp[0]);}
break;
case 482:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 483:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 484:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_pos, 2, yyvsp[-2],
				MAKE_const_slong((IPTR) yyvsp[0])); }
break;
case 485:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_name, 2, yyvsp[-2], yyvsp[0]); }
break;
case 486:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], yyvsp[0], NULL); }
break;
case 487:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-3], NULL,
					make_node(nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0])); }
break;
case 488:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], NULL,
					make_node(nod_del_default, (int) 0, NULL)); }
break;
case 489:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 538:
  if (!yytrial)
{ yyval = NULL; }
break;
case 539:
  if (!yytrial)
{ yyval = NULL; }
break;
case 540:
  if (!yytrial)
{ yyval = NULL; }
break;
case 541:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
					yyvsp[0], NULL, NULL, NULL, NULL); }
break;
case 542:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 543:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 544:
  if (!yytrial)
{ yyval = make_node (nod_cascade, 0, NULL); }
break;
case 545:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 546:
  if (!yytrial)
{ yyval = make_node (nod_idx_active, 1, yyvsp[-1]); }
break;
case 547:
  if (!yytrial)
{ yyval = make_node (nod_idx_inactive, 1, yyvsp[-1]); }
break;
case 548:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 549:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 550:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-4],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 551:
  if (!yytrial)
{ yyval = make_node(nod_mod_udf, e_mod_udf_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 552:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 553:
  if (!yytrial)
{ yyval = NULL; }
break;
case 554:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 555:
  if (!yytrial)
{ yyval = NULL; }
break;
case 556:
  if (!yytrial)
{ yyval = NULL; }
break;
case 558:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 559:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 560:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, (int) 1, yyvsp[0]); }
break;
case 561:
  if (!yytrial)
{ yyval = make_node (nod_drop_difference, (int) 0, NULL); }
break;
case 562:
  if (!yytrial)
{ yyval = make_node (nod_begin_backup, (int) 0, NULL); }
break;
case 563:
  if (!yytrial)
{ yyval = make_node (nod_end_backup, (int) 0, NULL); }
break;
case 564:
  if (!yytrial)
{ yyval = make_node (nod_mod_trigger, (int) e_trg_count,
				yyvsp[-6], NULL, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 566:
  if (!yytrial)
{ yyval = NULL; }
break;
case 568:
  if (!yytrial)
{ yyval = NULL; }
break;
case 569:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 570:
  if (!yytrial)
{ yyval = make_node (nod_del_exception, 1, yyvsp[0]); }
break;
case 571:
  if (!yytrial)
{ yyval = make_node (nod_del_index, (int) 1, yyvsp[0]); }
break;
case 572:
  if (!yytrial)
{ yyval = make_node (nod_del_procedure, (int) 1, yyvsp[0]); }
break;
case 573:
  if (!yytrial)
{ yyval = make_node (nod_del_relation, (int) 1, yyvsp[0]); }
break;
case 574:
  if (!yytrial)
{ yyval = make_node (nod_del_trigger, (int) 1, yyvsp[0]); }
break;
case 575:
  if (!yytrial)
{ yyval = make_node (nod_del_view, (int) 1, yyvsp[0]); }
break;
case 576:
  if (!yytrial)
{ yyval = make_node (nod_del_filter, (int) 1, yyvsp[0]); }
break;
case 577:
  if (!yytrial)
{ yyval = make_node (nod_del_domain, (int) 1, yyvsp[0]); }
break;
case 578:
  if (!yytrial)
{ yyval = make_node (nod_del_udf, (int) 1, yyvsp[0]); }
break;
case 579:
  if (!yytrial)
{ yyval = make_node (nod_del_shadow, (int) 1, yyvsp[0]); }
break;
case 580:
  if (!yytrial)
{ yyval = make_node (nod_del_role, (int) 1, yyvsp[0]); }
break;
case 581:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 582:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 583:
  if (!yytrial)
{ yyval = make_node (nod_del_collation, (int) 1, yyvsp[0]); }
break;
case 587:
  if (!yytrial)
{ lex.g_field->fld_not_nullable = true; }
break;
case 590:
  if (!yytrial)
{ lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data; }
break;
case 591:
  if (!yytrial)
{
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				lex.g_field->fld_full_domain = true;
			}
break;
case 594:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-1]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-3]; }
break;
case 595:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-2]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-4]; }
break;
case 597:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 598:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] < 1)
			 		yyval = make_node (nod_list, (int) 2, 
					MAKE_const_slong ((IPTR) yyvsp[0]),
					MAKE_const_slong (1));
				  else
			 		yyval = make_node (nod_list, (int) 2, 
			   		MAKE_const_slong (1),
					MAKE_const_slong ((IPTR) yyvsp[0]) ); }
break;
case 599:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, 
			 	MAKE_const_slong ((IPTR) yyvsp[-2]),
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 605:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "BIGINT",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "BIGINT",
					isc_arg_end);
			lex.g_field->fld_dtype = dtype_int64; 
			lex.g_field->fld_length = sizeof (SINT64); 
			}
break;
case 606:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_long; 
			lex.g_field->fld_length = sizeof (SLONG); 
			}
break;
case 607:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_short; 
			lex.g_field->fld_length = sizeof (SSHORT); 
			}
break;
case 608:
  if (!yytrial)
{ 
			*stmt_ambiguous = true;
			if (client_dialect <= SQL_DIALECT_V5)
				{
				/* Post warning saying that DATE is equivalent to TIMESTAMP */
					ERRD_post_warning (isc_sqlwarn, isc_arg_number, (SLONG) 301, 
											   isc_arg_warning, isc_dtype_renamed, isc_arg_end);
				lex.g_field->fld_dtype = dtype_timestamp; 
				lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
				}
			else if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				yyabandon (-104, isc_transitional_date);
			else
				{
				lex.g_field->fld_dtype = dtype_sql_date; 
				lex.g_field->fld_length = sizeof (ULONG);
				}
			}
break;
case 609:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			lex.g_field->fld_dtype = dtype_sql_time; 
			lex.g_field->fld_length = sizeof (SLONG);
			}
break;
case 610:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_timestamp; 
			lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
			}
break;
case 613:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			}
break;
case 614:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_sub_type = 0;
			}
break;
case 615:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 616:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = 80;
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 617:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[0];
		  	}
break;
case 618:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT) 80;
		  	}
break;
case 619:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[0];
			}
break;
case 620:
  if (!yytrial)
{
			lex.g_field->fld_sub_type_name = yyvsp[0];
			}
break;
case 621:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT) 0;
			}
break;
case 622:
  if (!yytrial)
{
			lex.g_field->fld_character_set = yyvsp[0];
			}
break;
case 624:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 625:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = 1; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 626:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_varying; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 627:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			}
break;
case 628:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = 1; 
			}
break;
case 629:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_varying; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			}
break;
case 638:
  if (!yytrial)
{ 
			  lex.g_field->fld_sub_type = dsc_num_type_numeric;
			}
break;
case 639:
  if (!yytrial)
{  
			   lex.g_field->fld_sub_type = dsc_num_type_decimal;
			   if (lex.g_field->fld_dtype == dtype_short)
				{
				lex.g_field->fld_dtype = dtype_long;
				lex.g_field->fld_length = sizeof (SLONG);
				}
			}
break;
case 640:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_long; 
				lex.g_field->fld_length = sizeof (SLONG); 
			lex.g_field->fld_precision = 9;
				}
break;
case 641:
  if (!yytrial)
{		 
			if ( ((IPTR) yyvsp[-1] < 1) || ((IPTR) yyvsp[-1] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision most be between 1 and 18. */ 
			if ((IPTR) yyvsp[-1] > 9)
				{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect	 >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect	 <= SQL_DIALECT_V5) ) )
					ERRD_post (isc_sqlerr,
					   isc_arg_number, (SLONG) -817,
					   isc_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   isc_arg_number, (SLONG) db_dialect,
					   isc_arg_end);
				if (client_dialect <= SQL_DIALECT_V5)
					{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double);
					}
				else
					{
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
					{
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					isc_arg_end );

					}
				lex.g_field->fld_dtype = dtype_int64;
				lex.g_field->fld_length = sizeof (SINT64);
					}
				}
			else 
				if ((IPTR) yyvsp[-1] < 5)
					{
					lex.g_field->fld_dtype = dtype_short; 
					lex.g_field->fld_length = sizeof (SSHORT); 
					}
				else
					{
					lex.g_field->fld_dtype = dtype_long; 
					lex.g_field->fld_length = sizeof (SLONG); 
					}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 642:
  if (!yytrial)
{ 
			if ( ((IPTR) yyvsp[-3] < 1) || ((IPTR) yyvsp[-3] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision should be between 1 and 18 */ 
			if (((IPTR) yyvsp[-1] > (IPTR) yyvsp[-3]) || ((IPTR) yyvsp[-1] < 0))
				yyabandon (-842, isc_scale_nogt);
				/* Scale must be between 0 and precision */
			if ((IPTR) yyvsp[-3] > 9)
				{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect	 >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect	 <= SQL_DIALECT_V5) ) )
					ERRD_post (isc_sqlerr,
					   isc_arg_number, (SLONG) -817,
					   isc_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   isc_arg_number, (SLONG) db_dialect,
					   isc_arg_end);
				if (client_dialect <= SQL_DIALECT_V5)
					{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double); 
					}
				else
					{
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				  {
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					isc_arg_end );
				  }
				  /* client_dialect >= SQL_DIALECT_V6 */
				lex.g_field->fld_dtype = dtype_int64;
				lex.g_field->fld_length = sizeof (SINT64);
					}
				}
			else
				{
				if ((IPTR) yyvsp[-3] < 5)
					{
					lex.g_field->fld_dtype = dtype_short; 
					lex.g_field->fld_length = sizeof (SSHORT); 
					}
				else
					{
					lex.g_field->fld_dtype = dtype_long; 
					lex.g_field->fld_length = sizeof (SLONG); 
					}
				}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_scale = - (SSHORT)(IPTR) yyvsp[-1];
			}
break;
case 645:
  if (!yytrial)
{ 
			if ((IPTR) yyvsp[0] > 7)
				{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double); 
				}
			else
				{
				lex.g_field->fld_dtype = dtype_real; 
				lex.g_field->fld_length = sizeof (float);
				}
			}
break;
case 646:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_double; 
			lex.g_field->fld_length = sizeof (double); 
			}
break;
case 647:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_real; 
			lex.g_field->fld_length = sizeof (float); 
			}
break;
case 648:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_double; 
			lex.g_field->fld_length = sizeof (double); 
			}
break;
case 649:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 650:
  if (!yytrial)
{ yyval = 0; }
break;
case 654:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 655:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 656:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 660:
  if (!yytrial)
{ yyval = make_node (nod_user_savepoint, 1, yyvsp[0]); }
break;
case 661:
  if (!yytrial)
{ yyval = make_node (nod_release_savepoint, 2, yyvsp[-1], yyvsp[0]); }
break;
case 662:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 663:
  if (!yytrial)
{ yyval = 0; }
break;
case 664:
  if (!yytrial)
{ yyval = make_node (nod_undo_savepoint, 1, yyvsp[0]); }
break;
case 667:
  if (!yytrial)
{ yyval = make_node (nod_commit, e_commit_count, yyvsp[0]); }
break;
case 668:
  if (!yytrial)
{ yyval = make_node (nod_rollback, e_rollback_count, yyvsp[0]); }
break;
case 671:
  if (!yytrial)
{ yyval = make_node (nod_retain, 0, NULL); }
break;
case 672:
  if (!yytrial)
{ yyval = NULL; }
break;
case 674:
  if (!yytrial)
{ yyval = NULL; }
break;
case 675:
  if (!yytrial)
{yyval = make_node (nod_trans, 1, make_list (yyvsp[0])); }
break;
case 677:
  if (!yytrial)
{ yyval = NULL; }
break;
case 679:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 686:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_ONLY, (int) 0, NULL); }
break;
case 687:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_WRITE, (int) 0, NULL); }
break;
case 688:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_WAIT, (int) 0, NULL); }
break;
case 689:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_NO_WAIT, (int) 0, NULL); }
break;
case 690:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 692:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 693:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 694:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 695:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONCURRENCY, 0, NULL); }
break;
case 696:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 697:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 698:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_VERSION, 0, NULL); }
break;
case 699:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_NO_VERSION, 0, NULL); }
break;
case 700:
  if (!yytrial)
{ yyval = 0; }
break;
case 701:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_NO_AUTO_UNDO, 0, NULL); }
break;
case 702:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_IGNORE_LIMBO, 0, NULL); }
break;
case 703:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_RESTART_REQUESTS, 0, NULL); }
break;
case 704:
  if (!yytrial)
{ yyval = make_node(nod_lock_timeout, 1, MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 705:
  if (!yytrial)
{ yyval = make_node (nod_reserve, 1, make_list (yyvsp[0])); }
break;
case 706:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_SHARED; }
break;
case 707:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_PROTECTED ; }
break;
case 708:
  if (!yytrial)
{ yyval = (dsql_nod*) 0; }
break;
case 709:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_READ; }
break;
case 710:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_WRITE; }
break;
case 712:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 713:
  if (!yytrial)
{ yyval = make_node (nod_table_lock, (int) 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 714:
  if (!yytrial)
{ yyval = make_flag_node (nod_lock_mode, (SSHORT) ((SSHORT)(IPTR) yyvsp[-1] | (SSHORT)(IPTR) yyvsp[0]), (SSHORT) 0, NULL); }
break;
case 715:
  if (!yytrial)
{ yyval = 0; }
break;
case 717:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 718:
  if (!yytrial)
{ yyval = make_node (nod_set_statistics, (int) e_stat_count, yyvsp[0]); }
break;
case 719:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-2], NULL, NULL, yyvsp[0]); }
break;
case 720:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-3], yyvsp[-2], NULL, yyvsp[0]); }
break;
case 721:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]); }
break;
case 722:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_database); }
break;
case 723:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_domain); }
break;
case 724:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 725:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_view); }
break;
case 726:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 727:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_trigger); }
break;
case 728:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_udf); }
break;
case 729:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_blob_filter); }
break;
case 730:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_exception); }
break;
case 731:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 732:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 733:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_index); }
break;
case 734:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_role); }
break;
case 735:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_charset); }
break;
case 736:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_collation); }
break;
case 737:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 738:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 739:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 741:
  if (!yytrial)
{ yyval = NULL; }
break;
case 742:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) e_select_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 743:
  if (!yytrial)
{ yyval = make_node (nod_for_update, (int) e_fpd_count, yyvsp[0]); }
break;
case 744:
  if (!yytrial)
{ yyval = NULL; }
break;
case 745:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 746:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 747:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 748:
  if (!yytrial)
{ yyval = NULL; }
break;
case 749:
  if (!yytrial)
{ yyval = make_node (nod_select_expr, (int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 750:
  if (!yytrial)
{ yyval = make_flag_node (nod_with, NOD_UNION_RECURSIVE, 1, make_list(yyvsp[0])); }
break;
case 751:
  if (!yytrial)
{ yyval = make_node (nod_with, 1, make_list(yyvsp[0])); }
break;
case 752:
  if (!yytrial)
{ yyval = NULL; }
break;
case 754:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 755:
  if (!yytrial)
{ yyval = make_node (nod_derived_table, (int) e_derived_table_count, yyvsp[-1], yyvsp[-5], yyvsp[-4], NULL); }
break;
case 756:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 757:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE | NOD_SELECT_EXPR_SINGLETON,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 759:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-3], yyvsp[0]); }
break;
case 760:
  if (!yytrial)
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 762:
  if (!yytrial)
{ yyval = make_node (nod_query_spec, (int) e_qry_count, 
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 763:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], yyvsp[-1]); }
break;
case 764:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, NULL, yyvsp[0]); }
break;
case 765:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], NULL); }
break;
case 766:
  if (!yytrial)
{ yyval = 0; }
break;
case 767:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 768:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 769:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 770:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 771:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 772:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 773:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 774:
  if (!yytrial)
{ yyval = 0; }
break;
case 775:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 776:
  if (!yytrial)
{ yyval = 0; }
break;
case 778:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 780:
  if (!yytrial)
{ yyval = make_node (nod_alias, 2, yyvsp[-2], yyvsp[0]); }
break;
case 783:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 785:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 790:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 791:
  if (!yytrial)
{ yyval = make_node(nod_derived_table, (int) e_derived_table_count, yyvsp[-4], yyvsp[-1], yyvsp[0], NULL); }
break;
case 793:
  if (!yytrial)
{ yyval = NULL; }
break;
case 794:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 795:
  if (!yytrial)
{ yyval = NULL; }
break;
case 797:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 801:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-3],
				make_node (nod_join_inner, (int) 0, NULL), yyvsp[0], NULL); }
break;
case 802:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-2], yyvsp[0],
					make_node (nod_flag, 0, NULL)); }
break;
case 803:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 806:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 807:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 808:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-3], yyvsp[0], yyvsp[-2]); }
break;
case 809:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 810:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 811:
  if (!yytrial)
{ yyval = NULL; }
break;
case 813:
  if (!yytrial)
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[-2], yyvsp[0]); }
break;
case 814:
  if (!yytrial)
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[0], NULL); }
break;
case 815:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 816:
  if (!yytrial)
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 817:
  if (!yytrial)
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 818:
  if (!yytrial)
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 819:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 822:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 823:
  if (!yytrial)
{ yyval = NULL; }
break;
case 825:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 827:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 828:
  if (!yytrial)
{ yyval = NULL; }
break;
case 829:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 830:
  if (!yytrial)
{ yyval = NULL; }
break;
case 831:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 832:
  if (!yytrial)
{ yyval = NULL; }
break;
case 833:
  if (!yytrial)
{ yyval = make_node (nod_plan_expr, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 834:
  if (!yytrial)
{ yyval = 0; }
break;
case 835:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 836:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 837:
  if (!yytrial)
{ yyval = 0; }
break;
case 838:
  if (!yytrial)
{ yyval = 0; }
break;
case 840:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 841:
  if (!yytrial)
{ yyval = make_node (nod_plan_item, 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 844:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 845:
  if (!yytrial)
{ yyval = make_node (nod_natural, (int) 0, NULL); }
break;
case 846:
  if (!yytrial)
{ yyval = make_node (nod_index, 1, make_list (yyvsp[-1])); }
break;
case 847:
  if (!yytrial)
{ yyval = make_node (nod_index_order, 2, yyvsp[-1], yyvsp[0]); }
break;
case 849:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 850:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 851:
  if (!yytrial)
{ yyval = 0; }
break;
case 852:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 853:
  if (!yytrial)
{ yyval = 0; }
break;
case 855:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 856:
  if (!yytrial)
{ yyval = make_node (nod_order, (int) e_order_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 857:
  if (!yytrial)
{ yyval = 0; }
break;
case 858:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 859:
  if (!yytrial)
{ yyval = 0; }
break;
case 860:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 861:
  if (!yytrial)
{ yyval = 0; }
break;
case 862:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_FIRST); }
break;
case 863:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_LAST); }
break;
case 864:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count, NULL, yyvsp[0]); }
break;
case 865:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count,
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)),
				make_node (nod_add, 2,
					make_node (nod_subtract, 2, yyvsp[0], yyvsp[-2]),
					MAKE_const_slong (1))); }
break;
case 866:
  if (!yytrial)
{ yyval = NULL; }
break;
case 867:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count, 
				yyvsp[-6], yyvsp[-5], make_list (yyvsp[-2]), NULL, yyvsp[0]); }
break;
case 868:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], yyvsp[-2], NULL, yyvsp[-1], yyvsp[0]); }
break;
case 869:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], NULL, NULL, NULL, yyvsp[0]); }
break;
case 870:
  if (!yytrial)
{
			yyval = make_node(nod_merge, e_mrg_count, yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]);
		}
break;
case 871:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[-1], yyvsp[0]); }
break;
case 872:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], yyvsp[-1]); }
break;
case 873:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], NULL); }
break;
case 874:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, NULL, yyvsp[0]); }
break;
case 875:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 876:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 877:
  if (!yytrial)
{ yyval = make_node(nod_merge_update, e_mrg_update_count, make_list(yyvsp[0])); }
break;
case 878:
  if (!yytrial)
{ yyval = make_node(nod_merge_insert, e_mrg_insert_count, make_list(yyvsp[-4]), make_list(yyvsp[-1])); }
break;
case 881:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0]); }
break;
case 882:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-1], NULL, NULL, NULL, NULL, yyvsp[0], NULL); }
break;
case 885:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-7], make_list (yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0], NULL); }
break;
case 886:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-3], make_list (yyvsp[-1]), NULL, NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 887:
  if (!yytrial)
{
			yyval = make_node (nod_update_or_insert, (int) e_upi_count,
				yyvsp[-7], make_list (yyvsp[-6]), make_list (yyvsp[-3]), yyvsp[-1], yyvsp[0]);
		}
break;
case 888:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 889:
  if (!yytrial)
{ yyval = NULL; }
break;
case 890:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[0]), NULL); }
break;
case 891:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[-2]), make_list (yyvsp[0])); }
break;
case 892:
  if (!yytrial)
{ yyval = NULL; }
break;
case 893:
  if (!yytrial)
{ yyval = make_node (nod_cursor, (int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 895:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 896:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], yyvsp[-2]); }
break;
case 897:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 898:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 899:
  if (!yytrial)
{ yyval = make_node (nod_get_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 900:
  if (!yytrial)
{ yyval = make_node (nod_put_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 901:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 902:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, NULL, yyvsp[0]); }
break;
case 903:
  if (!yytrial)
{ yyval = NULL; }
break;
case 906:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 907:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 908:
  if (!yytrial)
{ yyval = NULL; }
break;
case 909:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 912:
  if (!yytrial)
{ yyval = NULL; }
break;
case 913:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 915:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 917:
  if (!yytrial)
{ yyval = NULL; }
break;
case 918:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 920:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 922:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 923:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], NULL); }
break;
case 924:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 926:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 928:
  if (!yytrial)
{ yyval = make_node (nod_or, 2, yyvsp[-2], yyvsp[0]); }
break;
case 929:
  if (!yytrial)
{ yyval = make_node (nod_and, 2, yyvsp[-2], yyvsp[0]); }
break;
case 930:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, yyvsp[0]); }
break;
case 943:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 944:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2, yyvsp[-2], yyvsp[0]); }
break;
case 945:
  if (!yytrial)
{ yyval = make_node (nod_lss, 2, yyvsp[-2], yyvsp[0]); }
break;
case 946:
  if (!yytrial)
{ yyval = make_node (nod_gtr, 2, yyvsp[-2], yyvsp[0]); }
break;
case 947:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 948:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 949:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 950:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 951:
  if (!yytrial)
{ yyval = make_node (nod_neq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 952:
  if (!yytrial)
{ yyval = make_node (nod_eql_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 953:
  if (!yytrial)
{ yyval = make_node (nod_lss_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 954:
  if (!yytrial)
{ yyval = make_node (nod_gtr_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 955:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 956:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 957:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 958:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 959:
  if (!yytrial)
{ yyval = make_node (nod_neq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 960:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 961:
  if (!yytrial)
{ yyval = make_node (nod_lss_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 962:
  if (!yytrial)
{ yyval = make_node (nod_gtr_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 963:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 964:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 965:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 966:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 967:
  if (!yytrial)
{ yyval = make_node (nod_neq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 970:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_equiv, 2, yyvsp[-4], yyvsp[0])); }
break;
case 971:
  if (!yytrial)
{ yyval = make_node (nod_equiv, 2, yyvsp[-5], yyvsp[0]); }
break;
case 972:
  if (!yytrial)
{ yyval = make_node (nod_between, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 973:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_between, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 974:
  if (!yytrial)
{ yyval = make_node (nod_like, 2, yyvsp[-2], yyvsp[0]); }
break;
case 975:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 2, yyvsp[-3], yyvsp[0])); }
break;
case 976:
  if (!yytrial)
{ yyval = make_node (nod_like, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 977:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 978:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-2], yyvsp[0]); }
break;
case 979:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_eql_any, 2, yyvsp[-3], yyvsp[0])); }
break;
case 980:
  if (!yytrial)
{ yyval = make_node (nod_containing, 2, yyvsp[-2], yyvsp[0]); }
break;
case 981:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_containing, 2, yyvsp[-3], yyvsp[0])); }
break;
case 982:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-2], yyvsp[0]); }
break;
case 983:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-3], yyvsp[0])); }
break;
case 984:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-3], yyvsp[0]); }
break;
case 985:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-4], yyvsp[0])); }
break;
case 986:
  if (!yytrial)
{ yyval = make_node (nod_exists, 1, yyvsp[-1]); }
break;
case 987:
  if (!yytrial)
{ yyval = make_node (nod_singular, 1, yyvsp[-1]); }
break;
case 988:
  if (!yytrial)
{ yyval = make_node (nod_missing, 1, yyvsp[-2]); }
break;
case 989:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_missing, 1, yyvsp[-3])); }
break;
case 990:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (1)); }
break;
case 991:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (2)); }
break;
case 992:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (3)); }
break;
case 994:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 995:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1006:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1007:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1008:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_add2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_add, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1009:
  if (!yytrial)
{ yyval = make_node (nod_concatenate, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1010:
  if (!yytrial)
{ yyval = make_node (nod_collate, (int) e_coll_count, (dsql_nod*) yyvsp[0], yyvsp[-2]); }
break;
case 1011:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_subtract2, 2, yyvsp[-2], yyvsp[0]);
			  else 
				  yyval = make_node (nod_subtract, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1012:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				   yyval = make_node (nod_multiply2, 2, yyvsp[-2], yyvsp[0]);
			  else
				   yyval = make_node (nod_multiply, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1013:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_divide2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_divide, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1014:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1015:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1019:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, NULL); }
break;
case 1020:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, yyvsp[-2]); }
break;
case 1021:
  if (!yytrial)
{ 
			  yyval = make_node (nod_dom_value, 0, NULL);
						}
break;
case 1024:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			yyval = make_node (nod_current_date, 0, NULL);
			}
break;
case 1025:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			yyval = make_node (nod_current_time, 1, yyvsp[0]);
			}
break;
case 1026:
  if (!yytrial)
{ yyval = make_node (nod_current_timestamp, 1, yyvsp[0]); }
break;
case 1027:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[-1]); }
break;
case 1028:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1029:
  if (!yytrial)
{ yyval = make_node (nod_array, (int) e_ary_count, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 1031:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1033:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1035:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1036:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 1037:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 1038:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DOUBLE); }
break;
case 1039:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1040:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1042:
  if (!yytrial)
{ yyval = MAKE_str_constant ((dsql_str*) yyvsp[0], lex.att_charset); }
break;
case 1043:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "DATE",
					isc_arg_end);
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DATE);
			}
break;
case 1044:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					isc_arg_end);
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIME);
			}
break;
case 1045:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIMESTAMP); }
break;
case 1046:
  if (!yytrial)
{ yyval = make_parameter (); }
break;
case 1047:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1048:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1049:
  if (!yytrial)
{ yyval = make_node (nod_current_role, 0, NULL); }
break;
case 1050:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_connection_id)); }
break;
case 1051:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_transaction_id)); }
break;
case 1052:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_gdscode)); }
break;
case 1053:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_sqlcode)); }
break;
case 1054:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_rows_affected)); }
break;
case 1055:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1056:
  if (!yytrial)
{ ((dsql_str*) yyvsp[0])->str_charset = (TEXT *) yyvsp[-1];
			  yyval = yyvsp[0]; }
break;
case 1058:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1059:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_POS_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1060:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_NEG_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1061:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] == 0)
				yyabandon (-842, isc_expec_positive);
				/* Positive number expected */
			  yyval = yyvsp[0];}
break;
case 1062:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_UNSIGNED_MAX)
				yyabandon (-842, isc_expec_ushort);
				/* Unsigned short integer expected */
			  yyval = yyvsp[0];}
break;
case 1064:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1065:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 1071:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 0, NULL); }
break;
case 1072:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 1, yyvsp[-1]); }
break;
case 1073:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_count,
									   NOD_AGG_DISTINCT, 1, yyvsp[-1]); }
break;
case 1074:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_total2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_total, 1, yyvsp[-1]);
			}
break;
case 1075:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_total2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_total,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1076:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_average2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_average, 1, yyvsp[-1]);
			}
break;
case 1077:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_average2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_average,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1078:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1079:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1080:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1081:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1082:
  if (!yytrial)
{ yyval = make_node (nod_agg_list, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1083:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_list, NOD_AGG_DISTINCT, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1084:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1085:
  if (!yytrial)
{ yyval = MAKE_str_constant (MAKE_cstring(","), lex.att_charset); }
break;
case 1088:
  if (!yytrial)
{ yyval = make_node (nod_extract, (int) e_extract_count, yyvsp[-3], yyvsp[-1]); }
break;
case 1092:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_bit), yyvsp[-1]); }
break;
case 1093:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1094:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1095:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_octet), yyvsp[-1]); }
break;
case 1096:
  if (!yytrial)
{ yyval = make_node(nod_sys_function, e_sysfunc_count, yyvsp[-3], make_list(yyvsp[-1])); }
break;
case 1142:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-6], make_node(nod_list, 3, yyvsp[-4], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1143:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-3], yyvsp[-5], yyvsp[-1]));
		}
break;
case 1144:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1145:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1146:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-9], make_node(nod_list, 4, yyvsp[-7], yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1147:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1148:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-5], make_node(nod_list, 2, yyvsp[-3], yyvsp[-1]));
		}
break;
case 1151:
  if (!yytrial)
{ yyval = make_node (nod_upcase, 1, yyvsp[-1]); }
break;
case 1152:
  if (!yytrial)
{ yyval = make_node (nod_lowcase, 1, yyvsp[-1]); }
break;
case 1153:
  if (!yytrial)
{ yyval = make_node (nod_substr, (int) e_substr_count, yyvsp[-4],
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)), yyvsp[-1]); }
break;
case 1154:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1155:
  if (!yytrial)
{ yyval = MAKE_const_slong (SHRT_POS_MAX); }
break;
case 1156:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]); }
break;
case 1157:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, 
				MAKE_const_slong (blr_trim_both), yyvsp[-3], yyvsp[-1]); }
break;
case 1158:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-3], NULL, yyvsp[-1]); }
break;
case 1159:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count,
				MAKE_const_slong (blr_trim_both), NULL, yyvsp[-1]); }
break;
case 1160:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_both); }
break;
case 1161:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_trailing); }
break;
case 1162:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_leading); }
break;
case 1163:
  if (!yytrial)
{ yyval = make_node (nod_udf, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1164:
  if (!yytrial)
{ yyval = make_node (nod_udf, 1, yyvsp[-2]); }
break;
case 1165:
  if (!yytrial)
{ yyval = make_node (nod_cast, (int) e_cast_count, yyvsp[-1], yyvsp[-3]); }
break;
case 1168:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, 
				make_node (nod_list, 2, make_node (nod_eql, 2, yyvsp[-3], yyvsp[-1]), 
				make_node (nod_null, 0, NULL)), yyvsp[-3]); }
break;
case 1169:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, 
				make_node (nod_list, 2, yyvsp[-5], yyvsp[-3]), yyvsp[-1]); }
break;
case 1170:
  if (!yytrial)
{ yyval = make_node (nod_coalesce, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1171:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-3], make_list(yyvsp[-1]), make_node(nod_null, 0, NULL)); }
break;
case 1172:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-5], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1175:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-2], make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1176:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-4], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1177:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1178:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1179:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1180:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1181:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1182:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1186:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1187:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-4], make_node(nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1188:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[0],
						MAKE_const_slong(1));
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[0],
						MAKE_const_slong(1));
			}
break;
case 1189:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[-3], yyvsp[-1]);
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[-3], yyvsp[-1]);
			}
break;
case 1190:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_year); }
break;
case 1191:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_month); }
break;
case 1192:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_day); }
break;
case 1193:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_hour); }
break;
case 1194:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_minute); }
break;
case 1195:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_second); }
break;
case 1196:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_millisecond); }
break;
case 1197:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_week); }
break;
case 1198:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_weekday); }
break;
case 1199:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_yearday); }
break;
case 1204:
  if (!yytrial)
{ yyval = make_node (nod_null, 0, NULL); }
break;

  default:
    break;
  }

#if YYDEBUG && defined(YYDBPR)
  if (yydebug) {
    printf("yydebug[%d]: after reduction, result is ", yytrial);
    YYDBPR(yyps->val);
    printf("\n");
  }
#endif

  // Perform user-defined position reduction
#ifdef YYREDUCEPOSNFUNC
  if(!yytrial) {
    YYCALLREDUCEPOSN(YYREDUCEPOSNFUNCARG);
  }
#endif

  yyps->ssp -= yym;
  yystate = *(yyps->ssp);
  yyps->vsp -= yym;
  yyps->psp -= yym;

  yym = yylhs[yyn];
  if (yystate == 0 && yym == 0) {
#if YYDEBUG
    if (yydebug) {
      printf("yydebug[%d,%p]: after reduction, shifting from state 0 to state %d\n", 
	     int(yydepth), yytrial, YYFINAL);
    }
#endif
    yystate = YYFINAL;
    *++(yyps->ssp) = YYFINAL;
    *++(yyps->vsp) = yyps->val;
    yyretlval = yyps->val;	// return value of root non-terminal to yylval
    *++(yyps->psp) = yyps->pos;
    yyretposn = yyps->pos;	// return value of root position to yyposn
    if (yychar < 0) {
      if ((yychar = YYLex1(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) {
        yychar = 0;
      }
#if YYDEBUG
      if (yydebug) {
        yys = 0;
        if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
        if (!yys) yys = "illegal-symbol";
        printf("yydebug[%d,%p]: state %d, reading %d (%s)\n", 
	       int(yydepth), yytrial, YYFINAL, yychar, yys); 
      }
#endif
    }
    if (yychar == 0) goto yyaccept;
    goto yyloop;
  }

  if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yystate) {
    yystate = yytable[yyn];
  } else {
    yystate = yydgoto[yym];
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: after reduction, shifting from state %d to state %d\n",
           int(yydepth), yytrial, *(yyps->ssp), yystate);
#endif
  if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
    YYMoreStack(yyps);
  }
  *++(yyps->ssp) = yystate;
  *++(yyps->vsp) = yyps->val;
  *++(yyps->psp) = yyps->pos;
  goto yyloop;


  //
  // Reduction declares that this path is valid.
  // Set yypath and do a full parse
  //
yyvalid:
  if (yypath) {
    goto yyabort;
  }
  while (yyps->save) {
    yyparsestate *save = yyps->save;
    yyps->save = save->save;
    save->save = yypath;
    yypath = save;
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: CONFLICT trial successful, backtracking to state %d, %d tokens\n",
           int(yydepth), yytrial, yypath->state, int(yylvp - yylvals - yypath->lexeme));
#endif
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  yychar = -1;
  yyps->ssp = yyps->ss + (yypath->ssp - yypath->ss);
  yyps->vsp = yyps->vs + (yypath->vsp - yypath->vs);
  yyps->psp = yyps->ps + (yypath->psp - yypath->ps);
  memcpy (yyps->ss, yypath->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
  YYSCopy(yyps->vs, yypath->vs,  yyps->vsp - yyps->vs + 1);
  YYPCopy(yyps->ps, yypath->ps,  yyps->psp - yyps->ps + 1);
  yylvp = yylvals + yypath->lexeme;
  yylpp = yylpsns + yypath->lexeme;
  yylexp = yylexemes + yypath->lexeme;
  yystate = yypath->state;
  goto yyloop;


yyabort:
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }

  YYSTYPE *pv;
  for(pv=yyps->vs; pv<yyps->vsp; pv++) {
    YYDELETEVAL(*pv,2);
  }

  YYPOSN *pp;
  for(pp=yyps->ps; pp<yyps->psp; pp++) {
    YYDELETEPOSN(*pp,2);
  }

  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (1);


yyaccept:
  if (yyps->save) goto yyvalid;
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (0);
}


int YYLex1(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous) {
  if(yylvp<yylve) {
    yylval = *yylvp++;
    yyposn = *yylpp++;
    return *yylexp++;
  } else {
    if(yyps->save) {
      if(yylvp==yylvlim) {
	yyexpand();
      }
      *yylexp = yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
      *yylvp++ = yylval;
      yylve++;
      *yylpp++ = yyposn;
      yylpe++;
      return *yylexp++;
    } else {
      return yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
    }
  }
}

int yyexpand() {
  int p = yylvp-yylvals;
  int s = yylvlim-yylvals;
  s += YYSTACKGROWTH;
  { Yshort  *tl = yylexemes; 
    YYSTYPE *tv = yylvals;
    YYPOSN  *tp = yylpsns;
    yylvals = new YYSTYPE[s];
    yylpsns = new YYPOSN[s];
    yylexemes = new Yshort[s];
    memcpy(yylexemes, tl, (s-YYSTACKGROWTH)*sizeof(Yshort));
    YYSCopy(yylvals, tv, s-YYSTACKGROWTH);
    YYPCopy(yylpsns, tp, s-YYSTACKGROWTH);
    delete[] tl;
    delete[] tv;
    delete[] tp;
  }
  yylvp = yylve = yylvals + p;
  yylvlim = yylvals + s;
  yylpp = yylpe = yylpsns + p;
  yylplim = yylpsns + s;
  yylexp = yylexemes + p;
  return 0;
}

void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYPCopy(YYPOSN *to, YYPOSN *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYMoreStack(yyparsestate *yyps) {
  int p = yyps->ssp - yyps->ss;                               
  Yshort  *tss = yyps->ss;
  YYSTYPE *tvs = yyps->vs;
  YYPOSN  *tps = yyps->ps;
  yyps->ss = new Yshort [yyps->stacksize + YYSTACKGROWTH];   
  yyps->vs = new YYSTYPE[yyps->stacksize + YYSTACKGROWTH];  
  yyps->ps = new YYPOSN [yyps->stacksize + YYSTACKGROWTH];  
  memcpy(yyps->ss, tss, yyps->stacksize * sizeof(Yshort));  
  YYSCopy(yyps->vs, tvs, yyps->stacksize);                  
  YYPCopy(yyps->ps, tps, yyps->stacksize);                  
  yyps->stacksize += YYSTACKGROWTH;                           
  delete[] tss;
  delete[] tvs;
  delete[] tps;
  yyps->ssp = yyps->ss + p;                                   
  yyps->vsp = yyps->vs + p;                                   
  yyps->psp = yyps->ps + p;                                   
}

yyparsestate *YYNewState(int size) {
  yyparsestate *p = new yyparsestate;
  p->stacksize = size+4;
  p->ss = new Yshort [size + 4];
  p->vs = new YYSTYPE[size + 4];
  p->ps = new YYPOSN [size + 4];
  memset(&p->vs[0], 0, (size+4)*sizeof(YYSTYPE));
  memset(&p->ps[0], 0, (size+4)*sizeof(YYPOSN));
  return p;
}

void YYFreeState(yyparsestate *p) {
  delete[] p->ss;
  delete[] p->vs;
  delete[] p->ps;
  delete p;
}
